#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

#define all(x) x.begin(), x.end()
#define trace(x) cout << #x << " = " << x << endl;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);
const ll MOD = (ll)(1e9 + 7);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

using ordered_set = tree<pair<ll, ll>,
                         null_type,
                         less<pair<ll, ll>>,
                         rb_tree_tag,
                         tree_order_statistics_node_update>;

void solve() {
    ll a, b, n, m;
    cin >> a >> b >> n >> m;

    if (2 * a != b) {
        if ((2 * n - m) % (2 * a - b)) {
            cout << -1;
            return;
        }

        ll r = (2 * n - m) / (2 * a - b);
        ll k = n - r * a;
        
        if (min(r, k) < 0) {
            cout << -1;
            return;
        }

        cout << k << ' ' << r;
        return;
    }

    if (m != 2 * n) {
        cout << -1;
        return;
    }

    cout << n << " 0";
}

signed main() {
    fast_stream();

    int tests = 1;
    // cin >> tests;

    while (tests--) {
        solve();
    }
}