#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

#define all(x) x.begin(), x.end()
#define trace(x) cout << #x << " = " << x << endl;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);
const ll MOD = (ll)(1e9 + 7);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

using ordered_set = tree<pair<ll, ll>,
                         null_type,
                         less<pair<ll, ll>>,
                         rb_tree_tag,
                         tree_order_statistics_node_update>;

void solve() {
    ll n;
    cin >> n;

    vector<ll> a(n), b(n), c(n), d(n);
    for (ll i = 0; i < n; ++i) cin >> a[i];
    for (ll i = 0; i < n; ++i) cin >> b[i];
    for (ll i = 0; i < n; ++i) cin >> c[i];
    for (ll i = 0; i < n; ++i) cin >> d[i];

    vector<ll> nol, otr, pol;
    for (ll i = 0; i < n; ++i) {
        if (a[i] == 0) {
            nol.push_back(i);
        }
        else if (a[i] < 0) {
            otr.push_back(i);
        }
        else {
            pol.push_back(i);
        }
    }

    vector<ll> upd(n, 0);
    ll ans1 = 0;
    for (ll i = 0; i < n; ++i) {
        if (a[i] == 0) {
            if (c[i] < d[i]) {
                a[i] += b[i];
                ans1 += c[i];
                upd[i] = 1;
            }
            else {
                a[i] -= b[i];
                ans1 += d[i];
                upd[i] = -1;
                otr.push_back(i);
            }
        }
    }

    if (otr.size() % 2 == 0) {
        cout << ans1;
        return;
    }

    ll ans = INF;

    for (ll i = 0; i < n; ++i) {
        if (a[i] < 0) {
            ll need = (abs(a[i]) + 1 + b[i] - 1) / b[i];
            if (upd[i] == -1) {
                ans = min(ans, -d[i] + c[i]);
            }
            else {
                ans = min(ans, need * c[i]);
            }
        }
        else {
            ll need = (a[i] + 1 + b[i] - 1) / b[i];
            if (upd[i] == 1) {
                ans = min(ans, -c[i] + d[i]);
            }
            else {
                ans = min(ans, need * d[i]);
            }
        }
    }

    cout << ans + ans1;
}

signed main() {
    fast_stream();

    int tests = 1;
    // cin >> tests;

    while (tests--) {
        solve();
    }
}