#include <bits/stdc++.h>
using namespace std;
//#define int long long
const int inf = 1e9;

template <typename T>
vector <int> ps(T beg, T end) {
    vector <int> ps(end - beg + 1);
    for (int i = 0; i < end - beg; i++) {
        ps[i + 1] = ps[i] + *(beg + i);
    }
    return ps;
}
template <typename T>
void chkmin(T &a, T b) {
    a = min(a, b);
}
template <typename T>
void chkmax(T& a, T b) {
    a = max(a, b);
}
const int mod = 1e9 + 7;
int binpow(int x, int pw) {
    if (!pw) return 1;
    int f = binpow(x, pw / 2);
    f = (1ll * f * f) % mod;
    if (pw & 1) f = (1ll * f * x) % mod;
    return f;
}
int rev(int x) {
    return binpow(x, mod - 2);
}
struct mint{
    int x;
    mint (int _) {
        x = _ % mod;
    }
    mint operator + (const mint& _) const {
        return {(x + _.x) - mod * (x + _.x >= mod)};
    }
    mint operator - (const mint& _) const {
        return {(x - _.x) + mod * (x - _.x < 0)};
    }
    mint operator * (const mint& _) const {
        return {(1ll * x * _.x) % mod};
    }
    bool operator == (const mint& _) const {
        return x == _.x;
    }
    mint operator / (const mint& _) const {
        assert(!(_ == 0));
        return *this * rev(_.x);
    }
};

void solve() {

}
vector <int> count_dp(vector <int> a) { // функция, которая считает дпшку для каждого к
    // и предполагает, что a0 неизменное

    vector <vector <int>> f(a.size(), vector <int> (a.size(), -inf));
    // f[i][j] - чему равно число на позиции i если последнее непоменянное - j

    for (int lst = 0; lst < a.size(); lst++) {
        f[lst][lst] = a[lst];
        for (int i = lst + 1; i < a.size(); i++) {
            int c = f[lst][i - 1];
            if (c + a[i] > 0) break;
            int need_to_add = 1 - (c + a[i]);
            f[lst][i] = a[i] + need_to_add;
        }
    }
    // dp[i][j][lst] - ответ, если мы находимся тут и последнее непоменянное - lst

    vector <vector <vector <int>>> dp(a.size(), vector <vector <int>> (a.size(), vector <int> (a.size(), inf)));

    dp[0][0][0] = 0;
    for (int i = 1; i < a.size(); i++) {
        for (int j = 0; j <= i; j++) {
            for (int lst = 0; lst < i; lst++) {
                // если мы хотим поменять

                int val = f[lst][i - 1];
                if (val + a[i] <= 0) {
                    chkmin(dp[i][j][lst], dp[i - 1][j][lst] + (1 - (val + a[i])));
                    if (j > 0) {
                        chkmin(dp[i][j][i], dp[i - 1][j - 1][lst]);
                    }
                } else {
                    chkmin(dp[i][j][i], dp[i - 1][j][lst]);
                }
            }
        }
    }
    vector <int> ans(a.size(), inf);
    for (int lst = 0; lst < a.size(); lst++) {
        for (int k = 0; k <= a.size() - 1; k++) {
            chkmin(ans[k], dp[a.size() - 1][k][lst]);
        }
    }
    for (int i = 1; i < a.size(); i++) chkmin(ans[i], ans[i - 1]);
    return ans;
}
signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int n; cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    a.insert(a.begin(), 1e6 + 10);
    n++;
    vector <int> ans(n, inf);

    ans = count_dp(a);
    ans.pop_back();


//
//    for (int s = 0; s < n; s++) {
//        vector <int> l, r;
//        for (int i = s; i >= 0; i--) {
//            l.push_back(a[i]);
//        }
//        for (int i = s; i < n; i++) r.push_back(a[i]);
//        auto sl = count_dp(l), sr = count_dp(r);
//
//        // prefmin
//        for (int i = 0; i < sl.size(); i++) {
//            for (int j = 0; j < sr.size(); j++) {
//                chkmin(ans[i + j], sl[i] + sr[j]);
//            }
//        }
//    }
    for (int i : ans) cout << i << ' ';
}