#include <bits/stdc++.h>
using namespace std;
#define int long long
const int inf = 1e18;

template <typename T>
vector <int> ps(T beg, T end) {
    vector <int> ps(end - beg + 1);
    for (int i = 0; i < end - beg; i++) {
        ps[i + 1] = ps[i] + *(beg + i);
    }
    return ps;
}
template <typename T>
void chkmin(T &a, T b) {
    a = min(a, b);
}
template <typename T>
void chkmax(T& a, T b) {
    a = max(a, b);
}
const int mod = 1e9 + 7;
int binpow(int x, int pw) {
    if (!pw) return 1;
    int f = binpow(x, pw / 2);
    f = (1ll * f * f) % mod;
    if (pw & 1) f = (1ll * f * x) % mod;
    return f;
}
int rev(int x) {
    return binpow(x, mod - 2);
}
struct mint{
    int x;
    mint (int _) {
        x = _ % mod;
    }
    mint operator + (const mint& _) const {
        return {(x + _.x) - mod * (x + _.x >= mod)};
    }
    mint operator - (const mint& _) const {
        return {(x - _.x) + mod * (x - _.x < 0)};
    }
    mint operator * (const mint& _) const {
        return {(1ll * x * _.x) % mod};
    }
    bool operator == (const mint& _) const {
        return x == _.x;
    }
    mint operator / (const mint& _) const {
        assert(!(_ == 0));
        return *this * rev(_.x);
    }
};

void solve() {

}
struct seg{
    int col;
    int l, r;
    bool operator < (const seg& s) const {
        return r < s.r;
    }
};
const int maxn = 1005;
int p[maxn];
int sz[maxn];
vector <int> cols[maxn];
int get(int i) {
    if (p[i] == i) return i;
    return p[i] = get(p[i]);
}
void uni(int x, int y) {
    x = get(x), y = get(y);
    if (x == y) return;
    if (cols[x].size() < cols[y].size()) swap(x, y);
    p[y] = x;
    for (int i : cols[y]) cols[x].push_back(i);
}
signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;
    vector <int> a(n);
    vector <pair<int, int>> bounds(m, {1e9, -1e9});
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
        chkmin(bounds[a[i]].first, i);
        chkmax(bounds[a[i]].second, i);
    }
    vector <seg> s;
    for (int i = 0; i < m; i++) {
        if (bounds[i].first != 1e9) {
            s.push_back({i, bounds[i].first, bounds[i].second});
            cols[i].push_back(i);
        }
    }
    std::sort(s.begin(), s.end());
    // теперь хотелось бы сделать вектор с снмом
    iota(p, p + maxn, 0);
    fill(sz, sz + maxn, 1);
//    for (int i = 0; i < m; i++) cols[i].push_back(i);


    vector <seg> ss;
    ss.push_back(s[0]);
    for (int i = 1; i < s.size(); i++) {
        int l = s[i].l;
        int min_l = l;
        while (!ss.empty() && ss.back().r >= l) {
            uni(s[i].col, ss.back().col);
            chkmin(l, ss.back().l);
            ss.pop_back();
        }
        ss.push_back({s[i].col, l, s[i].r});
    }
    // v ss lezhit chto to


    vector <vector <int>> cost(m, vector <int> (m, 0));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) cin >> cost[i][j];
    }

    //

    vector <vector <int>> dp(ss.size(), vector <int> (m, inf));
    for (int to = 0; to < m; to++) {
        int pr_col = get(ss[0].col);
        int sum = 0;
        for (int j : cols[pr_col]) {
            sum += cost[j][to];
        }
        dp[0][to] = sum;
    }
    for (int i = 1; i < ss.size(); i++) {
        vector <int> prefmin(m);
        prefmin[0] = dp[i - 1][0];
        for (int j = 1; j < m; j++) prefmin[j] = min(prefmin[j - 1], dp[i - 1][j]);
        int pr_col = get(ss[i].col);
        for (int to = 0; to < m; to++) {
            int sum = 0;
            for (int j : cols[pr_col]) sum += cost[j][to];
            chkmin(dp[i][to], prefmin[to] + sum);
        }
    }
    int ans = inf;
    for (int i = 0; i < m; i++) chkmin(ans, dp[ss.size() - 1][i]);
    cout << ans;


}