#include <bits/stdc++.h>
using namespace std;
#define ll long long
const ll inf = 1e18;

template <typename T>
vector <int> ps(T beg, T end) {
    vector <int> ps(end - beg + 1);
    for (int i = 0; i < end - beg; i++) {
        ps[i + 1] = ps[i] + *(beg + i);
    }
    return ps;
}
template <typename T>
void chkmin(T &a, T b) {
    a = min(a, b);
}
template <typename T>
void chkmax(T& a, T b) {
    a = max(a, b);
}
const int mod = 1e9 + 7;
int binpow(int x, int pw) {
    if (!pw) return 1;
    int f = binpow(x, pw / 2);
    f = (1ll * f * f) % mod;
    if (pw & 1) f = (1ll * f * x) % mod;
    return f;
}
int rev(int x) {
    return binpow(x, mod - 2);
}
struct mint{
    int x;
    mint (int _) {
        x = _ % mod;
    }
    mint(ll _) {
        x = _ % mod;
    }
    mint operator + (const mint& _) const {
        return {(x + _.x) - mod * (x + _.x >= mod)};
    }
    mint operator - (const mint& _) const {
        return {(x - _.x) + mod * (x - _.x < 0)};
    }
    mint operator * (const mint& _) const {
        return {(1ll * x * _.x) % mod};
    }
    bool operator == (const mint& _) const {
        return x == _.x;
    }
    mint operator / (const mint& _) const {
        assert(!(_ == 0));
        return *this * rev(_.x);
    }
};

void solve() {

}
const int maxn = (1 << 19);
int tree[maxn * 2];
int tin[maxn], tout[maxn];
int timer = 1;

int head[maxn];
int lazy[maxn * 2];
int pr[maxn];
vector <int> g[maxn];
int dep[maxn];

const int logn = 19;
int binups[maxn][logn];

void dfs1(int v, int p) {
    binups[v][0] = max(p, 1);
    for (int i = 1; i < logn; i++) {
        binups[v][i] = binups[binups[v][i - 1]][i - 1];
    }
    tin[v] = timer++;
    dep[v] = dep[p] + 1;
    pr[v] = p;
    for (int i : g[v]) {
        if (i == p) continue;
        dfs1(i, v);
    }
    tout[v] = timer++;
}
bool is_anc(int p, int v) {
    return tin[p] <= tin[v] && tout[v] <= tout[p];
}
int lca(int u, int v) {
    if (is_anc(u,v)) return u;
    for (int i = logn - 1; i >= 0; i--) {
        if (!is_anc(binups[u][i], v)) u = binups[u][i];
    }
    return binups[u][0];
}
int s[maxn];
signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int n; cin >> n;
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs1(1, 0);
    ll last_ans = 0;
    int q, t;
    cin >> q >> t;
    vector <pair<int, ll>> sus, verts;
    while (q--) {
        ll mx = 0;
//        vector <pair<int, int>> sus;
        int k; cin >> k;
//        sus.reserve(k);
        sus.resize(0);
        while (k--) {
            int v, c;
            if (t == 1) {
                cin >> v >> c;
            } else {
                int u; cin >> u >> c;
                v = (u + last_ans) % (n - 1) + 2;
            }
            sus.emplace_back(v, c);
        }

        std::sort(sus.begin(), sus.end(), [](pair<int, int> a, pair<int, int> b) {
            return tin[a.first] < tin[b.first];
        });
        if (sus[0].first != 1) {
            sus.insert(sus.begin(), make_pair(1, 0));
        }

        verts.resize(0);
//        verts.reserve(k);
        verts.push_back(sus[0]);
        chkmax(mx, verts[0].second * dep[verts[0].first]);
        for (int i = 1; i < sus.size(); i++) {
            while (verts.size() >= 2 && lca(verts.back().first, sus[i].first) == lca(verts[verts.size() - 2].first, sus[i].first)) {
                ll w = verts.back().second;
                verts.pop_back();
                verts.back().second += w;
                mx = max(mx, verts.back().second * dep[verts.back().first]);
            }
            int lc = lca(sus[i].first, verts.back().first);
            ll w = sus[i].second + verts.back().second;
            chkmax(mx, dep[lc] * w);
            chkmax(mx, sus[i].second * dep[sus[i].first]);
            verts.back().first = lc;
            verts.push_back(sus[i]);
        }
        while (verts.size() != 1) {
            ll w = verts.back().second;
            verts.pop_back();
            verts.back().second += w;
            chkmax(mx, verts.back().second * dep[verts.back().first]);
        }
        cout << mx << '\n';
        last_ans = mx;
    }
}