#include<bits/stdc++.h>
#define ll long long

using namespace std;

ll n, INF = 1e14;
vector<ll> a;

void input() {
    cin >> n;
    a.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
}

void solve() {
    vector<vector<pair<ll, ll>>> dp(n, vector<pair<ll, ll>>(n, {-INF, INF}));
    dp[0][0] = {a[0], 0};
    for (ll i = 1; i < n; i++) {
        vector<vector<pair<ll, ll>>> pred = dp;
        dp.assign(n, vector<pair<ll, ll>>(n, {-INF, INF}));
        for (ll j = 0; j < n; j++) {
            for (ll t = 0; t < n; t++) {
                if (t > 0 && j > 0) {
                    //cout << pred[j - 1][t - 1].second << " " << max((ll)0, -(pred[j - 1][t - 1].first + a[i])) << endl;
                    dp[j][t] = {a[i] + max((ll)0, -(pred[j - 1][t - 1].first + a[i] - 1)), pred[j - 1][t - 1].second + max((ll)0, -(pred[j - 1][t - 1].first + a[i] - 1))};
                }
                if (t == 0) {
                    for (ll k = 0; k < n; k++) {
                        if (pred[j][k].second < dp[j][t].second) {
                            dp[j][t] = {a[i], pred[j][k].second};
                        }
                    }
                }
                //cout << j << " " << t << " " << dp[j][t].first << " " << dp[j][t].second << "\n";
            }
        }
    }
    for (ll i = n - 1; i > -1; i--) {
        ll minim = INF;
        for (ll j = 0; j < n; j++) {
            minim = min(minim, dp[i][j].second);
        }
        cout << minim << " ";
    }
}

void output() {

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    input();
    solve();
    output();
    return 0;
}