#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <unordered_set>
#include <random>

using namespace std;

int f(vector<int> z, int k) {
    if (z.size() == 0 && k >= 0) return 0;
    if (k < 0) return 1e9;
    if (z[z.size() - 1] <= 0) {
        z.pop_back();
        return f(z, k);
    }
    else {
        int a = z[z.size() - 1];
        z.pop_back();
        int ans1 = f(z, k - 1);
        if(z.size()!=0) z[z.size() - 1] -= a;
        int ans2 = f(z, k) + a;
        return min(ans1, ans2);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    mt19937 rnd(10);
    int n;
    cin >> n;
    vector<int> z0(n);
    for (auto &i : z0) cin >> i;
    vector<int> z(n - 1);
    for (int i = 0; i < n - 1; i++) {
        z[i] = max(0, -(z0[i] + z0[i + 1] - 1));
    }
    vector<int> ans(n);
    for (int i = 0; i < n; i++) {
        ans[i] = f(z, i);
    }
    for (auto &i : ans) cout << i << ' ';
    
}