#include <algorithm>
#include <iostream>
#include <cstdint>
#include <vector>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    const int INF = -1;
    int n; cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> b(n-1, 0);
    b[0] += a[0];
    for (int i = 1; i < n-1; ++i) {
        b[i-1] += a[i];
        b[i] += a[i];
    }
    b[n-2] += a[n-1]; --n;
    for (int i = 0; i < n; ++i) {
        b[i] = max(-b[i]+1, 0);
    }
    /*for (auto i : b) {
        cout << i << ' ';
    }
    cout << '\n';*/
    vector<vector<int>> cnt(n, vector<int>(n, INF));
    for (int i = 0; i < n; ++i) {
        cnt[i][0] = b[i];
        for (int j = 1; j <= i; ++j) {
            cnt[i][j] = max(0, b[i]-cnt[i-1][j-1]);
        }
    }

    vector<vector<vector<int>>> dp(n, vector<vector<int>>(n+1, vector<int>(n+1, INF)));
    dp[0][0][0] = 0;
    dp[0][1][1] = b[0];
    for (int i = 1; i < n; ++i) {
        for (int k = 0; k <= i; ++k) {
            int minim = INF;
            for (int j = 0; j<=i; ++j) {
                if (dp[i-1][j][k] != INF) {
                    if (minim == INF || dp[i-1][j][k]<minim) {
                        minim = dp[i-1][j][k];
                    }
                }
            }
            dp[i][0][k] = minim;
        }
        for (int j = 1; j <= i; ++j) {
            for (int k = j; k <= i; ++k) {
                dp[i][j][k] = dp[i-1][j-1][k-1]+cnt[i][j-1];
            }
        }
        dp[i][i+1][i+1] = dp[i-1][i][i]+cnt[i][i];
    }

    for (int k = n; k >= 0; --k) {
        int minim = INF;
        for (int j = 0; j<=n; ++j) {
            if (dp[n-1][j][k] != INF) {
                if (minim == INF || dp[n-1][j][k]<minim) {
                    minim = dp[n-1][j][k];
                }
            }
        }
        cout << minim << ' ';
    }
    cout << '\n';

    return 0;
}