#include<bits/stdc++.h>
using namespace std;
using ll = long long;


struct r {
    ll a, b, c, d;
    ll need_to_pol;
    ll need_to_otr;
};

bool comp(r a, r b) {
    return a.c - a.d < b.c - b.d;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    vector<r> a(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i].a;
    }

    for (int i = 0; i < n; i++) {
        cin >> a[i].b;
    }

    for (int i = 0; i < n; i++) {
        cin >> a[i].c;
    }

    for (int i = 0; i < n; i++) {
        cin >> a[i].d;
    }

    for (int i = 0; i < n; i++) {
        if (a[i].a == 0) {
            a[i].need_to_otr = a[i].d;
            a[i].need_to_pol = a[i].c;
        } else if (a[i].a > 0) {
            a[i].need_to_pol = 0;
            a[i].need_to_otr = (a[i].a + a[i].b) / a[i].b;
            a[i].need_to_otr *= a[i].d;
        } else {
            a[i].need_to_pol = (-a[i].a + a[i].b) / a[i].b;
            a[i].need_to_otr = 0;
            a[i].need_to_pol *= a[i].c;
        }
    }

    int amount_otr = 0;
    int amount_pol = 0;
    int amount_0 = 0;
    for (int i = 0; i < n; i++) {
        if (a[i].a < 0) {
            amount_otr++;
        } else if (a[i].a > 0) {
            amount_pol++;
        } else {
            amount_0++;
        }
    }

    vector<r> zeros;
    for (int i = 0; i < n; i++) {
        if (a[i].a == 0) zeros.push_back(a[i]);
    }

    sort(zeros.rbegin(), zeros.rend(), comp);

    ll chetn_0 = 0;
    ll nechtn_0 = 0;

    if (amount_0 > 0) {
        ll ans = 0;
        for (int i = 0; i < zeros.size(); i++) ans += zeros[i].c;

        ll last = ans;
        for (int i = 0; i < zeros.size() - 1; i += 2) {
            ll cur = - zeros[i].c + zeros[i].d - zeros[i + 1].c + zeros[i + 1].d;
            last += cur;
            ans = min(last, ans);
        }
        
        chetn_0 = ans;

        ans = 0;
        for (int i = 0; i < zeros.size(); i++) ans += zeros[i].c;

        last = ans - zeros[0].c + zeros[0].d;
        for (int i = 1; i < zeros.size() - 1; i += 2) {
            ll cur = - zeros[i].c + zeros[i].d - zeros[i + 1].c + zeros[i + 1].d;
            last += cur;
            ans = min(last, ans);
        }
        
        nechtn_0 = ans;
    }

    ll v1 = 1e9 + 1;
    ll v2 = 1e9 + 1;

    if (amount_otr % 2 == 1) {
        for (int i = 0; i < n; i++) {
            if (a[i].a > 0)
                v1 = min(v1, a[i].need_to_otr);
            if (a[i].a < 0)
                v1 = min(v1, a[i].need_to_pol);
        }
        v2 = 0;
    } else {
        for (int i = 0; i < n; i++) {
            if (a[i].a > 0)
                v2 = min(v2, a[i].need_to_otr);
            if (a[i].a < 0)
                v2 = min(v2, a[i].need_to_pol);
        }
        v1 = 0;
    }

    if (amount_0 > 0)
        cout << min(v1 + chetn_0, v2 + nechtn_0);
    else
        cout << v1;
    return 0;
}