#include<bits/stdc++.h>
using namespace std;
using ll = long long;


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<vector<int>> cost(m, vector<int> (m));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            cin >> cost[i][j];
        }
    }

    vector<int> dp(n, 1);
    dp[0] = 1;
    for (int i = 1; i < n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            if (a[j] <= a[i]) {
                dp[i] = max(dp[i], dp[j] + 1);
            }
        }
    }
    int best = 0;
    for (int i = 0; i < n; i++) {
        best = max(best, dp[i]);
    }

    cout << (n - best) * cost[0][1];
    return 0;
}