#include <bits/stdc++.h>

using namespace std;

#define int long long

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    map<int, int> inp;
    map<int, int> fir;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
        inp[a[i]] = i;
        if (fir.count(a[i]) == 0) {
            fir[a[i]] = i;
        }
    }
    int g[m][m];
    int o = 0;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            cin >> g[i][j];
            o = max(o, g[i][j]);
        }
    }
    vector<pair<int, int>> s;
    for (int i = 0; i < m; i++) {
        s.push_back({fir[i], 1});
        s.push_back({inp[i], 0});
    }
    sort(s.begin(), s.end());
    vector<vector<int>> otr(1, vector<int>(m, 0));
    int now = 0;
    int t = 0;
    for (auto i : s) {
        if (i.second) {
            now++;
            for (int j = 0; j < m; j++) {
                otr[t][j] += g[a[i.first]][j];
            }
        } else {
            now--;
        }
        if (now == 0) {
            t++;
            otr.emplace_back();
            otr[t].resize(m, 0);
        }
    }
    vector<vector<int>> dp(t, vector<int>(m));
    vector<vector<int>> pref(t, vector<int>(m, 1e10));
    for (int i = 0; i < m; i++) {
        dp[0][i] = otr[0][i];
        pref[0][i] = min((i > 0 ? pref[0][i - 1] : (int) 1e10), otr[0][i]);
    }
    for (int i = 1; i < t; i++) {
        for (int j = 0; j < m; j++) {
            dp[i][j] = pref[i - 1][j] + otr[i][j];
            pref[i][j] = min((j > 0 ? pref[i][j - 1] : (int) 1e10), dp[i][j]);
        }
    }
    int otv = 1e10;
    for (int i = 0; i < m; i++) {
        otv = min(otv, dp[t - 1][i]);
    }
    cout << otv;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
//    cin >> T;
    while (T--) {
        solve();
        cout << '\n';
    }
}

//void SPARSE() {
//    int n;
//    cin >> n;
//    int c = __lg(n) + 1;
//    vector<int> a(n);
//    vector<vector<int>> sp(n, vector<int>(c));
//    for (int i = 0; i < n; i++) {
//        sp[i][0] = a[i];
//    }
//    for (int l = 1; l < c; l++) {
//        for (int i = 0; i + (1 << (l - 1)) < n; i++) {
//            sp[i][l] = min(sp[i][l - 1], sp[i + (1 << (l - 1))][l - 1]);
//        }
//    }
//    int getx(int l, int r) {
//        int t = __lg(r - l);
//        return min(sp[l][t], sp[r - (1 << t)][t]);
//    }
//}