#include <bits/stdc++.h>

using namespace std;

#define int long long

bool sq(int x) {
    int y = sqrt(x);
    return x == y * y;
}

map<int, int> prime;

bool isp(int x) {
    if (prime.count(x) == 0) {
        for (int i = 2; i <= sqrt(x); i++) {
            if (x % i == 0) {
                prime[x] = false;
                return false;
            }
        }
        prime[x] = true;
        return true;
    } else {
        return prime[x];
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    if (sq(n + 1)) {
        cout << n / 2 + n % 2 << '\n';
        if (n % 2 == 0) {
            for (int i = 1; i <= n / 2; i++) {
                cout << 2 << '\n' << i << ' ' << n - i + 1 << '\n';
            }
        } else {
            for (int i = 1; i <= n / 2; i++) {
                cout << 2 << '\n' << i << ' ' << n - i + 1 << '\n';
            }
            cout << 1 << '\n' << n / 2 + 1;
        }
        return;
    }
    vector<int> primes;
    vector<bool> p(n + 1, true);
    for (int i = 2; i <= n; i++) {
        if (p[i]) {
            primes.push_back(i);
        }
        for (auto j : primes) {
            if (i * j > n) break;
            p[i * j] = false;
        }
    }
    int last = 0;
    vector<int> otv;
    for (int t = 0; t < m; t++) {
        for (int i = n; i > last; i--) {
            int now = i * (i + 1) / 2 - last * (last + 1) / 2;
            if (sq(now) || (now <= n ? p[i] : false) || isp(now)) {
                otv.push_back(i);
                last = i;
                break;
            } else {
                for (auto j : primes) {
                    if (now % j == 0 && sq(now / j)) {
                        otv.push_back(i);
                        last = i;
                        break;
                    }
                }
            }
        }
    }
    cout << otv.size() << '\n';
    last = 1;
    for (auto i : otv) {
        cout << i - last + 1 << '\n';
        for (; last <= i; last++) {
            cout << last << ' ';
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
//    cin >> T;
    while (T--) {
        solve();
        cout << '\n';
    }
}

//void SPARSE() {
//    int n;
//    cin >> n;
//    int c = __lg(n) + 1;
//    vector<int> a(n);
//    vector<vector<int>> sp(n, vector<int>(c));
//    for (int i = 0; i < n; i++) {
//        sp[i][0] = a[i];
//    }
//    for (int l = 1; l < c; l++) {
//        for (int i = 0; i + (1 << (l - 1)) < n; i++) {
//            sp[i][l] = min(sp[i][l - 1], sp[i + (1 << (l - 1))][l - 1]);
//        }
//    }
//    int getx(int l, int r) {
//        int t = __lg(r - l);
//        return min(sp[l][t], sp[r - (1 << t)][t]);
//    }
//}