﻿#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

vector<vi> g;
vi l, r, rc, used;

void dfs(int u, int x) {
    used[u] = x;
    rc.back() = max(rc.back(), r[u]);
    for (int v: g[u]) {
        if (used[v] == -1)
            dfs(v, x);
    }
}

int main() {
    fast;
    int n, m;
    cin >> n >> m;
    g.resize(m);
    l.assign(m, n);
    r.assign(m, -1);
    vi a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        if (l[a[i]] == n)
            l[a[i]] = i;
        r[a[i]] = i;
    }
    vector<vector<ll>> c(m, vector<ll>(m));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < m; ++j)
            cin >> c[i][j];
    }
    for (int i = 0; i < m; ++i) {
        for (int j = i + 1; j < m; ++j) {
            if (r[i] >= l[j] && r[j] >= l[i]) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    used.assign(m, -1);
    for (int i = 0; i < m; ++i) {
        if (used[i] == -1) {
            rc.push_back(-1);
            dfs(i, (int)rc.size() - 1);
        }
    }
    vector<ll> d(m, 0);
    int i = 0;
    vector<bool> b(m, false);
    while (i < n) {
        int j = rc[used[a[i]]];
        vi e;
        for (int k = i; k <= j; ++k) {
            if (!b[a[k]]) {
                b[a[k]] = true;
                e.push_back(a[k]);
            }
        }
        vector<ll> dd(m);
        for (int k = 0; k < m; ++k) {
            dd[k] = d[k];
            for (int x: e)
                dd[k] += c[x][k];
            if (k > 0)
                dd[k] = min(dd[k], dd[k - 1]);
        }
        d.swap(dd);
        i = j + 1;
    }
    cout << d[m - 1] << '\n';
}
