// #pragma optimize("Ofast")
#include "bits/stdc++.h"
#define int long long

using namespace std;

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  int n;
  cin >> n;
  vector<vector<int>> g(n);
  for (int i = 0; i + 1 < n; i++) {
    int u, v;
    cin >> u >> v;
    u--, v--;
    g[u].push_back(v);
    g[v].push_back(u);
  }
  vector<int> depth(n), pr(n);
  function<void(int, int)> dfs = [&](int v, int p) {
    for (auto& to : g[v]) {
      if (to == p) continue;
      depth[to] = depth[v] + 1;
      pr[to] = v;
      dfs(to, v);
    }
  };
  dfs(0, 0);
  int q, t;
  cin >> q >> t;
  if (t == 1) {
    while (q--) {
      int k;
      cin >> k;
      vector<int> cost(n);
      for (int i = 0; i < k; i++) {
        int v, c;
        cin >> v >> c;
        v--;
        while (true) {
          cost[v] += c * (depth[v] + 1);
          if (v == 0) {
            break;
          }
          v = pr[v];
        }
      }
      cout << *max_element(cost.begin(), cost.end()) << '\n';
    }
  }
}