#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
using namespace std;
typedef long long ll;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m;
    cin >> n >> m;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) cin >> a[i], --a[i];
    vector<vector<ll>> c(m, vector<ll>(m));
    for (ll i = 0; i < m; ++i) {
        for (ll j = 0; j < m; ++j) cin >> c[i][j];
    }
    unordered_map<ll, ll> f, l;
    for (ll i = 0; i <= m; ++i) f[i] = n, l[i] = -1;
    for (ll i = 0; i < n; ++i) f[a[i]] = min(f[a[i]], i), l[a[i]] = i;
    ll mx = 0, mn = 0;
    vector<pair<ll, ll>> p;
    for (ll i = 0; i < n; ++i) {
        mx = max(mx, l[a[i]]);
        if (i == mx) p.push_back({mn, mx}), mn = mx + 1;
    }
    vector<vector<ll>> c1 ((ll)p.size(), vector<ll>(m, 0));
    vector<ll> u(m, 0);
    for (ll i = 0; i < (ll)p.size(); ++i) {
        for (ll j = p[i].first; j <= p[i].second; ++j) {
            if (u[a[j]]) continue;
            for (ll k = 0; k < m; ++k) c1[i][k] += c[a[j]][k], c[a[j]][k] = 0;
            u[a[j]] = 1;
        }
    }
    vector<vector<ll>> dp((ll)p.size(), vector<ll>(m, 0));
    for (ll i = 0; i < (ll)p.size(); ++i) {
        for (ll j = 0; j < m; ++j) {
            if (i) dp[i][j] = dp[i - 1][j];
            dp[i][j] += c1[i][j];
            if (j) dp[i][j] = min(dp[i][j], dp[i][j - 1]);
        }
    }
    cout << dp.back().back();
    return 0;
}