#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, q;
    cin >> n >> q;
    vector<string> s(n);
    vector<set<ll>> z(n);
    vector<ll> x(n, 0), y(n, 0);
    for (ll i = 0; i < n; ++i) {
        cin >> s[i];
        if (i > 0) x[i] = x[i - 1] + (ll)s[i - 1].size();
        if (s[i].back() == '1') y[i] = 1;
        for (ll j = 0; j < (ll)s[i].size(); ++j) {
            if (j == 0 || s[i][j] != s[i][j - 1]) z[i].insert(x[i] + j);
        }
    }
    ll c1 = 0, c2 = 0;
    for (ll i = 0; i < n; ++i) {
        auto it = z[i].end();
        --it;
        ll c = x[i] + (ll)s[i].size() - (*it);
        if (y[i] == 0) c = 0;
        if (c){
            if (c % 2) ++c1;
            else ++c2;
        }
    }
    if (c1 % 2 == 0 && c2 % 2 == 0) cout << "Second\n";
    else cout << "First\n";
    while (q--) {
        ll l, r;
        cin >> l >> r;
        --l, --r;
        c1 = 0, c2 = 0;
        for (ll i = 0; i < n; ++i) {
            ll l1 = max(l, x[i]), r1 = min(r, x[i] + (ll)s[i].size() - 1);
            if (l1 <= r1) {
                if (r1 == x[i] + (ll)s[i].size() - 1) y[i] = 1 - y[i];
                if (z[i].find(l1) != z[i].end()) {
                    if (l1 != x[i]) z[i].erase(l1);
                } else z[i].insert(l1);
                if (r1 < x[i] + (ll)s[i].size() - 1) {
                    if (z[i].find(r1 + 1) != z[i].end()) z[i].erase(r1 + 1);
                    else z[i].insert(r1 + 1);
                }
            }
            auto it = z[i].end();
            --it;
            ll c = x[i] + (ll)s[i].size() - (*it);
            if (y[i] == 0) c = 0;
            if (c){
                if (c % 2) ++c1;
                else ++c2;
            }
        }
        if (c1 % 2 == 0 && c2 % 2 == 0) cout << "Second\n";
        else cout << "First\n";
    }
    return 0;
}