#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INFLL = 1e18;

void solve() {
    int n;
    cin >> n;

    vector<int> a(n), b(n), c(n), d(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }


    vector<vector<int>> t(n, vector<int> (2));

    for (int i = 0; i < n; i++) {
        if (a[i] == 0) {
            t[i][1] = d[i];
            t[i][0] = c[i];
        } else if (a[i] < 0) {
            t[i][1] = 0;
            t[i][0] = (abs(a[i]) / b[i] + 1) * c[i];
        } else if (a[i] > 0) {
            t[i][0] = 0;
            t[i][1] = (abs(a[i]) / b[i] + 1) * d[i];
        }
    }   

    vector<vector<int>> dp(n + 1, vector<int> (2));
    dp[0][0] = 0;
    dp[0][1] = INFLL;

    for (int i = 1; i <= n; i++) {
        dp[i][0] = min(dp[i - 1][0] + t[i - 1][0], dp[i - 1][1] + t[i - 1][1]);
        dp[i][1] = min(dp[i - 1][0] + t[i - 1][1], dp[i - 1][1] + t[i - 1][0]);
    }

    cout << dp[n][0];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();
    return 0;
}