#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INFLL = 1e12;

void solve() {
    int n, m;
    cin >> n >> m;

    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<vector<int>> dp(n + 1, vector<int> (m + 1, INFLL));

    vector<vector<int>> matrix(m + 1, vector<int> (m + 1));
    for (int i = 1; i <= m; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> matrix[i][j];
        }
    }

    for (int i = 1; i <= m; i++) {
        dp[1][i] = min(dp[1][i - 1], matrix[a[0]][i]);
    }

    for (int i = 2; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            dp[i][j] = dp[i - 1][j] + matrix[a[i - 1]][j];

            dp[i][j] = min(dp[i][j], dp[i][j - 1]);
        }
    }

    int ans = INFLL;

    for (int i = 1; i <= m; i++) {
        ans = min(ans, dp[n][i]);
    }

    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();
    return 0;
}