#include <bits/stdc++.h>

#define int long long

using namespace std;

const int MAXN = 3057;
const int INFLL = 1e12;

vector<int> gr[MAXN];
int p[MAXN];

void dfs(int start, int pr) {
    p[start] = pr;

    for (int i : gr[start]) {
        if (i != pr) {
             dfs(i, start);
        }
    }
}

void dfs2(int start, int d, map<int, vector<int>> &love, map<int, int> &cool) {
    for (int c : love[start]) {
        cool[start] += (d + 1) * c;
    }

    for (int i : gr[start]) {
        if (i != p[i]) {
            dfs2(i, d + 1, love, cool);
        }
    }
}

void solve() {
    int n;
    cin >> n;

    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }

    dfs(0, -1);

    int q, t;
    cin >> q >> t;

    assert(t == 1);

    for (int i = 0; i < q; i++) {
        int k;
        cin >> k;

        map<int, vector<int>> love;
        for (int i = 0; i < k; i++) {
            int v, c;
            cin >> v >> c;
            v--;
            while (v != -1) {
                love[v].push_back(c);
                v = p[v];
            }
        }

        map<int, int> cool;

        dfs2(0, 0, love, cool);

        int mx = -INFLL;
        int ind = -1;

        for (auto a : cool) {
            if (mx < a.second) {
                mx = a.second;
                ind = a.first;
            }
        }

        cout << ind + 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();
    return 0;
}