#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <queue>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e18;

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    vector<ll> a(n), b(n), c(n), d(n);
    for (ll& x : a) {
        cin >> x;
    }
    for (ll& x : b) {
        cin >> x;
    }
    for (ll& x : c) {
        cin >> x;
    }
    for (ll& x : d) {
        cin >> x;
    }
    ll s = 0, cnt_m = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) {
            if (c[i] < d[i]) {
                s += c[i];
            } else {
                s += d[i];
                cnt_m++;
            }
        } else if (a[i] < 0) {
            cnt_m++;
        }
    }
    if (cnt_m % 2 == 0) {
        cout << s;
        return 0;
    }
    ll ans = INF;
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) {
            if (c[i] < d[i]) {
                ans = min(ans, s - c[i] + d[i]);
            } else {
                ans = min(ans, s - d[i] + c[i]);
            }
        } else if (a[i] < 0) {
            ans = min(ans, s + (abs(a[i]) + 1 + b[i] - 1) / b[i] * c[i]);
        } else {
            ans = min(ans, s + (a[i] + 1 + b[i] - 1) / b[i] * d[i]);
        }
    }
    cout << ans;
}