#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <queue>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e18;

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    vector<ll> A(n - 1), b(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < n - 1; i++) {
        A[i] = b[i] + b[i + 1];
    }
    n--;
    vector<vector<ll>> dp(n + 1, vector<ll>(n + 1, INF));
    dp[0][0] = 0;
    for (int p = 0; p < n; p++) {
        dp[p + 1] = dp[p];
        ll s = 0;
        vector<ll> a = A;
        for (int i = p; i >= 0; i--) {
            if (a[i] <= 0) {
                for (int k = 0; k + p - i <= n; k++) {
                    dp[p + 1][k + p - i] = min(dp[p + 1][k + p - i], dp[i][k] + s);
                }
                s += 1 - a[i];
                if (i != 0) {
                    a[i - 1] += 1 - a[i];
                } else {
                    dp[p + 1][p + 1] = s;
                }
            } else {
                for (int k = 0; k + p + 1 - i <= n; k++) {
                    dp[p + 1][k + p + 1 - i] = min(dp[p + 1][k + p + 1 - i], dp[i][k] + s);
                }
                break;
            }
        }
    }
    for (int k = n; k >= 0; k--) {
        ll ans = INF;
        for (int i = 0; i <= n; i++) {
            ans = min(ans, dp[i][k]);
        }
        cout << ans << ' ';
    }
}