#ifndef ASTRON
#pragma GCC optimize("O3,unroll-loops")
#endif

#include <bits/stdc++.h>
using namespace std;

#define int long long
#define ld long double

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& i : v) in >> i;
    return in;
}

void solve() {
    int a, b, m, n;
    cin >> a >> b >> n >> m;
    if (b - 2 * a == 0) {
        if (m != 2 * n) cout << -1;
        else cout << n << ' ' << 0;
        return;
    }
    int x = (m - 2 * n) / (b - 2 * a);
    int y = n - a * x;
    if (x < 0 || y < 0 || a * x + y != n || b * x + 2 * y != m) {
        cout << -1;
    } else {
        cout << y << ' ' << x;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve(), cout << '\n';
}