#ifndef ASTRON
#pragma GCC optimize("O3,unroll-loops")
#endif

#include <bits/stdc++.h>
using namespace std;

#define int long long
#define ld long double

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& i : v) in >> i;
    return in;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n), c(n), d(n);
    cin >> a >> b >> c >> d;
    bool pos = true;
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] != 0) {
            if (a[i] < 0) {
                pos ^= 1;
            }
            continue;
        }
        if (c[i] < d[i]) {
            ans += c[i];
        } else {
            ans += d[i];
            pos ^= 1;
        }
    }

    if (pos) {
        cout << ans;
        return;
    }

    int cans = ans;
    ans = 1e18;
    for (int i = 0; i < n; i++) {
        if (a[i] != 0) continue;
        if (c[i] < d[i]) {
            ans = min(ans, cans + d[i] - c[i]);
        } else {
            ans = min(ans, cans + c[i] - d[i]);
        }
    }

    for (int i = 0; i < n; i++) {
        if (a[i] == 0) continue;
        if (a[i] > 0) {
            ans = min(ans, cans + d[i] * (a[i] / b[i] + 1));
        } else {
            ans = min(ans, cans + c[i] * (abs(a[i]) / b[i] + 1));
        }
    }
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve(), cout << '\n';
}