#ifndef ASTRON
#pragma GCC optimize("O3,unroll-loops")
#endif

#include <bits/stdc++.h>
using namespace std;

#define int long long
#define ld long double

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& i : v) in >> i;
    return in;
}

int dp[505][505];

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    a.insert(a.begin(), 0ll);
    memset(dp, 0x3c, sizeof dp);
    dp[0][0] = 0;
    dp[1][0] = 0;

    for (int i = 2; i <= n; i++) {
        for (int k = 0; k <= i; k++) {
            int cur = 0;
            if (k != 0)
                dp[i][k] = min(dp[i][k], dp[i-1][k-1]);
            vector<int> b = a;
            for (int j = i-1; j > 0; j--) {
                //b[j] + b[j+1] > 0
                if (b[j] + b[j+1] <= 0) {
                    cur += 1 - (b[j] + b[j+1]);
                    b[j] += 1 - (b[j] + b[j+1]);
                }
                if (k != 0)
                    dp[i][k] = min(dp[i][k], cur + dp[j-1][k-1]);
                else if (j == 1)
                    dp[i][k] = min(dp[i][k], cur);
            }
        }
    }

    for (int i = 0; i < n; i++) {
        cout << dp[n][i] << ' ';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve(), cout << '\n';
}