#include <bits/stdc++.h>
using namespace std;

using ll = long long;

constexpr ll inf = 1144000000000000000;
constexpr int Inf = 0x3f3f3f3f;

constexpr int maxn = 505;

ll dp[maxn][maxn], dp2[maxn][maxn];

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& e : a)
        cin >> e;
    for (int l = 0; l < n - 1; ++l) {
        for (int r = l + 1; r < n; ++r) {
            int carry = 0;
            for (int i = l + 1; i <= r; ++i) {
                int f = a[i - 1] + a[i] + carry;
                carry = max(1 - f, 0);
                dp[l][r] += carry;
            }
        }
    }
    memset(dp2, 0x3f, sizeof dp2);
    dp2[0][0] = 0;
    auto get = [&](int i, int j) {
        if (i >= 0) {
            return dp2[i][j];
        }
        return 0ll;
    };
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < n; ++j)
            dp2[i][j] = dp2[i - 1][j];
        for (int l = 0; l < i; ++l) {
            for (int r = l + 1; r <= i; ++r) {
                int cov = r - l;
                for (int s = 0; s <= max(l - 1, 0); ++s) {
                    dp2[i][s + cov] = min(dp2[i][s + cov], dp[l][r] + get(l - 1, s));
                }
            }
        }
    }
    for (int i = 0; i < n; ++i)
        cout << dp2[n - 1][n - i - 1] << ' ';
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int Tc = 1;
    // cin >> Tc;
    while (Tc--)
        solve(), cout << "\n";
    return 0;
}