#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define pii pair<int, int>
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 4e5 + 1, logn = 19;
int n;
vector<int> g[maxn];
int d[maxn], tin[maxn], tout[maxn], T = 0, up[logn][maxn];

void dfs(int v = 0, int p = -1) {
    tin[v] = T++;
    for (int l = 1; l < logn; l++)up[l][v] = up[l - 1][up[l - 1][v]];
    for (int u: g[v]) {
        if (p == u) continue;
        up[0][u] = v;
        d[u] = d[v] + 1;
        dfs(u, v);
    }
    tout[v] = T;
}

int anc(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int lca(int u, int v) {
    if (anc(u, v)) return u;
    if (anc(v, u)) return v;
    for (int l = logn - 1; l >= 0; l--)
        if (!anc(up[l][v], u))
            v = up[l][v];
    return up[0][v];
}

int f[maxn];

void upd(int x, int ty) {
    for (; x < T; x |= (x + 1)) f[x] += ty;
}

int get(int r) {
    int ans = 0;
    for (; r >= 0; r = ((r + 1) & r) - 1) ans += f[r];
    return ans;
}

int getv(int v) {
    int l = tin[v], r = tout[v] - 1;
    return (get(r) - get(l - 1)) * d[v];
}

void solve() {
    cin >> n;
    d[0] = 1;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v, u--, v--;
        g[u].push_back(v), g[v].push_back(u);
    }
    dfs();
    int q, ty, ans = 0;
    cin >> q >> ty, ty--;
    while (q--) {
        int k;
        cin >> k;
        vector<pii > car(k);
        for (auto &[v, w]: car) {
            cin >> v >> w;
            if (ty) v = (v + ans) % (n - 1) + 2;
            v--;
            upd(tin[v], w);
        }
        sort(all(car), [&](pii c1, pii c2) {
            int v1 = c1.first, v2 = c2.first;
            return tin[v1] < tin[v2];
        });
        stack<int> s;
        vector<int> look;
        for (auto &[v, w]: car) {
            int last = -1;
            while (!s.empty() && !anc(s.top(), v)) {
                look.push_back(s.top());
                last = s.top();
                s.pop();
            }
            if (last != -1) s.push(lca(last, v));
            s.push(v);
        }
        while (!s.empty()) look.push_back(s.top()), s.pop();
        ans = 0;
        for (int v: look) ans = max(ans, getv(v));
        cout << ans << '\n';
        for (auto &[v, w]: car) upd(tin[v], -w);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}