#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <deque>
#include <algorithm>
//#include <bits/stdc++.h>

using namespace std;
#define int long long
using ll = long long;
int inf_ = 1e18 + 7;

struct Fast {
	void solve() {
		int n;
		cin >> n;
		vector<int>a(n), b(n), c(n), d(n);
		for (auto& i : a) cin >> i;
		for (auto& i : b) cin >> i;
		for (auto& i : c) cin >> i;
		for (auto& i : d) cin >> i;
		vector<vector<int>> dp(n + 1, vector<int>(2, inf_));
		dp[0][0] = 0;
		for (int i = 0; i < n; i++) {
			if (a[i] != 0) {
				dp[i + 1] = dp[i];
				continue;
			}
			if (dp[i][0] != inf_) {
				dp[i + 1][0] = dp[i][0] + c[i];
				dp[i + 1][1] = dp[i][0] + d[i];
			}
			if (dp[i][1] != inf_) {
				dp[i + 1][0] = min(dp[i + 1][0], dp[i][1] + d[i]);
				dp[i + 1][1] = min(dp[i + 1][1], dp[i][1] + c[i]);
			}
		}
		int cnt = 0;
		for (auto i : a) cnt += (i < 0);
		int mn_p = inf_, mn_o = inf_;
		for (int i = 0; i < n; i++) {
			if (a[i] < 0) {
				int l = (abs(a[i]) / b[i] + 1) * c[i];
				mn_o = min(mn_o, l);
			}
			if (a[i] > 0) {
				int l = (abs(a[i]) / b[i] + 1) * d[i];
				mn_p = min(mn_p, l);
			}
		}
		int ans = inf_;
		if (cnt % 2 == 0) {
			ans = min({ ans, dp.back()[0], dp.back()[1] + mn_o, dp.back()[1] + mn_p });
		}
		else {
			ans = min({ ans, dp.back()[1], dp.back()[0] + mn_o, dp.back()[0] + mn_p });
		}
		cout << ans;
	}
};

signed main() {
	int __ = 1;
	//cin >> __;
	while (__--) {
		auto s1 = Fast();
		s1.solve();
	}
	return 0;
}
