#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <deque>
#include <algorithm>
//#include <bits/stdc++.h>

using namespace std;
#define int long long
using ll = long long;
int inf_ = 1e18 + 7;

struct Fast {
	void solve() {
		int n, m;
		cin >> n >> m;
		vector<int> a(n);
		for (auto& i : a) cin >> i, i--;
		vector<vector<int>> c(m, vector<int>(m));
		for (auto& i : c) for (auto& j : i) cin >> j;
		vector<int> cnt(m);
		for (auto i : a) cnt[i]++;
		vector<vector<int>> b;
		set<int> s, t;
		for (int i = 0; i < n; i++) {
			if (s.find(a[i]) != s.end()) {
				cnt[a[i]]--;
				if (cnt[a[i]] == 0) s.erase(a[i]);
			}
			else {
				t.insert(a[i]);
				s.insert(a[i]);
				cnt[a[i]]--;
				if (cnt[a[i]] == 0) s.erase(a[i]);
			}
			if (s.empty()) {
				b.emplace_back();
				for (auto j : t) b.back().push_back(j);
				t.clear();
			}
		}
		n = b.size();
		vector<vector<int>> dp(2, vector<int>(m));
		for (int i = 0; i < n; i++) {
			for (int clr = 0; clr < m; clr++) {
				int sum = 0;
				for (auto x : b[i]) sum += c[x][clr];
				dp[1][clr] = (i ? dp[0][clr] : 0) + sum;
				dp[1][clr] = min(dp[1][clr], (clr ? dp[1][clr - 1] : inf_));
			}
			swap(dp[0], dp[1]);
		}
		cout << dp[0][m - 1];
	}
};

signed main() {
	int __ = 1;
	//cin >> __;
	while (__--) {
		auto s1 = Fast();
		s1.solve();
	}
	return 0;
}