#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <deque>
#include <algorithm>
//#include <bits/stdc++.h>

using namespace std;
#define int long long
using ll = long long;
int inf_ = 1e18 + 7;

struct Fast {
	int n, ans = -inf_;
	vector<vector<int>> g;
	vector<int> s;
	pair<int, int> dfs(int v, int pr, int h) {
		pair<int, int> sm = { s[v] * (h + 2), s[v] };
		for (auto u : g[v]) {
			if (u == pr) continue;
			auto t = dfs(u, v, h + 1);
			sm.first += t.first;
			sm.second += t.second;
		}
		sm.first -= sm.second;
		ans = max(ans, sm.first);
		return sm;
	}
	void solve() {
		cin >> n;
		g.resize(n);
		for (int i = 0; i < n - 1; i++) {
			int x, y;
			cin >> x >> y;
			x--;
			y--;
			g[x].push_back(y);
			g[y].push_back(x);
		}
		int q, t;
		cin >> q >> t;
		while (q--) {
			int k;
			cin >> k;
			s.assign(n, 0);
			for (int i = 0; i < k; i++) {
				int x, c;
				cin >> x >> c;
				x--;
				s[x] = c;
			}
			ans = -inf_;
			dfs(0, -1, 0);
			cout << ans << '\n';
		}
	}
};

signed main() {
	int __ = 1;
	//cin >> __;
	while (__--) {
		auto s1 = Fast();
		s1.solve();
	}
	return 0;
}