#include <bits/stdc++.h>

using namespace std;

//@formatter:off
using ll = long long;
template<typename T> istream &operator>>(istream &is, vector<T> &a);
template<typename T> ostream &operator<<(ostream &os, vector<T> &a);
//@formatter:on

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll A, B, n, m;
    cin >> A >> B >> n >> m;

    if (2ll * n == m){
        cout << n << " " << 0 << "\n";
        return 0;
    }
    if ((B - 2ll * A) == 0){
        cout << -1 << "\n";
        return 0;
    }

    ll y = (m - 2ll * n) / (B - 2ll * A);
    ll x = n - A * y;

    if (x + A * y == n && 2ll * x + B * y == m && x >= 0 && y >= 0){
        cout << x << " " << y << "\n";
    } else {
        cout << -1 << "\n";
    }
}

// region POZOR
template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (int i = 0; i < a.size(); i++)
        os << a[i] << " \n"[i == a.size() - 1];
    return os;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a)
        is >> i;
    return is;
}
// endregion