#include <bits/stdc++.h>

using namespace std;

//@formatter:off
using ll = long long;
template<typename T> istream &operator>>(istream &is, vector<T> &a);
template<typename T> ostream &operator<<(ostream &os, vector<T> &a);
//@formatter:on

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll n;
    cin >> n;

    vector<ll> a(n), b(n), c(n), d(n);
    cin >> a >> b >> c >> d;

    int pw = 1;
    for (int i = 0; i < n; ++i) {
        if (a[i] < 0) pw *= -1;
    }
    int cnt0 = std::count(a.begin(), a.end(),0);
    if (cnt0 == 0){
        if (pw==1)cout<<0 << "\n";
        else {
            ll best = 1e18;
            for (int i = 0; i < n; ++i) {
                if (n > 1 && a[i] > 0){
                    best = min(best, (abs(a[i])/b[i] + 1) * d[i]);
                }
                if (a[i] < 0){
                    best = min(best, (abs(a[i])/b[i] + 1) * c[i]);
                }
            }
            cout << best << "\n";
        }
        return 0;
    }

    ll cost = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] == 0) cost += c[i];
    }
    cout << cost << "\n";
}

// region POZOR
template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (int i = 0; i < a.size(); i++)
        os << a[i] << " \n"[i == a.size() - 1];
    return os;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a)
        is >> i;
    return is;
}
// endregion