#include <bits/stdc++.h>

using namespace std;

//@formatter:off
using ll = long long;
template<typename T> istream &operator>>(istream &is, vector<T> &a);
template<typename T> ostream &operator<<(ostream &os, vector<T> &a);
//@formatter:on

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll n;
    cin >> n;

    vector<ll> a(n);
    cin >> a;

    vector<ll> best(n, 1e18);
    for (ll mask = 0; mask < (1<<(n - 1)); ++mask) {
        int good = 0;
        vector<int> fix(n - 1);
        for (int i = 0; i < n; ++i) {
            if ((mask >> i) & 1) fix[i] = true;
        }

        ll cnt = 0;
        vector<ll> aa = a;
        for (int i = 1; i < n; ++i) {
            if ((aa[i] + aa[i - 1] > 0) || !fix[i - 1]) continue;
            else cnt += -(aa[i] + aa[i - 1]) + 1, aa[i] += -(aa[i] + aa[i - 1]) + 1;
        }

        for (int i = 1; i < n; ++i) {
            good += aa[i] + aa[i - 1] > 0;
        }
        ll bad = n - good - 1;
        for (ll i = bad; i < n; ++i) {
            best[i] = min(best[i], cnt);
        }
    }

    cout << best;
}

// region POZOR
template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (int i = 0; i < a.size(); i++)
        os << a[i] << " \n"[i == a.size() - 1];
    return os;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a)
        is >> i;
    return is;
}
// endregion