#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <cmath>
#include <complex>

using namespace std;

using ll = long long;
using ld = long double;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-7;

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll a, b, n, m;
    cin >> a >> b >> n >> m;

    if (b == 2 * a) {
        if (m == 2 * n) {
            ll y = 0;
            ll x = n - a * y;

            if (x >= 0 && y >= 0) {
                cout << x << " " << y;
            } else {
                cout << -1;
            }
        } else {
            cout << -1;
        }
    } else {
        if ((m - 2 * n) % (b - 2 * a) == 0) {
            ll y = (m - 2 * n) / (b - 2 * a);
            ll x = n - a * y;

            if (x >= 0 && y >= 0) {
                cout << x << " " << y;
            } else {
                cout << -1;
            }
        } else {
            cout << -1;
        }
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}