#include <bits/stdc++.h>

using namespace std;

#ifndef LOCAL
#pragma GCC optimize("unroll-loops,O3")
// #pragma GCC target("avx2")
#endif

#define int long long
#define pint pair<int, int>
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

template<class T>
bool cmax(T& a, T b) {
    if (a >= b) return false;
    a = b;
    return true;
}

template<class T>
bool cmin(T& a, T b) {
    if (a <= b) return false;
    a = b;
    return true;
}

vector<int> prost;

inline void solve(int n, int m) {
    if (n == 1) {
	cout << "1\n1\n1\n";
	return;
    }
    for (auto& pr : prost) {
        int s = n * (n + 1) / 2 - pr;
        if (s < 0) continue;
        bool good = false;
        for (auto &x: prost) {
            if (x > s) break;
            if (s % x) continue;
            int left = s / x;
            int z = sqrt(left);
            if (z * z == left) {
                good = true;
                break;
            }
        }
        if (good) {
            cout << "2\n";
	    if (pr <= n) {
		cout << "1\n" << pr << endl;
 		cout << n - 1 << endl;
		for (int i = 1; i <= n; ++i) {
			if (i != pr) cout << i << ' ';
		}
	    } else {
		vector<int> nums;
		int now = n;
		while (pr > now) {
			nums.push_back(now);
			pr -= now;
			now--;
		}
		nums.push_back(pr);
		reverse(all(nums));
		cout << nums.size() << endl;
		for (auto& el : nums) cout << el << ' ';
		cout << endl;
		cout << n - nums.size() << endl;
		for (int i = 1; i <= n; ++i) {
			auto it = lower_bound(all(nums), i);
			if (it != nums.end() && *it == i) continue;
			cout << i << ' ';
		}
	    }
	    return;
        }
    }
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    prost.reserve(10000);
    for (int i = 1; i <= 1e5; ++i) {
        bool any = false;
        for (int j = 2; j * j <= i; ++j) {
            any |= i % j == 0;
        }
        if (!any) prost.push_back(i);
    }
    int ttt = 1;
//    cin >> ttt;
    while (ttt--) {
        int n, m;
	cin >> n >> m;
	solve(n, m);
    }

    return 0;
}