#include <bits/stdc++.h>

using namespace std;

#ifndef LOCAL
#pragma GCC optimize("unroll-loops,O3")
// #pragma GCC target("avx2")
#endif

#define int long long
#define pint pair<int, int>
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

template<class T>
bool cmax(T& a, T b) {
    if (a >= b) return false;
    a = b;
    return true;
}

template<class T>
bool cmin(T& a, T b) {
    if (a <= b) return false;
    a = b;
    return true;
}

inline void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> v(n);
    for (auto& el : v) cin >> el, el--;
    vector<vector<int>> cost(m, vector<int>(m));
    for (auto& u : cost) for (auto& el : u) cin >> el;
    vector<int> c;
    for (auto& el : v) {
        if (c.empty() || c.back() != el) {
            c.push_back(el);
        }
    }
    n = c.size();
    v = std::move(c);
    vector<pint> lr(m, {1e9, -1});
    for (int i = 0; i < n; ++i) {
        cmin(lr[v[i]].first, i);
        cmax(lr[v[i]].second, i);
    }
    int C = 0;
    vector<pint> t;
    for (int i = 0; i < m; ++i) {
        if (lr[i].second == -1) continue;
        t.emplace_back(lr[i].first, i);
        t.emplace_back(lr[i].second, i);
    }
    vector<vector<int>> comp;
    sort(all(t));
    vector<char> used(m);
    for (auto& [pos, col] : t) {
        if (C == 0) comp.emplace_back();
        if (!used[col]) {
            C++;
            comp.back().push_back(col);
            used[col] = 1;
        } else {
            C--;
            used[col] = 0;
        }
    }
    int k = comp.size();
    vector<vector<int>> dp(k, vector<int>(m, 0));
    for (int to = 0; to < m; ++to) {
        for (auto& col : comp[0]) {
            dp[0][to] += cost[col][to];
        }
    }
    for (int i = 1; i < k; ++i) {
        int mn = 1e18;
        for (int to = 0; to < m; ++to) {
            cmin(mn, dp[i - 1][to]);
            dp[i][to] = mn;
            for (auto& col : comp[i]) {
                dp[i][to] += cost[col][to];
            }
        }
    }
    int mn = 1e18;
    for (int to = 0; to < m; ++to) {
        cmin(mn, dp.back()[to]);
    }
    cout << mn << endl;
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
//    cin >> ttt;
    while (ttt--) {
        solve();
    }

    return 0;
}