#include <bits/stdc++.h>

using namespace std;

#ifndef LOCAL
#pragma GCC optimize("unroll-loops,O3")
// #pragma GCC target("avx2")
#endif

#define int long long
#define pint pair<int, int>
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

template<class T>
bool cmax(T& a, T b) {
    if (a >= b) return false;
    a = b;
    return true;
}

template<class T>
bool cmin(T& a, T b) {
    if (a <= b) return false;
    a = b;
    return true;
}

vector<vector<int>> graph;
vector<int> p, sum, d;

void dfs(int v, int par) {
    p[v] = par;
    d[v] = d[par] + 1;
    sum[v] = 0;
    for (auto& to : graph[v]) {
        if (to != par) {
            dfs(to, v);
        }
    }
}

inline void solve() {
    int n;
    cin >> n;
    graph.resize(n);
    p.resize(n);
    d.resize(n);
    sum.resize(n);
    d[0] = -1;
    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    dfs(0, 0);
    int q, t;
    cin >> q >> t;
    int last = 0;

    while (q--) {
        int k;
        cin >> k;
        while (k--) {
            int a, b;
            cin >> a >> b;
            if (t == 1) a--;
            else a = (a + last) % (n - 1) + 1;
            while (p[a] != a) {
                sum[a] += b;
                a = p[a];
            }
            sum[a] += b;
        }
        int best = 0;
        for (int i = 0; i < n; ++i) {
            cmax(best, (d[i] + 1) * sum[i]);
        }
        cout << best << endl;
        fill(all(sum), 0);
        last = best;
    }
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
//    cin >> ttt;
    while (ttt--) {
        solve();
    }

    return 0;
}