#include <assert.h>

#include <algorithm>
#include <deque>
#include <iostream>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll INF = 1e18;
const ll mod = 1e9 + 7;
const char sep = ' ';

template <typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (ll i = 0; i < (ll)arr.size(); ++i) {
        in >> arr[i];
    }
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, vector<T>& arr) {
    for (auto el : arr) {
        out << el << sep;
    }
    return out;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> ans;
    ll i = 2;
    while (i <= 2 * n) {
        ans.emplace_back();
        for (ll j = 1; j <= n; ++j) {
            if ((j % i) * 2 == i) {
                ans.back().push_back(j);
            }
        }
        i *= 2;
    }
    cout << ans.size() << '\n';
    for (auto el : ans) {
        cout << el.size() << '\n' << el << '\n';
    }
}