#include <assert.h>

#include <algorithm>
#include <deque>
#include <iostream>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll INF = 1e18;
const ll mod = 1e9 + 7;
const char sep = ' ';

template <typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (ll i = 0; i < (ll)arr.size(); ++i) {
        in >> arr[i];
    }
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, vector<T>& arr) {
    for (auto el : arr) {
        out << el << sep;
    }
    return out;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n;
    cin >> n;
    vector<ll> arr(n), dp(n);
    cin >> arr;
    ll bad = 0;
    for (ll i = 0; i + 1 < n; ++i) {
        if (arr[i] + arr[i + 1] <= 0) {
            ++bad;
        }
    }
    for (ll i = bad; i < n; ++i) {
        dp[i] = 0;
    }
    for (ll i = bad - 1; i >= 0; --i) {
        ll cur = 0;
        for (ll i = 0; i + 1 < n; ++i) {
            if (arr[i] + arr[i + 1] <= 0) {
                ++cur;
            }
        }
        bool flag = false;
        for (ll j = cur; j < i; ++j) {
            dp[j] = dp[i + 1];
            flag = true;
        }
        if (flag) continue;
        ll res = INF, ind = -1;
        for (ll j = 1; j + 1 < n; ++j) {
            if (arr[j - 1] + arr[j] <= 0) {
                if (abs(arr[j - 1] + arr[j]) + 1 < res) {
                    res = abs(arr[j - 1] + arr[j]) + 1;
                    ind = j;
                }
            }
            if (arr[j + 1] + arr[j] <= 0) {
                if (abs(arr[j + 1] + arr[j]) + 1 < res) {
                    res = abs(arr[j + 1] + arr[j]) + 1;
                    ind = j;
                }
            }
        }
        dp[i] = dp[i + 1] + res;
        arr[ind] += res;
    }
    cout << dp;
}