#include <bits/stdc++.h>
#define pb push_back

using namespace std;
using ll = long long;
using vi = vector<ll>;
using ld = long double;
using pi = pair<ll, ll>;

ll sgn(ll x) {
    if (x > 0) return 1;
    else if (x < 0) return -1;
    else return 0;
}

const ll INF = 1e18 + 2;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n;
    cin >> n;

    vi a(n), b(n), c(n), d(n), wasZero(n);

    for (ll i = 0; i < n; ++i) cin >> a[i];
    for (ll i = 0; i < n; ++i) cin >> b[i];
    for (ll i = 0; i < n; ++i) cin >> c[i];
    for (ll i = 0; i < n; ++i) cin >> d[i];
    for (int i = 0; i < n; ++i) wasZero[i] = (a[i] == 0);

    ll pr = 1;
    ll pr2 = 1;
    vi idx;
    for (ll i = 0; i < n; ++i) {
        pr *= sgn(a[i]);
        if (a[i] != 0) pr2 *= sgn(a[i]);
        else idx.pb(i);
    }

    if (pr == 0) {
        ll total = 0;
        for (int i = 0; i < n; ++i) {
            if (wasZero[i]) {
                if (c[i] <= d[i]) {
                    a[i] += b[i];
                    total += c[i];
                } else {
                    a[i] -= b[i];
                    total += d[i];
                }
            }
        }
        int prn = 1;
        for (int i = 0; i < n; ++i) prn *= sgn(a[i]);
        if (prn > 0) {
            cout << total;
        } else {
            ll mn = INF;
            for (int i = 0; i < n; ++i) {
                if (wasZero[i]) {
                    if (a[i] > 0) {
                        mn = min(mn, d[i] - c[i]);
                    } else {
                        mn = min(mn, c[i] - d[i]);
                    }
                } else {
                    if (a[i] > 0) {
                        ll need = a[i] / b[i] + 1;
                        mn = min(mn, d[i] * need);
                    } else {
                        ll need = abs(a[i]) / b[i] + 1;
                        mn = min(need * c[i], mn);
                    }
                }
            }
            cout << total + mn;
        }
    } else if (pr == 1) {
        cout << 0;
    } else {
        ll mn = INF;
        for (ll i = 0; i < n; ++i) {
            if (a[i] > 0) {
                ll need = a[i] / b[i] + 1;
                mn = min(need * d[i], mn);
            } else {
                ll need = abs(a[i]) / b[i] + 1;
                mn = min(need * c[i], mn);
            }
        }
        cout << mn;
    }

    return 0;
}