#include <bits/stdc++.h>
#define pb push_back

using namespace std;
using ll = long long;
using vi = vector<int>;
using ld = long double;
using pi = pair<int, int>;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    int logn = log2(n) + 1;

    vector<vi> opers(logn + 1);

    for (int i = 1; i <= n; ++i) {
        int l = 0;
        int r = logn + 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (i % (1 << mid) == 0) l = mid;
            else r = mid;
        }
        //cout << "i " << i << " " << l << endl;
        opers[l].pb(i);
    }

    int last = 0;

    for (int i = 0; i < logn + 1; ++i) {
        if (opers[i].size() == 0) {
            last = i - 1;
            break;
        }
    }   

    cout << last + 1 << endl;
    for (int i = 0; i <= last; ++i) {
        cout << opers[i].size() << endl;
        for (auto x : opers[i]) {
            cout << x << ' ';
        }
        cout << endl;
    }

    return 0;
}