﻿#include <iostream>
#include <vector>
#include <set>

using namespace std;

using ll = long long;

vector<int> p, sz;

int pr(int x) {
	if (p[x] == -1) return x;
	return p[x] = pr(p[x]);
}

void obed(int a, int b) {
	a = pr(a);
	b = pr(b);
	if (a == b) return;
	if (sz[a] < sz[b]) swap(a, b);
	sz[a] += sz[b];
	p[b] = a;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	ll n, m;
	cin >> n >> m;
	vector<int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	vector<vector<ll>>b(m, vector<ll>(m));
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < m; j++) {
			cin >> b[i][j];
		}
	}
	p.resize(m, -1);
	sz.resize(m, 1);
	set<int> X;
	vector<set<int>> y;
	vector<pair<int, int>> fl(m, { 1e9, -1e9 });
	for (int i = 0; i < n; i++) {
		fl[a[i] - 1].first = min(fl[a[i] - 1].first, i);
		fl[a[i] - 1].second = max(fl[a[i] - 1].second, i);
	}
	vector<int> ev(n);
	for (int i = 0; i < m; i++) {
		if (fl[i].second < 0) continue;
		ev[fl[i].first] = 1;
		ev[fl[i].second] = -1;
		if (fl[i].first == fl[i].second) ev[fl[i].first] = 10;
	}
	for (int i = 0; i < n; i++) {
		if (!ev[i]) continue;
		if (ev[i] == 10) {
			if (!int(X.size())) {
				X.insert(a[i] - 1);
				y.push_back({ a[i] - 1 });
			}
			else {
				X.insert(a[i] - 1);
				obed(a[i] - 1, pr(*X.begin()));
				y.back().insert(a[i] - 1);
			}
			X.erase(a[i] - 1);
			continue;
		}
		if (ev[i] == -1) {
			X.erase(a[i] - 1);
			continue;
		}
		if (!int(X.size())) {
			X.insert(a[i] - 1);
			y.push_back({ a[i] - 1 });
			continue;
		}
		X.insert(a[i] - 1);
		obed(a[i] - 1, pr(*X.begin()));
		y.back().insert(a[i] - 1);
	}
	int N = int(y.size());
	vector<vector<ll>> dp(N+1, vector<ll>(m));
	for (int i = 1; i <= N; i++) {
		ll mi = 1e18;
		for (int j = 0; j < m; j++) {
			mi = min(mi, dp[i - 1][j]);
			ll an = 0;
			for (int xx : y[i - 1]) an += b[xx][j];
			dp[i][j] = mi + an;
		}
	}
	ll mi = 1e18;
	for (int i = 0; i < m; i++) mi = min(mi, dp[N][i]);
	cout << mi;
}


