﻿#include <iostream>
#include <vector>
#include <set>

using namespace std;

using ll = long long;

ll foo(string& s) {
	ll an = 0;
	for (char c : s) {
		an *= 2;
		if (c == '1') an++;
	}
	return an;
}

void ans(vector<string>& a, vector<ll>& g) {
	ll x = 0;
	for (string s : a) {
		x ^= g[foo(s)];
	}
	if (x) cout << "First\n";
	else cout << "Second\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	vector<ll> g(1e6);
	g[0] = 0;
	for (int i = 1; i < 1e6; i++) {
		vector<int> a(4);
		if (i % 2) {
			a[g[i - 1]] = 1;
			a[g[i / 2]] = 1;
		}
		else {
			a[g[i - 1]] = 1;
		}
		for (int j = 0; j < 4; j++) {
			if (!a[j]) {
				g[i] = j;
				break;
			}
		}
	}
	int n, q;
	cin >> n >> q;
	vector<string> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	ans(a, g);
	while (q--) {
		int L, R;
		cin >> L >> R;
		L--;
		int cnt = 0;
		for (int i = 0; i < n; i++) {
			string S = "";
			for (int j = 0; j<int(a[i].size()); j++) {
				if (j + cnt >= R || j + cnt < L) {
					S += a[i][j];
				}
				else {
					if (a[i][j] == '0') S += '1';
					else S += '0';
				}
			}
			a[i] = S;
			cnt += int(a[i].size());
		}
		ans(a, g);
	}
}


