#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define pb push_back
#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using pii = pair<int, int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int OO = 1e18;

void solve() {
    int n;
    cin >> n;
    vec<int> a(n + 1), b(n + 1), c(n + 1), d(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> b[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> c[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> d[i];
    }

    vec<vec<int>> dp(n + 1, vec<int>(2, OO));
    dp[0][0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int p = 0; p <= 1; p++) {
            int ls = (a[i] < 0 ? 0 : (a[i] / b[i] + 1) * d[i]);
            int bg = (a[i] > 0 ? 0 : (-a[i] / b[i] + 1) * c[i]);

            dp[i][p] = min(dp[i][p], dp[i - 1][p] + bg);
            dp[i][p ^ 1] = min(dp[i][p ^ 1], dp[i - 1][p] + ls);
        }
    }

    cout << dp[n][0];
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}