#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define pb push_back
#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)x.size()

using pii = pair<int, int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int OO = 1e18;

bool check(int x) {
    if (!x) return true;

    int cnt = 0;
    for (int div = 2; div * div <= x; div++) {
        int c = 0;
        while (x % div == 0) {
            x /= div;
            c++;
        }

        if (c & 1) cnt++;
    }
    if (x > 1) cnt++;

    return cnt <= 1;
}

void solve() {
    int n, m;
    cin >> n >> m;

    int sum = n * (n + 1) / 2;
    vec<vec<int>> res;
    for (int x = 1; x <= sum; x++) {
        if (check(x) && check(sum - x)) {
            vec<bool> used(n + 1);
            res.pb({});
            for (int i = n; i >= 1; i--) {
                if (i <= x) {
                    x -= i;
                    used[i] = true;
                    res.back().pb(i);
                }
            }

            for (int i = 1; i <= n; i++) {
                if (!used[i]) {
                    if (sz(res) < 2) {
                        res.pb({});
                    }
                    res.back().pb(i);
                }
            }

            break;
        }
    }

    cout << sz(res) << '\n';
    for (auto &x : res) {
        cout << sz(x) << '\n';
        for (auto &y : x) {
            cout << y << ' ';
        }
        cout << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}