#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define pb push_back
#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)x.size()

using pii = pair<int, int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int OO = 1e18;

void solve() {
    int n, m;
    cin >> n >> m;
    vec<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    vec<vec<int>> cost(m + 1, vec<int>(m + 1));
    for (int i = 1; i <= m; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> cost[i][j];
        }
    }

    vec<vec<int>> dp(n + 1, vec<int>(m + 1, OO));
    dp[0][0] = 0;
    for (int i = 1; i <= n; i++) {
        int mn = dp[i - 1][0];
        for (int j = 1; j <= m; j++) {
            mn = min(mn, dp[i - 1][j]);
            dp[i][j] = min(dp[i][j], mn + cost[a[i]][j]);
        }
    }

    cout << *min_element(all(dp[n]));
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}