#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define rep1(i, n) for(int i = 1; i <= (n); ++i)

using namespace std;
using i64 = long long;

mt19937 rd(chrono::steady_clock::now().time_since_epoch().count());

constexpr int N = 1e5 + 10;
int a[N], b[N], c[N], d[N];

void solve(){
	int n;
	cin >> n;
	int x = 0;
	i64 cost = 0;
	rep(i, n) cin >> a[i];
	rep(i, n) cin >> b[i];
	rep(i, n) cin >> c[i];
	rep(i, n) cin >> d[i];
	rep(i, n){
		if(a[i] < 0) x ^= 1;
		else if(a[i] == 0){
			if(c[i] > d[i]) x ^= 1, cost += d[i];
			else cost += c[i];
		}
	}
	if(x == 0){
		cout << cost;
		return;
	}
	i64 ans = LLONG_MAX;
	rep(i, n){
		if(a[i] > 0){
			i64 x = (a[i] + 1 + b[i] - 1) / b[i];
			ans = min(ans, cost + x * d[i]);
		}else if(a[i] < 0){
			i64 x = (abs(a[i]) + 1 + b[i] - 1) / b[i];
			ans = min(ans, cost + x * c[i]);
		}else if(a[i] == 0){
			if(c[i] > d[i]){
				ans = min(ans, cost - d[i] + c[i]);
			}else{
				ans = min(ans, cost - c[i] + d[i]);
			}
		}
	}
	cout << ans;
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef requiem
	freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);
#endif
	int tt = 1;
	// cin >> tt;
	while(tt--) solve();
	// cerr << fixed << 1.0 * clock() / CLOCKS_PER_SEC;
	return 0;
}