//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops", "omit-frame-poller", "inline")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,avx2,fma,tune=native")

#include <bits/stdc++.h>

#define int long long
#define ld long double
#define F first
#define S second
using namespace std;
const int mod = 1e9 + 7;
const int inf = 1e18;
vector<vector<int>> g, rg, ng;
vector<int> top;
vector<bool> used;

void tops(int v) {
    used[v] = 1;
    for (int i : g[v]) {
        if (!used[i]) {
            tops(i);
        }
    }
    top.push_back(v);
}

void tops1(int v) {
    used[v] = 1;
    for (int i : ng[v]) {
        if (!used[i]) {
            tops1(i);
        }
    }
    top.push_back(v);
}

vector<int> cmp;
int C = 0;

void dfs(int v) {
    cmp[v] = C;
    for (int i : rg[v]) {
        if (cmp[i] == -1) {
            dfs(i);
        }
    }
}

signed main() {
    //freopen("penguins.in", "r", stdin);
    //freopen("penguins.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    g.resize(m);
    rg.resize(m);
    used.resize(m);
    cmp.resize(m, -1);
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }
    for (int i = 0; i < n - 1; ++i) {
        if (a[i] != a[i + 1]) {
            g[a[i]].push_back(a[i + 1]);
            rg[a[i + 1]].push_back(a[i]);
        }
    }
    for (int i = 0; i < m; ++i) {
        if (!used[i]) {
            tops(i);
        }
    }
    reverse(top.begin(), top.end());
    for (int i:top) {
        if (cmp[i] == -1) {
            dfs(i);
            C++;
        }
    }
    ng.resize(C);
    vector<int> in(C), out(C);
    for (int i = 0; i < m; ++i) {
        for (int j : g[i]) {
            if (cmp[j] != cmp[i]) {
                ng[cmp[i]].push_back(cmp[j]);
                in[cmp[j]]++;
                out[cmp[i]]++;
            }
        }
    }
    used.assign(C, 0);
    top.clear();
    for (int i = 0; i < C; ++i) {
        if (!used[i]) {
            tops1(i);
        }
    }
    reverse(top.begin(), top.end());
    vector<vector<int>> cost(m, vector<int>(m));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> cost[i][j];
        }
    }
    vector<vector<int>> gr(C);
    for (int i = 0; i < m; ++i) {
        gr[cmp[i]].push_back(i);
    }
    a.clear();
    for (int i : top) {
        if (in[i] == 0 && out[i] == 0 && gr[i].size() == 1) {
            continue;
        }
        a.push_back(i);
    }
    vector<int> dp(m);
    for (int i = 0; i < m; ++i) {
        int p = 0;
        for (int h : gr[a[0]]) {
            p += cost[h][i];
        }
        dp[i] = p;
    }
    vector<int> prefmn(m);
    prefmn[0] = dp[0];
    for (int i = 1; i < m; ++i) {
        prefmn[i] = min(prefmn[i - 1], dp[i]);
    }
    for (int i = 1; i < a.size(); ++i) {
        for (int j = 0; j < m; ++j) {
            int p = 0;
            for (int h : gr[a[i]]) {
                p += cost[h][j];
            }
            dp[j] = prefmn[j] + p;
        }
        prefmn[0] = dp[0];
        for (int j = 1; j < m; ++j) {
            prefmn[j] = min(prefmn[j - 1], dp[j]);
        }
    }
    cout << prefmn.back();
    return 0;
}