//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops", "omit-frame-poller", "inline")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,avx2,fma,tune=native")

#include <bits/stdc++.h>

#define int long long
#define ld long double
#define F first
#define S second
using namespace std;
const int mod = 1e9 + 7;
const int inf = 1e18;
int n;
vector<vector<int>> g;
vector<int> dist;
vector<int> pred;

void dfs(int v, int p) {
    for (int i : g[v]) {
        if (i == p) {
            continue;
        }
        dist[i] = dist[v] + 1;
        pred[i] = v;
        dfs(i, v);
    }
}

signed main() {
    //freopen("penguins.in", "r", stdin);
    //freopen("penguins.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    g.resize(n);
    dist.resize(n);
    pred.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    dfs(0, -1);
    int q, t;
    cin >> q >> t;
    while (q--) {
        int k;
        cin >> k;
        vector<int> cnt(n);
        for (int i = 0; i < k; ++i) {
            int v, c;
            cin >> v >> c;
            v--;
            while (v != 0) {
                cnt[v] += (dist[v] + 1) * c;
                v = pred[v];
            }
            cnt[0] += c;
        }
        int mx = 0;
        for (int i = 0; i < n; ++i) {
            mx = max(mx, cnt[i]);
        }
        cout << mx << '\n';
    }
    return 0;
}