#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
#define  int long long
const int N = 3e5 + 1;
const int mod = 1e9 + 7;

template<typename T>
bool umx(T& a, T b) {
    return (a < b ? a = b, 1 : 0);
}
template<typename T>
bool umn(T& a, T b) {
    return (a > b ? a = b, 1 : 0);
}

mt19937_64 rng(time(0));

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //    freopen ("input.txt", "r", stdin);
//    freopen ("output.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int k = 0; k < n; ++k) {
        cin >> a[k];
    }

    vector<int> ve;
    vector<vector<pair<int,ll>>> weights;
    for (int i = 0; i < n - 1; ++i) ve.push_back(a[i] + a[i + 1]);
    for (int i = 0; i < n - 1; ++i) {
        if (ve[i] > 0) continue;
        int j = i;
        while (j < n - 1 && ve[j] <= 0) ++j;
        vector<int> p;
        for (int l = i; l < j; ++l) p.push_back(ve[l]);
        vector<int> was = p;
        vector<vector<ll>> dp((int)p.size() + 22, vector<ll>((int)p.size() + 22, 1e18));
        vector<vector<ll>> cost ((int)p.size() + 22, vector<ll>((int)p.size() + 22));
        for (int l = 0; l < (int)p.size(); ++l) {
            int last = 0;
            for (int len = 1; len <= (int)p.size() - l; ++len) {
                if (len == 1) {
                    cost[l][len] = (-p[l]) + 1;
                    last = (-p[l]) + 1;
                }
                else {
                    int nw = p[l + len - 1] + last;
                    if (nw <= 0) {
                        cost[l][len] = cost[l][len - 1] + (-nw) + 1;
                        last = (-nw) + 1;
                    }
                    else {
                        cost[l][len] = cost[l][len - 1];
                        last = 0;
                    }
                }
            }
        }
        dp[0][0] = 0;
        for (int maink = 0; maink <= p.size(); ++maink) {
            for (int l = 0; l < (int)p.size(); ++l) {
                umn(dp[l + 1][maink], dp[l][maink]);
                for (int len = 1; len <= (int)p.size() - l; ++len) {
                    if (maink + len > p.size()) break;
                    umn (dp[l + len][maink + len], dp[l][maink] + cost[l][len]);
                }
            }
        }
        vector<pair<int,ll>>v;
        for (int f = 0; f <= (int)p.size(); ++f) {
            if (dp[p.size()][f] != 1e18) v.push_back({f, dp[p.size()][f]});
        }
        weights.push_back(v);
        i = j - 1;
    }
    vector<vector<ll>> bag(weights.size() + 2, vector<ll>(n + 2, 1e18));
    bag[0][0] = 0;
    for (int i = 0; i < (int)weights.size(); ++i) {
        for (int w = 0; w <= n; ++w) {
            umn(bag[i + 1][w], bag[i][w]);
            for (auto [add, cost] : weights[i]) {
                if (w + add <= n) umn(bag[i + 1][w + add], bag[i][w] + cost);
            }
        }
    }

    for (int k = 0; k < n; ++k) {
        int cnt = 0;
        for (int i = 0; i < n - 1; ++i) {
            if (a[i] + a[i + 1] <= 0) ++cnt;
        }
        if (cnt <= k) {
            cout << "0 ";
            continue;
        }
        int need = cnt - k;
        if (bag[(int)weights.size()][need] == 1e18) assert(0);
        cout << bag[(int)weights.size()][need] << ' ';
    }
    return 0;
}