#include <iostream>
#include <vector>

using namespace std;


#define int long long
#define sz(v) (int)v.size()

typedef pair<int, int> pii;

void solve() {
    int n, m;
    cin >> n >> m;
    if (n == 1) {
        cout << "1\n1\n1";
        return;
    }
    vector<vector<int>> groups(20);
    vector<int> used(n + 1);
    for (int i = 0; i < sz(groups); i++)
        for (int j = 1; j <= n; j++)
            if (!used[j] && j / (1 << i) % 2 != 0) {
                groups[i].push_back(j);
                used[j] = 1;
            }

    int ans = 0;
    for (int i = 0; i < sz(groups); i++)
        if (sz(groups[i]))
            ans++;
    cout << ans << "\n";
    for (int i = 0; i < sz(groups); i++)
        if (sz(groups[i])) {
            cout << sz(groups[i]) << "\n";
            for (int u : groups[i])
                cout << u << " ";
            cout << "\n";
        }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr)->sync_with_stdio(false);
    solve();
}