#define _CRT_SECURE_NO_WARNINGS


//#define _DEBUG


#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <utility>

using namespace std;
using ll = long long;
using ld = long double;
const ll LLINF = 4000000000000000000;

#ifdef _DEBUG
#define debug(x) cerr << #x << " = " << x << '\n'
#else
#define debug(x) ;
#endif

template<typename T1 = int, typename T2 = T1>
struct Pair{
    T1 f;
    T2 s;
    Pair(T1 f, T2 s) : f(f), s(s) {;}
};

template<typename T1 = int, typename T2 = T1>
Pair<T1, T2> m_p(T1 f, T2 s){
    return Pair(f, s);
}

template<typename T1 = int, typename T2 = T1>
ostream& operator<< (ostream& os, const Pair<T1, T2> a){
    return os << "( " << a.f << ", " << a.s << " )";
}

template<typename T>
T dUp (T a, T b){
    return (a + b - 1) / b;
}

ll stv[100100];
ll chn[100100];
ll pu[100100];
ll pd[100100];

void solve(){
    
    int qe, res = 1;
    ll tp = 0, pch = LLINF;
    cin >> qe;
    for(int i = 0; i < qe; ++i){
        cin >> stv[i];
    }
    for(int i = 0; i < qe; ++i){
        cin >> chn[i];
    }
    for(int i = 0; i < qe; ++i){
        cin >> pu[i];
    }
    for(int i = 0; i < qe; ++i){
        cin >> pd[i];
    }
    for(int i = 0; i < qe; ++i){
        if(stv[i] == 0){
            if(pu[i] > pd[i]){
                res *= -1;
                tp += pd[i];
                pch = min(pch, pu[i] - pd[i]);
            }
            else{
                tp += pu[i];
                pch = min(pch, pd[i] - pu[i]);
            }
        }
        else if(stv[i] > 0){
            pch = min(pch, pd[i] * dUp(stv[i] + 1, chn[i]));
        }
        else{
            res *= -1;
            pch = min(pch, pu[i] * dUp(-stv[i] + 1, chn[i]));
        }
    }
    if(res < 0) {
        res = 1;
        tp += pch;
    }
    cout << tp << '\n';

}

void precount(){

}

int main(){
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);

    int t = 1;

    precount();
    //cin >> t;

    while(t--){
        solve();
    }

}