#define _CRT_SECURE_NO_WARNINGS


//#define _DEBUG


#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <utility>

using namespace std;
using ll = long long;
using ld = long double;

#ifdef _DEBUG
#define debug(x) cerr << #x << " = " << x << '\n'
#else
#define debug(x) ;
#endif

template<typename T1 = int, typename T2 = T1>
struct Pair{
    T1 f;
    T2 s;
    Pair(T1 f, T2 s) : f(f), s(s) {;}
};

template<typename T1 = int, typename T2 = T1>
Pair<T1, T2> m_p(T1 f, T2 s){
    return Pair(f, s);
}

template<typename T1 = int, typename T2 = T1>
ostream& operator<< (ostream& os, const Pair<T1, T2> a){
    return os << "( " << a.f << ", " << a.s << " )";
}

bool used[100100];
int n;

vector<vector<int>> res;

void add(ll sum){
    if(sum == 0) return;
    res.emplace_back();
    for(int i = n; i > 0; --i){
        if(!used[i] && i <= sum){
            used[i] = true;
            res.back().push_back(i);
            sum -= i;
        }
    }
    debug(sum);
}

vector<ll> sums;

void solve(){
    
    ll rest;
    cin >> n;
    rest = ((ll)n * (n + 1)) / 2;
    for(int i = 32; i >= 0; i -= 2){
        sums.push_back(((rest >> i) << i));
        rest -= ((rest >> i) << i);
    }

    for(int i = sums.size() - 1; i > -1; --i) add(sums[i]);

    cout << res.size() << '\n';
    for(auto &i : res){
        cout << i.size() << '\n';
        for(auto t : i) cout << t << ' ';
        cout << '\n';
    }

}

void precount(){

}

int main(){
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);

    int t = 1;

    precount();
    //cin >> t;

    while(t--){
        solve();
    }

}