#include <iostream>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <cassert>
#include <ctime>
#include <chrono>
#include <cstdio>
#include <random>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <deque>
#include <queue>
#include <bitset>
#include <list>
#include <fstream>
#include <functional>
#include <complex>
using namespace std;
mt19937_64 gen(666);
using ll = long long;
using ld = long double;
                
const ll INF = 1e18;
const ll M = 70;
const int MOD = 1e9 + 7;
const ll N = 2e5;
const int LOG = 20;
const ld EPS = 1e-6;
const int C = 100;


void solve() {
    ll n; cin >> n;
    vector<ll> a(n), b(n), c(n), d(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    for (int i = 0; i < n; i++) cin >> c[i];
    for (int i = 0; i < n; i++) cin >> d[i];

    vector<ll> zero, nzero;
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) {
            zero.push_back(i);
        } else {
            nzero.push_back(i);
        }
    }
    bool ok = false;
    vector<ll> gzero(2, INF);
    ll cnt0 = 0, cnt1 = 0, summn = 0, mndiff = INF;
    for (auto i : zero) {
        if (c[i] < d[i]) {
            summn += c[i];
            cnt0++;
        } else if (c[i] > d[i]) {
            summn += d[i];
            cnt1++;
        } else {
            summn += c[i];
            ok = true;
        }
        mndiff = min(mndiff, abs(c[i] - d[i]));
    }
    if (ok) {
        gzero[0] = summn;
        gzero[1] = summn;
    } else {
        if (cnt1 % 2 == 0) {
            gzero[0] = summn;
            gzero[1] = summn + mndiff;
        } else {
            gzero[0] = summn + mndiff;
            gzero[1] = summn;
        }
    }
    cnt0 = 0; cnt1 = 0;
    ll mnch = INF;
    for (auto i : nzero) {
        if (a[i] > 0) {
            cnt0++;
            mnch = min(mnch, (abs(a[i]) / b[i] + 1) * d[i]);
        }    
        else {
            cnt1++;
            mnch = min(mnch, (abs(a[i]) / b[i] + 1) * c[i]);
        }    
    }
    vector<ll> gnzero(2, INF);
    if (cnt1 % 2 == 0) {
        gnzero[0] = 0;
        gnzero[1] = mnch;
    } else {
        gnzero[0] = mnch;
        gnzero[1] = 0;
    }
    cout << min(gzero[0] + gnzero[0], gzero[1] + gnzero[1]) << '\n';
}
                
signed main() {

                    
    ios_base::sync_with_stdio(false); cin.tie(0);
   
    ll tst = 1;
    while (tst--) {
        solve();
    }
}