#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
#define int long long
using idexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

vector<int> g, sq, p;
unordered_set<int> s, s1;
mt19937 rnd(1);

bool check(int x, bool b) {
    int x1 = x;
    int cnt = 0;
    for (int i = 2; i * i <= x; i++) {
        int count = 0;
        while (x % i == 0) {
            x /= i;
            count++;
        }
        if (count % 2) cnt++;
    }
    if (x != 1) cnt++;
    if (cnt <= 1 && b) {
        s1.insert(x1);
    }
    return cnt <= 1;
}

vector<int> solve(int n) {
    s = s1;
    int sum = n * (n + 1) / 2;
    vector<int> ans;
    while (!check(sum, 0)) {
        if (rnd() % 2)s.erase(s.begin());
        int val = *(s.begin());
        s.erase(val);
        sum -= val;
        ans.push_back(val);
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    sq.resize(1e5 + 1);
    p.resize(1e5 + 1, 1);
    p[1] = 1;
    for (int i = 2; i < sq.size(); i++) {
        if (!p[i]) continue;
        for (int j = i * 2; j < sq.size(); j += i) {
            p[j] = 0;
        }
    }
    for (int i = 1; i * i < sq.size(); i++) {
        sq[i * i] = 1;
    }
    for (int i = 1; i <= n; i++) {
        if (check(i, 1)) g.push_back(i);
    }
    vector<int> ans;
    while (true) {
        ans = solve(n);
        if (ans.size() + 1 < m) {
            break;
        }
    }
    vector<int> was(n + 1);
    cout << ans.size() + 1 << '\n';
    for (int val: ans) {
        cout << "1\n" << val << '\n';
        if (val <= n)was[val] = 1;
    }
    cout << n - ans.size() << '\n';
    for (int i = 1; i <= n; i++) {
        if (!was[i]) {
            cout << i << ' ';
        }
    }
}