#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
#define int long long
using idexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

vector<int> g, sq, p;
set<int> s;

bool check(int x) {
    for (int i = 1; i * i <= x; i++) {
        if (x % i == 0) {
            if ((p[i] && sq[x / i]) || (p[x / i] && sq[i])) {
                s.insert(x);
                return 1;
            }
        }
    }
    return 0;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    vector<vector<int>> calc(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            int last = 0;
            for (int h = i + 1; h <= j; h++) {
                int need = max(-(w[h] + w[h - 1]) + 1 - last, 0ll);
                calc[i][j] += need;
                last = need;
            }
        }
    }
    vector<vector<int>> dp(n + 1, vector<int>(n, 1e18));
    dp[0][0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int k = 0; k < n; k++) {
            for (int j = 1; j <= i; j++) {
                if (k - (i - j) >= 0)
                    dp[i][k] = min(dp[i][k], dp[j - 1][k - (i - j)] + calc[j - 1][i - 1]);
            }
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        cout << dp[n][i] << ' ';
    }
}