#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
#define int long long
using idexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    vector<vector<int>> cost(m, vector<int>(m));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            cin >> cost[i][j];
        }
    }
    vector<int> dp(n + 1, 1e18);
    dp[0] = -1e18;
    int ans = 0;
    for (int i = 0; i < n; i++) {
        int l = 0, r = n + 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (dp[mid] <= w[i]) l = mid;
            else r = mid;
        }
        ans = max(ans, r);
        dp[r] = min(w[i], dp[r]);
    }
    cout << (n - ans) * (cost[0][1]);
}