#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>
#include <iomanip>
#include <cstdio>
#include <cmath>
using namespace std;
using ll = long long;
const ll INF = 3 * 1e18;
const int sz = 1e5 + 1;

bool check(ll a) {
    if ((ll)sqrt(a) * (ll)sqrt(a) == a)
        return true;
    ll x = 2;
    ll b = a;
    while (x * x <= a) {
        if (a % x == 0) {
            while (a % x == 0)
                a /= x;
            ll y = b / x;
            if ((ll)sqrt(y) * (ll)sqrt(y) == y)
                return true;
        }
        x++;
    }
    if (a > 1) {
        ll y = b / a;
        if ((ll)sqrt(y) * (ll)sqrt(y) == y)
            return true;
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i)
        a[i] = i + 1;
    vector<vector<int>> ans;
    int cur = n - 1;
    while (cur >= 0) {
        ll suf_sum = 0;
        int pred = 0;
        for (int i = 0; i <= cur; ++i) {
            suf_sum += a[i];
        }
        for (int i = 0; i <= cur; ++i) {
            if (check(suf_sum)) {
                pred = i;
                break;
            }
            suf_sum -= a[i];
        }

        ans.emplace_back();
        for (int i = pred; i <= cur; ++i)
            ans.back().push_back(a[i]);
        cur = pred - 1;
    }

    cout << ans.size() << "\n";
    for (auto el : ans) {
        cout << el.size() << "\n";
        for (int e : el) cout << e << " ";
        cout << "\n";
    }

    return 0;
}