#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>
#include <iomanip>
#include <cstdio>
#include <cmath>
using namespace std;
using ll = long long;
const ll INF = 1e18;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n; cin >> n;
    vector<ll> a(n + 1);
    for (int i = 1; i <= n; ++i)
        cin >> a[i];
    vector<vector<ll>> dp(n + 1, vector<ll>(n, INF));
    vector<vector<ll>> dp2(n + 1, vector<ll>(n + 1, INF));
    for (int l = 1; l <= n; ++l) {
        for (int r = l; r <= n; ++r) {
            dp2[l][r] = 0;
            ll pred = a[l];
            for (int z = l + 1; z <= r; ++z) {
                dp2[l][r] += max((ll)0, 1 - (pred + a[z]));
                pred = a[z] + max((ll)0, 1 - (pred + a[z]));
            }
        }
    }
    dp[0][0] = 0;
    for (int i = 1; i <= n; ++i) {
        dp[i][0] = 0;
        for (int k = 1; k < n; ++k) {
            dp[i][k] = dp[i - 1][k];
            for (int j = 0; j <= i - 2; ++j) {
                if (k - (i - j - 1) >= 0) {
                    ll add = dp2[j + 1][i];
                    dp[i][k] = min(dp[i][k], dp[j][k - (i - j - 1)] + add);
                }
            }
        }
    }
    for (int k = 0; k <= n - 1; ++k) {
        ll ans = INF;
        for (int j = n - k - 1; j <= n - 1; ++j)
            ans = min(ans, dp[n][j]);
        cout << ans << " ";
    }

    return 0;
}