#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>
#include <iomanip>
#include <cstdio>
#include <cmath>
using namespace std;
using ll = long long;
const ll INF = 1e18;

vector<vector<int>> g;
vector<int> par, d;

void dfs(int u, int p) {
    par[u] = p;
    for (int v : g[u]) {
        if (v != p) {
            d[v] = d[u] + 1;
            dfs(v, u);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n; cin >> n;
    g.resize(n);
    for (int _ = 0; _ < n - 1; ++_) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    par.resize(n, -1);
    d.resize(n, 0);
    dfs(0, -1);
    int q, t;
    cin >> q >> t;
    for (int _ = 0; _ < q; ++_) {
        int k; cin >> k;
        vector<int> ver(k);
        vector<ll> c(k);
        vector<set<int>> pred(k);
        for (int i = 0; i < k; ++i) {
            cin >> ver[i] >> c[i];
            ver[i]--;
            int cur = ver[i];
            while (cur != -1) {
                pred[i].insert(cur);
                cur = par[cur];
            }
        }
        ll ans = 0;
        for (int u = 0; u < n; ++u) {
            ll cur = 0;
            for (int i = 0; i < k; ++i) {
                if (pred[i].find(u) != pred[i].end()) {
                    cur += c[i] * (d[u] + 1);
                    //cout << "    " << u + 1 << " " << i << "\n";
                }
            }
            ans = max(ans, cur);
        }
        cout << ans << "\n";
    }

    return 0;
}