#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("tune=native")

#define all(x) x.begin(), x.end()
#define pb push_back
#define f first
#define s second

using namespace std;

typedef long double ld;
typedef long long ll;
const long long mod = 1e9 + 7;
const int N = 1 * (int)1e5 + 5;

vector< vector< ll > > cost;
void Solve(){
    int n, m; cin >> n >> m;
    int a[n + 1];
    for(int i = 1; i <= n; i++){
        cin >> a[i];
    }
    cost = vector< vector< ll > >(m, vector< ll >(m));
    for(int i = 0; i < m; i++){
        for(int j = 0; j < m; j++){
            cin >> cost[i][j];
        }
    }
    vector< int > dp(n + 2, mod);
    dp[0] = -mod;
    for(int i = 1; i <= n; i++){
        int j = upper_bound(all(dp), a[i]) - dp.begin();
        if(dp[j] > a[i] && dp[j - 1] < a[i]){
            dp[j] = a[i];
        }
    }
    ll ans = 1;
    for(int i = n; i >= 1; i--){
        if(dp[i] != mod){
            ans = i;
            break;
        }
    }
    cout << (n - ans) * cost[0][1];
}
int main(){
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    int T = 1;
    //cin >> T;
    while(T --> 0){
        Solve();
    }
}