#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("tune=native")

#define all(x) x.begin(), x.end()
#define pb push_back
#define f first
#define s second

using namespace std;

typedef long double ld;
typedef long long ll;
const long long mod = 1e18 + 7;
const int N = 1 * (int)1e5 + 5;

vector< vector< int > > g;
vector< ll > sum, dist;

vector< ll > a;
void dfs(int v, int pred, int d){
    sum[v] = a[v];
    dist[v] = d;
    for(auto to: g[v]){
        if(to == pred)
            continue;
        dfs(to, v, d + 1);
        sum[v] += sum[to];
    }
}
void Solve(){
    int n; cin >> n;
    g = vector< vector< int > >(n);
    for(int i = 0; i < n - 1; i++){
        int u, v; cin >> u >> v;
        u--; v--;
        g[u].pb(v);
        g[v].pb(u);
    }
    a.resize(n);
    sum.resize(n);
    dist.resize(n);
    int q, t; cin >> q >> t;
    while(q--){
        int k; cin >> k;
        vector< pair< int, int > > zap(k);
        for(int i = 0; i < k; i++){
            cin >> zap[i].f >> zap[i].s;
            a[zap[i].f - 1] = zap[i].s;
        }
        dfs(0, -1, 1);
        ll ans = 0;
        for(int i = 0; i < n; i++){
            ans = max(ans, sum[i] * dist[i]);
        }
        cout << ans << "\n";
        for(int i = 0; i < k; i++){
            a[zap[i].f - 1] = 0;
        }
    }
}
int main(){
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    int T = 1;
    //cin >> T;
    while(T --> 0){
        Solve();
    }
}