#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long long ld;

const ll MD = 1000000007;

ll bin_pow(ll a, ll k) {
    if (k == 0) return 1;
    ll t = bin_pow(a, k / 2);
    t = (t * t) % MD;
    if (k & 1) {
        return (t * a) % MD;
    }
    return t;
}


void solve() {
    ll a, b, n, m;
    cin >> a >> b >> n >> m;
    // a * x + y = n
    // b * x + 2 * y = m
    // 2 * a * x
    ll x1 = 2 * a - b;
    ll x2 = 2 * n - m;

    if (x1 == 0) {
        if (n * 2 == m) {
            cout << n << ' ' << 0;
        } else {
            cout << -1;
        }
        return;
    }
    if (x2 % x1 != 0) {
        cout << -1;
        return;
    }
    ll x = x2 / x1;
    ll y = n - a * x;
    if (x < 0 || y < 0) {
        cout << -1;
        return;
    }
    cout << y << ' ' << x;
    /*int n;
    cin >> n;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }*/
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}