#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <vector>
#include <iomanip>

using namespace std;
using ll = long long;


ll a, b, n, m;
bool check(ll ans1, ll ans2) {
	return (ans1 >= 0 && ans2 >= 0 && n == ans1 + ans2 * a && m == 2 * ans1 + ans2 * b);
}

void solve() {
	cin >> a >> b >> n >> m;
	if (n * 2 == m) {
		cout << n << " " << 0;
		return;
	}
	if (a < b) {
		ll x = m - 2 * n;
		ll y = b - 2 * a;
		if (x > 0 && y > 0) {
			if (x % y == 0) {
				ll k = x / y;
				if (check(n - k * a, k)) {
					cout << n - k * a << " " << k;
					return;
				}
			}
		}
		cout << -1;
		return;
	}
	if (a == b) {
		ll k = m - n;
		if (k >= 0) {
			if ((n - k) % a == 0 && (m - 2 * k) % b == 0 && check(k, (n - k) / a)) {
				cout << k << " " << (n - k) / a;
				return;
			}
		}
		cout << -1;
		return;
	}
	if ((m * a - n * b) % (2 * a - b) == 0) {
		ll k = (m * a - n * b) / (2 * a - b);
		if (n >= k && (n - k) % a == 0 && check(k, (n - k) / a)) {
			cout << k << " " << (n - k) / a;
			return;
		}
	}
	cout << -1;
}

signed main() {
//#ifdef _DEBUG
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
//#endif // _DEBUG

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t = 1;
	// cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}