#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <vector>
#include <iomanip>

using namespace std;
using ll = long long;
const ll MAX = 1e18;
#define all(a) a.begin(), a.end()

struct str {
	ll a, b, c, d;
};

bool cmp(str x, str y) {
	return x.a < y.a;
}

void solve() {
	ll n;
	cin >> n;
	vector<ll> a(n), b(n), c(n), d(n);
	for (auto& x : a) cin >> x;
	for (auto& x : b) cin >> x;
	for (auto& x : c) cin >> x;
	for (auto& x : d) cin >> x;
	vector<str> v, v0;
	ll ans = 0, cnt = 0;
	bool was_same = 0;
	for (int i = 0; i < n; ++i) {
		if (a[i] == 0) {
			v0.push_back({ a[i], b[i], c[i], d[i] });
			if (d[i] < c[i]) {
				cnt++;
				ans += d[i];
			}
			else {
				if (c[i] == d[i]) {
					was_same = 1;
				}
				ans += c[i];
			}
		}
		else {
			if (a[i] < 0) cnt++;
			v.push_back({ a[i], b[i], c[i], d[i] });
		}
	}
	sort(all(v), cmp);
	if (cnt % 2 == 0 || was_same) {
		cout << ans;
		return;
	}
	if (v0.size() == 0) {
		ll ans2 = MAX;
		for (int i = 0; i < n; ++i) {
			if (v[i].a < 0) {
				ans2 = min(ans2, (abs(v[i].a / v[i].b) + 1) * v[i].c);
			}
			else {
				ans2 = min(ans2, (abs(v[i].a / v[i].b) + 1) * v[i].d);
			}
		}
		cout << ans2;
		return;
	}
	ll ans2 = MAX;
	for (int i = 0; i < v.size(); ++i) {
		if (v[i].a < 0) {
			ll cur = (abs(v[i].a / v[i].b) + 1) * v[i].c;
			ans2 = min(ans2, ans + cur);
		}
		else {
			ll cur = (abs(v[i].a / v[i].b) + 1) * v[i].d;
			ans2 = min(ans2, ans + cur);
		}
	}
	for (int i = 0; i < v0.size(); ++i) {
		ll cur = 0;
		if (d[i] < c[i]) {
			cur = c[i] - d[i];
		}
		else {
			cur = d[i] - c[i];
		}
		ans2 = min(ans2, ans + cur);
	}
	cout << ans2;
}

signed main() {
	//#ifdef _DEBUG
	//	freopen("input.txt", "r", stdin);
	//	freopen("output.txt", "w", stdout);
	//#endif // _DEBUG

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t = 1;
	// cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}