#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <vector>
#include <iomanip>
#include <set>
#include <unordered_set>

using namespace std;
using ll = long long;
const ll MAX = 1e18;
#define all(a) a.begin(), a.end()


void solve() {
	ll n, m;
	cin >> n >> m;
	ll N = 100489;
	vector<ll> a(N + 1, 1);
	a[0] = a[1] = 0;
	unordered_set<ll> primes;
	for (ll i = 2; i <= N; ++i) {
		if (i * i > N || !a[i]) continue;
		primes.insert(i);
		for (ll j = i * i; j <= N; j += i) {
			a[j] = 0;
		}
	}
	a[1] = 2;
	for (ll i = 1; i <= N; ++i) {
		if (a[i]) {
			//cout << i << '\n';
			continue;
		}
		for (ll j = sqrt(i) + 1; j > 1; --j) {
			if (i % j == 0) {
				if (i == j * j) {
					a[i] = 2;
					break;
				}
				if ((a[j] == 1 && a[i / j] == 2) || (a[j * j] == 2 && (i % (j * j) == 0) && a[i / j / j] == 1)) {
					a[i] = 3;
					break;
				}
			}
		}
		if (!a[i] && i <= n) {
			continue;
		}
	}
	ll sum = (n + 1) * n / 2;
	ll best = 0;
	for (ll i = max(1ll, (ll)sqrt(sum) - 1000); i <= sum; ++i) {
		if (i * i <= sum) best = i;
		else break;
	}
	vector<vector<ll>> ans;
	vector<ll> used(n + 1, 0);
	ans.push_back({});
	ll prev = sum - best * best, cur = sum - best * best;
	for (int i = n; i > 0; --i) {
		if (prev <= n) break;
		if (!a[i]) continue;
		used[i] = 1;
		ans[0].push_back(i);
		prev -= i;
	}
	if (ans[0].size() == 0) {
		ans.pop_back();
	}
	cur = prev;
	while (cur > 0) {
		while (!a[cur]) --cur;
		ans.push_back({ cur });
		used[cur] = 1;
		prev -= cur;
		cur = prev;
	}
	ans.push_back({});
	for (int i = 1; i <= n; ++i) {
		if (!used[i]) {
			ans[ans.size() - 1].push_back(i);
		}
	}
	cout << ans.size() << '\n';
	for (auto v : ans) {
		cout << v.size() << '\n';
		for (auto x : v) {
			cout << x << " ";
		}
		cout << '\n';
	}
}

signed main() {
//#ifdef _DEBUG
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
//#endif // _DEBUG

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t = 1;
	// cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}