#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const ll INF = 1e18;
const ll mod = 1e9 + 7;

vector<vector<ll>> g;
vector<ll> pr;
vector<ll> c;
vector<ll> d;

void init(ll v = 0, ll p = -1) {
    pr[v] = p;
    for (auto to : g[v]) {
        if (to != p) {
            d[to] = d[v] + 1;
            init(to, v);
        }
    }
}

int main() {
    cout << setprecision(15);
    cout << fixed;
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll n;
    cin >> n;
    g.resize(n);
    pr.assign(n, -1);
    d.assign(n, 0);
    for (ll i = 0; i < n - 1; ++i) {
        ll x, y;
        cin >> x >> y;
        x--, y--;
        g[x].emplace_back(y);
        g[y].emplace_back(x);
    }
    init();
    ll q, t;
    cin >> q >> t;
    while (q--) {
        vector<ll> a(n, 0);
        ll k;
        cin >> k;
        ll ans = 0;
        for (ll i = 0; i < k; ++i) {
            ll x, c;
            cin >> x >> c;
            x--;
            while (pr[x] != -1) {
                a[x] += c;
                ans = max(ans, a[x] * (d[x] + 1));
                x = pr[x];
            }
            a[0] += c;
            ans = max(ans, a[0]);
        }
        cout << ans << "\n";
    }



    return 0;
}