#include <bits/stdc++.h>
#include <random>

using namespace std;
using ll = long long;
using db = double;

struct vec {
    db x, y;

    vec(db xx, db yy) : x(xx), y(yy) {}

    vec(const vec &a) : x(a.x), y(a.y) {}

    vec() : x(0), y(0) {}

    void operator+=(vec a) {
        x += a.x;
        y += a.y;
    }

    vec operator+(vec a) {
        vec res = *this;
        res += a;
        return res;
    }

    void operator-=(vec a) {
        x -= a.x;
        y -= a.y;
    }

    vec operator-(vec a) {
        vec res = *this;
        res -= a;
        return res;
    }

    vec operator*(db a) { return vec(x * a, y * a); }

    db len() { return sqrt(x * x + y * y); }

    db operator*(vec a) { return x * a.x + y * a.y; }

    db operator%(vec a) { return x * a.y - y * a.x; }
};

ll n, a, b, i, m, ab, hum;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    // cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin >> a >> b >> n >> m;
    if (2 * a - b == 0) {
        if (2 * n - m == 0) {
            cout << n << " " << 0;
            return 0;
        }else{
            cout << -1;
            return 0;
        }
    }
    if ((2 * n - m) / (2 * a - b) * (2 * a - b) != 2 * n - m) {
        cout << -1;
        return 0;
    }
    ab = (2 * n - m) / (2 * a - b);
    if (ab < 0) {
        cout << -1;
        return 0;
    }
    hum = (m - ab * b) / 2;
    if (hum < 0) {
        cout << -1;
        return 0;
    }
    cout << hum << " " << ab;
    return 0;
}