#include <bits/stdc++.h>
#include <random>

using namespace std;
using ll = long long;
using db = double;

struct vec {
    db x, y;

    vec(db xx, db yy) : x(xx), y(yy) {}

    vec(const vec &a) : x(a.x), y(a.y) {}

    vec() : x(0), y(0) {}

    void operator+=(vec a) {
        x += a.x;
        y += a.y;
    }

    vec operator+(vec a) {
        vec res = *this;
        res += a;
        return res;
    }

    void operator-=(vec a) {
        x -= a.x;
        y -= a.y;
    }

    vec operator-(vec a) {
        vec res = *this;
        res -= a;
        return res;
    }

    vec operator*(db a) { return vec(x * a, y * a); }

    db len() { return sqrt(x * x + y * y); }

    db operator*(vec a) { return x * a.x + y * a.y; }

    db operator%(vec a) { return x * a.y - y * a.x; }
};

ll n, m, i, j, sz;
vector<ll> out[22];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    // cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin >> n >> m;
    for (i = 1; i <= n; i++) {
        for (j = 0; j <= 20; j++) {
            if (i % (1 << j) == 0 && i % (1 << (j + 1)) != 0) {
                break;
            }
        }
        out[j].push_back(i);
        sz = max(sz, j);
    }
    cout << sz + 1 << endl;
    for (i = 0; i <= sz; i++) {
        cout << out[i].size() << endl;
        for (j = 0; j < out[i].size(); j++) {
            cout << out[i][j] << " ";
        }
        cout << endl;
    }
    return 0;
}