#include <bits/stdc++.h>
#include <random>

using namespace std;
using ll = long long;
using db = double;

struct vec {
    db x, y;

    vec(db xx, db yy) : x(xx), y(yy) {}

    vec(const vec &a) : x(a.x), y(a.y) {}

    vec() : x(0), y(0) {}

    void operator+=(vec a) {
        x += a.x;
        y += a.y;
    }

    vec operator+(vec a) {
        vec res = *this;
        res += a;
        return res;
    }

    void operator-=(vec a) {
        x -= a.x;
        y -= a.y;
    }

    vec operator-(vec a) {
        vec res = *this;
        res -= a;
        return res;
    }

    vec operator*(db a) { return vec(x * a, y * a); }

    db len() { return sqrt(x * x + y * y); }

    db operator*(vec a) { return x * a.x + y * a.y; }

    db operator%(vec a) { return x * a.y - y * a.x; }
};
string a[200002];
ll n, q,i, k0,k1,x,y,l,r,m,last[200002],ansl,ansr;
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    // cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin >> n >> q;
    for(i=0;i<n;i++){
        cin >> a[i];
        if(a[i].back()=='0'){
            k0++;
        }else{
            k1++;
        }
    }
    last[0]=a[0].size();
    for(i=1;i<n;i++){
        last[i]=last[i-1]+a[i].size();
    }
    if(k1%2==0){
        cout << "Second";
    }else{
        cout << "First";
    }
    cout << "\n";
    while(q--){
        cin >> x >> y;
        l=-1;
        r=n-1;
        while(r-l>1){
            m=(l+r)/2;
            if(last[m]<x){
                l=m;
            }else{
                r=m;
            }
        }
        ansl=r;
        if(y<a[0].size()){
            ansr=-1;
        }else{
            l=-1;
            r=n-1;
            while(r-l>1){
                m=(l+r)/2;
                if(last[m]>=x){
                    r=m;
                }else{
                    l=m;
                }
            }
            ansr=r;
        }
        for(i=ansl;i<=ansr;i++){
            if(a[i].back()=='0'){
                k0--;
                k1++;
                a[i].back()='1';
            }else{
                k0++;
                k1--;
                a[i].back()='0';
            }
        }
        if(k1%2==0){
            cout << "Second";
        }else{
            cout << "First";
        }
        cout << "\n";
    }
    return 0;
}