#include <iostream>
#include <vector>
#include <algorithm>
#include <string.h>
#include <fstream>
#include <numeric>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;

vector<ll> a;
ll ans = 1e18;

void rec(vector<int>& used, int i, int k, int n) {
	if (i == n) {
		vector<ll> na(n);
		for (int i = 0; i < n; ++i) {
			na[i] = a[i];
		}
		ll qans = 0;

		for (int i = 0; i < n - 1; ++i) {
			if (used[i]) {
				na[i + 1] += max(-(na[i] + a[i + 1]) + 1, 0LL);
				qans += na[i + 1] - a[i + 1];
			}
		}

		int qk = 0;
		for (int i = 1; i < n; ++i) {
			qk += (na[i - 1] + na[i] <= 0);
		}

		if (qk <= k && qans < ans) {
			ans = qans;
		}

		return;
	}

	used[i] = 0;
	rec(used, i + 1, k, n);
	used[i] = 1;
	rec(used, i + 1, k, n);
}

int main() {
	int n;
	cin >> n;

	a.resize(n);

	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	for (int k = 0; k < n; ++k) {
		ans = 1e18;
		vector<int> used(n);
		rec(used, 0, k, n);
		cout << ans << " ";
	}
}