#include <bits/stdc++.h>

using namespace std;

vector<pair<int, int>> factor(int n) {
    vector<pair<int, int>> v;
    for (int i = 2; 1ll * i * i <= n; i++) {
        if (n % i == 0) {
            v.push_back({i, 0});
            while (n % i == 0) {
                v.back().second++;
                n /= i;
            }
        }
    }
    if (n > 1) v.push_back({n, 1}); 
    return v;
}

int numberOfDivisors(int n) {
    auto v = factor(n);
    int res = 1;
    for (auto c : v) {
        res *= (c.second + 1);
    }
    return res;
}

bool check(int x) {
    auto v = factor(x);
    int k = 0;
    for (auto c : v)
        k += (c.second % 2 == 1);
    return (k <= 1);
}

int main() {
    ios::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> res;
    for (int a = 1; a <= n; a *= 2) {
        res.push_back({});
        for (int i = a; i <= n; i += 2 * a)
            res.back().push_back(i);
    }
    cout << (int)res.size() << '\n';
    for (auto v : res) {
        cout << (int)v.size() << '\n';
        for (int c : v)
            cout << c << ' ';
        cout << '\n';
    }
}