#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
const ll INF = 2e15 + 100, MOD = 1e9 + 7, N = 2e5 + 10, K = 6, MX = 1e5 + 4, base = 239;
const ld Pi = acos(-1);
mt19937 rnd(148);


void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    int c[m + 1][m + 1];
    for (int i = 1; i <= m; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> c[i][j];
        }
    }
    vector<vector<int>> dp(n + 2, vector<int>(m + 2, INF));
    dp[n + 1].assign(m + 2, 0);
    for (int j = m; j >= 0; j--) {
        dp[n + 1][j] = c[a[n]][j];
        if (j != m)
            dp[n + 1][j] = min(dp[n + 1][j], dp[n + 1][j + 1]);
    }
    int ans = INF;
    for (int i = n; i > 0; i--) {
        for (int j = 1; j <= m; j++) {
            dp[i][j] = min(dp[i][j], dp[i + 1][j]);
            if (i == 1) {
                ans = min(ans, dp[i][j]);
            }
        }
        if (i != 1) {
            for (int j = m; j > 0; j--) {
                dp[i][j] += c[a[i - 1]][j];
                if (j != m)
                    dp[i][j] = min(dp[i][j], dp[i][j + 1]);
            }
        }
    }
    cout << ans;


}


signed main() {
//    freopen("hull.in", "r", stdin);
//    freopen("hull.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}