#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

void naive() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &i : a) cin >> i;
    int mx = 202;
    int inf = 1e9 + 100;
    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(n, vector<int>(mx, inf)));
    for (int i = 0; i < mx; ++i) {
        dp[0][0][i] = i;
    }
    for (int i = 1; i < n; ++i) {
        for (int k = 0; k < n; ++k) {
            for (int j = 0; j < mx; ++j) {
                dp[i][k][0] = min(dp[i][k][0], dp[i - 1][k][j]);
                for (int l = 0; l < mx; ++l) {
                    if (dp[i - 1][k][j] != inf) {
                        dp[i][k][l] = min(dp[i][k][l], dp[i - 1][k][j] + l);
                        if (a[i] + a[i - 1] + j + l > 0) {
                            dp[i][k + 1][l] = min(dp[i][k + 1][l], dp[i - 1][k][j] + l);
                        }
                    }
                }
            }
        }
    }
    int mn = inf;
    vector<int> ans(n);
    for (int i = n - 1; i > -1; --i) {
        for (int j = 0; j < mx; ++j) {
            mn = min(dp[n - 1][i][j], mn);
        }
        cout << mn << ' ';
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &i : a) cin >> i;
//    int mx = 202;
    int inf = 1e9 + 100;
    vector<vector<map<int, int>>> dp(n, vector<map<int, int>>(n));
    dp[0][0][0] = 0;
    for (int i = 1; i < n; ++i) {
        vector<set<int>> was(n);
        for (int k = 0; k < n; ++k) {
            for (auto &[j, c] : dp[i - 1][k]) {
                int need = max(0, -a[i] - a[i - 1] - j + 1);
                if (was[k].find(0) == was[k].end()) {
                    was[k].insert(0);
                    dp[i][k][0] = c;
                } else {
                    dp[i][k][0] = min(dp[i][k][0], c);
                }
                /*if (was[k].find(need) == was[k].end()) {
                    was[k].insert(need);
                    dp[i][k][need] = c + need;
                } else {
                    dp[i][k][need] = min(dp[i][k][need], c + need);
                }*/
                if (k + 1 < n) {
                    if (was[k + 1].find(need) == was[k + 1].end()) {
                        was[k + 1].insert(need);
                        dp[i][k + 1][need] = c + need;
                    } else {
                        dp[i][k + 1][need] = min(dp[i][k + 1][need], c + need);
                    }
                }
            }
        }
    }
    int mn = inf;
    vector<int> ans(n);
    for (int i = n - 1; i > -1; --i) {
        for (auto &[j, c] : dp[n - 1][i]) {
            mn = min(c, mn);
        }
        cout << mn << ' ';
    }

}

int main() {
#ifndef LOCAL
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    solve();
    return 0;
}