#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    
    long long n;
    cin >> n;
    vector<long long> a(n, 0);
    vector<long long> b(n, 0);
    vector<long long> c(n, 0);
    vector<long long> d(n, 0);
    map<long long, bool> was_zero;
    long long summ = 0;
    long long pos = 0, neg = 0;
    long long ans = 1e10;
    
    for (long long i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] > 0) {
            pos ++;
        } else if (a[i] < 0) {
            neg ++;
        }
    }
    for (long long i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (long long i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (long long i = 0; i < n; i++) {
        cin >> d[i];
    }
    
    for (long long i = 0; i < n; i++) {
        if (a[i] == 0) {
            was_zero[i] = true;
            if (c[i] <= d[i]) {
                summ += c[i];
                a[i] += b[i];
                pos ++;
            } else {
                summ += d[i];
                a[i] -= b[i];
                neg ++;
            }
        } else {
            was_zero[i] = false;
        }
        
    }
    
    long long balance = (abs(neg)) % 2;
    long long add = 0;
    
    if (balance != 0) {
        
        if (a[0] > 0 && was_zero[0]) {
            ans = summ - c[0] + d[0];
        } else if (a[0] < 0 && was_zero[0]) {
            ans = summ - d[0] + c[0];
        } else if (a[0] > 0) {
            add = (a[0] / b[0]) + 1;
            ans = summ + add * d[0];
            
        } else {
            add = (abs(a[0]) / b[0]) + 1;
            ans = summ + add * c[0];
        }
        
        for (long long i = 0; i < n; i++) {
            if (a[i] > 0 && was_zero[i]) {
                ans = min(ans, summ - c[i] + d[i]);
            } else if (a[i] < 0 && was_zero[i]) {
                ans = min(ans, summ - d[i] + c[i]);
            } else if (a[i] > 0) {
                add = a[i] / b[i] + 1;
                ans = min(ans, summ + add * d[i]);
                
            } else {
                add = (abs(a[i]) / b[i]) + 1;
                ans = min(ans, summ + add * c[i]);
            }
        }
        
    } else {
        ans = summ;
    }
    
    cout << ans << '\n';
    
    
    return 0;
}