#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>
using namespace std;


using ll = long long;
using ld = long double;
using ull = unsigned long long;


int bubbleGum = 0;
#ifdef RODYA
#include "Templates/Debug Template.cpp"
#else
#define dbg(...) ++bubbleGum
#endif


// #define int ll
#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(v) (int)(v.size())
#define mp(a, b) make_pair(a, b)
#define eb emplace_back
#define endl "\n"

using pii = pair<int, int>;






const int N = 4e5 + 10, LOG = 19;



int n, q, typ;
vec<int> g[N];
int tin[N], tout[N], timer = 0;
int hi[N];
int up[N][LOG];



void input() {
    cin >> n;
    for (int i = 1; i <= n - 1; ++i) {
        int x, y; cin >> x >> y;
        g[x].eb(y); g[y].eb(x);
    }
}



void dfs(int v, int pr) {
    tin[v] = ++timer;
    for (int i = 1; i < LOG; ++i)
        up[v][i] = up[up[v][i - 1]][i - 1];

    for (auto& to : g[v]) {
        if (to == pr) continue;
        hi[to] = hi[v] + 1;
        up[to][0] = v;
        dfs(to, v);
    }
    tout[v] = ++timer;
}


bool isAncestor(int x, int y) {
    return tin[x] <= tin[y] && tout[y] <= tout[x];
}

int getLca(int x, int y) {
    if (x == y) return x;
    if (isAncestor(x, y)) return x;
    if (isAncestor(y, x)) return y;

    for (int i = LOG - 1; i >= 0; --i) {
        int to = up[x][i];
        if (!isAncestor(to, y))
            x = to;
    }
    return up[x][0];
}


int cost[N];
vec<int> g2[N];
ll ans = 0;



ll dfs2(int v, int pr) {
    ll res = cost[v];
    for (auto& to : g2[v]) {
        if (to == pr) continue;
        ll val = dfs2(to, v);
        res += val;
    }


    ll val = 1LL * (hi[v] + 1) * res;
    ans = max(ans, val);
    return res;
}


void solve() {
    cin >> q >> typ;
    ll lastans = 0;
    vec<int> st, tmp, be;
    
    while (q--) {
        int k; cin >> k;
        tmp.clear();
        for (int i = 0; i < k; ++i) {
            int v, c; cin >> v >> c;
            if (typ == 2)
                v = (v + lastans) % (n - 1) + 2;
            cost[v] = c;
            tmp.eb(v);
        }

        be.clear();
        sort(all(tmp), [&](int i, int j){ return tin[i] < tin[j]; });
        for (int i = 0; i + 1 < sz(tmp); ++i) {
            int x = tmp[i], y = tmp[i + 1];
            int lca = getLca(x, y);
            be.eb(lca);
        }
        for (auto& it : be) tmp.eb(it);
        
        sort(all(tmp), [&](int i, int j){ return tin[i] < tin[j]; });
        tmp.resize(unique(all(tmp)) - tmp.begin());

        st.clear();
        st.eb(tmp[0]);
        for (int i = 1; i < sz(tmp); ++i) {
            int v = tmp[i];
            while (!st.empty() && tout[v] > tout[st.back()])
                st.pop_back();

            assert(!st.empty());
            int pre = st.back();
            g2[pre].eb(v);
            st.eb(v);
        }



        ans = 0;
        dfs2(tmp[0], -1);



        cout << ans << "\n";
        lastans = ans;


        for (auto& v : tmp) {
            g2[v].clear();
            cost[v] = 0;
        }
    }
}



signed main() {
#ifdef RODYA
    freopen("./bigTest.in", "r", stdin);
#else
    ios_base::sync_with_stdio(false), cin.tie(0);
#endif



    input();
    up[1][0] = 1;
    dfs(1, -1);
    solve();



}


/*



 */