// Author: Boris_Ber
#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2")

#define all(s) (s).begin(), (s).end()
#define rall(s) (s).rbegin(), (s).rend()
#define sz(x) ((int) (x).size())
#define ff first
#define ss second
#define pb push_back
#define eb emplace_back
#define ppb pop_back

using namespace std;

#define int long long
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int MOD = 1e9 + 7;
const int MOD2 = 998244353;
const int INF = 1e9;
const ll INF2 = 1e18;

int tmp;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int &i: a) cin >> i;
    int c;
    cin >> c >> c;
    vector<int> dp(n + 1, INF);
    dp[0] = 0;
    int mx = 0;
    for (int i = 0; i < n; ++i) {
        int p = lower_bound(all(dp), a[i]) - dp.begin();
        dp[p] = min(dp[p], a[i]);
        mx = max(mx, p);
    }
    cout << m - mx;
}

signed main() {
    int tt = 1;
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("../input.txt", "r", stdin);
    // CHECK CIN PLACEMENT
    cin >> tt;
#endif
    while (tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}
