#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>

using namespace std;
//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
//gp_hash_table<int, int> d;

#define int long long

int inf = 1e15;

bool isPrime(int n) {
	if (n == 0 or n == 1 or n == 2) return true;
	for (int i = 2; i <= ceil(sqrt(n)); i++) {
		if (n % i == 0) return false;
	}
	return true;
}

vector<int> primes;

int n, m;

vector<vector<int>> ans;
void solve(int su, int ind, string s) {
	if (ind == primes.size()) {
		if (su >= 0 and isPrime(su)) {
			//cout << su << " " << ind << " " << s << "\n";
			ans.clear();
			vector<int> u;
			for (int i = 0; i < primes.size(); i++) {
				if (s[i] == '1') u.push_back(primes[i]);
			}
			for (int i : u) {
				ans.push_back({ i });
			}
			vector<int> u2;
			for (int i = 1; i <= n; i++) {
				if (find(u.begin(), u.end(), i) == u.end()) {
					u2.push_back(i);
				}
			}
			if (u2.size() > 0) ans.push_back(u2);
		}
		return;
	}
	solve(su, ind + 1, s + "0");
	solve(su - primes[ind], ind + 1, s + "1");
}



signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);


	int n;
	cin >> n;
	vector<int> l(n);
	for (int i = 0; i < n; i++) cin >> l[i];
	vector<int> l2;
	int cnt = (int)2e6 + 10;
	for (int i = 1; i < n; i++) {
		l2.push_back(l[i] + l[i - 1] + cnt);
	}
	vector<vector<vector<int>>> dp(n, vector<vector<int>>(n + 1, vector<int>(cnt * 2, inf)));
	dp[0][0][cnt + 1] = 0;
	for (int i = 1; i < n; i++) {
		for (int j = 0; j < n; j++) {
			for (int k = 0; k < cnt * 2; k++) {
				int q1 = l2[i - 1] < cnt;
				int q2 = k <= cnt;
				dp[i][j + q1][l2[i - 1]] = min(dp[i][j + q1][l2[i - 1]], dp[i - 1][j][k]);
				if (l2[i - 1] >= k) {
					if (q1) dp[i][j][cnt + 1] = min(dp[i][j][cnt + 1], dp[i - 1][j][k] + cnt + 1 - l2[i - 1]);
					if (q2 and j >= 1) dp[i][j - 1][cnt + 1 - k + l2[i - 1]] = min(dp[i][j - 1][cnt + 1 - k + l2[i - 1]], dp[i - 1][j][k] + cnt + 1 - k);
				}
				else {
					if (q2 and j >= 1) dp[i][j - 1 + q1][cnt + 1 - k + l2[i - 1]] = min(dp[i][j - 1 + q1][cnt + 1 - k + l2[i - 1]], dp[i - 1][j][k] + cnt + 1 - k);
					if (q1 and j >= 1) dp[i][j - q2][cnt + 1] = min(dp[i][j- q2][cnt + 1], dp[i - 1][j][k] + cnt + 1 - l2[i - 1]);
				}

			}
		}
	}
	for (int k = 0; k < n; k++) {
		int ans = inf;
		for (int j = 0; j < cnt * 2; j++) {
			ans = min(ans, dp[n - 1][k][j]);
		}
		cout << ans << " ";
	}


}

/*

дп текущий элемент, сколько плохих было, цена



-5 -1
-3 1
Всё хорошо

-1 -5
1 -3 -2
*/