#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<iomanip>
#include<numeric>
#include<set>
#include<map>
#include<algorithm>
#include<cmath>
#include<vector>
using namespace std;
using ll = long long;
vector<ll> sum, used, dist;
ll timer = 1;
vector<vector<ll>> g;
void dfs(ll v) {
    used[v] = timer;
    for (auto el : g[v]) {
        if (used[el] != timer) {
            dist[el] = dist[v] + 1;
            dfs(el);
            sum[v] += sum[el];
        }
    }
}
int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ll n;
    cin >> n;
    g.resize(n);
    sum.resize(n);
    used.resize(n);
    dist.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        ll x, y;
        cin >> x >> y;
        x--, y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dist[0] = 0;
    ll q, t;
    cin >> q >> t;
    ll lastans = 0;
    for (int id = 0; id < q; ++id) {
        ll k;
        cin >> k;
        timer++;
        fill(sum.begin(), sum.end(), 0);
        for (int i = 0; i < k; ++i) {
            ll ind, c;
            cin >> ind >> c;
            if (t == 2)
                ind = (ind + lastans) % (n - 1) + 2;
            ind--;
            sum[ind] += c;
        }
        dfs(0);
        ll ans = 0;
        for (int i = 0; i < n; ++i) {
            ans = max(ans, (dist[i] + 1) * sum[i]);
        }
        lastans = ans;
        cout << ans << '\n';
    }
}