#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#ifndef LOCAL
#pragma GCC optimize("03")
#pragma GCC target("avx2")
#pragma GCC diagnostic ignored "-Wpedantic"
#endif

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 generator(seed);
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using i128 = __int128;
using ll = long long;
using ld = long double;
using uint = unsigned int;

const ll INF = 2e18;
const int inf = 1e9;
const int MOD = 1e9 + 7;
const int maxn = 500007;
const ld pi = acos(-1);
const int P = 5167;
const double EPS = 1e-6;

#define int ll

void solve() {
    int A, B, n, m;
    cin >> A >> B >> n >> m;
    if (2 * A == B) {
        if (2 * n != m) {
            cout << -1;
            return;
        }
        cout << n << " " << 0;
        return;
    }
    if ((2 * n - m) % (2 * A - B) == 0) {
        int k = (2 * n - m) / (2 * A - B);
        if (n < k * A || k < 0) {
            cout << -1;
            return;
        }
        cout << n - k * A << " " << k;
        return;
    }
    cout << -1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(4);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //  cin >> t;
    while (t--) solve();
    //stress();
}