#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#ifndef LOCAL
#pragma GCC optimize("03")
#endif

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 generator(seed);
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using i128 = __int128;
using ll = long long;
using ld = long double;
using uint = unsigned int;

const ll INF = 2e18;
const int inf = 1e9;
const int MOD = 1e9 + 7;
const int maxn = 500007;
const ld pi = acos(-1);
const int P = 5167;
const double EPS = 1e-6;

#define int ll

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n), c(n), d(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    for (int i = 0; i < n; ++i) cin >> c[i];
    for (int i = 0; i < n; ++i) cin >> d[i];
    vector<int> costs(n);
    int cnt1 = 0;
    ll cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] > 0) {
            costs[i] = (a[i] / b[i] + 1) * d[i];
        }
        if (a[i] < 0) {
            cnt1++;
            costs[i] = ((-a[i] / b[i]) + 1) * c[i];
        }
        if (a[i] == 0) {
            if (c[i] < d[i]) {
                cnt += c[i];
                costs[i] = d[i] - c[i];
            } else {
                cnt1++;
                cnt += d[i];
                costs[i] = c[i] - d[i];
            }
        }
    }
    if (cnt1 % 2 == 0) cout << cnt;
    else {
        int mn = costs[0];
        for (int i = 1; i < n; ++i) mn = min(mn, costs[i]);
        cout << cnt + mn;
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(4);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //  cin >> t;
    while (t--) solve();
    //stress();
}