#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#ifndef LOCAL
#pragma GCC optimize("03")
#endif

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 generator(seed);
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using i128 = __int128;
using ll = long long;
using ld = long double;
using uint = unsigned int;

const ll INF = 2e18;
const int inf = 1e9;
const int MOD = 1e9 + 7;
const int maxn = 5e5 + 7;
const ld pi = acos(-1);
const int P = 5167;
const double EPS = 1e-6;

#define int ll

int check(vector<int> v, int l, int r) {
    if(l == r) return 0;
    ll sum = 0;
    vector<int> cnt(v.size());
    for(int i = l+1; i <= r; ++i){
        if(v[i]+v[i-1] < 0){
            cnt[i] = -(v[i]+v[i-1]) + 1;
        }
        sum += cnt[i];
    }
    return sum;
}

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) cin >> v[i];
    vector<vector<int>> dp(n, vector<int>(n, 1e15));
    for (int i = 0; i < n; ++i) dp[0][i] = 0;
    for (int i = 1; i < n; ++i) {
        for (int k = 0; k < n; ++k) {
            for (int j = 0; j <= i; ++j) {
                if (k >= (i - j))
                    dp[i][k] = min(dp[i][k], dp[j][k] + check(v, j, i));
            }
        }
    }
    for (int i = 0; i < n; ++i) cout << dp[n - 1][i] << " ";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(4);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //  cin >> t;
    while (t--) solve();
    //stress();
}