#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#ifndef LOCAL
#pragma GCC optimize("03")
#endif

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 generator(seed);
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using i128 = __int128;
using ll = long long;
using ld = long double;
using uint = unsigned int;

const ll INF = 2e18;
const int inf = 1e9;
const int MOD = 1e9 + 7;
const int maxn = 5e5 + 7;
const ld pi = acos(-1);
const int P = 5167;
const double EPS = 1e-6;

#define int ll

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<pair<int, int>> in(m, {1e9, -1});
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
        in[a[i]].first = min(in[a[i]].first, i);
        in[a[i]].second = max(in[a[i]].second, i);
    }
    vector<vector<int>> cost1(m, vector<int>(m));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> cost1[i][j];
        }
    }
    vector<int> type(n);
    int r = -1;
    int cnt = -1;
    for (int i = 0; i < n; ++i) {
        if (r < i) cnt++;
        r = max(r, in[a[i]].second);
        type[i] = cnt;
    }
    cnt++;
    vector<vector<int>> cost(cnt, vector<int>(m));
    vector<vector<bool>> used(cnt, vector<bool>(m, false));
    for (int i = 0; i < m; ++i) {
        if (in[i].second >= 0) {
            for (int j = 0; j < m; ++j) {
                cost[type[in[i].second]][j] += cost1[i][j];
            }
        }
    }
    for (int i = 0; i < n; ++i) a[i] = type[i];
    vector<int> v1 = {a[0]};
    for (int i = 1; i < n; ++i) {
        if (a[i] != v1.back()) v1.push_back(a[i]);
    }
    a = v1;
    n = cnt;
    vector<int> dp(m);
    vector<int> pref_mn(m);
    for (int i = 0; i < m; ++i) {
        dp[i] = cost[a[0]][i];
        if (i == 0) pref_mn[i] = dp[i];
        else pref_mn[i] = min(pref_mn[i - 1], dp[i]);
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            dp[j] = pref_mn[j] + cost[a[i]][j];
        }
        pref_mn[0] = dp[0];
        for (int j = 1; j < m; ++j) pref_mn[j] = min(pref_mn[j - 1], dp[j]);
    }
    ll ans = 1e18;
    for (auto c: dp) ans = min(ans, c);
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(4);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //  cin >> t;
    while (t--) solve();
    //stress();
}