#include <bits/stdc++.h>

#define int int64_t
#define endl '\n'
#define pii pair <int, int>
#define fi first
#define se second
#define pb push_back

using namespace std;

const int INF = 2e18, N = 5e5 + 50;

int f[N];

void upd (int i, int x) {
    while (i < N) {
        f[i] = max(f[i], x);
        i = (i | (i + 1));
    }
}

int get (int i) {
    int ans = 0;
    while (i > 0) {
        ans = max(ans, f[i]);
        i = (i & (i + 1)) - 1;
    }
    return ans;
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m;
    cin >> n >> m;
    int a[n];
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }
    int cost[m][m];
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> cost[i][j];
        }
    }
    int dp[2][m];
    dp[0][0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int lst = 0; lst < m; ++lst) {
            dp[(i + 1) & 1][lst] = INF;
        }
        for (int lst1 = 0; lst1 < m; ++lst1) {
            for (int lst2 = lst1; lst2 < m; ++lst2) {
                dp[(i + 1) & 1][lst2] = min(dp[(i + 1) & 1][lst2], dp[i & 1][lst1] + cost[a[i]][lst2]);
            }
        }
    }
    int ans = INF;
    for (auto to : dp[n & 1]) {
        ans = min(ans, to);
    }
    cout << ans;
}