#include <bits/stdc++.h>

#define int int64_t
#define endl '\n'
#define pii pair <int, int>
#define fi first
#define se second
#define pb push_back

using namespace std;

const int INF = 2e18, N = 1e5 + 50;

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n;
    cin >> n;
    vector <int> g[n];
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].pb(y);
        g[y].pb(x);
    }
    int q, t;
    cin >> q >> t;
    vector <int> total(n), pred(n), rast(n);
    function <void (int, int)> DFS = [&] (int v, int pr) {
        pred[v] = pr;
        for (auto to : g[v]) {
            if (to != pr) {
                rast[to] = rast[v] + 1;
                DFS(to, v);
            }
        }
    };
    DFS(0, -1);
    int last_ans = 0;
    while (q--) {
        int k;
        cin >> k;
        fill(total.begin(), total.end(), 0);
        while (k--) {
            int v, c;
            cin >> v >> c;
            if (t == 2) {
                v = (v + last_ans) % (n - 1) + 2;
                v--;
            } else {
                v--;
            }
            while (v != -1) {
                total[v] += (rast[v] + 1) * c;
                v = pred[v];
            }
        }
        last_ans = 0;
        for (auto to : total) {
            last_ans = max(last_ans, to);
        }
        cout << last_ans << endl;
    }
}