#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <cmath>
using namespace std;
const int INF = 1e9 + 7;
const int mod = 1e9 + 7;
#define int long long
int min(int a, int b) {
	return (a < b) ? a : b;
}
int max(int a, int b) {
	return (a > b) ? a : b;
}
void solve() {
	int A, B, n, m;
	cin >> A >> B >> n >> m;
	int alf = 2 * n - m, beta = 2 * A - B;
	if (beta != 0 && abs(alf) % abs(beta) != 0) {
		cout << -1 << endl;
		return;
	}
	int x = 0;
	if (beta != 0) x = abs(alf) / abs(beta);
	if (alf < 0) x *= -1;
	if (beta < 0) x *= -1;
	if (x < 0) {
		cout << -1 << endl;
		return;
	}
	int k = n - A * x;
	if (k < 0) {
		cout << -1 << endl;
		return;
	}
	if (A * x + k != n || B * x + 2 * k != m) {
		cout << -1 << endl;
		return;
	}
	cout << k << " " << x << endl;
}
signed main() {
	int t = 1;
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// cin >> t;
	while (t--) {
		solve();
	}
}
/*
1 2 3 4
*/