#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <cmath>
#include <unordered_set>
#define int long long
#define debug(x) cerr << (#x) <<": "<< x<< endl;
using namespace std;
const int INF = 1e16 + 7;
const int mod = 1e9 + 7;
int min(int a, int b) {
	return (a < b) ? a : b;
}
int max(int a, int b) {
	return (a > b) ? a : b;
}
const int N = 1e5 + 100;
vector<int> primes;
int n, m;
bool is_prime[N];
vector<int> all_good;
bool check(int cur_sum) {
	int p = lower_bound(all_good.begin(), all_good.end(), cur_sum) - all_good.begin();
	if (p >= 0 && p < all_good.size() && all_good[p] == cur_sum) return 1;
	return 0;
}
void solve(int n, int m) {
	for (int i = 2; i < N; i++) is_prime[i] = 1;
	primes.push_back(1);
	for (int i = 2; i < N; i++) {
		if (is_prime[i] == 0) continue;
		for (int j = i * i; j < N; j += i) {
			is_prime[j] = 0;
		}
	}
	for (int i = 0; i < N; i++) {
		if (is_prime[i]) primes.push_back(i);
	}
	int mx_sum = N * (N - 1) / 2;
	int D = N / 10;
	for (int i = 1; i < N; i++) {
		int x = i * i;
		for (auto c : primes) {
			if (x * c > mx_sum) break;
			all_good.push_back(x * c);
		}
	}
	sort(all_good.begin(), all_good.end());
	vector<vector<int> > ans;
	int cur_sum = 0;
	vector<int> now, pref_sum(n + 1);
	for (int i = 0; i < n; i++) {
		pref_sum[i + 1] = pref_sum[i] + i + 1;
	}
	int last = n;
	for (int i = 0; i < m; i++) {
		for (int j = D; j >= 0; j--) {
			int l = last - j;
			if (l <= 0) continue;
			int sum = pref_sum[last] - pref_sum[l - 1];
			if (check(sum)) {
				now.clear();
				for (int p = l; p <= last; p++) {
					now.push_back(p);
				}
				ans.push_back(now);
				last = l - 1;
				break;
			}
		}
		if (last == 0) break;
	}
	if (cur_sum != 0) {
		debug(n);
		debug(cur_sum);
		exit(-1);
	}
	cout << ans.size() << endl;
	for (auto c : ans) {
		cout << c.size() << '\n';
		for (auto x : c) {
			cout << x << " ";
		}
		cout << '\n';
	}
}
signed main() {
	int t = 1;
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// cin >> t;
	while (t--) {
		cin >> n >> m;
		solve(n, m);
	}
}
/*
10
-10 3 3 -2 -2 -2 -2 3 4 5
*/