#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <cmath>
#include <unordered_set>
#define int long long
#define debug(x) cerr << (#x) <<": "<< x<< endl;
using namespace std;
const int INF = 1e16 + 7;
const int mod = 1e9 + 7;
int min(int a, int b) {
	return (a < b) ? a : b;
}
int max(int a, int b) {
	return (a > b) ? a : b;
}
int n, q, type;
vector<vector<int> > gr;
vector<int> dist, to_add;
int ans = 0;
void dfs(int u, int p) {
	for (auto to : gr[u]) {
		if (to == p) continue;
		dist[to] = dist[u] + 1;
		dfs(to, u);
		to_add[u] += to_add[to];
	}
	ans = max(ans, (dist[u] + 1) * to_add[u]);
}
void solve() {
	cin >> n;
	gr = vector<vector<int> >(n);
	for (int i = 0; i < n - 1; i++) {
		int u, v; cin >> u >> v; u--; v--;
		gr[u].push_back(v);
		gr[v].push_back(u);
	}
	cin >> q >> type;
	for (int it = 0; it < q; it++) {
		int k; cin >> k;
		ans = 0;
		dist = vector<int>(n, 0);
		to_add = vector<int>(n, 0);
		for (int i = 0; i < k; i++) {
			int v, c; cin >> v >> c; v--;
			to_add[v] += c;
		}
		dfs(0, -1);
		cout << ans << '\n';
	}
}
signed main() {
	int t = 1;
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// cin >> t;
	while (t--) {
		solve();
	}
}
/*
10
-10 3 3 -2 -2 -2 -2 3 4 5
*/