//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops", "omit-frame-poller", "inline")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,avx2,fma,tune=native")

#include <bits/stdc++.h>

#define int long long
using namespace std;
const int inf = 1e18;
vector<vector<int>> g;
vector<int> pred;
vector<int> sum;
vector<int> de;

void dfs(int v, int p, int d) {
    pred[v] = p;
    de[v] = d + 1;
    for (int to: g[v]) {
        if (to != p)dfs(to, v, d + 1);
    }
}

void solve() {
    int n;
    cin >> n;
    g.assign(n, {});
    pred.assign(n, -1);
    de.assign(n, 0);
    sum.assign(n, 0);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0, -1, 0);
    int q, t;
    cin >> q >> t;
    while (q--) {
        int k;
        cin >> k;
        sum.assign(n, 0);
        int mx = 0;
        for (int i = 0; i < k; ++i) {
            int v, c;
            cin >> v >> c;
            v--;
            while (v >= 0) {
                sum[v] += de[v] * c;
                mx = max(mx, sum[v]);
                v = pred[v];
            }
        }
        cout << mx << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}