#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll

const int N = 1e5;

vector<bool> used( N + 10);

bool f(int s) {
    map<int, int> m;
    for (int i = 2; i <= int(sqrt(s)) + 1; ++i) {
        while (s % i == 0) {
            s /= i;
            m[i]++;
        }
    }
    if (s != 1) m[s]++;
    int cnt_nech = 0;
    for (auto i : m) {
        if (i.second % 2 == 1) cnt_nech++;
    }
    if (cnt_nech < 2) return true;
    return false;
}

void bin(int x, vector<vector<int>> &ans) {
    string s;
    while (x > 0) {
        s += to_string(x % 2);
        x /= 2;
    }
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] == '0') continue;
        int k = 1 << i;
        ans.push_back({k});
        used[k] = true;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    int s = n * (n + 1) / 2;
    vector<vector<int>> ans;
    int s0 = 0;
    for (int i = 0; i <= s; ++i) {
        if (f(s - i)) {
            s0 = s - i;
            break;
        }
    }
    bin(s - s0, ans);
    ans.emplace_back();
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            ans[ans.size() - 1].push_back(i);
        }
    }
    cout << ans.size() << "\n";
    for (auto i : ans) {
        cout << i.size() << "\n";
        for (auto j : i) {
            cout << j << " ";
        }
        cout << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}