#ifdef LOCAL
#define GLIBCXX_DEBUG 1
#endif
#include <bits/stdc++.h>
using namespace std;

template <typename T, typename V> ostream & operator<<(ostream & os, pair<T, V> p) {
    return os << "{" << p.first << "," << p.second << "}";
}

template <class T, class V, class Container> basic_ostream<T, V> & operator<<(basic_ostream<T, V> &os, Container x) {
    os << "[ ";
    for (auto &y : x)
        os << y << " ";
    os << "]";
    return os;
}
template <class T> bool chmin(T &x, T &y) {
    if (x > y) {
        x = y;
        return true;
    }
    return false;
}
template <class T> bool chmax(T &x, T &y) {
    if (x < y) {
        x = y;
        return true;
    }
    return false;
}

#ifdef LOCAL
void deb_out() { cerr << endl; }
template <typename Head, typename... Tail> void deb_out(Head H, Tail... T) {
    cerr << H << " ";
    deb_out(T...);
}
#define deb(...) cerr << "(" << (#__VA_ARGS__) << "): "; deb_out(__VA_ARGS__);
#else
#define deb(...) 1
#endif

typedef long long ll;
typedef long double ld;

#define int long long

const int INF = 2e15;

void solve_test() {
    int n;
    cin >> n;
    vector<int> a(n), b(n), c(n), d(n);
    for (auto &x : a)
        cin >> x;
    for (auto &x : b)
        cin >> x;
    for (auto &x : c)
        cin >> x;
    for (auto &x : d)
        cin >> x;
    vector<array<int, 2>> dp(n + 1);
    for (int i = 1; i <= n; ++i) {
        int make_neg = INF;
        if (a[i - 1] < 0) {
            make_neg = 0;
        } else {
            if (a[i - 1] % b[i - 1] == 0) {
                make_neg = (a[i - 1] + b[i - 1]) / b[i - 1] * d[i - 1];
            } else {
                make_neg = (a[i - 1] + b[i - 1] - 1) / b[i - 1] * d[i - 1];
            }
        }
        if (a[i - 1] == 0)
            make_neg = d[i - 1];

        int make_pos = INF;
        if (a[i - 1] > 0) {
            make_pos = 0;
        } else {
            make_pos = (abs(a[i - 1]) + b[i - 1] - 1) / b[i - 1] * c[i - 1];
            if (a[i - 1] % b[i - 1] == 0) {
                make_pos = (abs(a[i - 1]) + b[i - 1]) / b[i - 1] * c[i - 1];
            } else {
                make_pos = (abs(a[i - 1]) + b[i - 1] - 1) / b[i - 1] * c[i - 1];
            }
        }
        if (a[i - 1] == 0)
            make_pos = c[i - 1];
        if (i > 1) {
            dp[i][0] = min(dp[i - 1][0] + make_pos, dp[i - 1][1] + make_neg);
            dp[i][1] = min(dp[i - 1][0] + make_neg, dp[i - 1][1] + make_pos);
        } else {
            dp[i][0] = make_pos;
            dp[i][1] = make_neg;
        }
    }
    cout << dp[n][0] << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    // cin >> tt;
    for (int i = 0; i < tt; ++i) {
        solve_test();
    #ifdef LOCAL
        cout << "______________" << endl;
    #endif
    }
}