#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

template<typename T>
void sort(T &s) {
    sort(all(s));
}

const int inf = 2e9 + 2000;
const ll infll = 2e18 + 2000;

int main() {
    ios::sync_with_stdio(false);
//    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<ll> a(n), b(n), c(n), d(n);

    for (auto &i : a) {
        cin >> i;
    }
    for (auto &i : b) {
        cin >> i;
    }
    for (auto &i : c) {
        cin >> i;
    }
    for (auto &i : d) {
        cin >> i;
    }

    vector<int> nu;
    vector<int> mi;
    vector<int> pl;

    for (int j = 0; j < n; ++j) {
        auto i = a[j];

        if (i == 0) {
            nu.push_back(j);
        } else if(i < 0) {
            mi.push_back(j);
        } else {
            pl.push_back(j);
        }
    }

    int kom = sz(mi);
    int ko0 = sz(nu);

    if (ko0 == 0 && kom % 2 == 0) {
        cout << 0;
        exit(0);
    }

    if (ko0 == 0) {
        ll res = infll;
        for (int i = 0; i < n; ++i) {
            if (a[i] > 0) {
                ll k = a[i] / b[i] + 1ll;
                res = min(res, k * d[i]);
            } else {
                a[i] = -a[i];
                ll k = a[i] / b[i] + 1ll;
                res = min(res, k * c[i]);
            }
        }

        cout << res;
    } else {
        ll res = 0;

        for (auto i : nu) {
            if (c[i] >= d[i]) {
                kom += 1;
            }

            res += min(c[i], d[i]);
        }

        if (kom % 2 == 1) {
            ll mii = infll;

            for (auto i : nu) {
                mii = min(mii, abs(d[i] - c[i]));
            }

            for (auto i : mi) {
                a[i] = -a[i];
                ll k = a[i] / b[i] + 1ll;
                mii = min(mii, k * c[i]);
            }

            for (auto i : pl) {
                ll k = a[i] / b[i] + 1ll;
                mii = min(mii, k * d[i]);
            }

            cout << res + mii;
        } else {
            cout << res;
        }
    }
}