#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

template<typename T>
void sort(T &s) {
    sort(all(s));
}

const int inf = 2e9 + 2000;
const ll infll = 2e18 + 2000;

int main() {
    ios::sync_with_stdio(false);
//    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> a(n);

    for (auto &i : a) {
        cin >> i;
    }

    vector<vector<pair<int, int> > > dp(n - 1, vector<pair<int, int> > (n, {inf, inf}));

    if (a[0] + a[1] <= 0) {
        dp[0][0].first = 0;
        dp[0][1].second = abs(a[0] + a[1]) + 1;
    } else {
        dp[0][1].first = 0;
    }

    for (int i = 1; i < n - 1; ++i) {
        for (int j = 0; j <= i + 1; ++j) {
            if (a[i] + a[i + 1] > 0) {
                if (j == 0) {
                    continue;
                }

                dp[i][j].first = min(dp[i - 1][j - 1].first, dp[i - 1][j - 1].second);
            } else {
                int pp = abs(a[i - 1] + a[i]) + 1;
                int cn = abs(a[i] + a[i + 1]) + 1;

                if (pp < cn) {
                    dp[i][j].first = min(dp[i - 1][j].first, dp[i - 1][j].second);
                    if (j != 0) {
                        dp[i][j].second = min(dp[i - 1][j - 1].first + cn, dp[i - 1][j - 1].second + cn - pp);
                    }
                } else {
                    dp[i][j].first = min(dp[i - 1][j].first, ((j != 0) ? dp[i - 1][j - 1].second : inf));
                    if (j != 0) {
                        dp[i][j].second = dp[i - 1][j - 1].first + cn;
                    }
                }
            }
        }
    }

//    for (auto &i : dp) {
//        for (auto j : i) {
//            cout << j.first << ';' << j.second << ' ';
//        }
//        cout << "\n";
//    }

    vector<int> res;

    int mi = inf;

    for (int i = n - 1; i >= 0; --i) {
        mi = min(mi, min(dp.back()[i].first, dp.back()[i].second));
        res.push_back(mi);
    }


    for (auto i : res) {
        cout << i << ' ';
    }
}