#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const ll INF = 1e17;

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(false);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    int n; cin >> n;
    vector<ll> A(n, 0);
    for (int i = 0; i < n; i++)
        cin >> A[i];
    vector<ll> cnt1(n, 0), cnt2(n, 0);
    for (int i = 0; i < n; i++)
    {
        if (i != 0 && i != n - 1) {
            ll t = min(A[i] + A[i - 1], A[i] + A[i + 1]);
            if (t <= 0)
                cnt2[i] = abs(t) + 1;
            t = max(A[i] + A[i - 1], A[i] + A[i + 1]);
            if (t <= 0)
                cnt1[i] = abs(t) + 1;
        }else if (i == 0)
        {
            ll t = A[i] + A[i + 1];
            if (t <= 0)
                cnt1[i] = abs(t) + 1;
        }else
        {
            ll t = A[i] + A[i - 1];
            if (t <= 0)
                cnt1[i] = abs(t) + 1;
        }
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(n, INF));
    dp[0][0] = dp[1][0] = 0;
    dp[2][0] = cnt1[0];
    for (int i = 2; i < n + 1; i++)
    {
        if (A[i - 1] + A[i - 2] < 0)
        {
            for (int j = 1; j < n; j++)
                dp[i][j] = dp[i - 1][j - 1];
        }
        if (i != 2)
        {
            for (int j = 0; j < n; j++) {
                if (j > 0)
                    dp[i][j] = min(dp[i][j], dp[i - 3][j - 1] + cnt1[i - 2]);
                dp[i][j] = min(dp[i][j], dp[i - 3][j] + cnt2[i - 2]);
            }
        }
    }
    for (int i = 0; i < n; i++)
        cout << dp[n][i] << ' ';
    cout << '\n';
    return 0;
}