#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <tuple>

using namespace std;

struct num{
    int a;
    int b;
    int c;
    int d;
};

using ll = long long;

int const INF = 1E18;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector <num> v(n);
    int otr = 0;
    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == 0) {
                cin >> v[j].a;
                if (v[j].a < 0) {
                    ++otr;
                }
            } else if (i == 1) {
                cin >> v[j].b;
            } else if (i == 2) {
                cin >> v[j].c;
            } else {
                cin >> v[j].d;
            }
        }
    }
    ll res1 = 0;
    ll res2 = INF;
    for (int i = 0; i < n; ++i) {
        if (v[i].a == 0) {
            ll x = min(v[i].c, v[i].d);
            res1 += x;
            if (v[i].c > v[i].d) {
                ++otr;
            }
        }
    }
    if (otr % 2 == 0) {
        cout << res1;
        return 0;
    } else {
        ll res3 = INF;
        for (int i = 0; i < n; ++i) {
            if (v[i].a < 0) {
                ll y = (-1 * v[i].a) / v[i].b + 1;
                ll z = v[i].c;
                ll x = y * z;
                res2 = min (res2, x);
            } else if (v[i].a > 0) {
                ll y = v[i].a / v[i].b + 1;
                ll z = v[i].d;
                ll x = y * z;
                res2 = min (res2, x);
            } else if (v[i].a == 0) {
                ll x = max(v[i].c, v[i].d) - min(v[i].c, v[i].d);
                res3 = min (res3, x);
            }
        }
        cout << min(res1 + res2, res1 + res3);
    }
    return 0;
}