#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <tuple>

using namespace std;

using ll = long long;

int const INF = 1E9;

vector <vector <int>> ans;

void solve (int n) {
    if (n != 0) {
        vector <int> temp1;
        for (int i = 1; i <= n; i += 2) {
            temp1.push_back(i);
        }
        vector <int> temp2;
        for (int i = 2; i <= n; i += 4) {
            temp2.push_back(i);
        }
        if (temp1.size() > 0) {
            ans.push_back(temp1);
        }
        if (temp2.size() > 0) {
            ans.push_back(temp2);
        }
        solve(n / 4);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    solve(n);

    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i].size() << endl;
        int x = 1;
        for (int j = 1; j <= i / 2; ++j) {
            x *= 4;
        }
        for (auto e : ans[i]) {
            cout << e * x << " ";
        }
        cout << endl;
    }

    return 0;
}