//#pragma GCC optimize("Ofast")

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 9e18;

struct segment_tree {
    int n;
    vector<int> tree, add;

    segment_tree(vector<int>& a) {
        n = a.size();
        tree.resize(4 * n, 0);
        add.resize(4 * n, 0);
        build(1, 0, n, a);
    }

    void build(int v, int l, int r, vector<int>& a) {
        if (l + 1 == r) {
            tree[v] = a[l];
        }
        else {
            int m = (r + l) / 2;
            build(2 * v, l, m, a);
            build(2 * v + 1, m, r, a);
            tree[v] = tree[2 * v] + tree[2 * v + 1];
        }
    }

    void push(int v, int l, int r){
        int m = (r + l) / 2;
        add[2 * v] += add[v];
        add[2 * v + 1] += add[v];
        tree[2 * v] += (m - l) * add[v];
        tree[2 * v + 1] += (r - m) * add[v];
        add[v] = 0;
    }

/*    void add(int v, int l, int r, int lx, int rx, int val){
        if (r <= lx || rx <= l){
            return;
        }
        if (lx <= l && r <= rx){
            tree[v] += (r - l) * val;
            add[v] += val;
            return;
        }
        int m = (r + l) / 2;
        add(2 * v, l, m, lx, rx, val);
        add(2 * v + 1, m, r, lx, rx, val);
        tree[v] = tree[2 * v] + tree[2 * v + 1];
    }*/
};

istream& operator >> (istream& in, vector<int>& a) {
    for (int& i : a) {
        in >> i;
    }
    return in;
}

ostream& operator << (ostream& out, vector<int> a) {
    for (int i : a) {
        out << i << ' ';
    }
    return out;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(15);

    int n;
    cin >> n;
    vector<int> a(n), b(n), c(n), d(n);
    cin >> a >> b >> c >> d;

    bool flag = false;
    int ans = 0;
    int cnt_neg = 0;
    int mn_neg = INF, mn_pos = INF;
    int mn_zer_neg = INF, mn_zer_pos = INF, mn_zer_neg_ind = -1, mn_zer_pos_ind = -1;
    for (int i = 0; i < n; ++i){
        if (a[i] > 0){
            mn_neg = min(mn_neg, d[i] * (a[i] / b[i] + 1));
        } else if (a[i] < 0){
            mn_pos = min(mn_pos, c[i] * (abs(a[i]) / b[i] + 1));
            cnt_neg++;
        } else {
            if (d[i] == c[i]){
                flag = true;
            }
            if (d[i] < c[i]){
                cnt_neg++;
                if (mn_zer_pos > c[i]){
                    mn_zer_pos = c[i];
                    mn_zer_pos_ind = i;
                }
            } else {
                if (mn_zer_neg > d[i]){
                    mn_zer_neg = d[i];
                    mn_zer_neg_ind = i;
                }
            }
            ans += min(c[i], d[i]);
        }
    }

    if (flag || cnt_neg % 2 == 0){
        cout << ans;
    } else {
        int res = min(mn_neg, mn_pos);
        for (int i = 0; i < n; ++i){
            if (a[i] == 0){
                if (d[i] < c[i]){
                    res = min(res, c[i] - d[i]);
                } else {
                    res = min(res, d[i] - c[i]);
                }
            }
        }
        cout << ans + res;
    }



    return 0;
}