#include <bits/stdc++.h>
#define int long long

using namespace std;
using vint = vector<int>;
using ll = long long;

#define X first
#define Y second
#define pb push_back

const int INF = 2e18;

void solve() {
    int n; cin >> n;
    vint a(n), b(n), c(n), d(n);
    for (auto &e : a) cin >> e;
    for (auto &e : b) cin >> e;
    for (auto &e : c) cin >> e;
    for (auto &e : d) cin >> e;
    int prod = 1;
    bool zeros = false;
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) {
            zeros = true;
            continue;
        }
        prod *= a[i] / abs(a[i]);
    }
    if (prod > 0 && !zeros) {
        cout << 0;
    } else if (prod < 0 && !zeros) {
        int minCost = INF;
        for (int i = 0; i < n; i++) {
            if (a[i] > 0) {
                int cost = ((abs(a[i]) + b[i]) / b[i]) * d[i];
                minCost = min(minCost, cost);
            } else if (a[i] < 0) {
                int cost = ((abs(a[i]) + b[i]) / b[i]) * c[i];
                minCost = min(minCost, cost);
            }
        }
        cout << minCost;
    } else {
        int minf = INF;
        int sumh = 0;
        int zeroProd = 1;
        for (int i = 0; i < n; i++) {
            if (a[i] == 0) {
                int h = min(c[i], d[i]);
                int tmp = max(c[i], d[i]);
                int f = tmp - h;
                minf = min(minf, f);
                sumh += h;
                if (c[i] > d[i]) {
                    zeroProd *= -1;
                }
            }
        }
        int one, two;
        if (prod * zeroProd > 0) {
            one = sumh;
        } else {
            int minCost = INF;
            for (int i = 0; i < n; i++) {
                if (a[i] > 0) {
                    int cost = ((abs(a[i]) + b[i]) / b[i]) * d[i];
                    minCost = min(minCost, cost);
                } else if (a[i] < 0) {
                    int cost = ((abs(a[i]) + b[i]) / b[i]) * c[i];
                    minCost = min(minCost, cost);
                }
            }
            one = minCost + sumh;
        }
        if (prod * -zeroProd > 0) {
            two = sumh + minf;
        } else {
            int minCost = INF;
            for (int i = 0; i < n; i++) {
                if (a[i] > 0) {
                    int cost = ((abs(a[i]) + b[i]) / b[i]) * d[i];
                    minCost = min(minCost, cost);
                } else if (a[i] < 0) {
                    int cost = ((abs(a[i]) + b[i]) / b[i]) * c[i];
                    minCost = min(minCost, cost);
                }
            }
            two = minCost + sumh + minf;
        }
        cout << min(one, two);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    solve();

    return 0;
}