//#pragma GCC optimize("Ofast,O3,unroll-loops");
//#pragma GCC target("avx2,tune=native");

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define forn(i, a, b) for(int i = (a); i < (b); ++i)
#define fornn(i, a, b) for(int i = (a); i > (b); --i)
#define mp(a, b) make_pair(a, b)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define endl '\n'
#define pint pair<int, int>

const int INF = 1e9 + 7, INF2 = 998244353;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> ans;
    vector<bool> used(n + 1, false);
    ans.push_back({});
    for(int i = 1; i <= n; i += 2) {
        ans.back().push_back(i);
        used[i] = true;
    }

    forn(i, 1, n + 1) {
        if (used[i]) continue;
        ans.push_back({ });
        for(int j = i; j <= n; j += 2 * i) {
            ans.back().push_back(j);
            used[j] = true;
        }
    }
    cout << ans.size() << endl;
    forn(i, 0, ans.size()) {
        cout << ans[i].size() << endl;
        forn(j, 0, ans[i].size()) {
            cout << ans[i][j] << " ";
        }
        cout << endl;
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}
