#include <bits/stdc++.h>

#define _FORTIFY_SOURCE 0
#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")

using namespace std;

typedef long long ll;
typedef long double ld;
#define int ll
#define double ld

#ifdef LOCAL
#   define dbg(x) cout << #x " = " << (x) << '\n';
#   define dbgf printf
#else
#   define dbg(x)
#   define dbgf(...)
#endif

#define all(x) std::begin(x), std::end(x)
#define rall(x) std::rbegin(x), std::rend(x)

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &p) {
    return out << p.first << ' ' << p.second;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

const auto boostIO = []() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed;
    cout.precision(12);
    return 0;
} ();

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n), c(n), d(n);
    int cnt_zeros = 0;
    int cnt_n = 0;
    int cnt_p = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        cnt_zeros += (a[i] == 0);
        cnt_n += (a[i] < 0);
        cnt_p += (a[i] > 0);
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    if (cnt_zeros) {
        int mn = 1e18;
        for (int i = 0; i < n; i++) {
            if (a[i] > 0) {
                mn = min(mn, (a[i] / b[i] + 1) * d[i]);
            }
            else if (a[i] < 0) {
                mn = min(mn, (abs(a[i]) / b[i] + 1) * c[i]);
            }
        }
        vector<pair<int, int>> cd;
        for (int i = 0; i < n; i++) {
            if (a[i] == 0) {
                cd.push_back({c[i], d[i]});
            }
        }
        vector<vector<int>> dp(cd.size() + 1, vector<int>(2, 1e18));
        dp[0][cnt_n % 2] = 0;
        dp[0][!(cnt_n % 2)] = mn;
        for (int i = 1; i <= cd.size(); i++) {
            for (int j = 0; j < 2; j++) {
                dp[i][(j + 1) % 2] = min(dp[i][(j + 1) % 2], dp[i - 1][j] + cd[i - 1].second);
                dp[i][j] = min(dp[i][j], dp[i - 1][j] + cd[i - 1].first);
            }
        }
        cout << dp[cd.size()][0] << '\n';
    }
    else if (cnt_n % 2) {
        int mn = 1e18;
        for (int i = 0; i < n; i++) {
            if (a[i] > 0) {
                mn = min(mn, (a[i] / b[i] + 1) * d[i]);
            }
            else {
                mn = min(mn, (abs(a[i]) / b[i] + 1) * c[i]);
            }
        }
        cout << mn << '\n';
    }
    else {
        cout << 0 << '\n';
    }
}

signed main() {

    solve();

    return 0;
}