#include <bits/stdc++.h>

#define _FORTIFY_SOURCE 0
#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")

using namespace std;

typedef long long ll;
typedef long double ld;
#define int ll
#define double ld

#ifdef LOCAL
#   define dbg(x) cout << #x " = " << (x) << '\n';
#   define dbgf printf
#else
#   define dbg(x)
#   define dbgf(...)
#endif

#define all(x) std::begin(x), std::end(x)
#define rall(x) std::rbegin(x), std::rend(x)

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &p) {
    return out << p.first << ' ' << p.second;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

const auto boostIO = []() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed;
    cout.precision(12);
    return 0;
} ();

vector<int> p;
vector<vector<int>> c;

int get(int a) {
    return (a == p[a] ? a : (p[a] = get(p[a])));
}

void unite(int a, int b) {
    a = get(a);
    b = get(b);
    if (a == b) {
        return;
    }
    p[a] = b;
    for (int i = 0; i < c.size(); i++) {
        c[b][i] += c[a][i];
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    p.resize(m);
    iota(all(p), 0);
    vector<int> a(n);
    vector<int> last_pos(m, -1);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
        last_pos[a[i]] = i;
    }
    c.resize(m, vector<int>(m));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            cin >> c[i][j];
        }
    }
    int r = -1;
    for (int i = 0; i < n; i++) {
        if (i <= r) {
            unite(a[i - 1], a[i]);
        }
        r = max(r, last_pos[a[i]]);
    }
    vector<int> comp;
    for (int i = 0; i < n; i++) {
        if (comp.empty() || comp.back() != get(a[i])) {
            comp.push_back(get(a[i]));
        }
    }
    vector<vector<int>> dp(2, vector<int>(m + 1, 1e18));
    for (int i = 1; i <= m; i++) {
        dp[0][i] = min(dp[0][i - 1], c[comp[0]][i - 1]);
    }
    for (int i = 1; i < comp.size(); i++) {
        for (int j = 1; j <= m; j++) {
            dp[i % 2][j] = min(dp[i % 2][j - 1], c[comp[i]][j - 1] + dp[!(i % 2)][j]);
        }
    }
    cout << *min_element(all(dp[!(comp.size() % 2)]));
}

signed main() {

    solve();

    return 0;
}