#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define int long long

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int &i: a)
        cin >> i, --i;
    vector<vector<int>> cost(m, vector<int>(m));
    for (int i = 0; i < m; ++i)
        for (int j = 0; j < m; ++j)
            cin >> cost[i][j];
    vector<int> mn(m, 1e18), mx(m, -1e18);
    for (int i = 0; i < n; ++i)
        mn[a[i]] = min(mn[a[i]], i), mx[a[i]] = max(mx[a[i]], i);
    vector<vector<int>> gr(m);
    for (int i = 0; i < m; ++i)
        for (int j = 0; j < m; ++j)
            if (mx[i] > mn[j] && mx[j] > mn[i])
                gr[i].push_back(j);
    vector<bool> used(m, false);
    vector<int> now;
    auto dfs1 = [&](auto self, int v) -> void {
        used[v] = true;
        now.push_back(v);
        for (int u: gr[v])
            if (!used[u])
                self(self, u);
    };
    vector<vector<int>> cost2;
    for (int i : a)
        if (!used[i]) {
            now.clear();
            dfs1(dfs1, i);
            vector<int> c(m, 0);
            for (int j : now)
                for (int q = 0; q < m; ++q)
                    c[q] += cost[j][q];
            cost2.push_back(c);
        }
    n = cost2.size();
    cost = cost2;
    vector<vector<int>> dp(n + 1, vector<int>(m, 1e18));
    dp[0] = vector<int>(m, 0);
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < m; ++j)
            dp[i][j] = min(dp[i][j], dp[i - 1][j] + cost[i - 1][j]);
        for (int j = 1; j < m; ++j)
            dp[i][j] = min(dp[i][j], dp[i][j - 1]);
    }
    cout << dp[n].back();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}