#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define int long long

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> gr(n);
    for (int i = 1, u, v; i < n; ++i) {
        cin >> u >> v;
        --u, --v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    int q, t;
    cin >> q >> t;
    while (q--) {
        int k;
        cin >> k;
        vector<int> cnt(n, 0);
        while (k--) {
            int x, y;
            cin >> x >> y;
            --x;
            cnt[x] += y;
        }
        int res = 0;
        auto dfs = [&](auto self, int v, int p, int d) -> int {
            int sz = cnt[v];
            for (int u : gr[v])
                if (u != p)
                    sz += self(self, u, v, d + 1);
            res = max(res, (d + 1) * sz);
            return sz;
        };
        dfs(dfs, 0, -1, 0);
        cout << res << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}