#include <bits/stdc++.h>
using namespace std;

#define int long long
#define endl "\n"

ostream& operator << (ostream& out, pair<int, int>& a) {
    out << "| " << a.first << " " << a.second << " |";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

constexpr long long inf = 1e18;
constexpr long long N = 2e5 + 556;
constexpr long long A = 26;
constexpr long long T = 20;

void solve() {
    struct elem {
        int a, b, c, d;
    };

    int n;
    cin >> n;
    vector<elem> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].a;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].b;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].c;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].d;
    }

    vector<int> mkn, mkp;
    
    int ans = 0;
    int cntn = 0;
    for (int i = 0; i < n; i++) {
        // cin >> a[i].a >> a[i].b >> a[i].c >> a[i].d;

        if (a[i].a > 0) {
            mkn.push_back((a[i].a / a[i].b + 1) * a[i].d);
        }
        if (a[i].a < 0) {
            mkp.push_back((abs(a[i].a) / a[i].b + 1) * a[i].c);
            cntn++;
        }
        if (a[i].a == 0) {
            if (a[i].c < a[i].d) {
                ans += a[i].c;
                mkn.push_back(a[i].d - a[i].c);
            } else {
                ans += a[i].d;
                mkp.push_back(a[i].c - a[i].d);
                cntn++;
            }
        }
    }

    // cout << cntn << endl;

    if (cntn % 2 == 0) {
        cout << ans << endl;
    } else {
        int md = inf;
        sort(mkn.begin(), mkn.end());
        sort(mkp.begin(), mkp.end());
        if (mkn.size()) md = min(md, mkn.front());
        if (mkp.size()) md = min(md, mkp.front());


        cout << ans + md << endl;
    }

}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}