#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

ll INF = 1000000000000ll;

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    vector<ll> b(n);
    vector<ll> c(n);
    vector<ll> d(n);
    ll k_n, k_p, k_o;
    for (auto &now : a) {
        cin >> now;
        if (now > 0) k_p++;
        if (now < 0) k_o++;
        if (now == 0) k_n++;
    }
    for (auto &now : b) cin >> now;
    for (auto &now : c) cin >> now;
    for (auto &now : d) cin >> now;
    if (k_n == 0) {
        if (k_o % 2 == 0) {
            cout << 0 << "\n";
        } else {
            ll ans = INF;
            for (ll i = 0; i < n; i++) {
                if (a[i] > 0) {
                    ans = min(ans, d[i] * (a[i] / b[i] + 1));
                } else {
                    ans = min(ans, c[i] * (a[i] / b[i] + 1));
                }
            }
            cout << ans << "\n";
        }
    } else {
        vector<ll> p(n);
        vector<ll> o(n);
        ll ans = 0;
        for (ll i = 0; i < n; i++) {
            if (a[i] == 0) {
                p[i] = c[i];
                o[i] = d[i];
            } else if (a[i] > 0) {
                p[i] = 0;
                o[i] = d[i] * (a[i] / b[i] + 1);
            } else {
                p[i] = c[i] * (abs(a[i]) / b[i] + 1);
                o[i] = 0;
            }
            ans += p[i];
            o[i] -= p[i];
        }
        sort(o.begin(), o.end());
        for (ll i = 0; i < n - 1; i += 2) {
            if (o[i] + o[i + 1] <= 0) {
                ans += o[i] + o[i + 1];
            }
        }
        cout << ans;
    }
}

int main() {
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}