#include <bits/stdc++.h>

#define int int64_t

using namespace std;

const int INF = 1e18;
const int MAXN = 1002;
const long double DIS = 2e8;

int p[MAXN];
vector <int> w[MAXN];

int a[MAXN][MAXN];

int dp[MAXN][MAXN];
int dp1[MAXN][MAXN];

int get(int v){
    if(p[v] == v){
        return p[v];
    }
    return p[v] = get(p[v]);
}

void unit(int a, int b){
    a = get(a);
    b = get(b);
    if(a == b){
        return;
    }
    if(w[a].size() < w[b].size()){
        swap(a, b);
    }
    for(auto i:w[b]){
        w[a].push_back(i);
    }
    p[b] = a;
}

int get1(int p1, int p2){
    int cnt = 0;
    for(auto i:w[p1]){
        cnt += a[i][p2];
    }
    return cnt;
}

void solve(){
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; i++){
        p[i] = i;
        w[i].push_back(i);
        for(int j = 0; j < m; j++){
            dp[i][j] = INF;
        }
    }
    vector <int> v;
    vector <int> r(m);
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        k--;
        r[k] = i;
        v.push_back(k);
    }
    set <pair<int, int>> st;
    for(int i = 0; i < n; i++){
        while(st.size() && (*st.begin()).first == i){
            st.erase(st.begin());
        }
        if(st.size()){
            unit(v[i], (*st.begin()).second);
        }
        if(i != r[v[i]]){
            st.insert({r[v[i]], v[i]});
        }
    }
    for(int i = 0; i < m; i++){
        for(int j = 0; j < m; j++){
            cin >> a[i][j];
        }
    }
    vector <int> vv;
    for(auto i:v){
        if(!vv.size() || vv.back() != get(i)){
            vv.push_back(get(i));
        }
    }
    for(int i = 0; i < vv.size(); i++){
        if(i == 0){
            dp[0][0] = get1(vv[0], 0);
        }
        else{
            dp[i][0] = dp[i - 1][0] + get1(vv[i], 0);
        }
        for(int j = 1; j < m; j++){
            int add = get1(vv[i], j);
            if(i == 0){
                dp[i][j] = min(dp[i][j - 1], add);
            }
            else{
                dp[i][j] = min(dp[i][j - 1], add + dp[i - 1][j]);
            }
        }
    }
    int ans = INF;
    for(int i = 0; i < m; i++){
        ans = min(ans, dp[vv.size() - 1][i]);
    }
    cout << ans;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
    return 0;
}