/* alexok2006 */
#include<bits/stdc++.h>
//#include "/home/alexok/myutils/slav.h"
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define ll long long
#define ld long double
#define LLM 1e17
#define pp pair<int,int>
using namespace std;
template<class F,class S> ostream& operator<<(ostream& os,pair<F,S>& cur) { os<<"("<<cur.first<<";"<<cur.second<<")"; return os;}
template<class T> ostream& operator<<(ostream& os,vector<T>& arr) { for(auto i:arr) os<<i<<" "; return os;}
template<class T> istream& operator>>(istream& is,vector<T>& arr) { for(auto& i:arr) is>>i; return is;}

template<typename T> struct min_generator_target {    T& target;    template<typename U> T& operator=(const U& value) {        if(value < target) {            target = value;        }        return target;    }};struct min_generator_t {    template<typename T> friend auto operator+(T& target, min_generator_t) {        return min_generator_target<T>{target};    }    template<typename... Args> auto operator()(Args&&... args) const {        return std::min(std::forward<Args>(args)...);    }    template<typename T> auto operator()(std::initializer_list<T> ilist) const {return std::min(ilist);}template<typename T, typename Compare> auto operator()(std::initializer_list<T> ilist, Compare comp) const {return std::min(ilist, comp);    }} min_generator;
template<typename T> struct max_generator_target {    T& target;    template<typename U> T& operator=(const U& value) {        if(value > target) {            target = value;        }        return target;    }};struct max_generator_t {    template<typename T> friend auto operator+(T& target, max_generator_t) {        return max_generator_target<T>{target};    }    template<typename... Args> auto operator()(Args&&... args) const {        return std::max(std::forward<Args>(args)...);    }    template<typename T> auto operator()(std::initializer_list<T> ilist) const {        return std::max(ilist);    }    template<typename T, typename Compare> auto operator()(std::initializer_list<T> ilist, Compare comp) const {        return std::max(ilist, comp);    }} max_generator;
#define mins + min_generator
#define maxs + max_generator

#define MAXN 400400
#define LG 20
vector<int> tree[MAXN];
int binup[MAXN][LG];

int tin[MAXN];
int tout[MAXN];
int deep[MAXN];
int timer=-1;

void dfs(int w,int pred=0,int depth=0) {
  tin[w] = ++timer;
  deep[w] = depth;
  binup[w][0] = pred;
  for(int i=1;i<LG;i++) binup[w][i] = binup[ binup[w][i-1] ][ i-1 ];
  for(auto to:tree[w]) if(to!=pred) dfs(to,w,depth+1);
  tout[w] = timer;
}

int lca(int u,int v) {
  if(deep[v]>deep[u]) swap(u,v);
  int dt = deep[u]-deep[v];
  for(int i=0;i<LG;i++) if( (dt>>i)&1 ) u = binup[u][i];
  while(v!=u) {
    int mx=0;
    while( binup[v][mx]!=binup[u][mx] )mx++;
    if(!mx) return binup[v][0];
    v=binup[v][mx-1];
    u=binup[u][mx-1];
  }
  return v;
}

signed main()
{
ios_base::sync_with_stdio(0);
cin.tie(0);
int n;
cin>>n;

for(int i=1;i<n;i++) {
  int u,v;
  cin>>u>>v;
  v--,u--;
  tree[v].push_back(u);
  tree[u].push_back(v);
}

dfs(0);

int q,tp;
cin>>q>>tp;
ll lastans=0;

while(q--) {
  int k;
  cin>>k;
  vector< pair<int,pp> > kar(k);
  ll mx = 0;
  for(int i=0;i<k;i++) {
    ll u,c;
    cin>>u>>c;
    if(tp==2) u=(u+lastans)%(n-1) + 2;
    u--;
    mx maxs= c * (deep[u]+1);
    kar[i] = {tin[u], {u,c} };
  }
  sort(all(kar));
  //for(int i=0;i<k;i++) cout<<kar[i].second.first+1<<" ";cout<<endl;
  vector<ll> prefsum(k),pref(k);

  for(int i=0;i<k;i++) pref[i] = kar[i].second.second;

  for(int i=1;i<k;i++) pref[i]+=pref[i-1];
  
  auto get_sum = [&](int l,int r) {  ll res = pref[r]; if(l) res-=pref[l-1]; return res;};

  for(int i=1;i<k;i++) {
    int v = lca( kar[i].second.first, kar[i-1].second.first );
    int R = --upper_bound(all(kar), make_pair(tout[v],pp(1e9,1e9))) - kar.begin();
    int L = lower_bound(all(kar), make_pair(tin[v],pp(-1,-1))) - kar.begin();
    ll val = get_sum(L,R)*(deep[v]+1);
    //cout<<v+1<<":"<<val<<" "<<L<<";"<<R<<endl;
    mx maxs= val;
  }
  cout<<mx<<"\n";
  lastans = mx;
}

}