#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <bitset>
#include <algorithm>
#include <numeric>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<ll> vl;
typedef vector<bool> vb;

const int N = 1e4;
const int INF = 2e9;
const ll LINF = 1e18;

void solve() {
  int n, m;
  cin >> n >> m;
  vi arr(n);
  for (int &i : arr) cin >> i, i--;
  vector<vi> cost(m, vi(m));
  for (int i = 0; i < m; i++) {
    for (int j = 0; j < m; j++) {
      cin >> cost[i][j];
    }
  }
  ll c = cost[0][1];
  vi dp;
  for (int i = 0; i < n; i++) {
    auto it = lower_bound(all(dp), arr[i]);
    if (it == dp.end()) dp.push_back(arr[i]);
    else *it = arr[i];
  }
  cout << c * (n - dp.size()) << '\n';
}

int main() {
#ifdef LOCAL
  freopen("input.in", "r", stdin);
#endif
  int t = 1;
  while (t--) solve();
}