#include<bits/stdc++.h>

using namespace std;

#define ll long long

vector<vector<ll>> gr;
vector<ll> p1;
unordered_map<ll, ll> m1;
vector<ll> d1;

void dfs(ll v, ll p, ll d) {
    p1[v] = p;
    d1[v] = d;
    for (auto elem : gr[v]) {
        if (elem != p) {
            dfs(elem, v, d + 1);
        }
    }
}

vector<ll> a1;

void dfs1(ll v) {
    a1[v] = m1[v];
    for (auto elem : gr[v]) {
        if (elem != p1[v]) {
            dfs1(elem);
            a1[v] += a1[elem];
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    gr.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        u--;
        v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    p1.resize(n);
    d1.resize(n);
    dfs(0, 0, 0);
    ll q, t;
    cin >> q >> t;
    while (q--) {
        ll k;
        cin >> k;
        m1.clear();
        for (ll i = 0; i < k; i++) {
            ll v, x;
            cin >> v >> x;
            v--;
            m1[v] = x;
        }
        a1.assign(n, 0);
        dfs1(0);
        ll answer = 0;
        for (ll i = 0; i < n; i++) {
            answer = max(answer, (d1[i] + 1) * a1[i]);
        }
        cout << answer << '\n';
    }
}