#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
#define all(a) a.begin(), a.end()

const ll MOD = 1e9 + 7;
const ll INF = 1e18;

using ordered_set = tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    ld T = clock();
    while (t--)
        solve();
#ifdef _GLIBXX_DEBUG
    cout << endl;
    cerr << '\n' << ld(clock() - T) / CLOCKS_PER_SEC;
#endif
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n), b(n), c(n), d(n);
    for (ll &i: a)
        cin >> i;
    for (ll &i: b)
        cin >> i;
    for (ll &i: c)
        cin >> i;
    for (ll &i: d)
        cin >> i;
    ll cnt = 0, ans = 0;
    auto a1 = a;
    for (ll i = 0; i < n; i++) {
        if (a[i] == 0) {
            ans += min(c[i], d[i]);
            if (c[i] < d[i])
                a[i] += b[i];
            else
                a[i] -= b[i];
        }
        if (a[i] < 0)
            cnt++;
    }
    if (cnt % 2 == 0) {
        cout << ans << '\n';
        return;
    }
    ll mn = 1e18;
    for (ll i = 0; i < n; i++) {
        if (a1[i] == 0) {
            mn = min(mn, abs(d[i] - c[i]));
        } else {
            if (a[i] > 0) {
                mn = min(mn, (a[i] + b[i]) / b[i] * d[i]);
            } else {
                mn = min(mn, (-a[i] + b[i]) / b[i] * c[i]);
            }
        }
    }
    cout << ans + mn << '\n';
}