#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
#define aint(a) a.begin(), a.end()

const int MOD = 1e9 + 7;
const int INF = 1e18;

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int t = 1;
    //cin >> t;
    ld T = clock();
    while (t--)
        solve();
#ifdef _GLIBXX_DEBUG
    cout << endl;
    cerr << '\n' << ld(clock() - T) / CLOCKS_PER_SEC;
#endif
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &i: a)
        cin >> i;
    vector<vector<vector<pair<int, int>>>> dp(n,
                                              vector<vector<pair<int, int>>>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++)
            dp[i][j].resize(i + 1, {1e9, 1e9});
    }
    dp[0][0][0] = {0, 1e9};
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < i; k++) {
                dp[i][j][i].first = min(dp[i][j][i].first, dp[i - 1][j][k].first);
                dp[i][j][i].first = min(dp[i][j][i].first, dp[i - 1][j][k].second);
                if (j + 1 < n) {
                    dp[i][j + 1][k].first = min(dp[i][j + 1][k].first, dp[i - 1][j][k].second + max(0, a[k] - a[i]));
                    dp[i][j + 1][k].second = min(dp[i][j + 1][k].second,
                                                 dp[i - 1][j][k].first + max(0, 1 - a[k] - a[i]));
                    if (a[k] + a[i] > 0)
                        dp[i][j + 1][i].first = min(dp[i][j + 1][i].first, dp[i - 1][j][k].first);
                    if (-a[k] + 1 + a[i] > 0)
                        dp[i][j + 1][i].first = min(dp[i][j + 1][i].first, dp[i - 1][j][k].second);
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        int mn = 1e9;
        for (int j = 0; j < n; j++) {
            mn = min(mn, dp[n - 1][n - 1 - i][j].first);
            mn = min(mn, dp[n - 1][n - 1 - i][j].second);
        }
        cout << mn << '\n';
    }
}