#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
#define all(a) a.begin(), a.end()

const ll MOD = 1e9 + 7;
const ll INF = 1e18;

using ordered_set = tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    ld T = clock();
    while (t--)
        solve();
#ifdef _GLIBXX_DEBUG
    cout << endl;
    cerr << '\n' << ld(clock() - T) / CLOCKS_PER_SEC;
#endif
}

void dfs(ll s, vector<ll> &u, vector<vector<ll>> &g) {
    u[s] = 1;
    for (ll i: g[s]) {
        if (!u[i]) {
            dfs(i, u, g);
        }
    }
}

vector<ll> t;

void dfs_top(ll s, vector<ll> &u, vector<vector<ll>> &g) {
    u[s] = 1;
    for (ll i = 0; i < g.size(); i++) {
        if (g[s][i] && !u[i]) {
            dfs_top(i, u, g);
        }
    }
    t.push_back(s);
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> a(n);
    for (ll &i: a) {
        cin >> i;
        i--;
    }
    vector<vector<ll>> g(m, vector<ll>(m)), cost = g;
    vector<vector<ll>> g2(m);
    for (auto &i: cost) {
        for (ll &j: i)
            cin >> j;
    }
    for (ll i = 1; i < n; i++) {
        g2[a[i]].push_back(a[i - 1]);
    }

    for (ll i = 0; i < m; i++) {
        vector<ll> u(m);
        dfs(i, u, g2);
        g[i] = u;
    }

    vector<ll> u(m);
    vector<vector<ll>> v;
    vector<ll> comp(m);
    for (ll i = 0; i < m; i++) {
        if (u[i])
            continue;
        v.push_back({});
        for (ll j = 0; j < m; j++) {
            if (u[j])
                continue;
            if (g[i][j] && g[j][i]) {
                u[j] = 1;
                comp[j] = v.size() - 1;
                v.back().push_back(j);
            }
        }
    }

    ll m1 = v.size();
    vector<vector<ll>> g1(m1, vector<ll>(m1));
    for (ll i = 0; i < m1; i++) {
        for (ll j: v[i]) {
            for (ll k = 0; k < m; k++) {
                if (g[j][k]) {
                    g1[i][comp[k]] = 1;
                }
            }
        }
    }

    vector<ll> u1(m1);
    for (ll i = 0; i < m1; i++) {
        if (u1[i] == 0) {
            dfs_top(i, u1, g1);
        }
    }
    vector<ll> cnt(m);
    for (ll i: a)
        cnt[i]++;
    for (ll i = 0; i < m; i++) {
        if (cnt[i] == 0) {
            for (ll &j: cost[i])
                j = 0;
        }
    }
    vector<vector<ll>> dp(m1 + 1, vector<ll>(m + 1, 1e15));
    for (ll &i: dp[0])
        i = 0;
    for (ll i = 1; i <= m1; i++) {
        for (ll j = 0; j < m; j++) {
            ll c = 0;
            for (ll k: v[t[i - 1]])
                c += cost[k][j];
            dp[i][j + 1] = min(dp[i][j + 1], dp[i - 1][j + 1] + c);
            dp[i][j + 1] = min(dp[i][j + 1], dp[i][j]);
        }
    }
    ll ans = *min_element(all(dp.back()));
    cout << ans << '\n';
}