#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
const ll INF = LLONG_MAX;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<vector<ll>> cost(m, vector<ll>(m));
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> cost[i][j];
        }
    }
    vector<int> mini(m, n);
    vector<int> maxi(m, -1);
    for (int i = 0; i < n; ++i) {
        if (mini[a[i]] > i) {
            mini[a[i]] = i;
        }
        if (maxi[a[i]] < i) {
            maxi[a[i]] = i;
        }
    }
    vector<vector<int>> event;
    for (int i = 0; i < m; ++i) {
        if (mini[i] == n) continue;
        event.push_back({mini[i], 0, i});
        event.push_back({maxi[i], 1, i});
    }
    std::sort(event.begin(), event.end());
    vector<vector<int>> seg;
    int bal = 0;
    for (auto ev : event) {
        if (ev[1] == 0) {
            if (bal == 0) {
                seg.emplace_back();
            }
            bal++;
            seg[seg.size() - 1].push_back(ev[2]);
        } else {
            bal--;
        }
    }
    int k = seg.size();
    vector<vector<ll>> dp(k, vector<ll>(m));
    for (int j = 0; j < m; ++j) {
        ll s = 0;
        for (int el : seg[0]) {
            s += cost[el][j];
        }
        dp[0][j] = s;
    }
    for (int i = 1; i < k; ++i) {
        int minj = 0;
        for (int j = 0; j < m; ++j) {
            ll s = 0;
            for (int el : seg[i]) {
                s += cost[el][j];
            }
            if (dp[i - 1][minj] > dp[i - 1][j]) {
                minj = j;
            }
            if (dp[i - 1][minj] == INF) {
                dp[i][j] = INF;
                continue;
            }
            dp[i][j] = dp[i - 1][minj] + s;
        }
    }
    ll ans = INF;
    for (int j = 0; j < m; ++j) {
        ans = min(ans, dp[k - 1][j]);
    }
    cout << ans;
    return 0;
}