#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

mt19937 rnd(0);

bool check(ll x) {
    ll cnt = 0;
    for (ll j = 2; j * j <= x; j++) {
        ll c = 0;
        while (x % j == 0) {
            c++;
            x /= j;
        }
        if (c % 2 == 1) {
            cnt++;
        }
    }
    if (x > 1) {
        cnt++;
    }
    return cnt <= 1;
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n, m;
    cin >> n >> m;
    vector<ll> gg;
    for (ll i = 1; i <= n; i++) {
        if (check(i)) {
            gg.push_back(i);
        }
    }
    while (true) {
        ll sum = n * (n + 1) / 2;
        ll cnt = rnd() % min(ll(gg.size()), m);
        for (ll i = 0; i < gg.size(); i++) {
            swap(gg[i], gg[rnd() % (i + 1)]);
        }
        for (ll i = 0; i < cnt; i++) {
            sum -= gg[i];
        }
        if (check(sum)) {
            cout << cnt + 1 << '\n';
            set<ll> other;
            for (ll i = 1; i <= n; i++) {
                other.insert(i);
            }
            for (ll i = 0; i < cnt; i++) {
                cout << "1\n" << gg[i] << '\n';
                other.erase(gg[i]);
            }
            cout << other.size() << '\n';
            for (ll i: other) {
                cout << i << ' ';
            }
            return 0;
        }
    }
}