#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <deque>
#include <unordered_map>

using namespace std;

#define int long long
#define x first
#define y second

int inf = 1'000'000'000'000;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> v(n);
	vector<vector<int>> cost(m, vector<int>(m)), c(m, vector<int>(m));
	for (auto& i : v) {
		cin >> i;
		i--;
	}
	for (auto& i : cost) {
		for (auto& j : i) {
			cin >> j;
		}
	}
	vector<vector<int>> v1(m);
	for (int i = 0; i < n; i++) {
		v1[v[i]].push_back(i);
	}
	vector<vector<int>> pod;
	vector<int> v3(m);
	for (int i = 0; i < n; i++) {
		vector<int> ans1;
		v3[v[i]]++;
		ans1.push_back(v[i]);
		bool b = false;
		for (int j = 0; j < m; j++) {
			if (v3[j] != 0 && v3[j] != v1[j].size()) {
				b = true;
			}
		}
		while (b) {
			i++;
			v3[v[i]]++;
			if (v3[v[i]] == 1) ans1.push_back(v[i]);
			b = false;
			for (int j = 0; j < m; j++) {
				if (v3[j] != 0 && v3[j] != v1[j].size()) {
					b = true;
				}
			}
		}
		pod.push_back(ans1);
	}
	/*
	7 3
3 1 3 1 2 2 2
0 1 2
3 4 5
6 7 8

7 3
3 1 1 1 1 1 2
0 2 3
3 0 1
1 4 0




2 0
1
*/
	unordered_map<int, int> ma;
	int cnt = 0;
	for (auto& i : pod) {
		for (auto& j : i) {
			ma[j] = cnt++;
		}
	}
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < m; j++) {
			c[ma[i]][j] = cost[i][j];
		}
	}
	for (auto&i : v) {
		i = ma[i];
	}

	for (int i = 1; i < m; i++) {
		for (int j = 0; j < m; j++) {
			c[i][j] += c[i - 1][j];
		}
	}
	for (auto& i : pod) {
		sort(pod.begin(), pod.end());
	}
	vector<vector<int>> dp(pod.size(), vector<int>(m));
	for (int j = 0; j < m; j++) {
		dp[0][j] = min(c[pod[0][pod[0].size() - 1]][j], (j == 0 ? inf : dp[0][j - 1]));
	}
	for (int i = 1; i < pod.size(); i++) {

		for (int j = 0; j < m; j++) {
			dp[i][j] = min(dp[i - 1][j] + c[pod[i][pod[i].size() - 1]][j] - c[pod[i][0] - 1][j], (j == 0 ? inf : dp[i][j - 1]));
		}
	}
	int ans = inf;
	for (auto& i : dp[pod.size() - 1]) {
		ans = min(i, ans);
	}
	cout << ans;
}

signed main() {
	//ios_base::sync_with_stdio(false);
	//cin.tie(0);
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
	}
}