#include <bits/stdc++.h>

#pragma GCC optimize("02,03,Ofast,unroll-loops,inline")
#pragma GCC target("avx,avx2,sse,sse2,ssse3,sse4")

const long long MOD1 = 1e9 + 7;
const long long MOD2 = 1e9 + 9;
const long double PI = 3.1419514;

void speedInput() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(0);
  std::cout.tie(0);
}
long long deg(long long n, long long m, long long mod) {
    if (m == 0) return 1;
    if (m % 2 == 1) return 1ll * deg(n, m - 1, mod) * n % mod;
    long long cur = deg(n, m / 2, mod);
    return 1ll * cur * cur % mod;
}

class SegementTree {
    class Node {
     public:
        int val;
    };
 private:
    std::vector <Node> body;
 public:
    SegementTree() {

    }
};

class Elem {
 public:
    long long a, b, c, d;
};

void solveB() {
    int n;
    std::cin >> n;

    std::vector <Elem> elems(n);
    for (int i = 0; i < n; i++) {
        std::cin >> elems[i].a;
    }
    for (int i = 0; i < n; i++) {
        std::cin >> elems[i].b;
    }
    for (int i = 0; i < n; i++) {
        std::cin >> elems[i].c;
    }
    for (int i = 0; i < n; i++) {
        std::cin >> elems[i].d;
    }

    long long sum = 0;
    int cnt = 0;
    int beBoth = false;

    std::vector <int> cur(n);
    std::vector <int> e(n);

    for (int i = 0; i < n; i++) {
        if (elems[i].a == 0) {
            if (elems[i].c < elems[i].d) {
                sum += elems[i].c;
                cur[i] = elems[i].b;
                e[i] = elems[i].c;
            } else if (elems[i].c == elems[i].d) {
                beBoth = true;
                sum += elems[i].c;
                e[i] = elems[i].c;
            } else {
                sum += elems[i].d;
                cur[i] = -elems[i].b;
                e[i] = elems[i].d;
            }
        } else {
            cur[i] = elems[i].a;
            e[i] = 0;
        }

        if (cur[i] < 0) {
            cnt++;
        }
    }

    if (beBoth || cnt % 2 == 0) {
        std::cout << sum;
        return;
    }

    // std::cout << '!';

    long long res = LLONG_MAX;
    for (int i = 0; i < n; i++) {
        long long curRes = sum - e[i];
        if (cur[i] > 0) {
            curRes += (abs(elems[i].a) / elems[i].b + 1) * elems[i].d;
        } else {
            curRes += (abs(elems[i].a) / elems[i].b + 1) * elems[i].c;
        }
        res = std::min(res, curRes);
    }

    std::cout << res;
}

void solveC() {

}

signed main() {
    // speedInput();

    solveB();

    return 0;
}
