#include <bits/stdc++.h>

#pragma GCC optimize("02,03,Ofast,unroll-loops,inline")
#pragma GCC target("avx,avx2,sse,sse2,ssse3,sse4")

const long long MOD1 = 1e9 + 7;
const long long MOD2 = 1e9 + 9;
const long double PI = 3.1419514;

void speedInput() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(0);
  std::cout.tie(0);
}
long long deg(long long n, long long m, long long mod) {
    if (m == 0) return 1;
    if (m % 2 == 1) return 1ll * deg(n, m - 1, mod) * n % mod;
    long long cur = deg(n, m / 2, mod);
    return 1ll * cur * cur % mod;
}

class SegementTree {
    class Node {
     public:
        int val;
    };
 private:
    std::vector <Node> body;
 public:
    SegementTree() {

    }
};

class Elem {
 public:
    long long a, b, c, d;
};

void solveC() {
    int n;
    std::cin >> n;

    int m;
    std::cin >> m;

    std::vector <std::vector <int>> res;
    for (int i = 0; i < 20; i++) {
        res.push_back({});
        for (int j = 1; j * (1 << i) <= n; j += 2) {
            res[i].push_back(j * (1 << i));
        }
        if (res.back().empty()) {
            res.pop_back();
        }
    }

    std::cout << (int) res.size() << '\n';
    for (auto i : res) {
        std::cout << (int) i.size() << '\n';
        for (auto j : i) {
            std::cout << j << ' ';
        }
        std::cout << '\n';
    }
}

signed main() {
    speedInput();

    solveC();

    return 0;
}
