#include <bits/stdc++.h>

// #pragma GCC optimize("02,03,Ofast,unroll-loops,inline")
// #pragma GCC target("avx,avx2,sse,sse2,ssse3,sse4")

void speedInput() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(0);
  std::cout.tie(0);
}

const int MID = 100 + 1;

void solveE() {
    int n;
    std::cin >> n;

    std::vector <int> array(n);
    for (int i = 0; i < n; i++) {
        std::cin >> array[i];
        array[i] += MID;
    }

    std::vector <std::vector <std::vector <long long>>> dp(n + 1, std::vector <std::vector <long long>> (n + 1, std::vector <long long> (MID * 2 + 2, LLONG_MAX)));
    for (int cur = 0; cur <= MID * 2 + 1; cur++) {
        dp[0][0][cur] = 0;
    }

    for (int len = 1; len <= n; len++) {
        for (int j = 0; j < n; j++) {
            for (int cur = 0; cur <= MID * 2 + 1; cur++) {
                for (int prev = 0; prev <= MID * 2 + 1; prev++) {
                    if (cur + prev > 2 * MID && dp[len - 1][j][prev] != LLONG_MAX) {
                        dp[len][j][cur] = std::min(dp[len][j][cur], dp[len - 1][j][prev] + abs(cur - array[len - 1]));
                    } else if (cur + prev <= 2 * MID) {
                        if (j > 0 && dp[len - 1][j - 1][prev] != LLONG_MAX) {
                            dp[len][j][cur] = std::min(dp[len][j][cur], dp[len - 1][j - 1][prev] + abs(cur - array[len - 1]));
                        }
                    }
                }
            }
        }
    }

    for (int j = 0; j < n; j++) {
        long long res = LLONG_MAX;
        for (int cur = 0; cur <= MID * 2 + 1; cur++) {
            res = std::min(res, dp[n][j][cur]);
        }
        std::cout << res << ' ';
    }
}

signed main() {
    speedInput();

    solveE();

    return 0;
}
