#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#define int long long
#define ld long double

using namespace std;


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> pos(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
        pos[a[i]] = i;
    }
    vector<vector<int>> cost(m, vector<int>(m));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> cost[i][j];
        }
    }
    vector<int> nxt(n);
    for (int i = 0; i < n; ++i) {
        nxt[i] = pos[a[i]];
    }
    vector<unordered_map<int, int>> nw;
    int bar = -1;
    for (int i = 0; i < n; ++i) {
        if (i > bar) {
            unordered_map<int, int> d;
            nw.push_back(d);
        }
        bar = max(bar, nxt[i]);
        nw.back()[a[i]]++;
    }
    int k = (int)nw.size();
    vector<vector<int>> new_cost(k, vector<int>(m));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < m; ++j) {
            int cnt = 0;
            for (auto it = nw[i].begin(); it != nw[i].end(); ++it) {
                cnt += cost[it -> first][j];
            }
            new_cost[i][j] = cnt;
        }
    }
    vector<vector<int>> dp(k, vector<int>(m));
    for (int i = 0; i < m; ++i) {
        dp[0][i] = new_cost[0][i];
    }
    for (int i = 1; i < k; ++i) {
        int mn = dp[i - 1][0];
        for (int j = 0; j < m; ++j) {
            mn = min(mn, dp[i - 1][j]);
            dp[i][j] = mn + new_cost[i][j];
        }
    }
    int ans = 1e17;
    for (int i = 0; i < m; ++i) {
        ans = min(ans, dp.back()[i]);
    }
    cout << ans << endl;
    return 0;
}