#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;

void solve_c() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> ans(m);
    vector<ll> to(n + 1, -1);
    //for (ll )
}

const ll INF = 1e18 + 5;

void solve_d() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    for (ll &i : a) {
        cin >> i;
    }
    vector<vector<ll>> dp(n, vector<ll> (n, INF));
    dp[n - 1] = vector<ll> (n, 0);
    for (ll k = n - 2; k >= 0; --k) {
        dp[k][0] = 0;
        for (ll i = 1; i < n; ++i) {
            vector<ll> b = a;
            ll add = 0;
            ll c = 0;
            for (ll j = i; j > 0; --j) {
                if (b[j] + b[j - 1] <= 0) {
                    ll x = abs(b[j] + b[j - 1]) + 1;
                    b[j - 1] += x;
                    add += x;
                    c++;
                }
                dp[k][i] = min(dp[min(n - 1, k + c)][j - 1] + add, dp[k][i]);
            }
        }
        for (auto i : dp[k]) {
            cout << i << ' ';
        }
        cout << endl;
    }
    for (ll k = 0; k < n; ++k) {
        cout << dp[k][n - 1] << ' ';
    }
    cout << endl;
}

void solve_d2() {

    ll n;
    cin >> n;
    vector<ll> a(n);
    for (ll &i : a) {
        cin >> i;
    }
    for (ll mask = 0; mask < (1 << n); ++mask) {
        for (ll i = 0; i < n; ++i) {
            if ((mask >> i) & 1) {

            }
        }
    }
}

struct Event {
    ll pos, type, id;

    Event(ll pos, ll type, ll id) : pos(pos), type(type), id(id) {}
};

void solve_e() {
    ll n, m;
    cin >> n >> m;
    vector<ll> a(n);
    for (ll &i : a) {
        cin >> i;
        i--;
    }
    vector<vector<ll>> to(m, vector<ll> (m));
    for (auto &i : to) {
        for (auto &j : i) {
            cin >> j;
        }
    }
    vector<ll> l(m, n), r(m);
    for (ll i = 0; i < n; ++i) {
        r[a[i]] = i;
        l[a[i]] = min(l[a[i]], i);
    }
    vector<Event> seg;
    for (ll i = 0; i < m; ++i) {
        if (l[i] != n) {
            seg.emplace_back(l[i], 1, i);
            seg.emplace_back(r[i], -1, i);
        }
    }
    sort(seg.begin(), seg.end(), [] (const Event &a, const Event &b) {
        return a.pos < b.pos;
    });
    ll bal = 0;
    set<ll> open;
    vector<ll> c(m);
    ll col = 0;
    for (auto [pos, type, id] : seg) {
        if (type) {
            open.insert(id);
        }
        bal += type;
        if (bal == 0) {
            col++;
            for (auto i : open) {
                c[i] = col;
            }
            open.clear();
        }
    }
    col++;
    vector<vector<ll>> g(col, vector<ll> (m));
    for (ll i = 0; i < m; ++i) {
        for (ll j = 0; j < m; ++j) {
            g[c[i]][j] += to[i][j];
        }
    }
    /*for (auto i : c) {
        cout << i << ' ';
    }
    cout << endl;
    for (auto i : g) {
        for (auto j : i) {
            cout << j << ' ';
        }
        cout << endl;
    }*/

    vector<vector<ll>> dp(col, vector<ll> (m));
    dp[1] = g[1];
    for (ll i = 1; i < col; ++i) {
        ll mn = INF;
        for (ll j = 0; j < m; ++j) {
            mn = min(mn, dp[i - 1][j]);
            dp[i][j] = mn + g[i][j];
        }
    }
    ll ans = INF;
    for (ll j = 0; j < m; ++j) {
        ans = min(ans, dp[col - 1][j]);
    }
    cout << ans;
}

void sovle_f() {}

void solve_g() {}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve_e();
    }
    return 0;
}