#include <bits/stdc++.h>

using namespace std;

using ll = long long;
mt19937 rnd(chrono::system_clock::now().time_since_epoch().count());
const int INF = INT_MAX;

bool checkPrime(ll x) {
    for (int i = 2; 1ll * i * i <= x; i++) {
        if (x % i == 0) return false;
    }
    return true;
}

bool checkSum(int sm) {
    for (int x = 1; x * x <= sm; x++) {
        if (sm % (x * x) == 0 && checkPrime(sm / x / x)) return true;
    }
    return false;
}

bool tryToDivide(vector<int> x, vector<vector<int>>& res) {
    if (x.empty()) return true;
    int n = (int)x.size();
    for (int mask = 1; mask < (1 << n); mask++) {
        int sm = 0;
        for (int i = 0; i < n; i++) if (mask & (1 << i)) sm += x[i];
        if (checkSum(sm)) {
            vector<int> out;
            for (int i = 0; i < n; i++) if (!(mask & (1 << i))) out.push_back(x[i]);
            vector<vector<int>> ans;
            if (tryToDivide(out, ans)) {
                res.emplace_back();
                for (int i = 0; i < n; i++) if (mask & (1 << i)) res.back().push_back(x[i]);
                for (const auto& el : ans) res.push_back(el);
                return true;
            }
        }
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    ll sm = 1ll * n * (n + 1) / 2;

    ll maxPr = sm;
    for (; maxPr > 0 && !checkPrime(maxPr); maxPr--);
    vector<int> l;
    sm -= maxPr;
    for (int x = n; x > 0; x--) {
        if (x <= maxPr) {
            l.push_back(x);
            maxPr -= x;
        } else if (maxPr == 0) break;
        else {
            l.push_back((int) maxPr);
            break;
        }
    }
    m--;

    set<int> ss;
    for (int x = 1; x < n; x++) ss.insert(x);
    for (int val : l) ss.erase(val);
    vector<int> arr;
    for (int val : ss) arr.push_back(val);

    vector<vector<int>> ans = {l};
    if (!tryToDivide(arr, ans) || ans.size() > m) assert(0);
    cout << ans.size() << endl;
    for (auto el : ans) {
        cout << el.size() << endl;
        for (int x : el) cout << x << " ";
        cout << endl;
    }
}