#include <bits/stdc++.h>

using namespace std;

using ll = long long;
mt19937 rnd(chrono::system_clock::now().time_since_epoch().count());
const int INF = INT_MAX;

int n;
vector<int> a;
vector<vector<map<int, int>>> dp;

void recalc(int i, int kl, int prev, int val) {
    if (dp[i][kl].count(prev)) {
        dp[i][kl][prev] = min(dp[i][kl][prev], val);
    } else dp[i][kl][prev] = val;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    a.resize(n);
    for (int& i : a) cin >> i;
    int cntBad = 0;
    for (int i = 0; i < n - 1; i++) if (a[i] + a[i + 1] <= 0) cntBad++;

    dp.assign(n, vector<map<int, int>> (n + 1));
    dp[0][0][0] = 0;

    for (int i = 0; i < n - 1; i++) {
        for (int kl = 0; kl <= i + 1; kl++) {
            for (auto el : dp[i][kl]) {
                int prev;
                if (i == 0) prev = 1e6;
                else prev = a[i] + a[i - 1];
                if (prev + el.first <= 0) {
                    recalc(i + 1, kl + 1, 1 - prev - el.first, el.second + 1 - prev - el.first);
                }
                recalc(i + 1, kl, 0, el.second);
                if (a[i] + a[i + 1] <= 0) {
                    recalc(i + 1, kl + 1, 1 - a[i] - a[i + 1], el.second + 1 - a[i] - a[i + 1]);
//                    dp[i + 1][kl + 1][1 - a[i] - a[i + 1]] = el.second + 1 - a[i] - a[i + 1];
                }
                if (a[i] <= 0) {
                    recalc(i + 1, kl, 1 - a[i], el.second + 1 - a[i]);
//                    dp[i + 1][kl][1 - a[i]] = el.second + 1 - a[i];
                }
                if (prev + el.first <= 0 && a[i] + a[i + 1] <= 0) {
                    recalc(i + 1, kl + 2, max(1 - prev - el.first, 1 - a[i] - a[i + 1]), el.second + max(1 - prev - el.first, 1 - a[i] - a[i + 1]));
//                    dp[i + 1][kl + 2][max(1 - prev - el.first, 1 - a[i] - a[i + 1])] = el.second + max(1 - prev - el.first, 1 - a[i] - a[i + 1]);
                }
//                cout << "dp " << i << " " << kl << " " << el.first << "  " << el.second << endl;
            }
        }
    }

//    for (int kl = 0; kl <= n; kl++) {
//        for (auto el : dp[n - 1][kl]) {
//            cout << "dp " << n - 1 << " " << kl << " " << el.first << "  " << el.second << endl;
//        }
//    }




    vector<int> ans(n, INF);
    for (int kl = 0; kl <= cntBad; kl++) {
        for (auto el : dp[n - 1][kl]) {
            ans[cntBad - kl] = min(ans[cntBad - kl], el.second);
        }
    }
    cout << ans[0] << " ";
    for (int kl = 1; kl < n; kl++) {
        ans[kl] = min(ans[kl], ans[kl - 1]);
        cout << ans[kl] << " ";
    }
}