#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
#define ll long long
#define pii pair<int, int>
#define all(x) x.begin(), x.end()
using namespace __gnu_pbds;
using namespace std;
template <class T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e3;
vector<int> d;
vector<int> pos;
vector<vector<int> > g;
int n;
int typeq = 0;
void dfs(int v, int p, int h){
    pos[v] = d.size();
    d.push_back(h);
    for(auto i: g[v]){
        if(i != p) dfs(i, v, h + 1);
        d.push_back(h);
    }
    d.push_back(h);
}
vector<vector<int> > sparse;
int ln = 21;
void calc(){
    for(int i = 0; i < d.size(); i++){
        sparse[0][i] = d[i];
    }
    for(int t = 0; t < ln; t++){
        for(int i = 0; i < int(d.size()) - (1 << t); i++){
            sparse[t + 1][i] = min(sparse[t][i], sparse[t][i + (1 << t)]); 
        }
    }
}
int calcmin(int l, int r){
    int x = __lg(r - l);
    return min(sparse[x][l], sparse[x][r - (1 << x) + 1]);
}
ll pref_ans = 0;
ll calc_cur(vector<pii> &v, vector<ll> &pref, int l, int r){
    ll x = calcmin(v[l].first, v[r].first) + 1;
    x = x * 1ll * (pref[r] - pref[l - 1]);
    return x;
}
void solve(){
    int k;
    cin >> k;
    vector<pair<int, int> > qi(k + 1);
    int v, c;
    for(int i = 1; i <= k; i++){
        cin >> v >> c;
        if(typeq == 2){
            v = (v + pref_ans) % (n - 1) + 2;
        }
        qi[i] = {pos[v], c};
    }
    sort(qi.begin() + 1, qi.end());
    vector<ll> pref(k + 1, 0);
    for(int i = 1; i <= k; i++){
        pref[i] += pref[i - 1];
        pref[i] += qi[i].second;
    }
    ll mx = 0;
    for(int i = 1; i <= k; i++){
        mx = max(mx, (d[qi[i].first] + 1) * 1ll * qi[i].second);
    }
    for(int i = 2; i <= k; i++){
        int cmn = calcmin(qi[i - 1].first, qi[i].first) + 1;
        int l = 1, r = i - 1;
        int l1 = i - 1;
        while(l <= r){
            int mid = (l + r) >> 1;
            if(calcmin(qi[mid].first, qi[i - 1].first) + 1 >= cmn){
                l1 = mid;
                r = mid - 1;
            }
            else{
                l = mid + 1;
            }
        }
        l = i, r = k;
        int r1 = i;
        while(l <= r){
            int mid = (l + r) >> 1;
            if(calcmin(qi[i].first, qi[mid].first) + 1 >= cmn){
                r1 = mid;
                l = mid + 1;
            }
            else{
                r = mid - 1;
            }
        }
        // cout << cmn << "! " << l1 << " " << r1 << endl;
        mx = max(mx, (pref[r1] - pref[l1 - 1]) * 1ll * cmn);
    }
    cout << mx << "\n";
    pref_ans = mx;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n;
    g.resize(n + 1);
    pos.resize(n + 1);
    int a, b;
    for(int i = 1; i < n; i++){
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(1, 1, 0);
    sparse.resize(ln + 1, vector<int>(d.size() + 1));

    calc();
    int T = 1, t;
    cin >> T >> t;
    typeq = t;
    while(T--){
        solve();
    }
}