#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main(){
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    int dp[n + 1][n];
    for (int i = 0; i <= n; i++)
        for (int j = 0; j < n; j++)
            if (i == 0) dp[i][j] = 0;
            else dp[i][j] = 1000000000;
    int st[n][n];
    for (int i = 0; i < n; i++){
        st[i][i] = 0;
        int lst = a[i];
        for (int j = i + 1; j < n; j++){
            st[i][j] = st[i][j - 1] + max(0, -(a[j] + lst) + 1);
            lst = a[j] + max(0, -(a[j] + lst) + 1);
        }
    }
    for (int i = 1; i <= n; i++){
        dp[i][0] = st[0][i - 1];
        dp[i][i - 1] = 0;
        for (int j = 1; j < i; j++){
            for (int k = 0; k < i; k++)
                dp[i][j] = min(dp[i][j], dp[k][j - 1] + st[k][i - 1]);
        }
    }
    for (int i = 0; i < n; i++) cout << dp[n][i] << " ";
}