#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 4e5;
array<vector<int>, N> g;
int h[N];
ll cnt[N], dp[N];
ll meow;

void dfs(int v, int par) {
    for (auto &u : g[v]) {
        if (u == par)
            continue;
        h[u] = h[v] + 1;
        dfs(u, v);
    }
}

void walk(int v, int par) {
    dp[v] = cnt[v];
    for (auto &u : g[v]) {
        if (u == par)
            continue;
        walk(u, v);
        dp[v] += dp[u];
    }
    meow = max(meow, dp[v] * h[v]);
}

int main() {
#ifdef cot_in
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v].emplace_back(u);
        g[u].emplace_back(v);
    }
    h[0] = 1;
    dfs(0, -1);
    int q, t;
    cin >> q >> t;
    while (q--) {
        for (int i = 0; i < n; i++)
            cnt[i] = dp[i] = 0;
        int k;
        cin >> k;
        while (k--) {
            int v, c;
            cin >> v >> c;
            v--;
            cnt[v] += c;
        }
        meow = 0;
        walk(0, -1);
        cout << meow << '\n';
    }
    return 0;
}