// @maximka228
   
#pragma GCC optimize("O3") // the most "agressive" optimization
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
   
#include "bits/stdc++.h"
   
const int64_t MODULO = 1000000007;
const double PI = 3.14159265359;
const std::string ENDL = "\n";

// Hints:
// 1) Interval tasks solution ways: 1) prefix sums (prefix xors) or difference array 2) segment tree or fenwick tree 3) idea/constructive.
// 2) If the condition of the problem mentions 1) only 2 choices (for example, a problem about numbers consisting only of the digits 4 and 7) 2) any power of two (2, 4, 8 ...), then this is a bitmask problem.
// 3) Subsequences (array, string and so on) tasks solution ways: 1) DP 2) prefix sums (prefix xors) 3) two pointers.
   
// If you think, that your solution is correct, but you are still getting errors, check:
// 1) Overflow.
// 2) Such cases as n = 1 and so on. Also check task restrictions.
// 3) Memory usage.
 
int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
   
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    
    int64_t a, b, n, m;
    std::cin >> a >> b >> n >> m;
    
    int64_t x = 0;
    
    if (b - 2 * a == 0 && m - 2 * n != 0) {
        std::cout << -1 << ENDL;
        return 0;
    }
    
    if (b - 2 * a == 0) {
        x = 0;
    } else if ((m - 2 * n) % (b - 2 * a) == 0) {
        x = (m - 2 * n) / (b - 2 * a);
    } else {
        std::cout << -1 << ENDL;
        return 0;
    }
    
    if (x < 0 || n - a * x < 0) {
        std::cout << -1 << ENDL;
        return 0;
    }
    
    std::cout << n - a * x << " " << x << ENDL;
}