#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
#include <fstream>


using namespace std;

#define int long long

const int MAXN = 200005;
const long long INF = (long long)2e18;

int ceil(int a, int b) {
    if (a % b == 0) {
        return a / b;
    }
    return a / b + 1;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n), c(n), d(n);
    for (int &i: a) {
        cin >> i;
    }
    for (int &i: b) {
        cin >> i;
    }
    for (int &i: c) {
        cin >> i;
    }
    for (int &i: d) {
        cin >> i;
    }
    vector<vector<int>> dp(2, vector<int>(n));
    if (a[0] > 0) {
        dp[0][0] = 0;
        dp[1][0] = ceil(a[0] + 1, b[0]) * d[0];
    } else if (a[0] < 0) {
        dp[1][0] = 0;
        dp[0][0] = ceil(abs(a[0]) + 1, b[0]) * c[0];
    } else {
        dp[0][0] = ceil(abs(a[0]) + 1, b[0]) * c[0];
        dp[1][0] = ceil(a[0] + 1, b[0]) * d[0];
    }
    for (int i = 1; i < n; ++i) {
        if (a[i] > 0) {
            dp[0][i] = min(dp[0][i - 1], dp[1][i - 1] + ceil(a[i] + 1, b[i]) * d[i]);
            dp[1][i] = min(dp[1][i - 1], dp[0][i - 1] + ceil(a[i] + 1, b[i]) * d[i]);
        } else if (a[i] < 0) {
            dp[0][i] = min(dp[1][i - 1], dp[0][i - 1] + ceil(abs(a[i]) + 1, b[i]) * c[i]);
            dp[1][i] = min(dp[0][i - 1], dp[1][i - 1] + ceil(abs(a[i]) + 1, b[i]) * c[i]);
        } else {
            dp[0][i] = min(dp[1][i - 1] + ceil(a[i] + 1, b[i]) * d[i], dp[0][i - 1] + ceil(abs(a[i]) + 1, b[i]) * c[i]);
            dp[1][i] = min(dp[0][i - 1] + ceil(a[i] + 1, b[i]) * d[i], dp[1][i - 1] + ceil(abs(a[i]) + 1, b[i]) * c[i]);
        }
    }
    cout << dp[0].back();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("inp.txt", "r", stdin);
//    freopen("out.txt", "w", stdout);
    int ttt = 1;
//    cin >> ttt;
    while (ttt--) {
        solve();
    }
}