#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <string>
#include <set>
#include <map>
#define int long long

using namespace std;

istream & operator >> (istream & in, vector <auto> & v) {
    for (auto & el : v) {
        cin >> el;
    }
    return in;
}
ostream & operator << (ostream & in, vector <auto> & v) {
    for (auto & el : v) {
        cout << el << " ";
    }
    cout << "\n";
    return in;
}
vector <int> ans(500, 1e18);
vector <int> v(500, 1e18);
int n;

void f(int i, int pre, int kp, int sum) {
    if (i == n) {
        ans[kp] = min(ans[kp], sum);
//        cout << kp << " " << sum << "\n";
        return;
    }
    for (int j = 0; j < 200; j++) {
        f(i + 1, v[i] + j, kp + (pre + v[i] + j <= 0), sum + j);
    }
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    f(0, 1e18, 0, 0);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            ans[j] = min(ans[j], ans[i]);
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i] << " ";
    }
}

signed main()
{
//    cout << fixed << setprecision(9);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}