#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <string>
#include <set>
#include <map>
#define int long long

using namespace std;

istream & operator >> (istream & in, vector <auto> & v) {
    for (auto & el : v) {
        cin >> el;
    }
    return in;
}
ostream & operator << (ostream & in, vector <auto> & v) {
    for (auto & el : v) {
        cout << el << " ";
    }
    cout << "\n";
    return in;
}
ostream & operator << (ostream & in, vector <vector <auto>> & v) {
    for (auto & el : v) {
        cout << el;
    }
    cout << "\n";
    return in;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector <int> v;
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        a--;
        v.emplace_back(a);
    }
    vector <vector <int>> p(m, vector <int> (m));
    for (int i = 0; i < m; i++) {
        cin >> p[i];
    }
    vector <vector <int>> dp (v.size() + 1, vector <int> (m, 1e18));
    for (int i = 0; i < n; i++) {
        dp[0][i] = 0;
    }
    for (int i = 1; i < v.size() + 1; i++) {
        for (int j = 0; j < m; j++) {
            dp[i][j] = min(dp[i][j], dp[i - 1][j] + p[v[i - 1]][j]);
        }
        for (int j = 1; j < m; j++) {
            dp[i][j] = min(dp[i][j], dp[i][j - 1]);
        }
    }
//    cout << dp;
    cout << dp[v.size()][m - 1];
}
/**
4 4
1 4 3 2
0 3 2 1
3 0 2 1
3 2 0 1
3 2 1 0

*/
signed main()
{
//    cout << fixed << setprecision(9);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}