#include <bits/stdc++.h>

using namespace std;
#define int long long
#define sort stable_sort
#define f first
#define s second
#define pii pair<int,int>
#define pb push_back
#define ll long long
int cost[1000][1000];
vector<int> tour;
void dfs1(int v, vector<vector<int>>& r, vector<bool>& used){
    used[v] = true;
    for(int g: r[v]){
        if(used[g]) continue;
        dfs1(g,r,used);
    }
    tour.pb(v);
}
void dfs2(int v, vector<vector<int>>& r, vector<int>& comp, int c){
    comp[v] = c;
    for(int g: r[v]){
        if(comp[g] != -1) continue;
        dfs2(g,r,comp,c);
    }
}
int a[500000];
vector<set<int>> rr(1000);
vector<set<int>> derr(1000);
vector<vector<int>> r(1000);
vector<vector<int>> der(1000);
vector<vector<int>> costincomp(1000, vector<int>(1000,0));
vector<vector<int>> dp(1000, vector<int>(1000, 1e18));
void solve(){
    int n=500000,m=1000;
    cin >> n >> m;

    vector<int> howmany(m,0);
    for(int i = 0; i < n; ++i){
        a[i] = 1;
        cin >> a[i];
        a[i]--;
        howmany[a[i]]++;
    }
    for(int i = 0; i < m; ++i){
        for(int j = 0; j < m; ++j){
            if(i==j) cost[i][j] = 0;
    else cost[i][j] = rand();
            cin >> cost[i][j];
        }
    }
    for(int i = 0; i < n-1; ++i){
        if(a[i] == a[i+1]) continue;
        rr[a[i+1]].insert(a[i]);
        derr[a[i]].insert(a[i+1]);
    }
    for(int i = 0; i < m; ++i){
        for(int j: rr[i]){
            r[i].pb(j);
        }
        for(int j: derr[i]){
            der[i].pb(j);
        }
    }
    vector<bool>used(m, false);
    for(int i = 0; i < m; ++i){
        if(!used[i] && howmany[i] > 0){
            dfs1(i,r,used);
        }
    }
    vector<int> comp(m,-1);
    int cnt = 0;
    reverse(tour.begin(),tour.end());
    for(int i: tour){
        //cerr << i << "?\n";
        if(comp[i] == -1) {
            dfs2(i,der,comp,cnt);
            cnt++;
        }
    }
    vector<int> nextcomp(cnt,-1);
    vector<int> prevcomp(cnt,-1);

    for(int i = 0; i < m; ++i){
        for(int j: r[i]){
            if(comp[i] != comp[j]){

                nextcomp[comp[i]] = comp[j];
                prevcomp[comp[j]] = comp[i];
            }
        }
    }

    for(int i = 0; i < m; ++i){
        for(int j= 0; j < m; ++j){
            if(comp[i] == -1) continue;
            costincomp[comp[i]][j] += cost[i][j];
        }
    }
    for(int i = 0; i < m; ++i){
        dp[comp[a[0]]][i] = costincomp[comp[a[0]]][i];
    }
    int now = prevcomp[comp[a[0]]];
    while(now != -1){
        int tekmin = dp[nextcomp[now]][0];
        for(int i = 0; i < m; ++i){
            dp[now][i] = costincomp[now][i] + tekmin;
            if(i!=m-1) tekmin = min(tekmin, dp[nextcomp[now]][i+1]);
        }
        now = prevcomp[now];
    }

    int ans = 1e18;
    for(int i = 0; i < m; ++i){
        ans = min(ans, dp[comp[a[n-1]]][i]);
    }
    cout << ans << '\n';

}
signed main()
{
    #ifdef LOCAL
        setlocale(LC_ALL, "Russian");
    #else

    #endif // LOCAL
    srand(time(0));
    cin.tie(nullptr)->sync_with_stdio(false);

    int t=1;
   // cin >> t;
    while(t--){
        solve();
    }
}
