#include <iostream>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <vector>
#include <list>
//#include <>
//#include <>

#define all(v) v.begin(), v.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;

const ll INF = 1'000'000'000'000'000'000;
const ll MOD = 1'000'000'123;
vector<vector<int>> g;
vector<bool> used;
vector<int> order;

int gcd (int a, int b) {
    while(b != 0) {
        a %= b;
        swap(a,b);
    }
    return a;
}

struct DSU {
    vector<int> p;
    vector<int> r;

    int get(int v) {
        if (p[v] == v) {
           return v;
        }
        return (p[v] = get(p[v]));
    }

};

void dfs1(int v) {
    if (used[v])
        return;
    for(auto u : g[v]) {
        if (!used[u])
            dfs1(u);
    }
    order.push_back(v);
}

void Solve() {
    ll a,b,n,m;
    cin >> a >> b >> n >> m;
    ll c = b-2*a;
    ll t = m-2*n;
    if (c == 0 && t != 0) {
        cout << -1;
        return;
    }
    if (t == 0) {
        cout << n << ' ' << 0;
        return;
    }
    if (c > 0 && t < 0) {
        cout << -1;
        return;
    }
    if (c < 0 && t > 0) {
        cout << -1;
        return;
    }
    if (c < 0) {
        c *= -1;
        t *= -1;
    }
    if (t % c != 0) {
        cout << -1;
        return;
    }
    if (n < t/c*a) {
        cout << -1;
        return;
    }
    cout << n - (t/c)*a << ' ' << t/c;
    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int t = 1;
    //cin >> t;
    while(t--) {
        Solve();
    }
    return 0;
}
