#include <iostream>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <vector>
#include <list>
//#include <>
//#include <>

#define all(v) v.begin(), v.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;

const ll INF = 1'000'000'000'000'000'000;
const ll MOD = 1'000'000'123;
vector<vector<int>> g;
vector<bool> used;
vector<int> order;

int gcd (int a, int b) {
    while(b != 0) {
        a %= b;
        swap(a,b);
    }
    return a;
}

struct DSU {
    vector<int> p;
    vector<int> r;

    int get(int v) {
        if (p[v] == v) {
           return v;
        }
        return (p[v] = get(p[v]));
    }

};

void dfs1(int v) {
    if (used[v])
        return;
    for(auto u : g[v]) {
        if (!used[u])
            dfs1(u);
    }
    order.push_back(v);
}

void Solve() {
    int n;
    cin >> n;
    vector<ll> a(n);
    vector<ll> b(n);
    vector<ll> c(n);
    vector<ll> d(n);
    vector<int> ch(n, 0);
    for(auto& e : a) cin >> e;
    for(auto& e : b) cin >> e;
    for(auto& e : c) cin >> e;
    for(auto& e : d) cin >> e;

    ll ans = 0;
    int cnt = 0;
    for(int i = 0; i < n; i++) {
        if (a[i] == 0) {
            if (c[i] <= d[i]) {
                a[i] += b[i];
                ans += c[i];
                ch[i]++;
            } else {
                a[i] -= b[i];
                ans += d[i];
                ch[i]++;
                cnt++;
            }
        } else if (a[i] < 0) {
            cnt++;
        }
    }
    if (cnt%2 == 0) {
        cout << ans;
        return;
    }
    ll mini = INF;
    for(int i = 0; i < n; i++) {
        if (a[i] > 0) {
            if (a[i] % b[i] == 0) {
                mini = min(mini, max(0*1ll, (a[i]/b[i] + 1)*d[i] - ch[i]*(c[i] + d[i])));
            } else
                mini = min(mini, max(0*1ll, (a[i] + b[i] - 1)/b[i]*d[i] - ch[i]*(c[i] + d[i])));
        }
        else {
            if (labs(a[i]) % b[i] == 0) {
                mini = min(mini, max(0*1ll, (labs(a[i])/b[i] + 1)*c[i] - ch[i]*(c[i] + d[i])));
            } else
                mini = min(mini, max(0*1ll, (labs(a[i]) + b[i] - 1)/b[i]*c[i] - ch[i]*(c[i] + d[i])));
        }
    }
    ans += mini;
    cout << ans;
    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int t = 1;
    //cin >> t;
    while(t--) {
        Solve();
    }
    return 0;
}
