#include <iostream>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <vector>
#include <list>
//#include <>
//#include <>

#define all(v) v.begin(), v.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;

const ll INF = 1'000'000'000'000'000'000;
const ll MOD = 1'000'000'123;
vector<vector<int>> g;
vector<bool> used;
vector<int> order;

int gcd (int a, int b) {
    while(b != 0) {
        a %= b;
        swap(a,b);
    }
    return a;
}

struct DSU {
    vector<int> p;
    vector<int> r;

    int get(int v) {
        if (p[v] == v) {
           return v;
        }
        return (p[v] = get(p[v]));
    }

};

void dfs1(int v) {
    if (used[v])
        return;
    for(auto u : g[v]) {
        if (!used[u])
            dfs1(u);
    }
    order.push_back(v);
}

vector<ll> sq (ll n) {
    vector<ll> a;
    while(n != 0) {
        ll k = sqrt(n);
        n -= k*k;
        if (n == k * k) {
            n = 0;
            a.push_back(2*k*k);
        } else
            a.push_back(k*k);
    }
    return a;
}

void Solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> vec = sq(n*(n+1)/2);
    //for(auto e : vec) cout << e << ' ';
    vector<vector<int>> ans(vec.size());
    for(int i = n; i >= 1; i--) {
        for(int j = vec.size() - 1; j >= 0; j--) {
            if (vec[j] >= i) {
                ans[j].push_back(i);
                vec[j] -= i;
                break;
            }
        }
    }
    cout << vec.size() << '\n';
    for(auto el : ans) {
        cout << el.size() << '\n';
        for(auto e : el) cout << e << ' ';
        cout << '\n';
    }
    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int t = 1;
    //cin >> t;
    while(t--) {
        Solve();
    }
    return 0;
}
