#include <iostream>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <vector>
#include <list>
//#include <>
//#include <>

#define all(v) v.begin(), v.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;

const ll INF = 1'000'000'000'000'000'000;
const ll MOD = 1'000'000'123;
vector<vector<int>> g;
vector<bool> used;
vector<int> order;
vector<int> tin;
vector<int> tout;
vector<int> deep;

int gcd (int a, int b) {
    while(b != 0) {
        a %= b;
        swap(a,b);
    }
    return a;
}

struct DSU {
    vector<int> p;
    vector<int> r;

    int get(int v) {
        if (p[v] == v) {
           return v;
        }
        return (p[v] = get(p[v]));
    }

};
int timer = 0;
void dfs1(int v, int d) {
    tin[v] = timer++;
    used[v] = 1;
    deep[v] = d;
    for(auto u : g[v]) {
        if (!used[u])
            dfs1(u, d+1);
    }
    tout[v] = timer++;
}
    int n;
void Solve() {
    int k;
    cin >> k;
    vector<vector<int>> vec(k, vector<int>(2));
    for(auto& e : vec) {
        cin >> e[0] >> e[1];
        e[0]--;
    }
    int maxi = -1;
    for(int i = 0; i < n; i++) {
        //cout << tin[i] << ' ' << tout[i] << ' ' << deep[i] << endl;
        int tmp = 0;
        for(int j = 0; j < k; j++) {
            if (tin[i] <= tin[vec[j][0]] && tout[vec[j][0]] <= tout[i]) {
                tmp += vec[j][1];
            }
        }
        maxi = max(maxi, tmp*(deep[i] + 1));
    }
    cout << maxi << '\n';
    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    cin >> n;
    g.resize(n);
    for(int i = 0; i < n-1; i++) {
        int v,u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    tin.resize(n);
    tout.resize(n);
    deep.resize(n);
    used.assign(n, 0);
    dfs1(0, 0);
    int q,t;
    cin >> q >> t;
    while(q--) {
        Solve();
    }
    return 0;
}
