#include <bits/stdc++.h>
using namespace std;

template <typename T>
istream &operator>>(istream &in, vector <T> &vec) {
    for (auto &el : vec) {
        in >> el;
    }
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector <T> &vec) {
    for (auto el : vec) {
        out << el << ' ';
    }
    out << '\n';
    return out;
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using pll = pair <long long, long long>;

#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.begin(), vec.end()
#define F first
#define S second

void solution() {
    ll a, b, n, m;
    cin >> a >> b >> n >> m;

    if (a * 2 == b) {
        if (n * 2 == m) {
            cout << n << ' ' << 0;
        } else {
            cout << -1;
        }
        return;
    }

    ll z = m - n * 2, d = b - a * 2;
    if (d == 0 || z % d != 0) {
        cout << -1;
    } else {
        ll cnt = z / d;
        if (min(n - cnt * a, cnt) < 0) {
            cout << -1;
        } else {
            cout << n - cnt * a << ' ' << cnt;
        }
    }

}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tt = 1;
    // cin >> tt;
    while (tt--) {
        solution();
        cout << '\n';
    }

    return 0;
}