#include <bits/stdc++.h>
using namespace std;

template <typename T>
istream &operator>>(istream &in, vector <T> &vec) {
    for (auto &el : vec) {
        in >> el;
    }
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector <T> &vec) {
    for (auto el : vec) {
        out << el << ' ';
    }
    out << '\n';
    return out;
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using pll = pair <long long, long long>;

#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.begin(), vec.end()
#define F first
#define S second

void solution() {
    ll n;
    cin >> n;
    vector <ll> a(n), b(n), c(n), d(n);
    cin >> a >> b >> c >> d;

    vector <ll> dpp(n + 1), dpm(n + 1);
    ll ch = abs(a[0]) / b[0] + 1;
    if (a[0] > 0) {
        dpp[0] = 0, dpm[0] = ch * d[0];
    } else if (a[0] == 0) {
        dpp[0] = c[0], dpm[0] = d[0];
    } else {
        dpp[0] = ch * c[0], dpm[0] = 0;
    }
    for (ll i = 1; i < n; ++i) {
        ch = abs(a[i]) / b[i] + 1;
        if (a[i] > 0) {
            dpp[i] = min(dpp[i - 1], dpm[i - 1] + ch * d[i]);
            dpm[i] = min(dpp[i - 1] + ch * d[i], dpm[i - 1]);
        } else if (a[i] == 0) {
            dpp[i] = min(dpp[i - 1] + c[i], dpm[i - 1] + d[i]);
            dpm[i] = min(dpp[i - 1] + d[i], dpm[i - 1] + c[i]);
        } else {
            dpp[i] = min(dpp[i - 1] + ch * c[i], dpm[i - 1]);
            dpm[i] = min(dpp[i - 1], dpm[i - 1] + ch * c[i]);
        }
    }

    cout << dpp[n - 1];
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tt = 1;
    // cin >> tt;
    while (tt--) {
        solution();
        cout << '\n';
    }

    return 0;
}