#include <bits/stdc++.h>
using namespace std;

template <typename T>
istream &operator>>(istream &in, vector <T> &vec) {
    for (auto &el : vec) {
        in >> el;
    }
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector <T> &vec) {
    for (auto el : vec) {
        out << el << ' ';
    }
    out << '\n';
    return out;
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using pll = pair <long long, long long>;

#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.begin(), vec.end()
#define F first
#define S second

void solution() {
    ll n, m;
    cin >> n >> m;
    // if (n == 1) {
    //     cout << 1 << '\n' << 1 << '\n' << 1;
    //     return;
    // }

    ll num = 1, pw = 0;
    while (num <= n) {
        ++pw, num *= 2;
    }

    num = 1;
    cout << pw << '\n';
    for (ll i = 0; i < pw; ++i) {
        vector <ll> out;
        for (ll j = 1; j * num <= n; j += 2) {
            out.emplace_back(j * num);
        }
        num *= 2;
        cout << out.size() << '\n' << out;
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tt = 1;
    // cin >> tt;
    while (tt--) {
        solution();
        cout << '\n';
    }

    return 0;
}