#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define endl '\n'

typedef long long ll;
typedef long double ld;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 1e18 + 1;
const int MOD = 1e9 + 7;
const int MOD2 = 1e9 + 9;

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int n, m;
vector <bool> p;
vector <bool> f;
vector <vector <int>> ans;
vector <bool> used;

void func(int k){
    //cout << k << " ";
    if (k <= n && !used[k] && f[k]){
        used[k] = true;
        ans.push_back({k});
        return;
    }
    int ind = -1;
    for (int i = 1; i <= min(n, k); i++){
        if (k - i <= n && f[k - i] && !used[k - i]){
            ind = i;
            break;
        }
    }
    used[k - ind] = true;
    ans.push_back({k - ind});
    func(ind);
}

signed main(){
    Fast();
    cin >> n >> m;
    p.resize(n + 1, true);
    f.resize(n + 1, false);
    used.resize(n + 1, false);
    p[1] = true;
    for (int i = 2; i <= n; i++){
        if (!p[i])
            continue;
        p[i] = true;
        for (int j = i * i; j <= n; j++)
            p[j] = false;
    }
    for (int i = 1; i <= n; i++){
        int g = i * i;
        for (int j = g; j <= n; j += g){
            if (p[j / g])
                f[j] = true;
        }
    }
    //cout << 572893 << endl;
    if (n % 2 == 0)
        func(n / 2);
    else
        func((3 * n - 1) / 2);
    //cout << endl;
    ans.push_back({});
    for (int i = 1; i <= n; i++){
        if (!used[i])
            ans.back().push_back(i);
    }
    if (ans.back().empty())
        ans.pop_back();
    cout << (int)ans.size() << endl;
    for (int i = 0; i < (int)ans.size(); i++){
        cout << (int)ans[i].size() << endl;
        for (auto j:ans[i]){
            cout << j << " ";
        }
        cout << endl;
    }
}