#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define endl '\n'

typedef long long ll;
typedef long double ld;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 1e18 + 1;
const int MOD = 1e9 + 7;
const int MOD2 = 1e9 + 9;

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

signed main(){
    Fast();
    int n, m;
    cin >> n >> m;
    vector <int> a(n);
    vector <int> cnt(m);
    for (int i = 0; i < n; i++){
        cin >> a[i];
        a[i]--;
        cnt[a[i]]++;
    }
    vector <vector <int>> cost(m, vector <int> (m));
    for (int i = 0; i < m; i++){
        for (int j = 0; j < m; j++){
            cin >> cost[i][j];
        }
    }
    set <int> k;
    multiset <int> s;
    vector <vector <int>> g;
    for (int i = 0; i < n; i++){
        if (!k.count(a[i])){
            k.insert(a[i]);
            s.insert(cnt[a[i]]);
        }
        s.erase(s.find(cnt[a[i]]));
        s.insert(--cnt[a[i]]);
        if (*(--s.end()) == 0){
            vector <int> c(m);
            for (int j = 0; j < m; j++){
                for (int y:k){
                    c[j] += cost[y][j];
                }
            }
            g.push_back(c);
            s.clear();
            k.clear();
        }
    }
    vector <vector <int>> dp((int)g.size(), vector <int> (m, INF));
    vector <int> p(m);
    for (int i = 0; i < m; i++){
        dp[0][i] = g[0][i];
        p[i] = dp[0][i];
        if (i > 0)
            p[i] = min(p[i - 1], p[i]);
    }
    for (int i = 1; i < (int)g.size(); i++){
        for (int j = 0; j < m; j++){
            dp[i][j] = p[j] + g[i][j];
            p[j] = dp[i][j];
            if (j > 0)
                p[j] = min(p[j], p[j - 1]);
        }
    }
    cout << p[m - 1];
    return 0;
}