#ifndef LOCALEGOR
#pragma optmize("Ofast")
#pragma target("avx2")
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld PI = acosl(-1);

mt19937 rnd(3105);

bool ok(int n) {
    int t = 0;
    for (int d = 2; d * d <= n; ++d) {
        int c = 0;
        while (n % d == 0) {
            ++c;
            n /= d;
        }
        t += c & 1;
    }
    if (n > 1) {
        t += 1;
    }
    return t <= 1;
}

int n;
int sm(int a, int b) {
    return (b - a + 1) * (a + b) >> 1;
}
vector<pair<int, int>> res;
int m;
vector<int> ord;
vector<int> pord;
void gen(int i) {
    if (sz(res) > m) {
        return;
    }
    if (i == n + 1) {
        cout << sz(res) << '\n';
        for (auto pr : res) {
            cout << pr.second - pr.first + 1 << '\n';
            for (auto rk = pr.first; rk <= pr.second; ++rk) cout << ord[rk - 1] << ' ';
            cout << '\n';
        }
        exit(0);
    } 
    for (int j = n; j >= i; --j) {
        if (ok(pord[j] - pord[i - 1])) {
            res.push_back({i, j});
            gen(j + 1);
            res.pop_back();
        }
    }
}

void solve() {
    cin >> n;
    ord.resize(n);
    for (int i = 0; i < n; ++i) ord[i] = i + 1;
    shuffle(all(ord), rnd);
    pord.resize(n + 1);
    for (int i = 1; i <= n; ++i) {
        pord[i] = pord[i - 1] + ord[i - 1];
    }
    cin >> m;
    gen(1);
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen("INPUT.txt", "r", stdin);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}