#ifndef LOCALEGOR
#pragma optmize("Ofast")
#pragma target("avx2")
#endif

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld PI = acosl(-1);

mt19937 rnd(3105);

void solve() {
    int n;
    cin >> n;
    vector<gp_hash_table<int, ll>> dp(n);
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    dp[0][a[0]] = 0;
    for (int i = 1; i < n; ++i) {
        vector<gp_hash_table<int, ll>> ndp(n);
        for (int pk = 0; pk < n; ++pk) {
            for (auto&& [k, v] : dp[pk]) {
                if (a[i] + k <= 0) {
                    if (ndp[pk + 1].find(a[i]) == ndp[pk + 1].end() ||
                        v < ndp[pk + 1][a[i]]) {
                        ndp[pk + 1][a[i]] = v;
                    }
                    if (ndp[pk].find(-k + 1) == ndp[pk].end() ||
                        (v - (a[i] + k) + 1) < ndp[pk][-k + 1]) {
                        ndp[pk][-k + 1] = v - (a[i] + k) + 1;
                    }
                    if (ndp[pk].find(a[i]) == ndp[pk].end() ||
                        (v - (a[i] + k) + 1) < ndp[pk][a[i]]) {
                        ndp[pk][a[i]] = v - (a[i] + k) + 1;
                    }
                } else {
                    if (ndp[pk].find(a[i]) == ndp[pk].end() ||
                        v < ndp[pk][a[i]]) {
                        ndp[pk][a[i]] = v;
                    }
                }
            }
        }
        dp.swap(ndp);
    }
    int ans = INF;
    for (int k = 0; k < n; ++k) {
        for (auto&& [kk, vv] : dp[k]) {
            ans = min(ans, vv);
        }
        cout << ans << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen("INPUT.txt", "r", stdin);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}