// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <bits/stdc++.h>

using namespace std;

//#include <bits/extc++.h>
//using namespace __gnu_pbds;
//typedef tree<
//        int,
//        null_type,
//        less<int>,
//        rb_tree_tag,
//        tree_order_statistics_node_update>
//        ordered_set;

//#define int long long
#define int128 __int128
#define ld long double
#define all(x) x.begin(), x.end()
#define pb push_back
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int MAXN = 2e5 + 100, MOD = 1e9 + 1000 - 7, PW = 179, K = 17, SQ = 1000, INF = 1e9;


void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &it: a) cin >> it;
    vector<vector<int>> dp(n + 1, vector<int> (n, INF));
    dp[0][0] = 0;
    vector<vector<int>> segs(n, vector<int>(n, INF));
    for (int i = 0; i < n; ++i) {
        segs[i][i] = 0;
        int last = a[i];
        for (int j = i + 1; j < n; ++j) {
            segs[i][j] = segs[i][j - 1];
            segs[i][j] += max(0, (-last + 1) - a[j]);
            last = max(a[j], (-last + 1));
        }
    }
    for (int i = 0; i < n; ++i) {
//        dp[i][0] = 0;
        for (int j = 0; j <= i; ++j) {
            for (int z = i; z < n; ++z) {
                int delta = z - i;
                dp[z + 1][j + delta] = min(dp[z + 1][j + delta], dp[i][j] + segs[i][z]);
            }
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        cout << dp[n][i] << ' ';
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int T = 1;
//    cin >> T;
    while (T--)
        solve();
}