// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <bits/stdc++.h>

using namespace std;

//#include <bits/extc++.h>
//using namespace __gnu_pbds;
//typedef tree<
//        int,
//        null_type,
//        less<int>,
//        rb_tree_tag,
//        tree_order_statistics_node_update>
//        ordered_set;

#define int long long
#define int128 __int128
#define ld long double
#define all(x) x.begin(), x.end()
#define pb push_back
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int MAXN = 1e3 + 100, MOD = 1e9 + 1000 - 7, PW = 179, K = 17, SQ = 1000, INF = 1e18;

struct DSU{
    vector<int> p;

    DSU(int n) {
        p.assign(n, 0);
        for (int i = 0; i < n; ++i) p[i] = i;
    }

    int get(int u) {
        if (u == p[u]) return u;
        return p[u] = get(p[u]);
    }

    void uni(int u, int v) {
        u = get(u);
        v = get(v);
        if (u == v) return;
        if (rand() % 2) swap(u, v);
        p[u] = v;
    }
};

bool intersect(int l, int r, int l1, int r1) {
    return (l1 <= l && l <= r1) || (l1 <= r && r <= r1) || (l <= r1 && r1 <= r) || (l <= l1 && l1 <= r);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> inp(n), mnind(m, INF), mxind(m, -INF);
    for (auto &it: inp) cin >> it;
    vector<vector<int>> cost(m, vector<int>(m));
    for (auto &it: cost) {
        for (auto &i: it) cin >> i;
    }
    for (int i = 0; i < n; ++i) {
        inp[i]--;
        mnind[inp[i]] = min(mnind[inp[i]], i);
        mxind[inp[i]] = max(mxind[inp[i]], i);
    }
    DSU tree(m);
    for (int i = 0; i < m; ++i) {
        for (int j = i + 1; j < m; ++j) {
            if (intersect(mnind[i], mxind[i], mnind[j], mxind[j]))
                tree.uni(i, j);
        }
    }
    vector<pair<int, int>> cringe(m, {INF, -1});
    vector<vector<int>> nw_cost(m, vector<int>(m));
    for (int i = 0; i < m; ++i) {
        cringe[i].second = i;
        int t = tree.get(i);
        cringe[t].first = min(cringe[t].first, mnind[i]);
        for (int j = 0; j < m; ++j) {
            nw_cost[t][j] += cost[i][j];
        }
    }
    sort(all(cringe));
    while (!cringe.empty() && cringe.back().first == INF) cringe.pop_back();
    vector<int> curr_dp(m, 0);
    reverse(all(cringe));
    while (!cringe.empty()) {
        int vertex = cringe.back().second;
        cringe.pop_back();
        if (vertex == -1) continue;
        vector<int> dp(m, 0);
        for (int i = 0; i < m; ++i) {
            dp[i] = curr_dp[i] + nw_cost[vertex][i];
            if (i != 0) dp[i] = min(dp[i], dp[i - 1]);
        }
        swap(dp, curr_dp);
    }
    cout << curr_dp.back();
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int T = 1;
//    cin >> T;
    while (T--)
        solve();
}