#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vec vector
#define pb push_back


template<typename A>
void print(A &a, char sep=' '){
    for(auto &i: a)
        cout << i << sep;
    cout << "\n";
}

template<typename A>
void read(A &a){
    for(auto &i: a)
        cin >> i;
}

const int inf = (int)1e18 + 7;

void solve(){
    int n; cin >> n;
    vec<array<int, 4>> a(n);
    for(int j = 0; j < 4; ++j){
        for(int i = 0; i < n; ++i)
            cin >> a[i][j];
    }

    int mn = inf;
    for(auto &i: a){
        if(i[0] == 0)continue;
        int cur;
        int need = (abs(i[0]) + i[1]) / i[1];
        if(i[0] > 0){
            cur = need * i[3];
        }else{
            cur = need * i[2];
        }
        mn = min(cur, mn);
    }

    int radd = 0;
    int mnd = inf;
    int zn = 1;
    for(auto &i: a){
        if(i[0] == 0){
            mnd = min(mnd, abs(i[3] - i[2]));
            if(i[2] <= i[3]){
                radd += i[2];
                i[0] = i[1];
            }else{
                radd += i[3];
                i[0] = -i[1];
            }
        }
        if(i[0] < 0)zn *= -1;
    }
    if(zn > 0){
        cout << radd << "\n";
        return;
    }


    cout << min(radd + mn, radd + mnd) << "\n";
}



signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int tt = 1;
    // cin >> tt;
    while(tt--){
        solve();
    }
    return 0;
}