#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vec vector
#define pb push_back
#define all(x) (x).begin(), (x).end()

using vi = vector<int>;
using str = string;

template<typename A>
void print(A &a, str sep=" "){
    for(auto &i: a)
        cout << i << sep;
    cout << "\n";
}

template<typename A>
void read(A &a){
    for(auto &i: a)
        cin >> i;
}

mt19937 rnd(429643);

const int inf = (int)1e18 + 7;

vi prime_factor(int x){
    vi res;
    for(int i = 2; i * i <= x; ++i){
        while (x % i == 0){
            res.pb(i);
            x /= i;
        }
    }
    if(x > 1)res.pb(x);
    return res;
}

bool check(int x){
    vi pf = prime_factor(x);
    int p = 1;
    for(int i: pf){
        if(p % i == 0)p /= i;
        else p *= i;
    }
    if(count(all(pf), p) || p == 1)
        return true;
    else return false;
}

int n, m;

bool f = false;

bool solve(vi &r2){
    if(f)return false;
    bool ok = true;
    for(auto &i: r2)
        ok &= check(i);
    if(!ok)return false;
    cout << r2.size() + 1 << "\n";
    cout << n - r2.size() << "\n";
    for(int i = 1; i <= n; ++i){
        if(!count(all(r2), i))cout << i << " ";
    }
    cout << "\n";
    for(int i: r2){
        cout << 1 << "\n" << i << "\n";
    }
    exit(0);
    return ok;
}

void gen(vi &cur, int left, int last){
    if(f || (left != 0 && left <= last))return;
    if(left == 0){
        f |= solve(cur);
        return;
    }
    for(int j = last + 1; j <= left; ++j){
        cur.pb(j);
        gen(cur, left - j, j);
        cur.pop_back();
    }
}

void solve(){
    cin >> n >> m;
    int sm = (1 + n) * n / 2;
    //cerr << sm << "\n";
    int mn = 0;
    for(int i = 0; i < 1000; ++i){
        if(check(sm - i)){
            mn = i;
            break;
        }
    }
    //cerr << mn << "\n";
    vi cur;
    gen(cur, mn, 0);
}



signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int tt = 1;
    // cin >> tt;
    while(tt--){
        solve();
    }
    return 0;
}