#pragma _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>


using namespace std;

const int MAXN = 1e5 + 3;
const int MOD = 1e9 + 7;
const long long INF = 1e18;
vector<int> g[MAXN];
int d[MAXN], l[MAXN], used[MAXN], valuable[MAXN], ans[MAXN];
void dfs(int v) {
	used[v] = 1;
	int ans_ = l[v];
	for (auto u : g[v]) {
		if (!used[u]) {
			d[u] = d[v] + 1;
			dfs(u);
			ans_ += ans[u];
		}
	}
	ans[v] = ans_;
	valuable[v] = ans_ * (d[v] + 1);
}

int main() {
	int n;
	cin >> n;
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	int q, t;
	cin >> q >> t;
	for (int i = 0; i < q; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int v, c;
			cin >> v >> c;
			l[v] = c;
		}
		dfs(1);
		int best = 0;

		for (int i = 1; i <= n; ++i) {
			best = max(best, valuable[i]);
			valuable[i] = 0;
			l[i] = 0;
			ans[i] = 0;
			used[i] = 0;
			d[i] = 0;
		}
		cout << best << "\n";
	
	}
}