#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cassert>

// #define LOCAL
#define int long long

using namespace std;

const int INF = 1e16 + 7;

inline void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> res;
    for (int k = 0; (1 << k) <= n; k++) {
        vector<int> cur;
        for (int i = 1 << k; i <= n; i += (1 << (k + 1))) {
            cur.push_back(i);
        }
        res.push_back(cur);
    }
    cout << (int)res.size() << "\n";
    for (int i = 0; i < (int)res.size(); i++) {
        cout << (int)res[i].size() << "\n";
        for (int x : res[i]) {
            cout << x << " ";
        }
        cout << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif
    solve();
}