#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <map>
#include <string>
#include <unordered_set>
#include <unordered_map>
#include <random>


using namespace std;


using ll = long long;
using pii = pair<int, int>;

random_device rd;
mt19937 rng(rd());


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll a, b, n, m;
    cin >> a >> b >> n >> m;
    ll c1 = 2 * a - b, c2 = a * m - b * n;
    if (c1 < 0 && c2 > 0 || c1 > 0 && c2 < 0) {
        cout << -1;
        return 0;
    }
    if (c1 == 0) {
        if (c2 != 0) {
            cout << -1;
        }
        else {
            cout << n << " " << 0;
        }
        return 0;
    }
    if (c2 % c1 != 0) {
        cout << -1;
        return 0;
    }
    ll x = c2 / c1;
    ll xab = (n - x) / a;
    if (x < 0 || xab < 0) {
        cout << -1;
        return 0;
    }
    if (xab * a + x != n || xab * b + 2 * x != m) {
        cout << -1;
        return 0;
    }
    cout << x << " " << xab;
    return 0;
}