#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>

#define all(a) a.begin(), a.end()
#define rall(a) a.begin(), a.end()
#define read(a) for(int i = 0; i < a.size(); ++i) cin >> a[i];
#define print(a) for(int i = 0; i < a.size(); ++i) cout << a[i] << " "; cout << endl;

using namespace std;
typedef long long int64;
typedef unsigned long long uint64;

const double pi = 3.1415926536;
const int inf = 1e9;
const int64 INF = 1e18;
const int64 MOD = 1e9 + 7;

void solve()
{
	int64 n;
	cin >> n;
	vector<int64> a(n), b(n), c(n), d(n);
	read(a); read(b); read(c); read(d);
	vector<int64> e(n);

	int64 res = 0;
	for (int64 i = 0; i < n; ++i)
	{
		if (a[i] > 0)
		{			
			e[i] = ((abs(a[i]) / b[i]) + 1) * d[i];
		}
		else if(a[i] < 0)
		{			
			e[i] = ((abs(a[i]) / b[i]) + 1) * c[i];
		}
		else
		{
			if (c[i] < d[i])
			{
				a[i] = b[i];
				res += c[i];
				e[i] = d[i] - c[i];
			}
			else
			{
				a[i] = -b[i];
				res += d[i];
				e[i] = c[i] - d[i];
			}
		}
	}
	int64 cnt = 0;
	for (int i = 0; i < n; ++i)
	{
		if (a[i] < 0) ++cnt;
	}
	if (cnt % 2)
	{
		int64 minel = INF;
		for (auto i : e)
		{
			minel = min(minel, i);
		}
		res += minel;
	}
	cout << res << endl;
}

int main()
{	
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	int T = 1;
	/*cin >> T;*/
	while (T--) solve();
	return 0;
}