#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>

#define all(a) a.begin(), a.end()
#define rall(a) a.begin(), a.end()
#define read(a) for(int i = 0; i < a.size(); ++i) cin >> a[i];
#define print(a) for(int i = 0; i < a.size(); ++i) cout << a[i] << " "; cout << endl;

using namespace std;
typedef long long int64;
typedef unsigned long long uint64;

const double pi = 3.1415926536;
const int inf = 1e9;
const int64 INF = 1e18;
const int64 MOD = 1e9 + 7;

void solve()
{
	int n, m;
	cin >> n >> m;
	vector<vector<int>> res;
	int start = 1;
	int step = 2;
	for (int i = 0; start <= n; ++i)
	{
		res.push_back(vector<int>(0));
		for (int j = start; j <= n; j += step)
		{
			res[i].push_back(j);
		}
		start *= 2;
		step *= 2;
	}
	cout << res.size() << endl;
	for (int i = 0; i < res.size(); ++i)
	{
		cout << res[i].size() << endl;
		for (int j = 0; j < res[i].size(); ++j)
		{
			cout << res[i][j] << " ";
		}
		cout << endl;
	}
}

int main()
{	
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	int T = 1;
	/*cin >> T;*/
	while (T--) solve();
	return 0;
}