#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <iomanip>
#include <cmath>
#include <bitset>

using namespace std;

#define int long long
// #define double long double

using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using ld = long double;

const int max_n = 1e5 + 10;
const ll inf = 1e18 + 57;

struct el {
    int diff, c, d;
    el(int c1, int d1) {
        c = c1;
        d = d1;
        diff = d - c;
    }
};

bool comp(el l, el r) {
    return l.diff < r.diff;
}

void solve() {
    int n; cin >> n;
    vector<int> a(n), b(n), c(n), d(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    for (int i = 0; i < n; i++) cin >> c[i];
    for (int i = 0; i < n; i++) cin >> d[i];
    int otr_is = inf, pol_is = inf;
    int jad = 0;
    int cn = 0, co = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] > 0) {
            pol_is = min(pol_is, ((a[i] / b[i]) + 1) * d[i]);
        } else if (a[i] < 0) {
            a[i] *= -1;
            otr_is = min(otr_is, ((a[i] / b[i]) + 1) * c[i]);
            a[i] *= -1;
            co ^= 1;
        } else {
            cn++;
            jad += min(c[i], d[i]);
        }
    }
    int is = min(otr_is, pol_is);
    if (cn == 0) {
        cout << is * co;
        return;
    }
    int res = inf;
    vector<el> v;
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) {
            v.emplace_back(c[i], d[i]);
        }
    }
    std::sort(v.begin(), v.end(), comp);
    int sz = v.size();
    int pr = 0, sf = 0;
    for (int i = 0; i < sz; i++) {
        sf += v[i].c;
    }
    for (int i = 0; i <= sz; i++) {
        if (i % 2 == co) {
            res = min(res, pr + sf);
        }
        if (i < sz) {
            pr += v[i].d;
            sf -= v[i].c;
        }
    }
    jad = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) {
            if (c[i] < d[i]) {
                a[i] += b[i];
            } else {
                a[i] -= b[i];
            }
            jad += min(c[i], d[i]);
        }
    }
    pol_is = inf, otr_is = inf;
    co = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] > 0) {
            pol_is = min(pol_is, ((a[i] / b[i]) + 1) * d[i]);
        } else if (a[i] < 0) {
            a[i] *= -1;
            otr_is = min(otr_is, ((a[i] / b[i]) + 1) * c[i]);
            a[i] *= -1;
            co ^= 1;
        }
    }
    if (co == 0) {
        cout << min(res, jad);
        return;
    } else {
        cout << min(res, jad + min(pol_is, otr_is));
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}