#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <iomanip>
#include <cmath>
#include <bitset>

using namespace std;

// #define int long long
// #define double long double

using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using ld = long double;

const int max_n = 1e5 + 10;
const ll inf = 1e18 + 57;

void solve() {
    int n, m; cin >> n >> m;
    vector<vector<int>> res;
    vector<int> calc(n + 1, 0);
    for (int j = 1; j <= n; j++) {
        int mx = 0;
        for (int k = 0; k < 20; k++) {
            if (j % (1 << k) == 0) {
                mx = max(mx, k);
            }
        }
        calc[j] = mx;
    }
    for (int i = 0; i < 20; i++) {
        vector<int> v;
        for (int j = 1; j <= n; j++) {
            if (calc[j] == i) {
                v.push_back(j);
            }
        }
        if (!v.empty()) {
            res.push_back(v);
        }
    }
    cout << res.size() << '\n';
    for (auto v : res) {
        cout << v.size() << '\n';
        for (auto j : v) {
            cout << j << " ";
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}