#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <iomanip>
#include <cmath>
#include <bitset>

using namespace std;

// #define int long long
// #define double long double

using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using ld = long double;

const int max_n = 1e5 + 10;
const ll inf = 1e9 + 57;

void solve() {
    int n, m; cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    int c[m][m];
    for (int i = 0; i < m; i++) for (int j = 0; j < m; j++) cin >> c[i][j];
    int more[n + 1][m + 1];
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= m; j++) {
            more[i][j] = 0;
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= m; j++) {
            more[i][j] = more[i - 1][j] + (a[i - 1] > j);
        }
    }
    int dp[n + 1][m + 1];
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= m; j++) {
            dp[i][j] = inf;
        }
    }
    for (int i = 0; i <= m; i++) {
        dp[0][i] = 0;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 1; j <= m; j++) {
            for (int k = j; k <= m; k++) {
                dp[i + 1][k] = min(dp[i + 1][k], dp[i][j] + (a[i] != k));
            }
        }
    }
    ll res = inf;
    for (int i = 1; i <= m; i++) {
        res = min(res, 1ll * dp[n][i]);
    }
    res *= c[1][0];
    cout << res;
}

/*
3 3
3 1 2
1 1 1
1 1 1
 1 1 1
 */

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}