#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>

using namespace std;

#define INF 2e18
#define int long long

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> v(n);
    for (auto& i : v) {
        cin >> i;
        i--;
    }
    vector<vector<int>> a(m, vector<int>(m));
    for (auto& i : a) 
        for (auto& j : i)
            cin >> j;
    vector<vector<int>> dp(n, vector<int>(m));
    dp[0][0] = a[v[0]][0];
    for (int j = 1; j < m; j++) {
        dp[0][j] = min(dp[0][j - 1], a[v[0]][j]);
    }
    for (int i = 1; i < n; i++) {
        dp[i][0] = dp[i - 1][0] + a[v[i]][0];
        for (int j = 1; j < m; j++) {
            int t = dp[i - 1][j] + a[v[i]][j];
            dp[i][j] = min(t, dp[i][j - 1]);
        }
    }
    int ans = INF;
    for (int j = 0; j < m; j++) {
        ans = min(ans, dp[n - 1][j]);
    }
    cout << ans;
    return 0;
}