#include <iostream>
#include <vector>
#include <climits>
// #define fastio
// #define __GLIBCXX_DEBUG

using namespace std;

#define int long long
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

int n;
vector<int> a, b, c, d;

void resize() {
    a.resize(n);
    b.resize(n);
    c.resize(n);
    d.resize(n);
}

signed main() {

    cin >> n;
    resize();
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    for (int i = 0; i < n; ++i) cin >> c[i];
    for (int i = 0; i < n; ++i) cin >> d[i];

    // стоимость сделать данной префикс отрицательным и положительным соответственно
    int otr = LLONG_MAX;
    int pol = 0;

    for (int i = 0; i < n; ++i) {
        int potr = otr;
        int ppol = pol;
        otr = LLONG_MAX;
        pol = LLONG_MAX;
        // пусть данное число будет больше 0
        {
            int operations = 0;
            if (a[i] < 0) {
                operations = (abs(a[i]) / b[i]) + 1;
            } else if (a[i] == 0) {
                operations = 1;
            }
            int var_otr = (potr == LLONG_MAX) ? LLONG_MAX : operations * c[i] + potr;
            int var_pol = (ppol == LLONG_MAX) ? LLONG_MAX : operations * c[i] + ppol;
            otr = min(otr, var_otr);
            pol = min(pol, var_pol);
        }
        // пусть данное число будет меньше 0
        {
            int operations = 0;
            if (a[i] > 0) {
                operations = (a[i] / b[i]) + 1;
            } else if (a[i] == 0) {
                operations = 1;
            }
            int var_otr = (ppol == LLONG_MAX) ? LLONG_MAX : operations * d[i] + ppol;
            int var_pol = (potr == LLONG_MAX) ? LLONG_MAX : operations * d[i] + potr;
            otr = min(otr, var_otr);
            pol = min(pol, var_pol);
        }
    }

    cout << pol << endl;
    return 0;
}