#define __GLIBCXX_DEBUG
#include <iostream>
#include <vector>
#include <climits>
#define fastio

using namespace std;

#ifdef fastio
#define endl '\n'
#endif
#define int long long
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

bool check(int a) {
    int odd_cnt = 0;
    for (int x = 2; x * x <= a; ++x) {
        int p = 0;
        while (a % x == 0) {
            a /= x;
            ++p;
        }
        if (p % 2 == 1) ++odd_cnt;
        if (odd_cnt > 1) return false;
    }

    if (a != 1) ++odd_cnt;
    if (odd_cnt > 1) return false;
    return true;
}

signed main() {
    #ifdef fastio
    cin.tie(0);
    ios::sync_with_stdio(0);
    #endif
    #ifdef ROMALOCAL
    std::freopen("C:/Users/Sirius/Documents/vscode1/in.txt", "r", stdin);
    std::freopen("C:/Users/Sirius/Documents/vscode1/out.txt", "w", stdout);
    cout << "local run" << endl;
    #endif
    int n, m;

    cin >> n >> m;
    vector<vector<int>> ans;
    vector<int> arr;
    int su = 0;
    for (int i = n; i >= 1; --i) {
        su += i;
        arr.push_back(i);
        if (check(su)) {
            ans.push_back(arr);
            arr.clear();
            su = 0;
        }
    }
    if (!arr.empty()) ans.push_back(arr);

    cout << ans.size() << endl;
    for (const auto &row : ans) {
        cout << row.size() << endl;
        for (const auto &el : row) {
            cout << el << " ";
        }
        cout << endl;
    }

    return 0;
}