#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const ll inf = 1e17 + 10;
const int maxn = 1e4 + 10;


vector<int> primes;
vector<int> isp(maxn, 1);

void build_pr() {
    for (ll i = 2; i < maxn; i++) {
        if (!isp[i]) continue;
        primes.push_back(i);
        for (ll j = i*i; j <= maxn; j += i) {
            isp[j] = 0;
        }
    }
}

set<int> good;

void build_good() {
    build_pr();
    for (int k = 1; k*k <= maxn; k++) {
        good.insert(k*k);
        for (auto p : primes) {
            if (p > k*k) break;
            good.insert(k*k - p);
        }
    }
}

void solve() {
    /*build_good();
    for (int i = 0; i < 1000; i++) {
        if (good.find(i) == good.end()) {
            cout << i << '\n';
        }
    }*/
    int n, m;
    cin >> n >> m;
    cout << n << '\n';
    for (int i = 0; i < n; i++) {
        cout << 1 << '\n' << i + 1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
    return 0;
}