#include <bits/stdc++.h>
#define int long long

using namespace std;

int rmq(int l, int r, int i, vector<vector<vector<int>>>& sp) {
    int llg = __lg(r - l);
    return min(sp[i][llg][l], sp[i][llg][r - (1ll << llg)]);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> fst(m, -1), lst(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        if (fst[a[i]] == -1) {
            fst[a[i]] = i;
        }
        lst[a[i]] = i;
    }
    vector<vector<int>> cost(m, vector<int>(m));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> cost[i][j];
        }
    }
    int lg = 23;
    vector<vector<vector<int>>> sp(m, vector<vector<int>>(lg, vector<int>(m)));
    for (int j = 0; j < m; ++j) {
        for (int i = 0; i < m; ++i) {
            sp[j][0][i] = cost[j][i];
        }
        for (int i = 1; i < lg; ++i) {
            for (int k = 0; k < m; ++k) {
                sp[j][i][k] = min(sp[j][i - 1][k], sp[j][i - 1][min(m - 1, k + (1 << (i - 1)))]);
            }
        }
    }
    vector<vector<int>> count(n, vector<int>(m));
    vector<pair<pair<int, int>, vector<int>>> segs;
    int curl = n - 1, prev = n - 1;
    set<int> c;
    for (int i = n - 1; i >= 0; --i) {
        c.insert(a[i]);
        curl = min(curl, lst[a[i]]);
        if (curl == i) {
            vector<int> f;
            for (auto& el : c) f.push_back(el);
            c.clear();
            segs.push_back({{i, prev}, f});
            curl = i - 1;
            prev = i - 1;
        }
    }
    reverse(segs.begin(), segs.end());
    int s = segs.size();
    vector<vector<int>> dp(s + 1, vector<int>(m));
    for (int i = 1; i <= s; ++i) {
        for (int j = 0; j < m; ++j) {
            dp[i][j] = 1e18;
            for (int k = 0; k <= j; ++k) {
                int res = 0;
                for (auto& el : segs[i - 1].second) {
                    res += rmq(k, j + 1, el, sp);
                }
                cout << i << " " << j << " " << k << "\n";
                dp[i][j] = min(dp[i][j], res + dp[i - 1][k]);
            }
        }
    }
    cout << dp[s][m - 1] << "\n";
}