#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <algorithm>
#include <cmath>
#include <deque>

using namespace std;

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n, m;
	cin >> n >> m;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		a[i]--;
	}
	vector<vector<ll>> cost(m, vector<ll>(m));
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> cost[i][j];
		}
	}

	vector<vector<pair<ll, ll>>> dp(n, vector<pair<ll, ll>>(m, { -1, 3e18 }));
	for (int i = 0; i < m; ++i) {
		dp[0][i].first = cost[a[i]][i];
	}
	for (int i = 0; i < m; ++i) {
		dp[0][i].second = min(dp[0][i - 1].second, dp[0][i].first);
	}
	for (int i = 1; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			dp[i][j].first = dp[i - 1][j].second + cost[a[i]][j];
		}
		for (int j = 0; j < m; ++j) {
			dp[i][j].second = min(dp[i][j - 1].second, dp[i][j].first);
		}
	}
	ll ans = 3e18;
	for (int i = 0; i < m; ++i) {
		ans = min(ans, dp[n - 1][i].first);
	}
	cout << ans;
}