#include "bits/stdc++.h"

using namespace std;

//@formatter:off
template<class T> istream &operator>>(istream &is, vector<T> &a);
template<class T> ostream &operator<<(ostream &os, const vector<T> &a);
#define int long long
//@formatter:on

int gcd_ext(int a, int b, int &x, int &y) {
      if (b == 0) {
            x = 1;
            y = 0;
            return a;
      }
      int x1, y1;
      int d = gcd_ext(b, b % a, x1, y1);
      x = y1;
      y = x1 - y1 * (a / b);
      return d;
}

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      cin.tie(nullptr);
      ios_base::sync_with_stdio(false);
#endif
      int a, b, n, m;
      cin >> a >> b >> n >> m;

      for (int t = 0; t * b <= m and t * a <= n; ++t) {
            if ((m - t * b) % 2 == 0 and (m - t * b) / 2 == n - t * a) {
                  cout << n - t * a << ' ' << t << '\n';
                  return 0;
            }
      }

      cout << -1 << '\n';
}

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
      for_each(a.begin(), a.end(), [&](auto &some) { is >> some; });
      return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &a) {
      for_each(a.begin(), a.end(), [&](auto &some) { os << some << ' '; });
      return (os << '\n');
}