#include "bits/stdc++.h"

using namespace std;

//@formatter:off
template<class T> istream &operator>>(istream &is, vector<T> &a);
template<class T> ostream &operator<<(ostream &os, const vector<T> &a);
#define int long long
//@formatter:on

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      cin.tie(nullptr);
      ios_base::sync_with_stdio(false);
#endif
      int n;
      cin >> n;
      vector<int> a(n);
      cin >> a;

      vector<int> ans(n, 1e18);
      for (int m = 0; m < (1 << n); ++m) {
            vector<int> now = a;
            int cnt = 0;
            int res = 0;
            for (int i = 0; i < n - 1; ++i) {
                  if ((m >> i) & 1) {
                        cnt++;
                        continue;
                  }

                  if (now[i] + now[i + 1] <= 0) {
                        res += abs(now[i] + now[i + 1]) + 1;
                        now[i + 1] += abs(now[i] + now[i + 1]) + 1;
                  }
            }
            ans[cnt] = min(ans[cnt], res);
      }

      for (int i = 1; i < n - 1; ++i) ans[i] = min(ans[i], ans[i - 1]);
      cout << ans;
}

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
      for_each(a.begin(), a.end(), [&](auto &some) { is >> some; });
      return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &a) {
      for_each(a.begin(), a.end(), [&](auto &some) { os << some << ' '; });
      return (os << '\n');
}