#include "bits/stdc++.h"

using namespace std;

//@formatter:off
template<class T> istream &operator>>(istream &is, vector<T> &a);
template<class T> ostream &operator<<(ostream &os, const vector<T> &a);
#define int long long
//@formatter:on

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      cin.tie(nullptr);
      ios_base::sync_with_stdio(false);
#endif
      int n, m;
      cin >> n >> m;
      vector<int> a(n);
      cin >> a;

      for (int i = 0; i < n; ++i) a[i]--;

      vector cost(m, vector<int> (m));
      cin >> cost;

      vector dp(n, vector<int> (m));
      vector mn(n, vector<int> (m));
      for (int i = 0; i < m; ++i) {
            dp[0][i] = cost[a[0]][i];
      }

      mn[0][0] = dp[0][0];
      for (int i = 1; i < m; ++i) {
            mn[0][i] = min(mn[0][i - 1], dp[0][i]);
      }

      for (int i = 1; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                  dp[i][j] = mn[i - 1][j] + cost[a[i]][j];
            }

            mn[i][0] = dp[i][0];
            for (int j = 1; j < m; ++j) {
                  mn[i][j] = min(mn[i][j - 1], dp[i][j]);
            }
      }

      cout << mn[n - 1][m - 1] << '\n';
}

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
      for_each(a.begin(), a.end(), [&](auto &some) { is >> some; });
      return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &a) {
      for_each(a.begin(), a.end(), [&](auto &some) { os << some << ' '; });
      return (os << '\n');
}