#include <iomanip>
#include <string>
#include <algorithm>
#include <set>
#include <cmath>
#include <iostream>
#include <queue>
#include <map>
#include <random>
#include <vector>
using namespace std;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    int n; cin >> n;
    vector <int> mas(n);
    for (int i = 0; i < n; i++) { cin >> mas[i]; }
    vector <int> ans(n, 0);
    vector <int> sums(n - 1, 0);
    for (int i = 0; i < n - 1; i++) {
        sums[i] = ans[i] + ans[i + 1];
    }
    int maxmask = (1 << (n - 1));
    for (int mask = 1; mask < maxmask; mask++) {
        vector <int> byttes(n - 1);
        int cntt = 0;
        for (int j = 0; j < n - 1; j++) { byttes[j] = ((mask >> j) & 1); cntt += byttes[j]; }
        int fail = 0;
        for (int j = 0; j < n - 1; j++) {
            if (byttes[j] == 0 && sums[j] > 0) { fail = 0; }
        }
        if (fail) { continue; }
        vector <pair<int, int>> otrs;
        int st = -1;
        for (int i = 0; i < n; i++) {
            if (byttes[i] == 1 && (i == 0 || byttes[i - 1] == 0)) { st = i; }
            if (byttes[i] == 1 && (i == n - 1 || byttes[i + 1] == 0)) {
                otrs.push_back({ st, i });
            }
        }
        int moves = 0;
        for (auto para : otrs) {
            int a = para.first, b = para.second;
            for (int i = a; i <= b - 1; i++) {
                if (sums[i] <= 0) {
                    sums[i + 1] += 1 - sums[i];
                    moves += 1 - sums[i];
                    sums[i] = 1;
                }
            }
            if (sums[b] <= 0) {
                moves += 1 - sums[b];
            }
        }
        for (int i = 0; i < n - 1; i++) {
            sums[i] = ans[i] + ans[i + 1];
        }
        for (int i = 0; i <= cntt; i++) {
            ans[i] = min(ans[i], moves);
        }
    }
    for (int i = 0; i < n; i++) { cout << ans[i] << " "; }
    return 0;
}