#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll
typedef long double ld;
#define double ld
typedef unsigned long long ull;

#define all(x) std::begin(x),std::end(x)
#define rall(x) std::rbegin(x),std::rend(x)
#define pii pair<int,int>
#define vi vector<int>
#define fi first
#define se second
#define eb emplace_back
#define pb push_back
#define tri tuple<int,int,int>
#define quad tuple<int,int,int,int>
#define pent tuple<int,int,int,int,int>

const int INF = numeric_limits<int>::max()/7;
const int MOD = int(1e9+7);
mt19937 RNG(chrono::high_resolution_clock::now().time_since_epoch().count());

int add(int x, int y) {
  int res = x+y;
  return (res>=MOD?res-MOD:res);
}

int sub(int x, int y) {
  int res = x-y;
  return (res<0?res+MOD:res);
}

int binexp(int x, int y) {
  int res = 1;
  while (y) {
    if (y&1) {
      (res *= x)%=MOD;
    }
    (x *= x)%=MOD;
  }
  return res;
}

int rint(int from, int to) {
  uniform_int_distribution<int> d(from, to);
  return d(RNG);
}

int a,b,n,m;
void read() {
  cin >> a >> b >> n >> m;
  return;
}

pii answ;
void write() {
  if (answ.fi != -1) {
    cout << answ.fi << ' ' << answ.se << '\n';
  } else {
    cout << -1 << '\n';
  }
  return;
}


void solve1() { // Если B < A*2, то мы убираем больше голов => если голов перебор - двигаем левую границу, иначе -- правую
  int L = -1;  // Точно не хватает
  int R = min(n/a, m/b); // Точно хватает
  while (R-L > 1) {
    int mid = (R+L)/2;  // Сколько ABшек (предполагаем)
    int n1 = n-a*mid;
    int m1 = m-b*mid;
    if (n1*2 > m1) {
      L = mid;
    } else {
      R = mid;
    }
  }
  if ((n - a*R)*2 == m - b*R) {
    answ = make_pair(n-a*R, R);
  } else {
    answ = make_pair(-1LL,-1LL);
  }
  return;
}

void solve2() { // Если B > A*2, то мы убираем больше ног => если ног перебор - двигаем левую границу, иначе - правую
  int L = -1;  // Точно хватает
  int R = min(n/a, m/b); // Точно не хватает
  while (R-L > 1) {
    int mid = (R+L)/2;  // Сколько ABшек (предполагаем)
    int n1 = n-a*mid;
    int m1 = m-b*mid;
    if (n1*2 < m1) {
      L = mid;
    } else {
      R = mid;
    }
  }
  if ((n - a*R)*2 == m - b*R) {
    answ = make_pair(n-a*R, R);
  } else {
    answ = make_pair(-1LL,-1LL);
  }
  return;
}

void solve() {
  if (n*2 == m) {
    answ = make_pair(n,0LL);
  } else if (b < a*2) {
    solve1();
  } else if (b > a*2) {
    solve2();
  } else {
    answ = make_pair(-1LL,-1LL);
  }
  return;
}


signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int tt = 1;
//  cin >> tt;
  while (tt --> 0) {
    read();
    solve();
    write();
  }
  cout.flush();
  return 0;
}