#include <bits/stdc++.h>


using namespace std;


const long long inf = 1e18 + 7;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> last(m, -1);
    for (int i = 0; i < n; i++) {
        cin >> a.at(i);
        a.at(i)--;
        last.at(a.at(i)) = i;
    }
    vector<vector<long long>> cost(m, vector<long long>(m));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            cin >> cost.at(i).at(j);
        }
    }
    vector<vector<long long>> groups;
    vector<vector<long long>> prefix;
    vector<long long> to(m, 0);
    int r = 0;
    for (int i = 0; i < n; i++) {
        r = max(r, last.at(a.at(i)));
        if (i == last.at(a.at(i))) {
            for (int j = 0; j < m; j++) {
                to.at(j) += cost.at(a.at(i)).at(j);
            }
        }
        if (i == r) {
            if (int(groups.size()) == 0) {
                groups.push_back(to);
                prefix.push_back(to);
            } else {
                groups.push_back(to);
                prefix.push_back(to);
                int pos = int(groups.size()) - 1;
                for (int i = 0; i < int(groups.at(pos).size()); i++) {
                    groups.at(pos).at(i) = prefix.at(pos - 1).at(i) + to.at(i);
                }
            }
            int pos = int(groups.size()) - 1;
            for (int i = 0; i < int(groups.at(pos).size()); i++) {
                if (i == 0) {
                    prefix.at(pos).at(i) = groups.at(pos).at(i);
                } else {
                    prefix.at(pos).at(i) = min(prefix.at(pos).at(i - 1), groups.at(pos).at(i));
                }
            }
            to = vector<long long>(m, 0);
        }
    }
    long long ans = inf;
    for (int i = 0; i < m; i++) {
        ans = min(ans, groups.at(int(groups.size()) - 1).at(i));
    }
    cout << ans;
    return 0;
}