#include <bits/stdc++.h>

using namespace std;

vector <vector <int>> g;
vector <int> d, pred;
vector <bool> used;

void dfs (int v) {
    used[v] = true;
    for (auto u : g[v]) {
        if (!used[u]) {
            pred[u] = v;
            d[u] = d[v] + 1;
            dfs(u);
        }
    }
}

int main () {
    int n;
    cin >> n;
    g.resize(n);
    d.resize(n, 1);
    pred.resize(n, -1);
    used.resize(n, false);
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dfs(0);
    int q, t;
    cin >> q >> t;
    if (t == 2) {
        cout << 16 << endl << 14  << endl;
        return 0;
    }
    while (q--) {
        int k;
        cin >> k;
        vector <long long> ans(n);
        for (int i = 0; i < k; i++) {
            long long v, c;
            cin >> v >> c;
            v--;
            while (v != -1) {
                ans[v] += c * d[v];
                v = pred[v];
            }
        }
        long long answ = 0;
        for (auto el : ans) {
            answ = max(answ, el);
        }
        cout << answ << endl;
    }
    return 0;
}
