#include <iostream>

#include <vector>

using namespace std;

#define int long long

int f(vector <int>& a, int ll, int rr) {
    int n = rr - ll + 1;
    if (n == 3) {
        return max((long long) 0, 1 - a[ll + 1] - min(a[ll], a[ll + 2]));
    }
    if (n == 2) {
        return max((long long) 0, 1 - a[ll + 1] - a[ll]);
    }
    int x = max((long long) 0, 1 - a[ll] - a[ll + 1]);
    a[ll + 1] += x;
    return f(a, ll + 1, rr) + x;
}

signed main() {
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector <vector <int>> dp(n, vector <int>(n, 1000000000000));
    for (int i = 0; i < n; i++) {
        dp[i][0] = 0;
    }
    dp[1][1] = max((long long) 0, 1 - a[0] - a[1]);
    vector <vector <int>> dpp(n, vector <int>(n, 0));
    for (int ll = 0; ll < n; ll++) {
        for (int rr = ll + 1; rr < n; rr++) {
            vector <int> aa = a;
            dpp[ll][rr] = f(aa, ll, rr);
        }
    }
    for (int i = 2; i < n; i++) {
        for (int j = 0; j <= i; j++) {
            dp[i][j] = dp[i - 1][j];
            int ans = 0;
            for (int k = 1; k <= j; k++) {
                ans = dpp[i - k][i];
                if (i - k - 1 >= 0) {
                    dp[i][j] = min(dp[i][j], ans + dp[i - k - 1][j - k]);
                } else {
                    dp[i][j] = min(dp[i][j], ans + dp[n - 1][j - k]);
                }
            }
        }
    }
    int ans = 1000000000000;
    for (int i = n - 1; i >= 0; i--) {
        ans = min(dp[n - 1][i], ans);
        cout << ans << ' ';
    }
}