#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <cctype>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <array>
#include <bitset>
#include <cmath>
#include <random>
#include <iterator>

using namespace std;

using ll = long long;
using ld = long double;

template<typename T>
int szof(T& a) {
    return a.size();
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n), c(n), d(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    vector<vector<ll>> dp(n, vector<ll>(2));
    if (a[0] < 0) {
        dp[0][0] = (b[0] - a[0]) / b[0] * (ll)c[0];
    }
    if (a[0] == 0) {
        dp[0][0] = c[0], dp[0][1] = d[0];
    }
    if (a[0] > 0) {
        dp[0][1] = (a[0] + b[0]) / b[0] * (ll)d[0];
    }
    for (int i = 1; i < n; ++i) {
        ll p = 0, m = 0;
        if (a[i] < 0) {
            p = (b[i] - a[i]) / b[i] * (ll)c[i];
        }
        if (a[i] == 0) {
            p = c[i], m = d[i];
        }
        if (a[i] > 0) {
            m = (a[i] + b[i]) / b[i] * (ll)d[i];
        }
        dp[i][0] = min(dp[i - 1][0] + p, dp[i - 1][1] + m);
        dp[i][1] = min(dp[i - 1][1] + p, dp[i - 1][0] + m);
    }
    cout << dp[n - 1][0] << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios_base::fixed);
    cout.precision(6);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
