#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<int> prime;
vector<bool> arr(1e5 + 10, 0);

void make_prime(){
    vector<bool> p(1e5 + 10, 1);
    prime.push_back(1);
    for(int i= 2; i < 1e5 + 10; i++){
        if(p[i] == 1){
            prime.push_back(i);
            for(int j= 2; i * j < 1e5 + 10; j++) p[i * j]= 0;
        }
    }
}

void precount(){
    make_prime();

    arr[0]= 1;
    for(int i= 1; i * i < 1e5 + 11; i++){
        for(auto j: prime){
            arr[j]= 1;
            if(i * i * j <= 1e5 + 10) arr[i * i * j]= 1;
        }
    }
}

int n;
void make(vector<int> &used, int k, int ind){
    if(k <= n && !used[k]){
        used[k]= ind;
        return;
    }

    while(k > 0){
        for(int i= min(n, k); i > 0; i--){
            if(!used[i] && k >= i){
                used[i]= ind;
                k-= i;
            }
        }
    }
}

signed main(){
    int m; cin >> n >> m;

    if(n < 6){
        cout << n << "\n";
        for(int i= 1; i <= n; i++){
            cout << 1 << "\n";
            cout << i << '\n';
        }

        return 0;
    }

    precount();
    m= 0;
    int a, b, c= 0, d= 0;

    if(n % 2 == 0){
        int x= n;
        n/= 2;
        c= 2 * n * n;
        m= n;
        n= x;
    } else{
        int x= n;
        n/= 2;
        c= (n + 1) * (n + 1);
        d= n * n;
        m= n;
        n= x;
    }

    for(int j= 1; j <= m; j++){
        if(arr[j] && arr[m - j]){
            a= j;
            b= m - j;
        }
    }

    vector<int> qw{a, b, c, d};
    sort(qw.begin(), qw.end());
    a= qw[0]; b= qw[1], c= qw[2], d= qw[3];

    vector<int> used(n + 1, 0);

    if(a != 0) make(used, a, 1);
    if(b != 0) make(used, b, 2);
    if(c != 0) make(used, c, 3);

    vector<vector<int>> ans(4);
    for(int i= 1; i <= n; i++){
        ans[used[i]].push_back(i);
    }

    if(c == 0) cout << "1\n";
    else if(b == 0) cout << "2\n";
    else if(a == 0) cout << "3\n";
    else cout << "4\n";

    //cout << a << " " << b << " " << c << " " << d << "\n";
    //for(auto x: used) cout << x;
    //cout << "\n";

    for(int i= 0; i < 4; i++){
        if(ans[i].size() == 0) continue;
        cout << ans[i].size() << "\n";
        for(auto x: ans[i]) cout << x << " ";
        cout << "\n";
    }
}