#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<queue>
#include<algorithm>

#define ll long long
#define V vector
#define P pair
#define ii P<ll, ll>
#define for_i(n) for(int i = 0; i < n; i++)
#define for_j(n) for(int j = 0; j < n; j++)
#define for_p(n) for(int p = 0; p < n; p++)
#define for_i_in(l, r) for(int i = l; i < r; i++)
#define for_j_in(l, r) for(int j = l; j < r; j++)
#define for_p_in(l, r) for(int p = l; p < r; p++)
#define for_ir(n) for(int i = n - 1; i >= 0; i--)
#define for_jr(n) for(int j = n - 1; j >= 0; j--)
#define for_pr(n) for(int p = n - 1; p >= 0; p--)
#define F first
#define S second
#define pb push_back
#define has(s, x) (s.find(x) != s.end())

using namespace std;

const ll mod = 1000000007;
const ll mod_ = 1000000009;
const ll inf = 1ll << 60;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    int* a = new int[n];
    ll* d = new ll[m];
    fill(d, d + m, 0);
    for_i(n) {
        cin >> a[i];
        a[i]--;
        d[a[i]]++;
    }
    
    ll** c = new ll*[m];
    for_i(m) c[i] = new ll[m];
    for_i(m) for_j(m) cin >> c[i][j];

    map<int, ii> b;
    for_i(n) {
        if(!has(b, a[i]))
            b[a[i]].F = i;
        b[a[i]].S = i;
    }

    V<int>* g = new V<int>[m];
    for_i(m) {
        for_j_in(i + 1, m) {
            if(max(b[i].F, b[j].F) <= min(b[i].S, b[j].S)) {
                g[i].pb(j);
                g[j].pb(i);
            }
        }
    }

    set<int> us;
    V<V<int>> s;
    for_i(m) {
        if(has(us, i))
            continue;
        
        s.pb({i});
        us.insert(i);

        queue<int> q;
        q.push(i);
        for(int v = q.front(); !q.empty(); q.pop(), v = q.front()) {
            for(int u : g[v]) {
                if(has(us, u))
                    continue;
                s.back().pb(u);

                us.insert(u);
                q.push(u);
            }
        }
    }

    sort(s.begin(), s.end(), [&](V<int> v1, V<int> v2) {return b[v1[0]].F < b[v2[0]].F; });
    ll k = s.size();
    ll** r = new ll*[k];
    for_i(k) {
        r[i] = new ll[m];
        for_j(m) {
            r[i][j] = 0;
            for(int x : s[i])
                r[i][j] += d[x]*c[x][j];
        }
    }
    // 3 1 1 1 1 1 2
    // s = [3] [1] [2]
    // r = 1 4  0
    //     0 10 15
    //     3 0  1

    ll** dp = new ll*[k + 1];
    dp[0] = new ll[m];
    fill(dp[0], dp[0] + m, 0);
    for_i(k) {
        ll b = inf;
        dp[i + 1] = new ll[m];
        for_j(m) {
            b = min(b, dp[i][j]);
            dp[i + 1][j] = b + r[i][j];
        }
    }

    cout << *min_element(dp[k], dp[k] + m);
    return 0;
}