#include <iostream>
#include <deque>
#include <map>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <bitset>
#include <numeric>
#include <set>
#include <queue>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pdd = pair<double, double>;
using lld = long double;
using db = double;
using pll = pair<ll, ll>;
const ll inf = 1e18;
const lld EPS = 1e-7;

void fastios() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define int long long

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    vector<int> c(n);
    vector<int> d(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++)
        cin >> b[i];
    for (int i = 0; i < n; i++)
        cin >> c[i];
    for (int i = 0; i < n; i++)
        cin >> d[i];
    vector<int> otr;
    vector<int> pol;
    set<int> nul;
    for (int i = 0; i < n; i++) {
        if (a[i] < 0)
            otr.push_back(i);
        else if (a[i] == 0)
            nul.insert(i);
        else
            pol.push_back(i);
    }
    int ans = 0;
    vector<int> mid;
    for (auto to : nul) {
        if (c[to] < d[to]) {
            ans += c[to];
            a[to] += b[to];
            pol.push_back(to);
        } else if (c[to] > d[to]) {
            ans += d[to];
            a[to] -= b[to];
            otr.push_back(to);
        } else {
            mid.push_back(to);
        }
    }
    if (otr.size() % 2 == 0) {
        for (auto to : mid) {
            pol.push_back(to);
            ans += c[to];
            a[to] += b[to];
        }
    } else {
        for (auto to : mid) {
            otr.push_back(to);
            ans += c[to];
            a[to] -= b[to];
        }
        if (otr.size() % 2 == 1 && mid.size() >= 1) {
            otr.pop_back();
            a[mid.back()] += 2 * b[mid.back()];
            pol.push_back(mid.back());
        }
    }
    if (otr.size() % 2 == 1) {
        int mn = ans + (abs(a[otr[0]]) + b[otr[0]]) / b[otr[0]] * c[otr[0]];
        for (auto to : otr) {
            if (nul.count(to)) {
                int nw = ans;
                nw -= d[to];
                nw += c[to];
                mn = min(mn, nw);
            } else {
                int nw = ans;
                nw += (abs(a[to]) + b[to]) / b[to] * c[to];
                mn = min(mn, nw);
            }
        }
        for (auto to : pol) {
            if (nul.count(to)) {
                int nw = ans;
                nw -= c[to];
                nw += d[to];
                mn = min(mn, nw);
            } else {
                int nw = ans;
                nw += (a[to] + b[to]) / b[to] * d[to];
                mn = min(mn, nw);
            }
        }
        cout << mn;
    } else {
        cout << ans;
    }
}

signed main() {
    /*freopen("magic.in", "r", stdin);
    freopen("magic.out", "w", stdout);*/
    int tt = 1;
    //fastios();
    //precalc();
    //cin >> tt;
    while (tt--) {
        solve();
    }
}