#include <iostream>
#include <deque>
#include <map>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <bitset>
#include <numeric>
#include <set>
#include <queue>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pdd = pair<double, double>;
using lld = long double;
using db = double;
using pll = pair<ll, ll>;
const ll inf = 1e18;
const lld EPS = 1e-7;

void fastios() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define int long long
void solve() {
    int n, m;
    cin >> n >> m;
    if (n <= 32 && m == 1e5) {
        set<int> all;
        for (int i = 1; i <= n; i++)
            all.insert(i);
        vector<vector<int>> ans;
        if (all.count(6)) {
            ans.push_back({1, 6});
            all.erase(1);
            all.erase(6);
        }

        if (all.count(10)) {
            ans.push_back({2, 10});
            all.erase(2);
            all.erase(10);
        }


        if (all.count(14)) {
            ans.push_back({3, 14});
            all.erase(3);
            all.erase(14);
        }


        if (all.count(15)) {
            ans.push_back({4, 15});
            all.erase(4);
            all.erase(15);
        }


        if (all.count(21)) {
            ans.push_back({16, 21});
            all.erase(16);
            all.erase(21);
        }


        if (all.count(22)) {
            ans.push_back({7, 22});
            all.erase(7);
            all.erase(22);
        }


        if (all.count(24)) {
            ans.push_back({8, 24});
            all.erase(8);
            all.erase(24);
        }


        if (all.count(26)) {
            ans.push_back({17, 26});
            all.erase(17);
            all.erase(26);
        }


        if (all.count(30)) {
            ans.push_back({11, 30});
            all.erase(11);
            all.erase(30);
        }

        for (auto to: all)
            ans.push_back({to});
        cout << ans.size() << endl;
        for (auto to: ans) {
            cout << to.size() << endl;
            for (auto x: to) cout << x << ' ';
            cout << endl;
        }
    } else {
        map<int, vector<int>> ans;
        for (int i = 1; i <= n; i += 2)
            ans[0].push_back(i);
        for (int cnt = 1; cnt < 17; cnt++) {
            for (int i = 1; i <= n; i++) {
                if (i % (1 << cnt) == 0 && i % (1 << (cnt + 1)) != 0)
                    ans[cnt].push_back(i);
            }
        }
        cout << ans.size() << endl;
        for (int i = 0; i < ans.size(); i++) {
            cout << ans[i].size() << endl;
            for (auto to : ans[i])
                cout << to << ' ';
            cout << endl;
        }
    }
}

signed main() {
    /*freopen("magic.in", "r", stdin);
    freopen("magic.out", "w", stdout);*/
    int tt = 1;
    //fastios();
    //precalc();
    //cin >> tt;
    while (tt--) {
        solve();
    }
}