#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<stack>
#include<algorithm>
#include<cmath>
#include<iomanip>
#include<unordered_map>
#include<unordered_set>
#include<random>
#include<cstdio>

#define all(x) x.begin(), x.end()
#define rall() x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

ll gcd(ll a, ll b) {
	return b == 0 ? a : gcd(b, a % b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}
struct col {
	int l, r, c;
	col() {
		l = 1e9, r = -1e9;
	}
};
bool cmp(col a, col b) {
	return a.l < b.l;
}

//================================================

void solve() {


	/*int n, m;
	cin >> n >> m;*/

	int n, m;
	cin >> n >> m;
	vector<int> a(n);
	for (auto& i : a) cin >> i, --i;
	vector<vector<int>> c(m, vector<int>(m));
	for (auto& i : c) for (auto& j : i) cin >> j;
	vector<col> b(m);
	for (int i = 0; i < m; ++i) b[i].c = i;
	for (int i = 0; i < n; ++i) {
		b[a[i]].l = min(b[a[i]].l, i);
		b[a[i]].r = max(b[a[i]].r, i);
	}
	sort(all(b), cmp);
	vector<int> t(m, -1), cl(m);
	int ty = 0;
	for (int i = 0; i < m; ++i) {
		for (int j = i - 1; j >= 0; --j) {
			if (b[j].r > b[i].l) {
				t[i] = t[j];
				break;
			}
		}
		cl[i] = b[i].c;
		if (t[i] == -1) t[i] = ty++;
	}
	vector<vector<ll>> dp(m + 1, vector<ll>(m, 1e18)), pr(m + 1, vector<ll>(m, 1e18));
	for (int i = 0; i < m; ++i) pr[0][i] = 0, dp[0][i] = 0;
	for (int i = 0; i < m; ++i) {
		if (b[i].l == 1e9) {
			pr[i + 1] = pr[i];
			dp[i + 1] = dp[i];
			continue;
		}
		if (!i || t[i] != t[i - 1]) {
			for (int j = 0; j < m; ++j) {
				dp[i + 1][j] = pr[i][j] + c[cl[i]][j];
			}
		}
		else {
			for (int j = 0; j < m; ++j) {
				dp[i + 1][j] = dp[i][j] + c[cl[i]][j];
			}
		}
		pr[i + 1][0] = dp[i + 1][0];
		for (int j = 1; j < m; ++j) {
			pr[i + 1][j] = min(pr[i + 1][j - 1], dp[i + 1][j]);
		}
	}
	ll ans = 1e18;
	for (int i = 0; i < m; ++i) {
		ans = min(ans, dp[m][i]);
	}
	cout << ans;

	/*int n;
	cin >> n;
	vector<int> a(n), b(n);
	for (auto& i : a) cin >> i;
	for (int i = 1; i < n; ++i) {
		b[i] = max(0, -(a[i - 1] + a[i]) + 1);
	}
	vector<vector<ll>> dp(n, vector<ll>(n, 1e18));
	dp[0][0] = 0;
	for (int i = 1; i < n; ++i) {
		for (int k = 0; k < n; ++k) {
			if(k) dp[i][k] = dp[i - 1][k - 1];
			ll sum = 0;
			for (int j = i - 1; j >= 0; --j) {
				dp[i][k] = min(dp[i][k], dp[j][k] + sum);
			}
		}
	}
	ll mn = 1e18;
	for (int i = 0; i < n; ++i) {
		mn = min(mn, dp[n - 1][i]);
		cout << mn << ' ';
	}*/
}

//===============================================

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
	return 0;
}