#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ve vector
#define fi first
#define se second
#define all(x) x.begin(), x.end()

using namespace std;

typedef pair<ll, ll> pii;

const int MAXN = 3010;

ve<int> g[MAXN];
int p[MAXN];
int cost[MAXN];
int d[MAXN];

void dfs(int v){
    for(auto to : g[v])
        if(to != p[v]){
            p[to] = v;
            d[to] = d[v] + 1;
            dfs(to);
        }
}
void add(int v, int c){
    cost[v] += c;
    if(p[v] == v)
        return;
    add(p[v], c);
}

signed main(){
    int n;
    cin >> n;
    for(int i = 1; i < n; i++){
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    d[0] = 1;
    dfs(0);
    int q, t;
    cin >> q >> t;
    int lastans = 0;
    while(q--){
        memset(cost,0, sizeof(cost));
        int k;
        cin >> k;
        for(int i = 0; i < k; i++){
            int v, c;
            cin >> v >> c;
            if(t == 2){
                v = (v + lastans) % (n - 1) + 2;
            }
            v--;
            add(v, c);
        }
        int res = 0;
        for(int i = 0; i < n; i++)
            res = max(res, cost[i] * d[i]);
        lastans = res;
        cout << res << "\n";
    }
    return 0;
}