//#pragma optimize GCC("O3", "unroll-loops")
//#pragma GCC target("avx2", "bmi","bmi2", "popcnt")

#define _CRT_SECURE_NO_WARNINGS
#include <cmath>
#include <vector>
#include <algorithm>
#include <unordered_set>
#include <map>
#include <string>
#include <iostream>
#include <iomanip>
#include <deque>
#include <locale>
#include <unordered_map>
#include <random>
#include <bitset>
#include <queue>
#include <set>

using namespace std;

using ld = long double;
using ll = long long;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> ans;
    vector<int> used(n + 1);
    for (int k = 1; k < 50; k++) {
        int d = (1 << k);
        ans.push_back({});
        for (int j = d / 2; j <= n; j += d) {
            ans.back().push_back(j);
        }
        if (ans.back().empty()) {
            ans.pop_back();
            break;
        }
    }
    cout << ans.size() << "\n";
    for (auto x : ans) {
        cout << x.size() << "\n";
        for (auto y : x) {
            cout << y << " ";
        }
        cout << "\n";
    }
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();

    }
}