#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

#define all(x) x.begin(), x.end()
#define trace(x) cout << #x << " = " << x << endl;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);
const ll MOD = (ll)(1e9 + 7);

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

using ordered_set = tree<pair<ll, ll>,
                         null_type,
                         less<pair<ll, ll>>,
                         rb_tree_tag,
                         tree_order_statistics_node_update>;

bool is_right(ll x) {
    ll cnt_nechet = 0;
    for (ll i = 2; i * i <= x; ++i) {
        ll local = 0;
        while (x % i == 0) {
            x /= i;
            local++;
        }
        cnt_nechet += (local % 2);
    }
    if (x != 1) cnt_nechet++;

    if (cnt_nechet <= 1) return true;
    return false;
}

void solve() {
    ll n, m;
    cin >> n >> m;

    vector<vector<ll>> ans;
    ll now = n;

    while (now) {
        ll sum = now * (now + 1) / 2;

        for (ll i = 0; i < now; ++i) {
            sum -= i;

            if (is_right(sum)) {
                ans.push_back({});
                for (ll j = i + 1; j <= now; ++j) ans.back().push_back(j);
                now = i;
                break;
            }
        }
    }

    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.size() << '\n';
        for (auto j : i) cout << j << ' ';
        cout << '\n';
    }
}

signed main() {
    fast_stream();

    int tests = 1;
    // cin >> tests;

    while (tests--) {
        solve();
    }
}