#include <bits/stdc++.h>
using namespace std;
#define int long long
const int inf = 1e18;

template <typename T>
vector <int> ps(T beg, T end) {
    vector <int> ps(end - beg + 1);
    for (int i = 0; i < end - beg; i++) {
        ps[i + 1] = ps[i] + *(beg + i);
    }
    return ps;
}
template <typename T>
void chkmin(T &a, T b) {
    a = min(a, b);
}
template <typename T>
void chkmax(T& a, T b) {
    a = max(a, b);
}
const int mod = 1e9 + 7;
int binpow(int x, int pw) {
    if (!pw) return 1;
    int f = binpow(x, pw / 2);
    f = (1ll * f * f) % mod;
    if (pw & 1) f = (1ll * f * x) % mod;
    return f;
}
int rev(int x) {
    return binpow(x, mod - 2);
}
struct mint{
    int x;
    mint (int _) {
        x = _ % mod;
    }
    mint operator + (const mint& _) const {
        return {(x + _.x) - mod * (x + _.x >= mod)};
    }
    mint operator - (const mint& _) const {
        return {(x - _.x) + mod * (x - _.x < 0)};
    }
    mint operator * (const mint& _) const {
        return {(1ll * x * _.x) % mod};
    }
    bool operator == (const mint& _) const {
        return x == _.x;
    }
    mint operator / (const mint& _) const {
        assert(!(_ == 0));
        return *this * rev(_.x);
    }
};

void solve() {

}
vector <vector <int>> ans;
bool is_b(int x) {
    // factorize
    set<int> s;
    for (int d = 2; d * d <= x && s.size() <= 1; d++) {
        while (x % d == 0) {
            if (s.count(d)) s.erase(d);
            else s.insert(d);
            x /= d;
        }
    }
    if (x != 1) {
        if (s.count(x)) s.erase(x);
        else s.insert(x);
    }
    return s.size() <= 1;
}
bool solve(vector <int> a, int m) {
    if (a.empty()) return 1;
    if (m == 0) return 0;
    int sum = 0;
    for (int i : a) sum += i;
    vector <int> nxt;
    for (int i = 0; i < a.size(); i++) {
        if (is_b(sum)) {
            ans.emplace_back();
            ans.back().reserve(a.size() - i);
            for (int j = i; j < a.size(); j++) {
                ans.back().push_back(a[j]);
            }
            a.resize(i);
            return solve(a, m - 1);
        }
        sum -= a[i];
    }
    return 0;
}
signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    vector <int> a(n);
    std::iota(a.begin(), a.end(), 1);
    if (solve(a, m)) {
        cout << ans.size() << '\n';
        for (auto &v : ans) {
            cout << v.size() << '\n';
            for (int i : v) cout << i << ' ';
            cout << '\n';
            cout << '\n';
        }
    }
}