#include <bits/stdc++.h>
using namespace std;
#define int long long
template <typename T>
vector <int> ps(T beg, T end) {
    vector <int> ps(end - beg + 1);
    for (int i = 0; i < end - beg; i++) {
        ps[i + 1] = ps[i] + *(beg + i);
    }
    return ps;
}
template <typename T>
void chkmin(T &a, T b) {
    a = min(a, b);
}
template <typename T>
void chkmax(T& a, T b) {
    a = max(a, b);
}
const int mod = 1e9 + 7;
int binpow(int x, int pw) {
    if (!pw) return 1;
    int f = binpow(x, pw / 2);
    f = (1ll * f * f) % mod;
    if (pw & 1) f = (1ll * f * x) % mod;
    return f;
}
int rev(int x) {
    return binpow(x, mod - 2);
}
struct mint{
    int x;
    mint (int _) {
        x = _ % mod;
    }
    mint operator + (const mint& _) const {
        return {(x + _.x) - mod * (x + _.x >= mod)};
    }
    mint operator - (const mint& _) const {
        return {(x - _.x) + mod * (x - _.x < 0)};
    }
    mint operator * (const mint& _) const {
        return {(1ll * x * _.x) % mod};
    }
    bool operator == (const mint& _) const {
        return x == _.x;
    }
    mint operator / (const mint& _) const {
        assert(!(_ == 0));
        return *this * rev(_.x);
    }
};
void solve() {

}
const int maxn = (1 << 19);
int mexes[maxn];
int count_xor(vector <int> a) {
    int x = 0;
    for (int i : a) x ^= mexes[i];
    return x;
}
signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    for (int i = 1; i < maxn; i++) {
        if (i % 2 == 0) {
            mexes[i] = (mexes[i - 1] == 0 ? 1 : 0);
        } else {
            vector <int> sus = {mexes[i / 2], mexes[i - 1], 200};
            std::sort(sus.begin(), sus.end());
            for (int j = 0; j < sus.size(); j++) {
                if (sus[j] != j) {
                    mexes[i] = j;
                    break;
                }
            }
        }
    }

    int n, q;
    cin >> n >> q;
    vector <int> a(n);
    vector <int> lens(n);
    for (int i = 0; i < n; i++) {
        string s; cin >> s;
        lens[i] = s.size();
        for (int j = 0; j < s.size(); j++) {
            a[i] = 2 * a[i] + s[j] - '0';
        }
    }
    if (count_xor(a) == 0) cout << "Second\n";
    else cout << "First\n";
    while (q--) {
        int l, r;
        cin >> l >> r;
        l--;
        for (int i = 0; i < n; i++) {
            if (l >= lens[i]) {
                l -= lens[i];
                r -= lens[i];
                continue;
            }
            for (int num = max(l, 0ll); num < min(lens[i], r); num++) {
                int number_real = lens[i] - 1 - num;
                a[i] ^= (1 << number_real);
            }
            l -= lens[i];
            r -= lens[i];
        }
        if (count_xor(a) == 0) cout << "Second\n";
        else cout << "First\n";
    }

}