#include<bits/stdc++.h>
#define ll long long

using namespace std;

ll n, m, tek_color, ans;
vector<ll> a, top, color;
vector<bool> used;
vector<vector<ll>> cost, g, rev_g, comps;

void input() {
    cin >> n >> m;
    a.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    cost.assign(m, vector<ll>(m, 0));
    for (ll i = 0; i < m; i++) {
        for (ll j = 0; j < m; j++) {
            cin >> cost[i][j];
        }
    }
}

void dfs(ll u) {
    used[u] = true;
    for (ll i = 0; i < g[u].size(); i++) {
        if (!used[g[u][i]]) {
            dfs(g[u][i]);
        }
    }
    top.push_back(u);
}

void dfs2(ll u) {
    color[u] = tek_color;
    for (ll i = 0; i < rev_g[u].size(); i++) {
        if (color[rev_g[u][i]] == -1) {
            dfs2(rev_g[u][i]);
        }
    }
}

void solve() {
    g.resize(m);
    rev_g.resize(m);
    vector<ll> minim(m, n), maxim(m, -1);
    vector<bool> cant(n, true);
    for (ll i = 0; i < n; i++) {
        minim[a[i] - 1] = min(minim[a[i] - 1], i);
        maxim[a[i] - 1] = max(maxim[a[i] - 1], i);
        //cout << minim[a[i] - 1] << " " << maxim[a[i] - 1] << endl;
    }
    for (ll i = 0; i < m; i++) {
        for (ll j = 0; j < m; j++) {
            if (i != j) {
                if (minim[i] < maxim[j]) {
                    g[j].push_back(i);
                    rev_g[i].push_back(j);
                    cant[i] = false;
                    cant[j] = false;
                    //cout << minim[i] << " " << maxim[j] << " " << j << " " << i << endl;
                }
            }
        }
    }
    //return;
    top = {};
    used.assign(m, false);
    for (ll i = 0; i < m; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    reverse(top.begin(), top.end());
    tek_color = 0;
    color.assign(m, -1);
    for (ll i = 0; i < top.size(); i++) {
        if (color[top[i]] == -1) {
            dfs2(top[i]);
            tek_color++;
        }
    }
    //for (ll i = 0; i < m; i++) {
    //    cout << color[i] << endl;
    //}
    comps.resize(tek_color);
    for (ll i = 0; i < m; i++) {
        comps[tek_color - color[i] - 1].push_back(i);
    }
    vector<vector<ll>> dp(tek_color, vector<ll>(m, 0));
    for (ll i = 0; i < tek_color; i++) {
        for (ll j = 0; j < m; j++) {
            ll tek_cost = 0;
            if (cant[comps[i][0]]) {
                tek_cost = 0;
            } else {
                for (ll k = 0; k < comps[i].size(); k++) {
                    tek_cost += cost[comps[i][k]][j];
                }
            }
            if (i == 0 && j == 0) {
                dp[i][j] = tek_cost;
            } else if (j == 0) {
                dp[i][j] = dp[i - 1][j] + tek_cost;
            } else if (i == 0) {
                dp[i][j] = min(dp[i][j - 1], tek_cost);
            } else {
                dp[i][j] = min(dp[i][j - 1], dp[i - 1][j] + tek_cost);
            }
            //cout << i << " " << j << " " << dp[i][j] << "\n";
        }
    }
    ans = dp[tek_color - 1][m - 1];
}

void output() {
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    input();
    solve();
    output();
    return 0;
}