#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <unordered_set>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    long long n, m;
    cin >> n >> m;
    vector<vector<long long>> cost(m, vector<long long>(m));
    vector<long long> z(n); 
    for (auto &i : z) {
        cin >> i;
        i--;
    }
    for (auto &i : cost) {
        for (auto &j : i) cin >> j;
    }
    vector<long long> col(m, -1);
    for (long long i = 0; i < n; i++) {
        col[z[i]] = i;
    }
    vector<pair<long long, long long>> q;
    long long l = 0, r = -1;
    for (long long i = 0; i < n; i++) {
        r = max(r, col[z[i]]);
        if (r == i) {
            q.push_back({ l, r });
            l = i + 1;
            r = i;
        }
    }
    vector<vector<long long>> v;
    for (auto &i : q) {
        unordered_set<long long> col0;
        for (long long j = i.first; j <= i.second; j++) {
            col0.insert(z[j]);
        }
        vector<long long> col_cost(m);
        for (long long j = 0; j < m; j++) {
            long long ans = 0;
            for (auto &k : col0) {
                ans += cost[k][j];
            }
            col_cost[j] = ans;
        }
        v.push_back(col_cost);
    }
    vector<vector<long long>> dp(v.size(), vector<long long>(m));
    vector<vector<long long>> mn(v.size(), vector<long long>(m));
    for (long long i = 0; i < v.size(); i++) {
        for (long long j = 0; j < m; j++) {
            if (i == 0) {
                dp[i][j] = v[i][j];
            }
            else dp[i][j] = mn[i - 1][j] + v[i][j];
            if (j == 0) {
                mn[i][j] = dp[i][j];
            }
            else mn[i][j] = min(mn[i][j - 1], dp[i][j]);
        }
    }
    cout << mn[v.size() - 1][m - 1];
}