#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <unordered_set>
#include <random>

using namespace std;

vector<vector<long long>> gr;
vector<long long> used0, used;
long long h = 0;
long long ans = -1;
long long dfs(long long a) {
    used[a] = 1;
    long long sum = used0[a];
    for (auto &i : gr[a]) {
        if (used[i] == 0) {
            h++;
            sum += dfs(i);
            h--;
        }
    }
    ans = max(ans, (h + 1) * sum);
    return sum;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    long long n;
    cin >> n;
    gr.resize(n);
    used0.resize(n);
    for (long long i = 0; i < n - 1; i++) {
        long long a, b;
        cin >> a >> b;
        a--, b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    long long q, t;
    cin >> q >> t;
    while (q--) {
        long long k;
        cin >> k;
        vector<pair<long long, long long>> z0(k);
        for (auto &i : z0) cin >> i.first >> i.second;
        for (auto &i : z0) {
            i.first--;
            used0[i.first] = i.second;
        }
        used.assign(n, 0);
        h = 0;
        ans = 0;
        dfs(0);
        cout << ans << '\n';
        for (auto &i : z0) used0[i.first] = 0;
    }

}