#include <bits/stdc++.h>
using namespace std;
using ll = long long;

vector<vector<ll>> adj;
vector<ll> depth;
void dfs1(ll v = 0, ll p = -1) {
    depth[v] = (p == -1) ? 0 : (depth[p] + 1);
    for (ll u : adj[v]) {
        if (u == p) continue;
        dfs1(u, v);
    }
}

vector<ll> co;
vector<ll> val;

ll dfs(ll v = 0, ll p = -1) {
    val[v] = co[v] * (depth[v] + 1);
//    cout << v << " " << val[v] << endl;

    ll ret = 0;
    for (ll u : adj[v]) {
        if (u == p) continue;
        ret = max(dfs(u, v), ret);
        val[v] += val[u] - co[u];
        co[v] += co[u];
    }
    ret = max(val[v], ret);
//    cout << "*" << v << " " << val[v] << endl;
    return ret;
}

int main() {
    ll n;
    cin >> n;
    adj.resize(n);
    co.resize(n);
    val.resize(n);
    for (int e = 0; e < n - 1; ++e) {
        ll u, v;
        cin >> u >> v;
        adj[u - 1].push_back(v - 1);
        adj[v - 1].push_back(u - 1);
    }
    depth.resize(n);
    dfs1();

    ll last = 0;
    ll q, t;
    cin >> q >> t;
    while (q--) {
        ll k;
        cin >> k;
        co.assign(n, 0);
        for (ll i = 0; i < k; ++i) {
            ll v, c;
            cin >> v >> c;
            if (t == 2) {
                v = (v + last) % (n - 1) + 2;
            }
            co[v - 1] = c;
        }
        cout << (last = dfs()) << endl;
    }
    return 0;
}
