#include<bits/stdc++.h>
using namespace std;
using ll = long long;

int n;
vector<vector<int>> g;
vector<int> tin;
vector<int> tout;
vector<bool> used;
vector<int> dist;
int timer = 0;

void dfs(int v) {
    used[v] = true;
    tin[v] = timer++;

    for (auto el : g[v]) {
        if (!used[el]) {
            dist[el] = dist[v] + 1;
            dfs(el);
        }
    }

    tout[v] = timer++;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n;
    g.resize(n);
    tin.resize(n);
    tout.resize(n);
    used.resize(n);
    dist.resize(n);

    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    dfs(0);

    int q, t;
    cin >> q >> t;
    while (q--) {
        int am;
        cin >> am;
        vector<pair<int, int>> c(am);

        for (int i = 0; i < am; i++) {
            cin >> c[i].first >> c[i].second;
            c[i].first--;
        }

        int best = 0;
        for (int i = 0; i < n; i++) {
            int cur = 0;
            for (auto el : c) {
                if (tin[el.first] >= tin[i] && tin[el.first] <= tout[i]) {
                    cur += el.second * (dist[i] + 1);
                }
            }
            best = max(cur, best);
        }

        cout << best << endl;
    }
    return 0;
}