// #pragma optimize("Ofast")
#include "bits/stdc++.h"
#define int long long

using namespace std;

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  int n, m;
  cin >> n >> m;
  vector<int> a(n);
  vector<int> l(m + 1, n);
  vector<int> r(m + 1);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
    l[a[i]] = min(l[a[i]], i);
    r[a[i]] = i;
  }
  vector<vector<int>> cost(m + 1, vector<int>(m + 1));
  for (int i = 1; i <= m; i++) {
    for (int j = 1; j <= m; j++) {
      cin >> cost[i][j];
    }
  }
  vector<int> add(n), del(n);
  for (int c = 1; c <= m; c++) {
    if (l[c] == n) continue;
    add[l[c]] += 1;
    if (r[c] + 1 < n)
      del[r[c] + 1] += 1;
  }
  int bal = 0;
  int comp = 0;
  vector<int> col(n);
  for (int i = 0; i < n; i++) {
    bal -= del[i];
    if (bal == 0) {
      comp += 1;
    }
    col[i] = comp;
    bal += add[i];
  }
  vector<int> dp(m + 1, LLONG_MAX);
  dp[0] = 0;
  int ll = 0;
  for (int i = 0; i < comp; i++) {
    int rr = ll;
    vector<int> cnt(m + 1, 0);
    while (rr + 1 < n && col[rr + 1] == col[ll]) {
      rr++;
    }
    for (int j = ll; j <= rr; j++) cnt[a[j]] += 1;
    vector<int> to(m + 1);
    for (int j = 1; j <= m; j++) {
      if (cnt[j]) {
        for (int k = 1; k <= m; k++) {
          to[k] += cost[j][k];
        }
      }
    }
    vector<int> ndp(m + 1, LLONG_MAX);
    int mn = dp[0];
    for (int t = 1; t <= m; t++) {
      mn = min(mn, dp[t]);
      assert(mn != LLONG_MAX);
      ndp[t] = mn + to[t];
    }
    dp = ndp;
    ll = rr + 1;
  }
  int mn = LLONG_MAX;
  for (int i = 1; i <= m; i++) {
    mn = min(mn, dp[i]);
  }
  cout << mn << '\n';
}