//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

#include <bits/stdc++.h>
#include <immintrin.h>
#include <unordered_set>
#include <ctime>
#include <chrono>
#include <random>

//#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,avx2,tune=native")

using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using ll = long long;
#define int ll 
#define all(a) a.begin(), a.end()

using namespace std;
//using namespace __gnu_pbds;

mt19937 rnd(0);// chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rnd64(chrono::steady_clock::now().time_since_epoch().count());

//template <class A, class B> using gp_ht = gp_hash_table<A, B>;
//template <class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//template <class T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n), c(n), d(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    vector<vector<int>> dp(n, vector<int>(2, 3e18)); // pos,  mi

    int cu = max(0ll, ((-a[0] + b[0]) / b[0]));
    int cd = max(0ll, ((a[0] + b[0]) / b[0]));
    for (auto [w, cost] : vector<pair<int, int>>{ {a[0], 0}, {a[0] + b[0] * cu, c[0] * cu}, {a[0] - b[0] * cd, d[0] * cd}}) {
        if (w > 0) {
            dp[0][0] = min(dp[0][0], cost);
        }
        if (w < 0) {
            dp[0][1] = min(dp[0][1], cost);
        }
    }
    for (int i = 1; i < n; i++) {
        int cu = max(0ll, ((-a[i] + b[i]) / b[i]));
        int cd = max(0ll, ((a[i] + b[i]) / b[i]));
        for (auto [w, cost] : vector<pair<int, int>>{ {a[i], 0}, {a[i] + b[i] * cu, c[i] * cu}, {a[i] - b[i] * cd, d[i] * cd} }) {
            if (w > 0) {
                dp[i][0] = min(dp[i][0], dp[i - 1][0] + cost);
                dp[i][1] = min(dp[i][1], dp[i - 1][1] + cost);
            }
            if (w < 0) {
                dp[i][0] = min(dp[i][0], dp[i - 1][1] + cost);
                dp[i][1] = min(dp[i][1], dp[i - 1][0] + cost);
            }
        }
    }
    cout << dp[n - 1][0];
}

signed main() {
    cout.setf(ios_base::fixed);
    cout << fixed << setprecision(12);
    ios_base::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    auto f = freopen("input.txt", "r", stdin);
    auto f1 = freopen("output.txt", "w", stdout);
#endif
    int t;
    t = 1;// cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}