#include <bits/stdc++.h>

#define int long long

const int INFLL = 1e12;

using namespace std;

vector<int> v;
vector<int> ans;

int cost(int e, vector<int> &vv) {
    return vv[e] + vv[e + 1];
}

void solve() {
    int n;
    cin >> n;
    v.resize(n);
    ans.resize(n, INFLL);

    if (n > 20) {
        return;
    }

    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }

    for (int mask = 0; mask < (1 << n); mask++) {
       vector<int> vv = v;

        int answer = 0;

        for (int i = 0; i < n - 1; i++) {
            if (!((mask >> i) & 1)) {
                continue;
            }

            if (cost(i, vv) > 0) {
                continue;
            }

            int dlt = abs(cost(i, vv)) + 1;
            vv[i + 1] += dlt;
            answer += dlt;
        }

        int bal = 0;

        for (int i = 0; i < n - 1; i++) {
            if (cost(i, vv) > 0) {
                bal++;
            }
        }

       ans[bal] = min(ans[bal], answer);    
    }

    int answer = INFLL;

    for (int i = n - 1; i >= 0; i--) {
        answer = min(answer, ans[i]);
        cout << answer << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif  

    solve();
    return 0;
}