#ifndef ASTRON
#pragma GCC optimize("O3,unroll-loops")
#endif

#include <bits/stdc++.h>
using namespace std;

#define int long long
#define ld long double

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& i : v) in >> i;
    return in;
}

bool isfancy(int i) {
    for (int j = 1; j * j <= i; j++) {
        if (i % (j * j) == 0) {
            int left = i / (j * j);
            bool pr = true;
            for (int k = 2; k * k <= left; k++) {
                if (left % k == 0) {
                    pr = false;
                    break;
                }
            }
            if (pr == true) return true;
        }
    }
    return false;
}

void solve() {
    int n, m;
    cin >> n >> m;
    if (n == 1) {
        cout << 1 << '\n';
        cout << 1 << '\n';
        cout << 1;
        return;
    }

    vector<pair<int, int>> nums(n);
    for (int i = 0; i < n; i++) {
        nums[i] = {i + 1, i + 1};
    }
    vector<vector<int>> ans;
    while (nums.size()) {
        ans.emplace_back();
        vector<pair<int, int>> left;
        for (pair<int, int> i : nums) {
            if (i.first % 2) {
                ans.back().push_back(i.second);
            } else {
                left.push_back({i.first / 2, i.second});
            }
        }
        nums = left;
    }

    cout << ans.size() << '\n';
    for (auto v : ans) {
        assert(isfancy(accumulate(v.begin(), v.end(), 0ll)));
        cout << v.size() << '\n';
        for (int i : v) cout << i << ' ';
        cout << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve(), cout << '\n';
}