#ifndef ASTRON
#pragma GCC optimize("O3,unroll-loops")
#endif

#include <bits/stdc++.h>
using namespace std;

#define int long long
#define ld long double

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& i : v) in >> i;
    return in;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    cin >> a;
    vector<vector<int>> cost(m, vector<int>(m));
    cin >> cost;
    for (int& i : a) i--;
    vector<int> l(m, -1), r(m);
    for (int i = 0; i < n; i++) {
        if (l[a[i]] == -1) l[a[i]] = i;
        r[a[i]] = i;
    }

    vector<vector<int>> g;
    for (int i = 0; i < n; ) {
        int cr = r[a[i]];
        set<int> st;
        st.insert(a[i]);
        for (int j = i + 1; j <= cr; j++) {
            st.insert(a[j]);
            cr = max(cr, r[a[j]]);
        }

        g.emplace_back();
        for (int i : st) g.back().push_back(i);
        i = cr + 1;
    }

    int ans = 0;

    vector dp(m, vector<int>(m, 1e18));
    vector pref(m, vector<int>(m, 1e18));

    for (int i = 0; i < g.size(); i++) {
        if (i != 0) {
            for (int j = 0; j < m; j++) {
                dp[g[i][0]][j] = min(dp[g[i][0]][j], pref[g[i-1].back()][j] + cost[g[i][0]][j]);
                pref[g[i][0]][j] = dp[g[i][0]][j];
                if (j != 0)
                    pref[g[i][0]][j] = min(pref[g[i][0]][j], pref[g[i][0]][j-1]);
            }
        } else {
            for (int j = 0; j < m; j++) {
                dp[g[i][0]][j] = min(dp[g[i][0]][j], cost[g[i][0]][j]);
                pref[g[i][0]][j] = dp[g[i][0]][j];
                if (j != 0)
                    pref[g[i][0]][j] = min(pref[g[i][0]][j], pref[g[i][0]][j-1]);
            }
        }

        for (int j = 1; j < g[i].size(); j++) {
            for (int k = 0; k < m; k++) {
                dp[g[i][j]][k] = dp[g[i][j-1]][k] + cost[g[i][j]][k];
                pref[g[i][j]][k] = dp[g[i][j]][k];
                if (k != 0)
                    pref[g[i][j]][k] = min(pref[g[i][j]][k], pref[g[i][j]][k-1]);
            }
        }
    }

    cout << pref[g.back().back()][m-1];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve(), cout << '\n';
}