#include <bits/stdc++.h>
using namespace std;

int dp[501][501][501];

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    vector<int> inp(n);
    for (auto &i : inp) {
        cin >> i;
    }

    vector<int> a;
    for (int i = 0; i < n - 1; i++) {
        if (inp[i] + inp[i + 1] > 0) {
            a.push_back(0);
        } else {
            a.push_back(abs(inp[i] + inp[i + 1]) + 1);
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j <= i; j++) {
            for (int k = 0; k <= i; k++) {
                dp[i][j][k] = 1e9;
            }
        }

        dp[i][i][0] = 0;
    }

    dp[0][0][0] = 0;

    for (int i = 0; i < n - 1; i++) {
        int diff = 0;
        for (int dlt = 0; dlt <= i; dlt++) {
            for (int cnt = 0; cnt <= i; cnt++) {
                dp[i + 1][i + 1][cnt] = min(dp[i + 1][i + 1][cnt], dp[i][dlt][cnt]);
            }
        }

        for (int dlt = i; dlt >= 0; dlt--) {
            int diff = 0;
            int all = 0;
            bool ok = 0;
            for (int j = dlt; j < i; j++) {
                if (diff >= a[j]) {
                    ok = 1;
                    break;
                } else {
                    all += a[j] - diff;
                    diff = a[j] - diff;
                }
            }

            if (ok) continue;

            for (int cnt = 0; cnt <= i; cnt++) {
                if (diff >= a[i]) {
                    dp[i + 1][i + 1][cnt + 1] = min(dp[i + 1][i + 1][cnt + 1], dp[i][dlt][cnt]);
                } else {
                    dp[i + 1][dlt][cnt + 1] = min(dp[i + 1][dlt][cnt + 1], dp[i][dlt][cnt] + (a[i] - diff));
                }
            }
        }
    }

    vector<int> ans(n, 1e9);
    for (int dlt = 0; dlt < n; dlt++) {
        for (int cnt = 0; cnt < n; cnt++) {
            ans[cnt] = min(ans[cnt], dp[n - 1][dlt][cnt]);
        }
    }

    reverse(ans.begin(), ans.end());
    for (auto i : ans) {
        cout << i << ' ';
    }

    cout << endl;
}

/*
5
-1 -5 -1 -5 -1
*/