#include <bits/stdc++.h>
using namespace std;

#define int long long

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector<int> inp(n);
    for (auto &i : inp) {
        cin >> i;
        i--;
    }

    vector<vector<int>> cost(m, vector<int>(m));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            cin >> cost[i][j];
        }
    }

    vector<int> arr;
    for (int i = 0; i < n; i++) {
        if (i == 0 || inp[i] != inp[i - 1]) {
            arr.push_back(inp[i]);
        }
    }

    vector<vector<int>> dist(m, vector<int>(m, 1e18)), dist2 = dist;
    map<pair<int, int>, int> cur = {{{0, 0}, cost[arr[0]][0]}};

    int ans = 1e18;
    for (int _ = 0; _ < 2007; _++) {
        map<pair<int, int>, int> nxt;
        for (auto [pr, dist] : cur) {
            auto [a, b] = pr;
            if (b != m - 1) {
                if (nxt.find({a, b + 1}) == nxt.end()) {
                    nxt[{a, b + 1}] = 1e18;
                }

                nxt[{a, b + 1}] = min(nxt[{a, b + 1}], dist - cost[arr[a]][b] + cost[arr[a]][b + 1]);
            }

            if (a == arr.size() - 1) {
                ans = min(ans, dist);
            } else {
                if (nxt.find({a + 1, b}) == nxt.end()) {
                    nxt[{a + 1, b}] = 1e18;
                }

                nxt[{a + 1, b}] = min(nxt[{a + 1, b}], dist + cost[arr[a + 1]][b]);
            }
        }

        cur = nxt;
    }

    cout << ans << endl;
}