#include <bits/stdc++.h>
using namespace std;

using ll = long long;

constexpr ll inf = 1144000000000000000;
constexpr int Inf = 0x3f3f3f3f;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (auto& e : a)
        cin >> e;
    vector<vector<ll>> cost(m, vector<ll>(m));
    for (int i = 0; i < m; ++i)
        for (int j = 0; j < m; ++j)
            cin >> cost[i][j];
    vector<int> ff(n + 2, Inf);
    ff[0] = Inf;
    for (auto e : a) {
        auto q = lower_bound(ff.begin(), ff.end(), e);
        *q = e;
    }
    for (int i = 0; i <= n; ++i) {
        if (ff[i] == Inf) {
            cout << (n - i) * cost[0][1];
            return;
        }
    }
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int Tc = 1;
    // cin >> Tc;
    while (Tc--)
        solve(), cout << "\n";
    return 0;
}