squares = [x * x for x in range(1, 100000)]


def is_prime(x):
    if x in [2, 3]: return True
    for i in range(2, int(x ** 0.5) + 2):
        if x % i == 0: return False
    return True


def check(x):
    for i in range(len(squares)):
        k = 2
        while k * squares[i] <= x:
            if (k * squares[i] == x and is_prime(k)):
                return squares[i]
            k += 1
    return False

def find(x):
    l = 0
    r = len(squares) - 1
    while r - l > 1:
        m = (r + l) // 2
        if (squares[m] > x):
            r = m
        else:
            l = m
    if squares[l] == x: return True
    if squares[r] == x: return True
    return False



n, m = map(int, input().split())

ans = []

ans.append(range(1, n + 1, 2))

k = 2
while k <= n:
    group = range(k, n + 1, 2 * k)
    if len(group) > 0:
        ans.append(group)
    k *= 2
    
print(len(ans))
for i in ans:
    print(len(i))
    print(*i)
    # sm = sum(i)
    # if not find(sm) and not check(sm):
    #     print("FAILED", sm)
    #     break