#include "bits/stdc++.h"

#define int long long
#define ll long long
#define ull unsigned long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }
    if (n <= 20) {
        vector <tuple<int, int, int>> last = {{a[n - 1], 0, 0}};
        for (int i = n - 2; i >= 0; --i) {
            vector <tuple<int, int, int>> cur;
            for (auto &[x, y, z]: last) {
                if (a[i] + x > 0) {
                    cur.emplace_back(a[i], y, z);
                } else {
                    cur.emplace_back(a[i], y, z + 1);
                    int k = llabs(a[i] + x) + 1;
                    cur.emplace_back(a[i] + k, y + k, z);
                }
            }
            last = cur;
        }
        vector<int> b(n, INT64_MAX);
        for (int i = 0; i < n; ++i) {
            for (auto &[x, y, z]: last) {
                b[z] = min(b[z], y);
            }
        }
        int cur = 0;
        vector<int> ans(n);
        for (int i = n - 1; i >= 0; --i) {
            if (b[i] != INT64_MAX) {
                cur = max(cur, b[i]);
            }
            ans[i] = cur;
        }
        for (int i: ans) {
            cout << i << ' ';
        }
    } else {
        const int N = 100;
        vector<vector<vector<int>>> dp(n, vector<vector<int>> (n, vector<int> (N * 5 + 2, INT64_MAX)));
        dp[0][n - 1][a[n - 1] + N] = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = min(n - 2, n - 1 - i); j >= 0; --j) {
                for (int k = a[j] + N; k <= N * 4 + 1; ++k) {
                    for (int e = a[j + 1] + N; e <= N * 4 + 1; ++e) {
                        if (k + e > N * 2 && dp[i][j + 1][e] != INT64_MAX) {
                            dp[i][j][k] = min(dp[i][j][k], dp[i][j + 1][e] + k - a[j] - N);
                        } else {
                            if (i > 0 && dp[i - 1][j + 1][e] != INT64_MAX) {
                                dp[i][j][k] = min(dp[i][j][k], dp[i - 1][j + 1][e] + k - a[j] - N);
                            }
                            if (dp[i][j + 1][e] != INT64_MAX) {
                                int need = llabs(k + e - N * 2) + 1;
                                dp[i][j][k + need] = min(dp[i][j][k + need], dp[i][j + 1][e] + need + k - a[j] - N);
                            }
                        }
                    }
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            int res = INT64_MAX;
            for (int k = a[0] + N; k <= N * 4 + 1; ++k) {
                res = min(res, dp[i][0][k]);
            }
            cout << res << ' ';
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
}