#include <bits/stdc++.h>
using namespace std;
#define int long long
const int inf = 1e18;
#define x first
#define y second

signed main() {
  int n, m;
  cin >> n >> m;
  vector<int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }
  vector<vector<int>> c(m + 1, vector<int> (m + 1));
  for (int i = 1; i <= m; ++i) {
    for (int j = 1; j <= m; ++j) {
      cin >> c[i][j];
    }
  }
  vector<vector<int>> vh(m + 1);
  for (int i = 0; i < n; ++i) {
    vh[a[i]].emplace_back(i);
  }
  vector<pair<int, int>> bl;
  int u = n;
  while (u - 1 >= 0) {
    int l = vh[a[u - 1]][0];
    for (int j = u - 1; j >= l; --j) {
      l = min(l, vh[a[j]][0]);
    }
    bl.emplace_back(l, u - 1);
    u = l;
  }
  std::sort(bl.begin(), bl.end());
  int k = (int)bl.size();
  vector<vector<int>> clrs(k);
  vector<vector<int>> cnt(k, vector<int>(m + 1, 0));
  vector<vector<int>> cst(k, vector<int>(m + 1, 0));
  for (int i = 0; i < k; ++i) {
    for (int j = bl[i].x; j <= bl[i].y; ++j) {
      cnt[i][a[j]]++;
    }
  }
  for (int i = 0; i < k; ++i) {
    for (int j = 1; j <= m; ++j) {
      if (cnt[i][j] > 0) clrs[i].emplace_back(j);
    }
  }
  for (int i = 0; i < k; ++i) {
    for (int j = 1; j <= m; ++j) {
      for (auto d : clrs[i]) {
        if (d == j) continue;
        cst[i][j] += c[d][j];
      }
    }
  }
  vector<vector<int>> dp(k + 1, vector<int>(m + 1, inf));
  for (int i = 1; i <= m; ++i) {
    dp[0][i] = 0;
  }
  for (int i = 1; i <= k; ++i) {
    int mn = inf;
    for (int j = 1; j <= m; ++j) {
      mn = min(dp[i - 1][j], mn);
      dp[i][j] = mn + cst[i - 1][j];
    }
  }
  int ans = inf;
  for (int i = 1; i <= m; ++i) {
    ans = min(ans, dp[k][i]);
  }
  cout << ans;
  return 0;
}