#include <bits/stdc++.h>

using namespace std;

//@formatter:off
using ll = long long;
template<typename T> istream &operator>>(istream &is, vector<T> &a);
template<typename T> ostream &operator<<(ostream &os, vector<T> &a);
//@formatter:on

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n;
    cin >> n;

    vector<int> a(n);
    std::iota(a.begin(), a.end(), 1);
    ll pw = 1;
    vector<vector<int>> res;
    while (!a.empty()) {
        vector<int> v2;
        vector<int> v1;
        for (int j = 0; j < n; ++j) {
            if (a[j] % 2 == 1) v1.push_back(a[j]);
            else v2.push_back(a[j]);
        }
        for (auto &v: v1){
            v *= pw;
        }
        res.push_back(v1);
        pw *= 2;

        for (int & j : v2) {
            j /= 2;
        }
        a = v2;
        n = a.size();
    }

    cout << res.size() << "\n";
    for (auto v: res){
        cout << v.size() << "\n";
        cout << v;
    }
}

// region POZOR
template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (int i = 0; i < a.size(); i++)
        os << a[i] << " \n"[i == a.size() - 1];
    return os;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a)
        is >> i;
    return is;
}
// endregion