﻿#include <iostream>
#include <map>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <assert.h>
#include <stack>
#include <queue>
#include <random>
#include <unordered_map>
#include <unordered_set>
#include <set>

using namespace std;
#define all(arr) arr.begin(), arr.end() 
#define pii pair<int, int>
#define ff first
#define ss second
#define vi vector<int>
#define vvi vector<vi>
#define vpii vector<pii>

#define int long long
mt19937 rnd(time(0));
#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
const int INF = 1e18 + 7;

vi prime;
int N = 1e5 + 3;

signed main()
{

	int n, m;
	cin >> n >> m;
	vi a(n);
	for (auto& i : a) cin >> i;
	for (auto& i : a) i--;
	vvi dp(n, vi(m, INF));
	vvi b(m, vi(m));
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> b[i][j];
		}
	}
	for (int i = a[0]; i < m; ++i) dp[0][i] = 0;
	for (int i = 0; i < a[i]; ++i) dp[0][i] = b[a[0]][i];

	for (int i = 1; i < n; ++i) {
		for (int x = 0; x < m; ++x) {
			if (x == a[i]) {
				dp[i][x] = dp[i - 1][x];
				if (x > 0) dp[i][x] = min(dp[i][x - 1], dp[i][x]);
				continue;
			}
			dp[i][x] = min(dp[i][x], dp[i - 1][x] + b[a[i]][x]);
			if (x) dp[i][x] = min(dp[i][x], dp[i][x - 1]);
		}
	}

	int ans = INF;
	for (int x = 0; x < m; ++x) ans = min(ans, dp[n - 1][x]);
	cout << ans;
}