#include <bits/stdc++.h>

using namespace std;

#ifndef LOCAL
#pragma GCC optimize("unroll-loops,O3")
// #pragma GCC target("avx2")
#endif

#define int long long
#define pint pair<int, int>
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

template<class T>
bool cmax(T& a, T b) {
    if (a >= b) return false;
    a = b;
    return true;
}

template<class T>
bool cmin(T& a, T b) {
    if (a <= b) return false;
    a = b;
    return true;
}

inline void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (auto& el : v) cin >> el;
    vector<vector<map<int, int>>> dp(n, vector<map<int, int>>(n));
    for (int to = v[0]; to < 101; ++to) {
        dp[0][0][to] = to - v[0];
    }
    for (int i = 1; i < n; ++i) {
        for (int k = 0; k < n; ++k) {
            for (int prev = v[i - 1]; prev < 101; ++prev) {
                for (int now = v[i]; now < 101; ++now) {
                    int dx = now - v[i] + dp[i - 1][k][prev];
                    if (prev + now > 0) {
                        if (!dp[i][k].count(now)) dp[i][k][now] = dx;
                        else cmin(dp[i][k][now], dx);
                    } else {
                        if (k + 1 < n) {
                            if (!dp[i][k + 1].count(now)) dp[i][k + 1][now] = dx;
                            else cmin(dp[i][k + 1][now], dx);
                        }
                    }
                }
            }
        }
    }
    for (int k = 0; k < n; ++k) {
        int mn = 1e18;
        for (int to = v.back(); to < 101; ++to) {
            cmin(mn, dp.back()[k][to]);
        }
        cout << mn << ' ';
    }
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
//    cin >> ttt;
    while (ttt--) {
        solve();
    }

    return 0;
}