#include <assert.h>

#include <algorithm>
#include <deque>
#include <iostream>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll INF = 1e18;
const ll mod = 1e9 + 7;
const char sep = ' ';

template<typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (ll i = 0; i < (ll)arr.size(); ++i) {
        in >> arr[i];
    }
    return in;
}


template<typename T>
ostream& operator<<(ostream& out, vector<T>& arr) {
    for (auto el : arr) {
        out << el << sep;
    }
    return out;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, m, a, b;
    cin >> a >> b >> n >> m;
    if (b == 2 * a && m == 2 * n) {
        cout << n << " 0";
        return 0;
    } else if (b == 2 * a) {
        cout << -1;
        return 0;
    }
    if ((m - 2 * n) % (b - 2 * a)) {
        cout << -1;
        return 0;
    }
    ll ab = (m - 2 * n) / (b - 2 * a);
    ll chel = n - a * ab;
    if (ab >= 0 && chel >= 0) {
        cout << chel << " " << ab;
        return 0;
    }
    cout << -1;
}