// #pragma GCC target("avx2")
// #pragma GCC optimize("O3")

#include <bits/stdc++.h>
#define pb push_back

using namespace std;
using ll = long long;
using vi = vector<ll>;
using ld = long double;
using pi = pair<ll, ll>;

const ll INF = 1e9;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n;
    cin >> n;

    vi a(n);
    for (ll i = 0; i < n; ++i) cin >> a[i];

    vector<vector<vi>> dp(n, vector<vi>(n, vi(202, INF)));

    for (ll ai = a[0]; ai <= 101; ++ai) {
        dp[0][0][ai + 100] = ai - a[0];
    }

    for (ll i = 1; i < n; ++i) {
        for (ll ai = a[i]; ai <= 101; ++ai) {
            for (ll prev = -ai + 1; prev <= 101; ++prev) {
                dp[i][0][ai + 100] = min(dp[i][0][ai + 100], dp[i - 1][0][prev + 100] + ai - a[i]);
            }
            for (ll k = 1; k < n; ++k) {
                for (ll prev = -ai + 1; prev <= 101; ++prev) {
                    dp[i][k][ai + 100] = min(dp[i][k][ai + 100], dp[i - 1][k][prev + 100] + ai - a[i]);
                }
                for (ll prev = -100; prev <= -a[i]; ++prev) {
                    dp[i][k][ai + 100] = min(dp[i][k][ai + 100], dp[i - 1][k - 1][prev + 100] + ai - a[i]);
                }
            }
        }
    }

    vi ans(n, INF);

    for (ll k = 0; k < n; ++k) {
        for (ll last = -100; last <= 101; ++last) {
            for (ll g = 0; g <= k; ++g) {
                ans[k] = min(ans[k], dp[n - 1][g][last + 100]); 
            }
        }
    }

    for (auto x : ans) {
        cout << x << ' ';
    }

    return 0;
}