#include <bits/stdc++.h>
#define pb push_back

using namespace std;
using ll = long long;
using vi = vector<ll>;
using ld = long double;
using pi = pair<ll, ll>;

ll n;
vector<vi> g;

vi dp, par, dep;

void dfs_init(ll v, ll p) {
    par[v] = p;
    if (p != -1) dep[v] = dep[p] + 1;
    for (auto u : g[v]) {
        if (u != p) dfs_init(u, v);
    }
}

ll dfs(ll v, ll c) {
    dp[v] += c * (dep[v] + 1);
    if (par[v] != -1) return max(dp[v], dfs(par[v], c));
    else return dp[v];
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    g.resize(n);
    par.resize(n);
    dep.resize(n);

    for (ll i = 0; i < n - 1; ++i) {
        ll u, v;
        cin >> u >> v;
        --u; --v;
        g[u].pb(v);
        g[v].pb(u);
    }

    dfs_init(0, -1);

    ll q, t;
    cin >> q >> t;

    for (ll i = 0; i < q; ++i) {
        dp.clear();
        dp.resize(n);
        ll k;
        cin >> k;
        ll ans = 0;
        for (ll j = 0; j < k; ++j) {
            ll v, c;
            cin >> v >> c;
            --v;
            ans = max(ans, dfs(v, c));
        }
        cout << ans << endl;
    }

    return 0;
}