#include <bits/stdc++.h>
using namespace std;

#define in(a) a.begin(), a.end()
typedef long long ll;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

void read(int& x) {
	cin >> x;
}

template<typename T>
bool cmin(T& a, const T& b) {
	if (b < a) 
	{
		a = b;
		return true;
	}
	return false;
}

const ll oo = 1e15;

 main() {
	cin.tie(0)->sync_with_stdio(0);
	int n, m;
	cin >> n >> m;
	vector<int> a(n);
	for_each(in(a), read);
	vector<int> l(m, n), r(m, -1);
	for (int i = 0; i < n; ++i) {
		l[a[i] - 1] = min(l[a[i] - 1], i);
		r[a[i] - 1] = max(r[a[i] - 1], i + 1);
	}
	vector<int> ord(m);
	iota(in(ord), 0);
	sort(in(ord), [&](int i, int j) {
		return l[i] < l[j];
	});
	vector<vector<int>> c(m, vector<int>(m));
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> c[i][j];
		}
	}
	vector<vector<ll>> dp(m + 1, vector<ll>(m, oo));
	for (int col = 0; col < m; ++col) {
		dp[0][col] = 0;
	}
	for (int x : ord) {
		debug << x << ' ';
	}
	debug << endl;

	vector<vector<ll>> prefs(m, vector<ll>(m + 1));
	for (int col = 0; col < m; ++col) {
		for (int i = 0; i < m; ++i) {
			prefs[col][i + 1] = prefs[col][i] + c[ord[i]][col];
		}
	}

	ll ans = oo;
	int beg = 0;
	while (beg < m) {
		if (l[ord[beg]] == n) {
			ans = dp[beg][m - 1];
			break;
		}
		int end = beg;
		int my_r = r[ord[beg]];
		while (end < m && l[ord[end]] < my_r) {
			my_r = max(my_r, r[ord[end]]);
			end += 1;
		}
		for (int my_col = 0; my_col < m; ++my_col) {
			ll cost = prefs[my_col][end] - prefs[my_col][beg];
			// for (int i = beg; i < end; ++i) {
			// 	cost += c[ord[i]][my_col];
			// }
			cmin(dp[end][my_col], dp[beg][my_col] + cost);
			if (my_col > 0) {
				cmin(dp[end][my_col], dp[end][my_col - 1]);
			}
		}
		debug << beg << ' ' << end << endl;
		beg = end;
	}
	cmin(ans, dp[m][m - 1]);
	cout << ans;
	return 0;
}