#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n;
	cin >> n;
	vector <ll> a(n), b(n), c(n), d(n);
	int z = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		if (a[i] < 0) z++;
	}
	for (int i = 0; i < n; ++i) cin >> b[i];
	for (int i = 0; i < n; ++i) cin >> c[i];
	for (int i = 0; i < n; ++i) cin >> d[i];

	int f = 0;
	for (int i = 0; i < n; ++i) {
		if (a[i] == 0) f = 1;
	}
	ll ans = 0;
	vector <ll> delta;
	if (f == 1) {
		for (int i = 0; i < n; ++i) {
			if (a[i] == 0) {
				if (c[i] > d[i]) {
					a[i] -= b[i];
					z++;
				}
				else {
					a[i] += b[i];
				}
				ans += min(c[i], d[i]);
				delta.push_back(abs(d[i] - c[i]));
			}
		}
	}
	
	if (z % 2 == 0) {
		cout << ans;
		return 0;
	}
	vector <ll> r;
	for (int i = 0; i < n; ++i) {
		if (a[i] > 0) {
			r.push_back(d[i] * ((abs(a[i]) / b[i] + 1)));
		}
		else {
			r.push_back(c[i] * ((abs(a[i]) / b[i] + 1)));
		}
	}
	sort(r.begin(), r.end());
	if (f == 1) {
		r[0] = min(r[0], *min_element(delta.begin(), delta.end()));
	}
	cout << r[0] + ans;
	
	return 0;
}


//struct segtree {
//	vector <int> tree;
//	int sz;
//
//	void init(int n) {
//		sz = 1;
//		while (sz < n) sz *= 2;
//		tree.assign(2 * sz - 1, 0);
//	}
//
//	void build(vector <int>& a, int x, int l, int r) {
//		if (l == r - 1) {
//			if (a.size() > l) {
//				tree[x] = a[l];
//			}
//			return;
//		}
//		int m = (r + l) / 2;
//		build(a, 2 * x + 1, l, m);
//		build(a, 2 * x + 2, m, r);
//		tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
//	}
//
//	void build(vector <int>& a) {
//		init((int)a.size());
//		build(a, 0, 0, sz);
//	}
//};