#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
#define int ll

bool prime(int n) {
	if (n == 1) return false;
	int d = 2;
	while (d * d <= n) {
		if (n % d == 0) return false;
		d++;
	}
	return true;
}

bool good(int n) {
	int d = 2;
	map <int, int> fact;
	fact[1] = 2;
	while (d * d <= n) {
		while (n % d == 0) {
			n /= d;
			fact[d]++;
		}
		d++;
	}
	if (n > 1) {
		fact[n]++;
	}
	int k = -1;
	int c = 0;
	for (auto now : fact) {
		if (now.second % 2 == 1) {
			k = now.first;
			c++;
		}
	}
	if (c == 0 || c == 1 && prime(k)) {
		return true;
	} 
	return false;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n, m;
	cin >> n >> m;

	ll ans = 0;
	for (int i = 1; i <= n; ++i) {
		ans += i;
	}

	if (good(ans)) {
		cout << 1 << endl;
		cout << n << '\n';
		for (int i = 1; i <= n; ++i) cout << i << ' ';
		return 0;
	}
	for (int i = 1; i <= n; ++i) {
		if (good(i)) {
			ans -= i;
			if (good(ans)) {
				cout << 2 << endl;
				cout << 1 << endl;
				cout << i << '\n';
				cout << n - 1 << '\n';
				for (int j = 1; j <= n; ++j) {
					if (i == j) continue;
					cout << j << ' ';
				}
				return 0;
			}
			ans += i;
		}
	}
}


//struct segtree {
//	vector <int> tree;
//	int sz;
//
//	void init(int n) {
//		sz = 1;
//		while (sz < n) sz *= 2;
//		tree.assign(2 * sz - 1, 0);
//	}
//
//	void build(vector <int>& a, int x, int l, int r) {
//		if (l == r - 1) {
//			if (a.size() > l) {
//				tree[x] = a[l];
//			}
//			return;
//		}
//		int m = (r + l) / 2;
//		build(a, 2 * x + 1, l, m);
//		build(a, 2 * x + 2, m, r);
//		tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
//	}
//
//	void build(vector <int>& a) {
//		init((int)a.size());
//		build(a, 0, 0, sz);
//	}
//};