#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define pb push_back
#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)x.size()

using pii = pair<int, int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int OO = 1e18;

const int N = 501;
int n, a[N], b[N], dp[N][N];

void solve() {
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    for (int i = 1; i < n; i++) {
        b[i] = a[i + 1] + a[i];
    }

    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= n; j++) {
            dp[i][j] = OO;
        }
    }

    dp[0][0] = 0;
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < n; j++) {
            dp[i][j] = min(dp[i][j], dp[i - 1][j]);
            int pls = 0;
            int mn = 0;
            for (int g = 1; g <= i && j + g < n; g++) {
                int cur = b[i - g + 1] + pls;
                int need = 0;
                if (cur <= 0) {
                    need = -cur + 1;
                }
                mn += need;
                pls = need;
                dp[i][j + g] = min(dp[i][j + g], dp[i - g][j] + mn);
            }
        }
    }

    int res = OO;
    for (int k = 0; k < n; k++) {
        res = min(res, dp[n - 1][n - k - 1]);
        cout << res << ' ';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}