#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define rep1(i, n) for(int i = 1; i <= (n); ++i)

using namespace std;
using i64 = long long;

mt19937 rd(chrono::steady_clock::now().time_since_epoch().count());

constexpr int inf = 1.01e9;

constexpr int N = 5e2 + 10;
int a[N], dp[N][N], b[N][N], c[N][N];

void solve(){
	int n;
	cin >> n;
	rep1(i, n){
		cin >> a[i];
	}
	rep1(i, n) b[i][i] = a[i], c[i][i] = 0;
	for(int len = 2; len <= n; ++len){
		for(int i = 1; i + len - 1 <= n; ++i){
			b[i][i + len - 1] = a[i + len - 1] + max(0, -(b[i][i + len - 2] + a[i + len - 1]) + 1);
			c[i][i + len - 1] = c[i][i + len - 2] + b[i][i + len - 1] - a[i + len - 1];  
		}
	}
	rep(i, n + 1) rep(j, n) dp[i][j] = inf;
	dp[0][0] = 0;
	for(int i = 1; i <= n; ++i){ 
		dp[i][0] = c[1][i];
		for(int bad = 1; bad <= i; ++bad){
			for(int j = i; j >= 1; --j){
				dp[i][bad] = min(dp[i][bad], dp[j - 1][bad - 1] + c[j][i]);
			}
		}
	}
	rep(k, n) cout << dp[n][k] << ' ';
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef requiem
	freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);
#endif
	int tt = 1;
	// cin >> tt;
	while(tt--) solve();
	// cerr << fixed << 1.0 * clock() / CLOCKS_PER_SEC;
	return 0;
}