#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const ll MAXN = 5e5 + 20, INF = 1e18 + 9309706;

vector<ll> stck;
bool used[1010];
ll cost[1010][1010];
ll a[MAXN];
ll comp[1010];
ll dp[1010][1010];

template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

struct Dsu {
    int p[1010];
    int sz[1010];
    void init() {
        iota(p, p + 1010, 0);
        fill(sz, sz + 1010, 0);
    }
    int get(int i) {
        if (i == p[i]) return i;
        return p[i] = get(p[i]);
    }
    bool unite(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) return false;
        if (sz[a] < sz[b]) swap(a, b);
        p[b] = a;
        sz[a] += sz[b];
        return true;
    }
} dsu;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n, m;
    cin >> n >> m;
    if (n > 5e5 || m > 1000) {
        return 0;
    }
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    dsu.init();
    for (ll i = 0; i < m; i++) {
        for (ll j = 0; j < m; j++) {
            cin >> cost[i][j];
        }
    }
    stck.push_back(a[0]);
    used[a[0]] = true;
    for (ll i = 1; i < n; i++) {
        if (dsu.get(a[i]) != a[i] || used[a[i]]) {
            while (dsu.get(stck.back()) != dsu.get(a[i])) {
                dsu.unite(stck.back(), a[i]);
                stck.pop_back();
            }
        } else {
            used[a[i]] = true;
            stck.push_back(a[i]);
        }
    }
    for (ll j = 0; j < m; j++) {
        comp[j] = dsu.get(j);
        // cout << comp[j] << ' ';
    }
    for (ll i = 0; i < m; i++) {
        if (comp[i] == i) continue;
        for (ll j = 0; j < m; j++) {
            cost[comp[i]][j] += cost[i][j];
        }
    }
    /*
    for (ll i = 0; i < m; i++) {
        cout << comp[i] << ' ';
    }
    cout << '\n';
    for (ll i = 0; i < m; i++) {
        for (ll j = 0; j < m; j++) {
            cout << cost[i][j] << ' ';
        }
        cout << endl;
    }
    */
    for (ll i = 0; i < stck.size(); i++) {
        for (ll lst = 0; lst < m; lst++) {
            dp[i + 1][lst] = dp[i][lst] + cost[comp[stck[i]]][lst];
            // cout << i + 1 << ' ' << lst << ' ' << dp[i + 1][lst] << "s2 \n";
            if (lst > 0) {
                if (smin(dp[i + 1][lst], dp[i + 1][lst - 1])) {
                    // cout << i + 1 << ' ' << lst << ' ' << dp[i + 1][lst] << "s3 \n";
                }
            }
        }
    }
    cout << dp[stck.size()][m - 1] << endl;
}