#define _CRT_SECURE_NO_WARNINGS


//#define _DEBUG


#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <utility>

using namespace std;
using ll = long long;
using ld = long double;

#ifdef _DEBUG
#define debug(x) cerr << #x << " = " << x << '\n'
#else
#define debug(x) ;
#endif

template<typename T1 = int, typename T2 = T1>
struct Pair{
    T1 f;
    T2 s;
    Pair(T1 f, T2 s) : f(f), s(s) {;}
};

template<typename T1 = int, typename T2 = T1>
Pair<T1, T2> m_p(T1 f, T2 s){
    return Pair(f, s);
}

template<typename T1 = int, typename T2 = T1>
ostream& operator<< (ostream& os, const Pair<T1, T2> a){
    return os << "( " << a.f << ", " << a.s << " )";
}


void solve(){
    
    ll ph, pl, ah, al;
    cin >> ph >> pl >> ah >> al;
    if(ah * 2 == al){
        cout << ah << " 0\n";
        return;
    }
    if(pl - ph * 2 == 0 || (al - ah * 2) / (pl - ph * 2) < 0 || ah - ((al - ah * 2) / (pl - ph * 2)) * ph < 0){
        cout << "-1\n";
        return;
    }
    ll an = (al - ah * 2) / (pl - ph * 2);
    if((ah - an * ph) * 2 != (al - an * pl)){
        cout << "-1\n";
        return;
    }
    cout << ah - an * ph << ' ' << an << '\n';

}

void precount(){

}

int main(){
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);

    int t = 1;

    precount();
    //cin >> t;

    while(t--){
        solve();
    }

}