#define _CRT_SECURE_NO_WARNINGS


//#define _DEBUG


#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <utility>

using namespace std;
using ll = long long;
using ld = long double;
const int INF = 2000000000;

#ifdef _DEBUG
#define debug(x) cerr << #x << " = " << x << '\n'
#else
#define debug(x) ;
#endif

template<typename T1 = int, typename T2 = T1>
struct Pair{
    T1 f;
    T2 s;
    Pair(T1 f, T2 s) : f(f), s(s) {;}
};

template<typename T1 = int, typename T2 = T1>
Pair<T1, T2> m_p(T1 f, T2 s){
    return Pair(f, s);
}

template<typename T1 = int, typename T2 = T1>
ostream& operator<< (ostream& os, const Pair<T1, T2> a){
    return os << "( " << a.f << ", " << a.s << " )";
}

int dp[555][555];
int sp[555];
int arr[555];


void solve(){
    
    int qe;
    cin >> qe;
    for(int i = 0; i < qe; ++i){
        cin >> arr[i];
        sp[i] += arr[i];
        sp[i + 1] = arr[i];
    }
    sp[0] = 1;
    for(int le = 1; le < qe; ++le){
        for(int mb = 0; mb < qe; ++mb){
            if(mb >= le) continue;
            if(sp[le] > 0){
                dp[le][mb] = dp[le - 1][mb];
                continue;
            }
            if(mb > 0) dp[le][mb] = dp[le - 1][mb - 1];
            else dp[le][mb] = INF;
            int cp = -sp[le] + 1, lp = -sp[le] + 1, mi = 1;
            dp[le][mb] = min(dp[le][mb], dp[le - 1][mb] + cp);
            for(int i = 1; sp[le - i] + lp <= 0; ++i){
                cp += -sp[le - i] - lp + 1;
                lp = -sp[le - i] - lp + 1;
                dp[le][mb] = min(dp[le][mb], dp[le - i - 1][mb] + cp);
                debug(cp);
                debug(lp);
                debug(dp[le][mb]);
                debug(dp[le - i - 1][mb]);
                ++mi;
            }
            dp[le][mb] = min(dp[le][mb], dp[max(le - mi - 1, 0)][mb] + cp);
            debug(max(le - mi - 1, 0));
            debug(dp[max(le - mi - 1, 0)][mb]);
            debug(cp);

            debug(le);
            debug(mb);
            debug(dp[le][mb]);
        }
    }
    for(int mb = 0; mb < qe ; ++mb){
        cout << dp[qe - 1][mb] << ' ';
    }
    cout << '\n';

}

void precount(){

}

int main(){
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);

    int t = 1;

    precount();
    //cin >> t;

    while(t--){
        solve();
    }

}