#include <iostream>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <cassert>
#include <ctime>
#include <chrono>
#include <cstdio>
#include <random>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <deque>
#include <queue>
#include <bitset>
#include <list>
#include <fstream>
#include <functional>
#include <complex>
using namespace std;
mt19937_64 gen(666);
using ll = long long;
using ld = long double;
                
const ll INF = 1e18;
const ll M = 70;
const int MOD = 1e9 + 7;
const ll N = 2e5;
const int LOG = 20;
const ld EPS = 1e-6;
const int C = 100;


void solve() {
    ll a, b, n, m; cin >> a >> b >> n >> m;
    if (m - 2 * n == 0) {
        cout << n << " " << 0 << '\n';
        return;
    }
    
    if (b - 2 * a == 0) {
        cout << -1 << '\n';
        return;
    }

    if ((m - 2 * n) % (b - a * 2) != 0) {
        cout << -1 << '\n';
        return;
    }
    
    ll x = (m - 2 * n) / (b - 2 * a);
    ll k = n - x * a;
    if (x * b + 2 * k == m && k >= 0 && x >= 0) {
        cout << k << " " << x << '\n';
    } else {
        cout << -1 << '\n';
    }
}
                
signed main() {

                    
    ios_base::sync_with_stdio(false); cin.tie(0);
   
    ll tst = 1;
    while (tst--) {
        solve();
    }
}