#include <iostream>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <cassert>
#include <ctime>
#include <chrono>
#include <cstdio>
#include <random>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <deque>
#include <queue>
#include <bitset>
#include <list>
#include <fstream>
#include <functional>
#include <complex>
using namespace std;
mt19937_64 gen(666);
using ll = long long;
using ld = long double;
                
const ll INF = 1e18;
const ll M = 70;
const int MOD = 1e9 + 7;
const ll N = 2e5;
const int LOG = 20;
const ld EPS = 1e-6;
const int C = 100;


bool is_prime(ll n) {
    if (n == 1) return true;
    for (ll d = 2; d * d <= n; d++) {
        if (n % d == 0) {
            return false;
        }
    }
    return true;
}

ll find(ll sum) {
    for (ll has = sum; has >= 1; has--) {
        if (is_prime(has)) {
            return has;
        }
    }
}

void solve() {
    ll n, m; cin >> n >> m;
    ll sum = n * (n + 1) / 2;
    vector<ll> get;
    ll cur = sum;
    while (!is_prime(cur)) {
        ll nw = find(cur);
        get.push_back(nw);
        cur = cur - nw;
    }
    get.push_back(cur);
    vector<vector<ll>> ans;
    vector<bool> used(n + 1, false);
    for (int i = 1; i < get.size(); i++) {
        ans.push_back({get[i]});
        used[get[i]] = true;
    }
    vector<ll> cmp;
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            cmp.push_back(i);
        }
    }
    ans.push_back(cmp);
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.size() << '\n';
        for (auto j : i) {
            cout << j << " ";
        }
        cout << '\n';
    }
}
                
signed main() {
                    
    ios_base::sync_with_stdio(false); cin.tie(0);
   
    ll tst = 1;
    while (tst--) {
        solve();
    }
}