#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
#define int long long
using idexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

int n;
vector<vector<int>> g;
vector<int> cost;
int ans = 0;

void dfs(int v, int d, int par) {
    for (int i: g[v]) {
        if (i != par) {
            dfs(i, d + 1, v);
            cost[v] += cost[i];
        }
    }
    ans = max(ans, cost[v] * (d + 1));
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    int q, t;
    cin >> q >> t;
    while (q--) {
        int k;
        cin >> k;
        cost.assign(n, 0);
        for (int i = 0; i < k; i++) {
            int x, y;
            cin >> x >> y;
            cost[x - 1] += y;
        }
        ans = 0;
        dfs(0, 0, -1);
        cout << ans << '\n';
    }
}