#include <bits/stdc++.h>

using namespace std;

#define int long long

const int inf = 1e18 + 100;


const int maxnum = 2e6;

vector<int> mex(maxnum, 0);

void make_mex() {
    for (int i = 1; i < maxnum; i++) {
        set<int> q;
        q.insert(mex[i - 1]);
        if (i % 2 == 1) {
            q.insert(mex[i / 2]);
        }
        while (q.find(mex[i]) != q.end()) {
            mex[i]++;
        }
    }
}


int from_s_to_num(string s) {
    int n = s.size();
    int ans = 0;
    for (int i = 0; i < n; i++) {
        ans *= 2;
        if (s[i] == '1') {
            ans++;
        }
    }
    return ans;
}



void make_ans(vector<string> & lst) {
    int xorr = 0;
    for (int i = 0; i < lst.size(); i++) {
        int num = from_s_to_num(lst[i]);
        xorr ^= mex[num];
    }
    if (xorr != 0) {
        cout << "First" << endl;
    } else {
        cout << "Second" << endl;
    }
}



signed main() {
    cout.precision(15);
    cin.tie(0);
    cout.tie(0);
    make_mex();
    int n, q;
    cin >> n >> q;
    vector<string> lst(n, "");
    for (int i = 0; i < n; i++) {
        cin >> lst[i];
    }
    vector<int> siz_of_s(n, 0);
    for (int i = 0; i < n; i++) {
        siz_of_s[i] = lst[i].size();
    }
    make_ans(lst);
    for (; q > 0; --q) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        for (int i = 0; i < n; i++) {
            if (siz_of_s[i] < l) {
                l -= siz_of_s[i];
                r -= siz_of_s[i];
            } else {
                int ind = l;
                while (l <= r && ind < siz_of_s[i]) {
                    if (lst[i][ind] == '0') {
                        lst[i][ind] = '1';
                    } else {
                        lst[i][ind] = '0';
                    }
                    l++;
                    ind++;
                }
                if (l > r) {
                    break;
                }
            }
        }
        make_ans(lst);
    }

}