#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long long ld;

const ll MD = 1000000007;

ll bin_pow(ll a, ll k) {
    if (k == 0) return 1;
    ll t = bin_pow(a, k / 2);
    t = (t * t) % MD;
    if (k & 1) {
        return (t * a) % MD;
    }
    return t;
}

int n, m;
vector<vector<bool>> g;
vector<vector<bool>> g2;
vector<int> tin;
vector<int> ts;
vector<int> u;
vector<int> u2;

void dfs(int v, int C) {
    u2[v] = C;
    for (int i = 0; i < m; i++) {
        if (g[v][i] && !u2[i]) {
            dfs(i, C);
//            g[v][i] = 2;
        }
    }
    ts.push_back(v);
}

void dfs2(int v, int c) {
    u[v] = c;
    for (int i = 0; i < m; i++) {
        if (g[i][v] && !u[i]){ // && u2[i] == u2[v]) {
            dfs2(i, c);
        }
    }
}


void dfs3(int v) {
    u[v] = true;
    ts.push_back(v);
    for (int i = 0; i < m; i++) {
        if (g2[v][i] && !u[i]) {
            dfs3(i);
        }
    }
}

void solve() {
    cin >> n >> m;
    g.resize(m, vector<bool>(m));
    vector<int> a(n);
    vector<int> k(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
        k[a[i]]++;
    }
    int l = a[0];
    for (int j = 1; j < n; j++) {
        if (a[j] != l) {
            g[a[j]][l] = true;
            l = a[j];
        }
    }
    u.resize(m);
    u2.resize(m);
    tin.resize(m);
    int c1 = 0;
    for (int i = 0; i < m; i++) {
        if (!u2[i]) {
            c1++;
            dfs(i, c1);
        }
    }
    reverse(ts.begin(), ts.end());
    u.clear();
    u.resize(m);
    int C = 0;
    for (int i: ts) {
        if (!u[i]) {
            C++;
            dfs2(i, C);
        }
    }
//    vector<vector<int>> b1(m, vector<int>(m));
    vector<vector<ll>> b(C, vector<ll>(m));
    g2.resize(C, vector<bool>(C));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            ll x;
            cin >> x;
//            cin >> b1[i][j];
            if(k[i])
                b[u[i] - 1][j] += x;// * k[i];
            if (g[i][j] && u[i] != u[j]) {
                g2[u[i] - 1][u[j] - 1] = true;
            }
        }
    }
    u.clear();
    ts.clear();
    u.resize(C);
    for (int i = 0; i < C; i++) {
        if (!u[i]) {
            dfs3(i);
        }
    }
    reverse(ts.begin(), ts.end());
    vector<vector<ll>> d(C + 1, vector<ll>(m));
    for (int i = 1; i <= C; i++) {
        ll mn = d[i - 1][0];
        for (int j = 0; j < m; j++) {
            mn = min(mn, d[i - 1][j]);
            d[i][j] = mn + b[ts[i - 1]][j];
        }
    }
    ll mn = d[C][0];
    for (int j = 0; j < m; j++) {
        mn = min(mn, d[C][j]);
    }
    cout << mn;
}

void solve1() {
    int n;
    cin >> n;
    vector<int> a(n + 2);
    a[0] = a[n + 1] = 2000000;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    int ans = 0;
    vector<int> a1(n);
    vector<bool> u(n);
    for (int i = 1; i < n; i++) {
        int m = -1000000000;
        int mi = -1;
        for (int j = 1; j < n; j++) {
            if (!u[j] && m < (a[j] + a[j + 1])) {
                m = a[j] + a[j + 1];
                mi = j;
            }
        }
        if (m > 0) {
            u[mi] = true;
            a1[i] = ans;
            continue;
        }
        u[mi] = true;
//        int l = 0;
//        int r = 1000000000;
//        while (r - l > 1) {
//            m = (r + l) / 2;
//
//
//
//        }
        m--;
        ans += -m;
        if (a[mi - 1] > a[mi + 2]) {
            int d = a[mi - 1] - a[mi + 2];
            d = min(d, -m);
            a[mi + 1] += d;
            m += d;
        } else {
            int d = -a[mi - 1] + a[mi + 2];
            d = min(d, -m);
            a[mi] += d;
            m += d;
        }
        if (m < 0) {
            m = -m;
            a[mi] += m / 2;
            a[mi + 1] += (m - m / 2);
        }
        a1[i] = ans;
    }
    reverse(a1.begin(), a1.end());
    for (int i: a1) {
        cout << i << ' ';
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}