#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const ll INF = 1e18;
const ll mod = 1e9 + 7;



int main() {
    cout << setprecision(15);
    cout << fixed;
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll n;
    cin >> n;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<ll> b(n, 0);
    for (ll i = 0; i < n - 1; ++i) {
        b[i] = a[i] + a[i + 1];
    }
    vector<ll> ans(n, INF);
    for (ll mask = 0; mask < (1 << (n - 1)); ++mask) {
        auto nb = b;
        ll s = 0;
        for (ll i = 0; i < n - 1; ++i) {
            if (mask & (1 << i)) {
                nb[i] = 1;
                s++;
            }
        }
        vector<ll> dp(n , INF);
        dp[0] = 0;
        for (ll i = 0; i < n - 1; ++i) {
            dp[i + 1] = dp[i] + max(0ll, -nb[i] + 1);
            nb[i + 1] += max(0ll, -nb[i] + 1);
        }
        for (ll i = s; i < n; ++i) {
            ans[i] = min(ans[i], dp.back());
        }
    }
    for (auto el : ans) {
        cout << el << " ";
    }



    return 0;
}