#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const ll INF = 1e18;
const ll mod = 1e9 + 7;



int main() {
    cout << setprecision(15);
    cout << fixed;
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll n, m;
    cin >> n >> m;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<ll>> cost(m, vector<ll>(m));
    for (ll i = 0; i < m; ++i) {
        for (ll j = 0; j < m; ++j) {
            cin >> cost[i][j];
        }
    }

    vector<ll> dp(n + 1, INF);
    dp[0] = -INF;
    for (ll i = 0; i < n; ++i) {
        ll it = lower_bound(dp.begin(), dp.end(), a[i] + 1) - dp.begin() - 1;
        dp[it + 1] = min(dp[it + 1], a[i]);
    }
    ll ans = lower_bound(dp.begin(), dp.end(), INF) - dp.begin() - 1;
    cout << cost[0][1] * (n - ans) << "\n";



    return 0;
}