#include <bits/stdc++.h>
#include <random>

using namespace std;
using ll = long long;
using db = double;

struct vec {
    db x, y;

    vec(db xx, db yy) : x(xx), y(yy) {}

    vec(const vec &a) : x(a.x), y(a.y) {}

    vec() : x(0), y(0) {}

    void operator+=(vec a) {
        x += a.x;
        y += a.y;
    }

    vec operator+(vec a) {
        vec res = *this;
        res += a;
        return res;
    }

    void operator-=(vec a) {
        x -= a.x;
        y -= a.y;
    }

    vec operator-(vec a) {
        vec res = *this;
        res -= a;
        return res;
    }

    vec operator*(db a) { return vec(x * a, y * a); }

    db len() { return sqrt(x * x + y * y); }

    db operator*(vec a) { return x * a.x + y * a.y; }

    db operator%(vec a) { return x * a.y - y * a.x; }
};

ll n, i, a[100002], b[100002], c[100002], d[100002], ch[100002], kl, km, k0, ans, mn;
vector<ll> f0l, f0m, flm, fml;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    // cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin >> n;
    for (i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (i = 0; i < n; i++) {
        if (a[i] == 0) {
            if (c[i] > d[i]) {
                kl++;
            }
            ans += min(c[i], d[i]);
        } else if (a[i] < 0) {
            kl++;
        }
    }
    if (kl % 2 == 1) {
        mn = 1e9;
        for (i = 0; i < n; i++) {
            if (a[i] > 0) {
                mn = min(mn, ((a[i] / b[i]) + 1) * d[i]);
            } else if (a[i] == 0) {
                mn = min(mn, max(c[i], d[i]) - min(c[i], d[i]));
            } else {
                mn = min(mn, ((-a[i] / b[i]) + 1) * c[i]);
            }
        }
        cout << ans + mn;
    } else {
        cout << ans;
    }
    return 0;
}