#include <iostream>
#include <vector>
#include <algorithm>
#include <string.h>
#include <fstream>
#include <numeric>

using namespace std;
using ll = long long;
using pii = pair<int, int>;

int main() {
	ll n, m, a, b;
	cin >> a >> b >> n >> m;

	if (2 * a == b) {
		if (m == 2 * n) {
			cout << n << " " << 0 << "\n";
		} else {
			cout << -1 << "\n";
		}
		return 0;
	}

	ll x = (m - 2 * n);
	ll y = (b - 2 * a);

	if (abs(x) % abs(y) != 0) {
		cout << -1 << "\n";
		return 0;
	}

	ll k = x / y;

	if (k < 0 || k * a > n) {
		cout << -1 << "\n";
		return 0;
	}

	cout << n - k * a << " " << k << "\n";
}