#include <iostream>
#include <vector>
#include <algorithm>
#include <string.h>
#include <fstream>
#include <numeric>

using namespace std;
using ll = long long;
using pii = pair<int, int>;

vector<ll> a, b, c, d;

ll to_neg(int i) {
	if (a[i] < 0) {
		return 1e18;
	}

	ll k = (a[i] + b[i] - 1) / b[i];
	k += (a[i] % b[i] == 0);
	return k * d[i];
}

ll to_pos(int i) {
	if (a[i] > 0) {
		return 1e18;
	}

	ll k = (abs(a[i]) + b[i] - 1) / b[i];
	k += (abs(a[i]) % b[i] == 0);
	return k * c[i];
}

int main() {
	int n;
	cin >> n;

	a.resize(n);
	b.resize(n);
	c.resize(n);
	d.resize(n);

	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	for (int i = 0; i < n; ++i) {
		cin >> b[i];
	}

	for (int i = 0; i < n; ++i) {
		cin >> c[i];
	}

	for (int i = 0; i < n; ++i) {
		cin >> d[i];
	}

	ll sgn = 1;
	ll cost = 0;

	for (int i = 0; i < n; ++i) {
		if (a[i] == 0) {
			sgn *= (c[i] < d[i] ? 1 : -1);
			cost += min(c[i], d[i]);
		}
		else {
			sgn *= (a[i] > 0 ? 1 : -1);
		}
	}

	if (sgn == 1) {
		cout << cost << "\n";
		return 0;
	}

	ll ans = 1e18;
	for (int i = 0; i < n; ++i) {
		ll flp = min(to_neg(i), to_pos(i));
		if (a[i] == 0) {
			flp = max(c[i], d[i]) - min(c[i], d[i]);
		}
		ans = min(ans, cost + flp);
	}

	cout << ans << "\n";
}