#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int N = 100100;

int n;

ll a[N];
ll b[N];
ll c[N], d[N]; 

vector<int> z, nz;

ll solve1(int mod) {
    int k = 0;
    for (int c : nz) {
        k += (a[c] < 0);
    }
    if ((k & 1) == mod)
        return 0;
    ll res = (ll)1e18;
    for (ll i : nz) {
        if (a[i] > 0) {
            ll x = a[i] / b[i] + 1;
            res = min(res, x * d[i]); 
        } else {
            ll x = (-a[i]) / b[i] + 1;
            res = min(res, x * c[i]);
        }
    }
    return res;
}

ll solve2(int mod) {
    ll tot = 0;
    for (int i : z) tot += c[i];
    vector<ll> res;
    for (int i : z) {
        res.push_back(d[i] - c[i]);
    } 
    sort(res.begin(), res.end());
    ll ans = (mod ? (ll)1e18 : 0);
    ll sum = 0, turn = 0;
    for (ll dif : res) {
        turn = !turn;
        sum += dif;
        if (turn == mod) 
            ans = min(ans, sum);
    }
    return tot + ans;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        if (!a[i]) z.push_back(i);
        else nz.push_back(i);
    }
    for (int i = 1; i <= n; i++)
        cin >> b[i];
    for (int i = 1; i <= n; i++)
        cin >> c[i];
    for (int i = 1; i <= n; i++)
        cin >> d[i];
    
    cout << min(solve1(0) + solve2(0), solve1(1) + solve2(1));

}