#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
const ll INF = 2e13 + 100, MOD = 1e9 + 7, N = 2e3 + 10, K = 6, MX = 1e3 + 4, base = 239;
const ld Pi = acos(-1);
mt19937 rnd(148);

int dp[2][55][N];

void solve() {
    int n;
    cin >> n;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    for (int k = 0; k < n; k++) {
        for (int j = 0; j < N; j++) {
            dp[1][k][j] = INF;
        }
    }
    dp[1][0][a[1] + MX] = 0;
    for (int i = 1; i < n; i++) {
        int d = i % 2, d2 = (i + 1) % 2;
        for (int k = 0; k < n; k++) {
            for (int j = 0; j < N; j++) {
                dp[d2][k][j] = INF;
                if (k > 0)
                    dp[d][k][j] = min(dp[d][k - 1][j], dp[d][k][j]);
            }
        }
        for (int k = 0; k < n; k++) {
            for (int j = 0; j < N; j++) {
                if (j + a[i + 1] - MX > 0) {
                    dp[d2][k][a[i + 1] + MX] = min(dp[d2][k][a[i + 1] + MX], dp[d][k][j]);
                } else {
                    if (MX + a[i + 1] + abs(j + a[i + 1] - MX) + 1 < N)
                        dp[d2][k][MX + a[i + 1] + abs(j + a[i + 1] - MX) + 1] = min(dp[d2][k][MX + a[i + 1] + abs(j + a[i + 1] - MX) + 1], dp[d][k][j] + abs(j + a[i + 1] - MX) + 1);
                    dp[d2][k + 1][a[i + 1] + MX] = min(dp[d2][k + 1][a[i + 1] + MX], dp[d][k][j]);
                }
            }
        }
    }
    for (int k = 0; k < n; k++) {
        int mn = INF;
        for (int j = 0; j < N; j++) {
            mn = min(mn, dp[n % 2][k][j]);
        }
        cout << mn << " ";
    }

}


signed main() {
//    freopen("hull.in", "r", stdin);
//    freopen("hull.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}