#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <iomanip>
#include <chrono>
#include <ctime>
#include <random>
#include <unordered_map>
#include <unordered_set>
#define endl '\n'

typedef long long i64;
typedef long double ld;

const i64 INF = 1e18;

using namespace std;

mt19937 rnd(777);

i64 gcd(i64 a, i64 b) {
	while (b) swap(b, a %= b);
	return a;
}

i64 lcm(i64 a, i64 b) {
	return a * b / gcd(a, b);
}

const i64 S = 1e5 + 10;
i64 a[S], b[S], c[S], d[S], ch[S];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	
	i64 n; cin >> n;

	for (i64 x = 1; x <= n; ++x) {
		cin >> a[x];
	}

	for (i64 x = 1; x <= n; ++x) {
		cin >> b[x];
	}

	for (i64 x = 1; x <= n; ++x) {
		cin >> c[x];
	}

	for (i64 x = 1; x <= n; ++x) {
		cin >> d[x];
	}
	i64 mult = 1, cost = 0;
	for (i64 x = 1; x <= n; ++x) {
		if (a[x] == 0) {
			ch[x] = 1;
			if (c[x] < d[x]) {
				a[x] += b[x];
				cost += c[x];
			}
			else {
				a[x] -= b[x];
				cost += d[x];
			}
		}
		if (a[x] < 0) mult *= -1;
	}

	if (mult == 1) cout << cost;
	else {
		i64 minAns = INF;
		for (i64 x = 1; x <= n; ++x) {
			if (!ch[x] && a[x] < 0) {
				minAns = min(minAns, cost + c[x] * (abs(a[x]) / b[x] + 1));
			}
			else if (ch[x] && a[x] < 0) {
				minAns = min(minAns, cost - d[x] + c[x]);
			}
			else if (!ch[x] && a[x] > 0) {
				minAns = min(minAns, cost + d[x] * (abs(a[x]) / b[x] + 1));
			}
			else {
				minAns = min(minAns, cost - c[x] + d[x]);
			}
		}
		cout << minAns;
	}

} 