#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <iomanip>
#include <chrono>
#include <ctime>
#include <random>
#include <unordered_map>
#include <unordered_set>
#define endl '\n'

typedef long long i64;
typedef long double ld;

const i64 INF = 1e18;

using namespace std;

mt19937 rnd(777);

i64 gcd(i64 a, i64 b) {
	while (b) swap(b, a %= b);
	return a;
}

i64 lcm(i64 a, i64 b) {
	return a * b / gcd(a, b);
}

const i64 S = 21, D = 1e5 + 10;
vector <i64> p[S]; 
i64 used[D];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	
	i64 n, m; cin >> n >> m;
	i64 d = 1, ans = 0;

	for (i64 x = 1; x <= 20; ++x) {
		bool ok = false;
		for (i64 y = 1; y <= n; ++y) {
			if (!used[y] && y % d == 0 && y % (2 * d) != 0) {
				p[x].push_back(y);
				used[y] = 1;
				ok = true;
			}
		}
		d *= 2;
		ans += (ok == true);
	}

	cout << ans << endl;

	for (i64 x = 1; x <= 20; ++x) {
		if (p[x].size()) {
			cout << p[x].size() << endl;
			for (auto y : p[x]) cout << y << " ";
			cout << endl;
		}
	}
	
} 