#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <iomanip>
#include <chrono>
#include <ctime>
#include <random>
#include <unordered_map>
#include <unordered_set>
#define endl '\n'

typedef long long i64;
typedef long double ld;

const i64 INF = 1e18;

using namespace std;

mt19937 rnd(777);

i64 gcd(i64 a, i64 b) {
	while (b) swap(b, a %= b);
	return a;
}

i64 lcm(i64 a, i64 b) {
	return a * b / gcd(a, b);
}

const i64 S = 505;
i64 a[S], b[S], ans[S], add[S][S];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	
	i64 n; cin >> n;

	for (i64 x = 1; x <= n; ++x) {
		cin >> a[x];
	}

	i64 cnt = 0;

	for (i64 x = 1; x < n; ++x) {
		b[x] = a[x] + a[x + 1];
		if (b[x] <= 0) ++cnt;
	}

	--n;

	i64 lstAns = 0;

	for (i64 x = 1; x <= n; ++x) {
		if (b[x] <= 0) {
			i64 d = abs(b[x]) + 1;
			b[x] = 1;
			b[x + 1] += d;
			add[x][x + 1] += d;
			lstAns += d;
		}
	}

	ans[0] = lstAns;

	for (i64 k = 1; k < cnt; ++k) {
		for (i64 x = 1; x <= n; ++x) {
			if (b[x] == 1) {
				if (x - 1 >= 1 && b[x - 1] > 1 && add[x - 1][x]) {
					--add[x - 1][x];
					--lstAns;
					b[x - 1] -= 1;
					b[x] = 0;
					break;
				}
				if (x + 1 <= n && b[x + 1] > 1 && add[x][x + 1]) {
					--add[x - 1][x];
					--lstAns;
					b[x - 1] -= 1;
					b[x] = 0;
					break;
				}
			}
		}
		ans[k] = lstAns;
	}
	
	for (i64 x = 0; x <= n; ++x) {
		cout << ans[x] << " ";
	}
} 