#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using i128 = __int128_t;
using ui128 =__uint128_t;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) cin >> a[i];

    int cost[m + 1][m + 1];
    for (int i = 1; i <= m; i++) for (int j = 1; j <= m; j++) cin >> cost[i][j];

    set<int> s_ok;
    for (int i = 0; i <= n; i++) s_ok.insert(i);

    int prv[m + 1] = {};
    for (int i = 1; i <= n; i++) {
        if (prv[a[i]]) {
            while (!s_ok.empty()) {
                auto it = s_ok.lower_bound(prv[a[i]]);
                if (it == s_ok.end() || *it >= i) break;
                s_ok.erase(it);
            }
        }
        prv[a[i]] = i;
    }

    vector<int> ok;
    for (auto el : s_ok) ok.push_back(el);
    int cnt = ok.size() - 1;

    vector<vector<ll>> seg_cost(cnt + 1, vector<ll>(m + 1));
    for (int i = 1; i <= cnt; i++) {
        set<int> cur;
        for (int j = ok[i - 1] + 1; j <= ok[i]; j++) cur.insert(a[j]);

        for (int col = 1; col <= m; col++) for (auto el : cur) seg_cost[i][col] += cost[el][col];
    }


    vector<vector<ll>> dp(cnt + 1, vector<ll>(m + 1, 1e18));
    dp[0].assign(m + 1, 0);

    for (int i = 1; i <= cnt; i++) {
        for (int lst = 1; lst <= m; lst++) {
            dp[i][lst] = dp[i][lst - 1];
            dp[i][lst] = min(dp[i][lst], dp[i - 1][lst] + seg_cost[i][lst]);
        }
    }

    cout << dp[cnt][m] << '\n';

    return 0;
}