#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using i128 = __int128_t;
using ui128 =__uint128_t;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

const int MAXN = 404040;
vector<int> g[MAXN];
int d[MAXN], p[MAXN];

void calc(int v, int prv) {
    p[v] = prv;
    for (auto u : g[v]) {
        if (u == prv) continue;
        d[u] = d[v] + 1;
        calc(u, v);
    }
}

ll ans[MAXN];

void add(int v, ll c) {
    if (!v) return;
    ans[v] += (d[v] + 1) * c;
    add(p[v], c);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    calc(1, 0);

    int q, t;
    cin >> q >> t;
    ll last_ans = 0;
    for (int query_id = 0; query_id < q; query_id++) {
        fill(ans + 1, ans + n + 1, 0);
        int k;
        cin >> k;
        for (int i = 0; i < k; i++) {
            int v, c;
            cin >> v >> c;
            if (t == 2) v = (v + last_ans) % (n - 1) + 2;
            add(v, c);
        }

        last_ans = *max_element(ans + 1, ans + n + 1);
        cout << last_ans << '\n';
    }

    return 0;
}