#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

vector<vector<int>> g;
vector<int> par, deep;

void dfs(int v, int p) {
    par[v] = p;
    for (auto &u : g[v]) {
        if (u != p) {
            deep[u] = deep[v] + 1;
            dfs(u, v);
        }
    }
}

void solve() {
    int n;
    cin >> n;

    g.resize(n);
    par.resize(n);
    deep.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }
    dfs(0, 0);
    int q, t;
    cin >> q >> t;
    while (q--) {
        int k;
        cin >> k;
        vector<ll> ans(n);
        for (int i = 0; i < k; ++i) {
            int v, c;
            cin >> v >> c;
            --v;
            int now = v;
            while (true) {
                ans[now] += 1ll * (deep[now] + 1) * c;
                if (now == 0) {
                    break;
                }
                now = par[now];
            }
        }
        ll otv = 0;
        for (int i = 0; i < n; ++i) {
            otv = max(otv, ans[i]);
        }
        cout << otv << '\n';
    }
}

int main() {
#ifndef LOCAL
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    solve();
    return 0;
}