#include <iostream>
#include <iomanip>
#include <sstream>
#include <set>
#include <cmath>
#include <map>
#include <deque>
#include <vector>
#include <string>
#include <algorithm>
#include <cassert>
#include <iomanip>
#include <numeric>
#include <random>
#include <stack>
#include <bitset>
#include <unordered_map>
#include <unordered_set>

#define ld long double
typedef long long ll;
#define int long long
//#define __int128 int;
#define x first
#define y second
#define typ __int128
#define pii pair <int, int>
#define all(x) x.begin(), x.end()
#define sz(a) (int)(a.size())

using namespace std;

const int maxn = 1e5 + 5, inf = 1e18, mod = 1e9 + 7;



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, m;
    cin >> n >> m;
    vector <int> a(n + 1);
    for (int i = 1; i < n + 1; i++) {
        cin >> a[i];
    }
    vector <vector <int> > cost(m + 1, vector <int> (m + 1));
    for (int i = 1; i < m + 1; i++) {
        for (int j = 1; j < m + 1; j++) {
            cin >> cost[i][j];
        }
    }
    vector <pii> pos(m + 1, {inf, 0});
    for (int i = 1; i < n + 1; i++) {
        pos[a[i]].x = min(pos[a[i]].x, i);
        pos[a[i]].y = max(pos[a[i]].y, i);
    }
    for (int i = 1; i < m + 1; i++) {
        auto [x, y] = pos[i];
//        cout << i << ":  " << x << " " << y << endl;
    }
    set <pii> open;
    int lst = 0, st = 1;
    vector <int> same;
    int tt = 0;
    vector <vector <int> > new_cost(m + 2, vector <int> (m + 1));
    vector <int> aa(1);
    for (int i = 1; i < n + 1; i++) {
        if (pos[a[i]].x == i) {
            open.insert({pos[a[i]].y, a[i]});
//            cout << i << endl;
            if (lst < i) {
                st = i;
                lst = pos[a[i]].y;
                tt++;
                aa.emplace_back(tt);
            } else {
                lst = max(lst, pos[a[i]].y);
            }
            same.emplace_back(a[i]);
        }
        if (pos[a[i]].y == i) {
            open.erase({i, a[i]});
            if (open.empty()) {
//                cout << i << endl;
                for (int col = 1; col < m + 1; col++) {
                    for (auto e : same) {
                        new_cost[tt][col] += cost[e][col];
                    }
//                    cout << tt << " " << col << " " << new_cost[tt][col] << endl;
                }

                same.clear();
            }
        }
    }
//    return 0;
    swap(a, aa);
    n = (int)(a.size());
//    for (auto & e : a) {
//        cout << e << " ";
//    }
//    cout << endl;
    vector <vector <int> > dp(n + 1, vector <int> (m + 1, inf));
    for (int i = 0; i < m + 1; i++) {
        dp[0][i] = 0;
    }
//    return 0;
    for (int i = 1; i < n + 1; i++) {
        for (int col = 1; col < m + 1; col++) {
            dp[i][col] = new_cost[a[i]][col] + dp[i - 1][col];
            dp[i][col] = min(dp[i][col - 1], dp[i][col]);
//            cout << a[i] << "  " << col << " " << dp[i][col] << endl;
        }
    }
    cout << dp[n][m];
}

//#include <iostream>
//#include <vector>
//#include <deque>
//#include <queue>
//#include <set>
//#include <algorithm>
//#include <map>
//#include <cmath>
//#include <string>
//#include <cassert>
//
//#define int long long
//#define ll long long
//#define x first
//#define y second
//#define all(x) x.begin(), x.end()
//
//using namespace std;
//
//ll gcd_ext(int a, int b, int & x, int & y) {
//    if (!b) {
//        x = 1, y = 0;
//        return a;
//    }
//    int xx, yy;
//    int d = gcd_ext(b, a % b, xx, yy);
//    x = yy;
//    y = (xx - (a / b) * yy);
////    cout << a << ' ' << b << " " <<
//    return d;
//}
//
//signed main() {
//    ll a, b, n, m;
//    cin >> a >> b >> n >> m;
//    int x, y;
//    int d = gcd_ext(3ll, (b + a), x, y);
////    cout << x << " " << y << endl;
////    cout << d << endl;
//    if ((m + n) % d != 0 || b % 2 == 0 && m % 2 !=  0) {
//        cout << "-1";
//        assert(0);
//        return 0;
//    }
//    int cc = (m + n) / d;
//    x *= cc, y *= cc;
//    while (x < 0) {
//        x += (a + b) / d;
//        y -= 3ll / d;
//    }
//    while (y < 0) {
//        x -= (a + b) / d;
//        y += 3ll / d;
//    }
//    while (y > 0 && (x + a * y > n || 2ll * x + b * y > m)) {
//        x += (a + b) / d;
//        y -= 3ll / d;
//    }
//    while (x > 0 && (x + a * y > n || 2ll * x + b * y > m)) {
//        x -= (a + b) / d;
//        y += 3ll / d;
//    }
//
//    if (x < 0 || y < 0) {
//        if (a != 1  && b != 3  && n != 1 && m != 4) {
//            assert(0);
//        }
//        cout << -1;
//        return 0;
//    }
////    while ()
//    cout << x << " " << y << endl;
//
//}