// Author: Boris_Ber
#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2")

#define all(s) (s).begin(), (s).end()
#define rall(s) (s).rbegin(), (s).rend()
#define sz(x) ((int) (x).size())
#define ff first
#define ss second
#define pb push_back
#define eb emplace_back
#define ppb pop_back

using namespace std;

#define int long long
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int MOD = 1e9 + 7;
const int MOD2 = 998244353;
const int INF = 1e9;
const ll INF2 = 1e18;

int tmp;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> v(4, vector<int>(n));
    for (auto &i: v) for (auto &j: i) cin >> j;
    vector<int> cnt(3);
    for (int i = 0; i < n; ++i) {
        if (v[0][i] < 0) {
            cnt[0]++;
        } else if (v[0][i] == 0) {
            cnt[1]++;
        } else {
            cnt[2]++;
        }
    }
    if (cnt[1] == 0) {
        if (cnt[0] % 2 == 0) {
            cout << 0;
        } else {
            int ans = INF2;
            for (int i = 0; i < n; ++i) {
                if (v[0][i] > 0) {
                    ans = min(ans, (v[0][i] + v[1][i]) / v[1][i] * v[3][i]);
                } else {
                    ans = min(ans, (-v[0][i] + v[1][i]) / v[1][i] * v[2][i]);
                }
            }
            cout << ans;
        }
    } else {
        int ans = 0;
        vector<int> used(n, 0);
        for (int i = 0; i < n; ++i) {
            if (v[0][i] == 0) {
                cnt[1]--;
                if (v[2][i] < v[3][i]) {
                    used[i] = 1;
                    ans += v[2][i];
                    cnt[2]++;
                } else {
                    used[i] = 2;
                    ans += v[3][i];
                    cnt[0]++;
                }
            }
        }
        if (cnt[0] % 2 == 0) {
            cout << ans;
        } else {
            int best = INF;
            for (int i = 0; i < n; ++i) {
                if (used[i] == 0) {
                    if (v[0][i] > 0) {
                        best = min(best, (v[0][i] + v[1][i]) / v[1][i] * v[3][i]);
                    } else {
                        best = min(best, (-v[0][i] + v[1][i]) / v[1][i] * v[2][i]);
                    }
                } else if (used[i] == 1) {
                    best = min(best, v[3][i] - v[2][i]);
                } else if (used[i] == 2) {
                    best = min(best, v[2][i] - v[3][i]);
                }
            }
            cout << ans + best;
        }
    }
}

signed main() {
    int tt = 1;
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("../input.txt", "r", stdin);
    // CHECK CIN PLACEMENT
    cin >> tt;
#endif
    while (tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}
