#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>

using namespace std;
//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
//gp_hash_table<int, int> d;

#define int long long

int inf = 1e15;

bool isPrime(int n) {
	if (n == 0 or n == 1 or n == 2) return true;
	for (int i = 2; i <= ceil(sqrt(n)); i++) {
		if (n % i == 0) return false;
	}
	return true;
}

vector<int> primes;

int n, m;

vector<vector<int>> ans;
void solve(int su, int ind, string s) {
	if (ind == primes.size()) {
		if (su >= 0 and isPrime(su)) {
			//cout << su << " " << ind << " " << s << "\n";
			ans.clear();
			vector<int> u;
			for (int i = 0; i < primes.size(); i++) {
				if (s[i] == '1') u.push_back(primes[i]);
			}
			for (int i : u) {
				ans.push_back({ i });
			}
			vector<int> u2;
			for (int i = 1; i <= n; i++) {
				if (find(u.begin(), u.end(), i) == u.end()) {
					u2.push_back(i);
				}
			}
			if (u2.size() > 0) ans.push_back(u2);
		}
		return;
	}
	solve(su, ind + 1, s + "0");
	solve(su - primes[ind], ind + 1, s + "1");
}



signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);


	cin >> n >> m;

	for (int i = 1; i <= n; i++) {
		if (isPrime(i)) {
			primes.push_back(i);
			if (primes.size() == 9) break;
		}
	}
	int su = (n + 1) * n / 2;
	solve(su, 0, "");
	cout << ans.size() << "\n";
	for (auto i : ans) {
		cout << i.size() << "\n";
		for (int j : i) cout << j << " ";
		cout << "\n";
	}


}

/*

sum = (b + a) * (b - a + 1) / 2

b + a = 2k(b - a + 1)
2k = (b + a) / (b - a + 1)
k = (b + a) / (b - a + 1) / 2


*/