#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const int mod = 1e9 + 7;
const int MAX = 1e5 + 7;

#define int long long

void solve() {
    int n;
    cin >> n;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    vector<int> b(n + 1, 0);
    for (int i = 1; i < n; i++) {
        b[i] = a[i] + a[i + 1];
        if (b[i] <= 0) {
            b[i] = abs(b[i]) + 1;
        } else {
            b[i] = 0;
        }
    }
    int dp[n + 2][n + 2];
    int f[n + 2][n + 2];
    for (int i = 0; i <= n + 1; i++) {
        for (int j = 0; j <= n + 1; j++) {
            dp[i][j] = 2e18;
            f[i][j] = 0;
        }
    }
    for (int i = 1; i < n; i++) {
        int add = 0;
        vector<int> c = b;
//        cout << c[1] << ' ' << c[2] << '\n';
        for (int j = i; j < n; j++) {
            if (c[j] > 0) {
                add += c[j];
                c[j + 1] -= c[j];
                c[j] = 0;
            }
            f[i][j] = add;
        }
    }
    dp[0][0] = 0;
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < n; j++) {
            dp[i][j] = min(dp[i][j], dp[i - 1][j]);
        }
        for (int j = 0; j < n; j++) {
            for (int nxt = i; nxt < n; nxt++) {
                if (j + (nxt - i + 1) < n) {
                    dp[nxt + 1][j + (nxt - i + 1)] = min(dp[nxt + 1][j + (nxt - i + 1)], dp[i - 1][j] + f[i][nxt]);
                }
            }
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        cout << min(dp[n][i], dp[n - 1][i]) << ' ';
    }
}

int32_t main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}