#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#ifndef LOCAL
#pragma GCC optimize("03")
#endif

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 generator(seed);
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using i128 = __int128;
using ll = long long;
using ld = long double;
using uint = unsigned int;

const ll INF = 2e18;
const int inf = 1e9;
const int MOD = 1e9 + 7;
const int maxn = 500007;
const ld pi = acos(-1);
const int P = 5167;
const double EPS = 1e-6;

#define int ll

void solve() {
    int n, m;
    cin >> n >> m;
    vector<bool> used(n + 1);
    int cnt = 0;
    vector<vector<int>> ans;
    while (cnt != n) {
        ans.push_back({});
        int d = 1;
        for (int i = 1; i <= n; ++i) {
            if (!used[i]) {
                if (d == 1) {
                    cnt++;
                    d--;
                    ans.back().push_back(i);
                    used[i] = true;
                } else d++;
            }
        }
    }
    cout << ans.size();
    for (auto c: ans) {
        cout << "\n" << c.size() << "\n";
        for (auto d: c) cout << d << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(4);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //  cin >> t;
    while (t--) solve();
    //stress();
}