#include <bits/stdc++.h>

#define int int64_t
#define endl '\n'
#define pii pair <int, int>
#define fi first
#define se second
#define pb push_back

using namespace std;

const int INF = 2e18, N = 1e5 + 50;

int lp[N];
vector <int> pr;

bool ok (int x) {
    int d = sqrtl(x);
    return (d * d == x);
}

bool prime (int x) {
    if (x == 1) {
        return 0;
    }
    for (int i : pr) {
        if (i * i > x) {
            break;
        }
        if (x % i == 0) {
            return 0;
        }
    }
    return 1;
}

bool good (int x) {
    if (ok(x) || prime(x)) {
        return 1;
    }
    for (int i : pr) {
        if (i * i > x) {
            break;
        }
        if (x % i == 0) {
            if (ok(x / i)) {
                return 1;
            }
        }
    }
    return 0;
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    for (int i = 2; i < N; ++i) {
        if (!lp[i]) {
            lp[i] = i;
            pr.pb(i);
        }
        for (int j = 0; j < (int)pr.size() && pr[j] <= lp[i] && i * pr[j] < N; ++j) {
            lp[i * pr[j]] = pr[j];
        }
    }
    int n, m;
    cin >> n >> m;
    if (n <= 32) {
        vector <int> v(n);
        iota(v.begin(), v.end(), 1);
        mt19937 gen(time(0));
        while (true) {
            shuffle(v.begin(), v.end(), gen);
            vector <bool> dp(n);
            vector <int> pr(n, -1);
            for (int i = 0; i < n; ++i) {
                bool can = 1;
                if (i) {
                    can = dp[i - 1];
                }
                if (!can) {
                    continue;
                }
                int s = 0;
                for (int j = i; j < n; ++j) {
                    s += v[j];
                    if (good(s)) {
                        dp[j] = 1;
                        pr[j] = i;
                    }
                }
            }
            if (dp[n - 1]) {
                int now = n - 1;
                vector <vector <int>> ans;
                while (now >= 0) {
                    int pred = pr[now];
                    vector <int> cur;
                    for (int i = pred; i <= now; ++i) {
                        cur.pb(v[i]);
                    }
                    ans.pb(cur);
                    now = pred - 1;
                }
                cout << ans.size() << endl;
                for (auto to : ans) {
                    cout << to.size() << endl;
                    for (auto x : to) {
                        cout << x << ' ';
                    }
                }
                return 0;
            }
        }
    }
    cout << n / 2 << endl;
    int l = 1, r = n;
    for (int i = 1; i <= n / 2; ++i) {
        cout << 2 << endl;
        cout << l << ' ' << r << endl;
        l++; r--;
    }
}