#include <bits/extc++.h>

using namespace __gnu_pbds;

#define ff first
#define ss second
#define int long long

using ll = long long;
using ull = unsigned long long;
using ordered_set = tree<int, null_type, std::less<>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n, m; std::cin >> n >> m;
    std::vector<int>a(n), pos(m);
    for (int i = 0; i < n; ++i) std::cin >> a[i], pos[--a[i]] = i;
    std::vector<std::vector<int>>c(m, std::vector<int>(m));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < m; ++j) std::cin >> c[i][j];
    }
    std::vector<std::vector<ll>>dp(2, std::vector<ll>(m));
    int j = 0;
    for (int i = 0; i < n;) {
        int r = pos[a[i]];
        std::set<int>s;
        for (; i <= r && i < n; ++i) {
            r = std::max(r, pos[a[i]]);
            s.insert(a[i]);
        }
        ll min = 1e18;
        for (int k = 0; k < m; ++k) {
            ll sum = 0;
            min = std::min(min, dp[j][k]);
            for (auto it : s) sum += c[it][k];
            dp[j ^ 1][k] = min + sum;
        }
        j ^= 1;
    }
    ll ans = 1e18;
    for (int i = 0; i < m; ++i) ans = std::min(ans, dp[j][i]);
    std::cout << ans << '\n';
}

int32_t main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);

    int T = 1;
//    std::cin >> T;
    while(T--) {
        solve();
    }
}