#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

void solve() {
    int n;
    cin >> n;
    
    vector <int> a(n);
    for (int& i : a) cin >> i;
    vector <int> b(n);
    for (int& i : b) cin >> i;
    vector <int> c(n);
    for (int& i : c) cin >> i;
    vector <int> d(n);
    for (int& i : d) cin >> i;
    
    int cnt0 = 0, cntm = 0, cntp = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) cnt0++;
        if (a[i] < 0) cntm++;
        if (a[i] > 0) cntp++;
    }
    
    if (cnt0 == 0) {
        if (cntm % 2 == 0) {
            cout << 0 << "\n";
        } else {
            int mn = LINF;
            for (int i = 0; i < n; i++) {
                if (a[i] < 0) {
                    int need = (abs(a[i]) + b[i]) / b[i];
                    mn = min(mn, need * c[i]);
                } else {
                    int need = (a[i] + b[i]) / b[i];
                    mn = min(mn, need * d[i]);
                }
            }
            cout << mn << "\n";
        }
        return;
    }
    
    int res = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) {
            if (c[i] <= d[i]) {
                res += c[i];
                cntp++;
            } else {
                res += d[i];
                cntm++;
            }
        }
    }
    if (cntm % 2 == 0) {
        cout << res << "\n";
    } else {
        int ans = LINF;
        for (int i = 0; i < n; i++) {
            if (a[i] == 0) {
                if (c[i] <= d[i]) {
                    ans = min(ans, res - c[i] + d[i]);
                } else {
                    ans = min(ans, res - d[i] + c[i]);
                }
            } else if (a[i] < 0) {
                int need = (abs(a[i]) + b[i]) / b[i];
                ans = min(ans, res + need * c[i]);
            } else {
                int need = (a[i] + b[i]) / b[i];
                ans = min(ans, res + need * d[i]);
            }
        }
        cout << ans << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}