#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <cmath>
#define int long long
#define debug(x) cerr << (#x) <<": "<< x<< endl;
using namespace std;
const int INF = 1e18 + 7;
const int mod = 1e9 + 7;
int min(int a, int b) {
	return (a < b) ? a : b;
}
int max(int a, int b) {
	return (a > b) ? a : b;
}
int n;
int check_to_zero(vector<int> a, vector<int> b, vector<int> c, vector<int> d) {
	int cnt_otr = 0;
	for (int i = 0; i < n; i++) {
		if (a[i] < 0) cnt_otr++;
	}
	if (cnt_otr % 2 == 0) return 0;
	int res = INF;
	for (int i = 0; i < n; i++) {
		int may = 0;
		may = (abs(a[i]) + b[i]) / b[i];
		if (a[i] < 0) {
			may *= c[i];
		} else {
			may *= d[i];
		}
		res = min(res, may);
	}
	return res;
}
void solve() {
	cin >> n;
	vector<int> a(n), b(n), c(n), d(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	for (int i = 0; i < n; i++) cin >> b[i];
	for (int i = 0; i < n; i++) cin >> c[i];
	for (int i = 0; i < n; i++) cin >> d[i];
	vector<int> zeros;
	for (int i = 0; i < n; i++) {
		if (a[i] == 0) {
			zeros.push_back(i);
		}
	}
	int ans = INF;
	if (zeros.size() == 0) {
		ans = check_to_zero(a, b, c, d);
	} else {
		int add = 0;
		vector<int> aa = a;
		for (int i = 0; i < zeros.size(); i++) {
			int it = zeros[i];
			if (c[it] < d[it]) {
				aa[it] += b[it];
			} else {
				aa[it] -= b[it];
			}
			add += min(c[it], d[it]);
		}
		int may = check_to_zero(aa, b, c, d);
		ans = min(ans, may + add);
		if (may != 0) {
			int mn_r = INF;
			for (int i = 0; i < zeros.size(); i++) {
				int it = zeros[i];
				mn_r = min(abs(c[it] - d[it]), mn_r);
			}
			int to_may = add + mn_r;
			ans = min(ans, to_may);
		}
	}
	cout << ans << endl;
}
signed main() {
	int t = 1;
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// cin >> t;
	while (t--) {
		solve();
	}
}
/*
3
5 -1 5
2 2 2
2 2 2
2 2 2
*/