#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <cmath>
#define int long long
#define debug(x) cerr << (#x) <<": "<< x<< endl;
using namespace std;
const int INF = 1e16 + 7;
const int mod = 1e9 + 7;
int min(int a, int b) {
	return (a < b) ? a : b;
}
int max(int a, int b) {
	return (a > b) ? a : b;
}
const int N = 501;
void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	map<pair<int, int>, int> dp;
	dp[{0, a[0]}] = 0;
	for (int i = 1; i < n; i++) {
		map<pair<int, int>, int> next_dp;
		for (auto c : dp) {
			int now = c.first.first, last = c.first.second, mn = c.second;
			int fl = (a[i] + last) <= 0, add = a[i] + last - 1;
			if (next_dp.count({ now + fl, a[i] }) == 0) {
				next_dp[{now + fl, a[i]}] = mn;
			} else {
				next_dp[{now + fl, a[i]}] = min(next_dp[{now + fl, a[i]}], mn);
			}
			add = abs(min(0, add));
			if (next_dp.count({ now, a[i] + add }) == 0) {
				next_dp[{now, a[i] + add}] = mn + add;
			} else {
				next_dp[{now, a[i] + add}] = min(next_dp[{now, a[i] + add}], mn + add);
			}
		}
		dp = next_dp;
	}
	vector<int> pref_min(n, INF);
	for (auto c : dp) {
		int how = c.first.first, mn = c.second;
		pref_min[how] = min(pref_min[how], mn);
	}
	for (int i = 0; i < n - 1; i++) pref_min[i + 1] = min(pref_min[i], pref_min[i + 1]);
	for (auto c : pref_min) cout << c << " ";
	cout << endl;
}
signed main() {
	int t = 1;
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// cin >> t;
	while (t--) {
		solve();
	}
}
/*
10
-10 3 3 -2 -2 -2 -2 3 4 5
*/