//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops", "omit-frame-poller", "inline")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,avx2,fma,tune=native")

#include <bits/stdc++.h>

using namespace std;
const int inf = 2e9;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<int>> sum(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        vector<int> z;
        z.push_back(a[i]);
        for (int j = i + 1; j < n; ++j) {
            z.push_back(a[j]);
            vector<int> z1 = z;
            int s = 0;
            for (int l = 1; l < z1.size(); ++l) {
                if (z1[l - 1] + z1[l] <= 0) {
                    s += (1 - (z1[l - 1] + z1[l]));
                    z1[l] += (1 - (z1[l - 1] + z1[l]));
                }
            }
            sum[i][j] = s;
        }
    }
    vector dp(n, vector<int>(n, inf));
    dp[0][0] = 0;
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j <= i; ++j) {
            if (a[i] + a[i - 1] <= 0 && dp[i - 1][j] != inf) {
                dp[i][j] = min(dp[i][j], dp[i - 1][j]);
            }
            for (int k = i; k >= 1; --k) {
                int su = sum[k - 1][i];
                if ((i - k + 1) <= j && dp[k - 1][j - (i - k + 1)] != inf) {
                    dp[i][j] = min(dp[i][j], su + dp[k - 1][j - (i - k + 1)]);
                }
            }
        }
    }
    int ans = inf;
    for (int i = n - 1; i >= 0; --i) {
        ans = min(ans, dp[n - 1][i]);
        cout << ans << " ";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}