#pragma GCC optimize("O3")
#include <cmath>
#include <ctime>
#include <algorithm>
#include <bitset>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <istream>
#include <iterator>
#include <list>
#include <map>
#include <unordered_map>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <string>
#include <vector>
#include <random>
#include <bitset>
#include <cmath>
#include <cstdint>
#define int long long
using namespace std;
constexpr  int MOD = 1e15, MAXN = 2e5 + 10;
int INF = 1e9;
long double EPS = 1e-15;

vector<int> h, nex;

void dfs(int v, vector<int>& use, vector<vector<int>>& g) {
    use[v] = 1;
    for (auto to : g[v]) {
        if (use[to] == 0) {
            h[to] = h[v] + 1;
            nex[to] = v;
            dfs(to, use, g);
        }
    }
}

void sovel() {
    int n;
    cin >> n;
    h.resize(n);
    nex.resize(n);
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    vector<int> use(n);
    dfs(0, use, g);
    int q, t;
    cin >> q >> t;
    for (int i = 0; i < q; ++i) {
        int u, c;
        cin >> u >> c;
        u--;
        int nas = 0;
        while (u != 0) {
            nas = max(nas, (h[i] + 1) * c);
            u = nex[u];
        }
        cout << nas << "\n";
    }
}

signed main() {
    srand(time(NULL));
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t; t = 1;
    while (t--) {
        sovel();
    }
}