//#pragma GCC optimize("02", "03", "Ofast, inline, popcnt, sse, sse2, ssse3, sse4")
//#pragma GCC target("avx2")

#include <iostream>
#include <vector>
#include <queue>
#include <iomanip>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <stack>
#include <string>
#include <set>
#include <map>
#include <time.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

//struct segmentree {
//    int size;
//    vector<int> tree;
//
//    void init(int n) {
//        size = 1;
//        while (size < n) {
//            size *= 2;
//        }
//        tree.resize(size * 2 - 1);
//    }
//
//    void build(vector<int> &a) {
//        init(a.size());
//    }
//};

static const int inf = 2e18 + 100;

void solveA() {
    int A, B, n, m;
    cin >> A >> B >> n >> m;
    int cntl = n;
    int rb = m - cntl * 2;
    int qwe = B - 2 * A;
    if (qwe == 0) {
        if (cntl * 2 == m) {
            cout << cntl << " 0";
        } else {
            cout << -1;
        }
    } else if (((rb % qwe) + qwe) % qwe == 0) {
        int cnt = rb / qwe;
        if (cnt < 0) {
            cout << -1;
            return;
        }
        cnt = abs(cnt);
        cntl -= cnt;
        if (cntl < 0) {
            cout << -1;
            return;
        }
        cout << cntl << ' ' << cnt;
    } else {
        cout << -1;
    }
}

vector<vector<int>> ans;
vector<pair<int, int>> par;

void f(int n) {
    if (n == 0) {
        return;
    }
    int j = 1;
    while (j * j <= n) {
        j++;
    }
    j--;
    ans.push_back({});
    int st = (int) par.size() - 1;
    for (int i = (int) par.size() - 1; i >= st - j * j + 1; i--) {
        ans.back().push_back(par[i].first);
        ans.back().push_back(par[i].second);
        par.pop_back();
    }
    f(n - j * j);
}

vector<vector<vector<int>>> pred;

void solve(int n, bool out = false) {
//    int n;
//    cin >> n;
    ans.clear();
    par.clear();
    int pr;
    for (int i = n + 1; i <= inf; i++) {
        int j = 2;
        bool q = true;
        while (j * j <= i) {
            if (i % j == 0) {
                q = false;
                break;
            }
            j++;
        }
        if (q) {
            pr = i;
            break;
        }
    }
    int q = n - (pr - n - 1);
    int z = n - q;
    int st = z + 1;
    for (int i = z + 1; i < st + q / 2; i++) {
        par.push_back({i, n - i + (z + 1)});
    }
    f(q / 2);
    vector<vector<int>> dop = pred[z];
    if (out) {
        if (n == 1) {
            ans.push_back({1});
        }
        cout << dop.size() + ans.size() << '\n';
        for (auto &c: dop) {
            cout << c.size() << ' ';
            for (auto &w: c) {
                cout << w << ' ';
            }
            cout << '\n';
        }
        for (auto &c: ans) {
            cout << c.size() << ' ';
            for (auto &w: c) {
                cout << w << ' ';
            }
            cout << '\n';
        }
    } else {
        for (auto &c: dop) {
            pred[n].push_back(c);
        }
        for (auto &c: ans) {
            pred[n].push_back(c);
        }
        if (n == 1) {
            pred[n].push_back({1});
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    // cin >> tt;
    int maxx = 0;
    pred.resize(73);
    for (int i = 0; i <= 72; i++) {
        solve(i);
        maxx = max((int) ans.size(), maxx);
    }
    while (tt--) {
        int n, m;
        cin >> n >> m;
        solve(n, true);
    }
    return 0;
}