#include <bits/stdc++.h>
#pragma GCC optimize("O3")
using namespace std;
#define int long long

// bool is_prime(int x) {
//     if (x < 1) return false;
//     for (int i = 2; i * i <= x; i++) {
//         if (x % i == 0) {
//             return false;
//         }
//     }
//     return true;
// }

const int MAX = 3.5e6 + 1;
vector<bool> is_prime(MAX, true);
bool is_good[MAX];

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    mt19937 rnd(42);
    int n, m;
    cin >> n >> m;
    if (n % 2 == 0 && (int) (sqrt(n + 1)) * (int) (sqrt(n + 1)) == n + 1) {
        cout << n / 2 << "\n";
        for (int i = 1; i <= n / 2; i++) {
            cout << "2\n" << i << " " << n + 1 - i << "\n";
        }
        return 0;
    }
    is_prime[0] = false;
    is_prime[1] = false;
    for (int i = 1; i * i < MAX; i++) {
        is_good[i * i] = true;
    }
    for (int i = 2; i < MAX; i++) {
        if (is_prime[i]) {
            for (int j = i * i; j < MAX; j += i) {
                is_prime[j] = false;
            }
            for (int j = 1; j * j * i < MAX; j++) {
                is_good[j * j * i] = true;
            }
        }
    }
    vector<int> A(n);
    for (int i = 0; i < n; i++) A[i] = i + 1;

    while (true) {
        shuffle(A.begin(), A.end(), rnd);
        vector<int> ans;
        int sum = 0;
        for (int i = 0; i < n; i++) {
            sum += A[i];
            if (sum >= MAX) {
                break;
            }
            if (is_good[sum]) {
                sum = 0;
                ans.push_back(i);
            }
        }
        if (!ans.empty() && ans.back() == n - 1) {
            vector<vector<int>> result;
            int pr = 0;
            for (int x : ans) {
                result.push_back({A.begin() + pr, A.begin() + x + 1});
                pr = x + 1;
            }
            cout << result.size() << "\n";
            for (auto &V : result) {
                cout << V.size() << "\n";
                for (int x : V) {
                    cout << x << " ";
                }
                cout << "\n";
            }
            break;
        }
    }
    return 0;
}