#ifdef LOCAL
#define GLIBCXX_DEBUG 1
#endif
#include <bits/stdc++.h>
using namespace std;

template <typename T, typename V> ostream & operator<<(ostream & os, pair<T, V> p) {
    return os << "{" << p.first << "," << p.second << "}";
}

template <class T, class V, class Container> basic_ostream<T, V> & operator<<(basic_ostream<T, V> &os, Container x) {
    os << "[ ";
    for (auto &y : x)
        os << y << " ";
    os << "]";
    return os;
}
template <class T> bool chmin(T &x, T &y) {
    if (x > y) {
        x = y;
        return true;
    }
    return false;
}
template <class T> bool chmax(T &x, T &y) {
    if (x < y) {
        x = y;
        return true;
    }
    return false;
}

#ifdef LOCAL
void deb_out() { cerr << endl; }
template <typename Head, typename... Tail> void deb_out(Head H, Tail... T) {
    cerr << H << " ";
    deb_out(T...);
}
#define deb(...) cerr << "(" << (#__VA_ARGS__) << "): "; deb_out(__VA_ARGS__);
#else
#define deb(...) 1
#endif

typedef long long ll;
typedef long double ld;

#define int long long

void solve_test() {
    int a, b, n, m;
    cin >> a >> b >> n >> m;
    int cnt1 = 0, cnt2 = 0;
    if (2 * a != b) {
        if ((2 * n - m) % (2 * a - b) != 0) {
            cout << "-1\n";
            return;
        }
        cnt2 = (2 * n - m) / (2 * a - b);
        if (cnt2 < 0) {
            cout << "-1\n";
            return;
        }
        cnt1 = (n - a * cnt2);
        if (cnt1 < 0) {
            cout << "-1\n";
            return;
        }
    } else {
        if (m != 2 * n) {
            cout << "-1\n";
            return;
        }
        cnt1 = n;
        cnt2 = 0;
    }
    cout << cnt1 << " " << cnt2 << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    // cin >> tt;
    for (int i = 0; i < tt; ++i) {
        solve_test();
    #ifdef LOCAL
        cout << "______________" << endl;
    #endif
    }
}