#ifdef LOCAL
#define _GLIBCXX_DEBUG 1
#endif
#include <bits/stdc++.h>
using namespace std;
#define sz(a) (int)((a).size())

template <class T, class V> ostream & operator << (ostream & os, pair<T, V> const& p) { return os << "{" << p.first << "," << p.second << "}"; }
template <class T, class V, class Container> basic_ostream <T, V> & operator << (basic_ostream <T, V> & os, Container const& x) { os << "[ "; for (auto& y : x) os << y << " "; return os << "]"; }
template <typename T> bool chmin(T &a, T b) { return (b < a) ? a = b, 1 : 0; }
template <typename T> bool chmax(T &a, T b) { return (b > a) ? a = b, 1 : 0; }

#ifdef LOCAL
void deb_out() { cerr << endl; }
template <typename Head, typename... Tail> void deb_out(Head H, Tail... T) { cerr << " " << H; deb_out(T...); }
#define deb(...) cerr << "(" << #__VA_ARGS__ << "):", deb_out(__VA_ARGS__)
#else
#define deb(...) 1
#endif

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;

#define int long long 
const int INF = 2e15;

void solve_test() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (auto &x : a) {
        cin >> x;
        --x;
    }
    vector<vector<int>> cost1(m, vector<int>(m));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < m; ++j)
            cin >> cost1[i][j];
    }
    vector<int> left(m, n), right(m);
    for (int i = 0; i < n; ++i) {
        chmin(left[a[i]], i);
        chmax(right[a[i]], i);
    }
    int cnt = 0;
    int l = 0;
    vector<pair<int, int>> b;
    for (int i = 0; i < n; ++i) {
        if (i == left[a[i]]) {
            cnt++;
        }
        if (i == right[a[i]]) {
            cnt--;
        }
        if (cnt == 0) {
            b.push_back({l, i});
            l = i + 1;
        }
    }
    deb(b);
    vector<vector<int>> cost2(sz(b), vector<int>(m));
    vector<int> vis(m);
    for (int i = 0; i < sz(b); ++i) {
        for (int j = 0; j < m; ++j) {
            for (int k = b[i].first; k <= b[i].second; ++k) {
                if (!vis[a[k]]) {
                    cost2[i][j] += cost1[a[k]][j];
                    vis[a[k]] = 1;
                }
            }
            for (int k = b[i].first; k <= b[i].second; ++k) {
                vis[a[k]] = 0;
            }
        }
    }

    vector<vector<int>> dp(sz(b), vector<int>(m, INF));
    int mn = INF;
    for (int i = 0; i < m; ++i) {
        chmin(mn, cost2[0][i]);
        dp[0][i] = mn;
    }
    for (int i = 1; i < sz(b); ++i) {
        for (int j = 0; j < m; ++j) {
            dp[i][j] = cost2[i][j] + dp[i - 1][j];
            if (j)
                chmin(dp[i][j], dp[i][j - 1]);
        }
    }
    cout << *min_element(dp[sz(b) - 1].begin(), dp[sz(b) - 1].end()) << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    // cin >> tt;
    for (int i = 1; i <= tt; ++i) {
        solve_test();
        #ifdef LOCAL
        cout << "_____________________" << endl;
        #endif
    }
    #ifdef LOCAL
    cerr << endl << "Elapsed time: " << 1. * clock() / CLOCKS_PER_SEC << '\n';
    #endif
    return 0;
}