#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

template<typename T>
void sort(T &s) {
    sort(all(s));
}

const int inf = 2e9 + 2000;
const ll infll = 2e18 + 2000;

int main() {
    ios::sync_with_stdio(false);
//    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector<int> a(n);

    set<int> se;

    for (auto &i : a) {
        cin >> i;
        i--;
        se.insert(i);
    }

    vector<vector<ll> > c(m ,vector<ll> (m));

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> c[i][j];
        }
    }

    if (sz(se) == n) {
        vector<vector<ll> > dp(n, vector<ll> (m));
        for (int i = 0; i < m; ++i) {
            dp[0][i] = c[a[0]][i];
        }

        for (int i = 1; i < n; ++i) {
            ll mi = infll;
            for (int j = 0; j < m; ++j) {
                mi = min(mi, dp[i - 1][j]);
                dp[i][j] = c[a[i]][j] + mi;
            }
        }

//        for (auto &i : dp) {
//            for (auto j : i) {
//                cout << j << ' ';
//            }
//            cout << "\n";
//        }

        ll mi = infll;

        for (auto i : dp.back()) {
            mi = min(mi, i);
        }

        cout << mi;
    } else {
        cout << 1;
    }
}