#define _CRT_SECURE_NO_WARNINGS
#include<set>
#include<sstream>
#include<iomanip>
#include<vector>
#include<map>
#include<algorithm>
#include<iostream>
#include<cmath>
using namespace std;
using ll = long long;
using vi = vector<int>;
using vl = vector<ll>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const int INF = 1e9 + 7;
#define endl '\n'
#define cinv(x) for (auto & el: x) cin >> el;
#define all(x) x.begin(), x.end()
const ll LINF = 1LL << 62;
int main() {
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0); cin.tie(0);
	int n;
	cin >> n;
	vi a(n);
	cinv(a);
	vl p(n, -INF);
	int cnt = 0;
	for (int i = 0; i < n - 1; i++)
	{
		p[i] = a[i] + a[(i + 1) % n];
		if (p[i] <= 0) {
			cnt++;
		}
		else {
			p[i] = -INF;
		}
	}
	vi res(n + 1);
	for (int k = cnt; k > 0; k--)
	{
		int index = -1;
		for (int i = 0; i < n - 1; i++)
		{
			if (index == -1 && p[i] != -INF) {
				index = i;
			}
			else if (p[i] > p[index]) {
				index = i;
			}
		}
		if (index == -1) {
			res[k - 1] = res[k];
			continue;
		}
		if (index == 0 || p[index - 1] < p[index + 1]) {
			if (p[index + 1] != -INF) {
				p[index + 1] -= p[index] - 1;
			}
		}
		else if (index == n - 2 || (index != 0 && p[index - 1] > p[index + 1])) {
			if (p[index - 1] != -INF) {
				p[index - 1] -= p[index] - 1;
			}
		}
		
		res[k - 1] = res[k] - p[index] + 1;
		p[index] = -INF;
	}
	res.pop_back();
	for (int el : res) {
		cout << el << " ";
	}
	
	return 0;
}