#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int __int128
mt19937 rng(chrono::high_resolution_clock().now().time_since_epoch().count());
template <typename T>
using orset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
const int maxn = 1e6;
long long a[maxn], b[maxn], c[maxn], d[maxn];

int down(int i) {
    if (a[i] < 0) return 0;
    long long toget = a[i] % b[i] - b[i];
    return (a[i] - toget) / b[i] * d[i];
}

int up(int i) {
    if (a[i] > 0) return 0;
    long long toget = a[i] % b[i] + b[i];
    return (toget - a[i]) / b[i] * c[i];
}

void solve() {
    long long n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    bool otr = 0;
    __int128 bansotr = down(0), bansplus = up(0);
    for (int i = 1; i < n; i++) {
        __int128 bansotr1, bansplus1;
        bansotr1 = min(bansotr + up(i), bansplus + down(i));
        bansplus1 = min(bansplus + up(i), bansotr + down(i));
        bansplus = bansplus1;
        bansotr = bansotr1;
    }
    if (bansplus == 0) {
        cout << "0\n";
        exit(0);
    }
    string s;
    while (bansplus > 0) {
        s.push_back('0' + bansplus % 10);
        bansplus /= 10;
    }
    reverse(s.begin(), s.end());
    cout << s << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    solve();
}