#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
mt19937 rng(chrono::high_resolution_clock().now().time_since_epoch().count());
template <typename T>
using orset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
const int maxn = 1e3 + 1;
int cost[maxn][maxn], a[maxn * maxn];
int dp[maxn][maxn];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            cin >> cost[i][j];
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            dp[i][j] = 1e18;
        }
    }
    for (int i = 0; i < m; i++) {
        dp[0][i] = cost[a[0]][i];
    }
    for (int i = 1; i < m; i++) {
        for (int j = 0; j < m; j++) {
            for (int k = j; k < m; k++) {
                dp[i][k] = min(dp[i][k], dp[i - 1][j] + cost[a[i]][k]);
            }
        }
    }
    int myans = 1e18;
    for (int i = 0; i < m; i++) {
        myans = min(myans, dp[n - 1][i]);
    }
    cout << myans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    solve();
}