#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
mt19937 rng(chrono::high_resolution_clock().now().time_since_epoch().count());
template <typename T>
using orset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
const int maxn = 1e6;
int a[maxn], b[maxn], b1[maxn];
int ans[22], cost[maxn], par[maxn], bcost[maxn];
vector<int> g[maxn];
int dep[maxn];

bool bit(int x, int i) {
    return ((x >> i) & 1);
}

void dfs1(int v, int p) {
    par[v] = p;
    for (auto u : g[v]) {
        if (u == p) continue;
        dep[u] = dep[v] + 1;
        dfs1(u, v);
    }
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y; x--, y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dep[0] = 1;
    dfs1(0, 0);
    int q, t;
    cin >> q >> t;
    while (q--) {
        int k;
        cin >> k;
        fill(bcost, bcost + n, 0);
        int bans = 0;
        for (int i = 0; i < k; i++) {
            int v, c;
            cin >> v >> c; v--;
            while (v != 0) {
                bcost[v] += dep[v] * c;
                bans = max(bans, bcost[v]);
                v = par[v];
            }
        }
        cout << bans << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    solve();
}