#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T>
int sz(T& a) {
    return (int)a.size();
}


ll ans = 0;
vector<vector<int>> g;
vector<ll> dp;
void dfs(int v, int p, int dist) {
    for (int nxt:g[v]) {
        if (nxt==p) continue;
        dfs(nxt, v, dist+1);
        dp[v] += dp[nxt];
    }
    ans = max(ans, dp[v]*(dist+1));
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);


    int n;
    cin >> n;
    g.resize(n);
    for (int i=0; i<n-1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    int q, t;
    cin >> q >> t;
    while (q--) {
        ans = 0;
        dp.assign(n, 0);
        int k; cin >> k;
        while (k--) {
            int v; ll x;
            cin >> v >> x;
            v--;
            dp[v] += x;
        }
        dfs(0, -1, 0);
        cout << ans << '\n';
    }


    return 0;

}