// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/hash_policy.hpp>

#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define file_in freopen("C:\\work\\input.txt", "r", stdin);
#define file_out freopen("C:\\work\\output.txt", "W", stdout);
#define str string
#define pb push_back
#define ff first
#define sc second
#define all(a) a.begin(), a.end()
#define sz(a) (int(a.size()))
#define int ll

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T1, typename T2> istream &operator>>(istream &in, pair<T1, T2> &p) { in >> p.ff >> p.sc; return in; }
template<typename T1, typename T2> ostream &operator<<(ostream &out, const pair<T1, T2> &p) { out << p.ff << " " << p.sc; return out; }
template<typename T> istream &operator>>(istream &in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream &operator<<(ostream &out, const vector<T> &a) { for (auto &el : a) out << el << ' '; return out; }
template<typename T, typename T2> ostream &operator<<(ostream &out, const set<T, T2> &a) { for (auto &el : a) out << el << ' '; return out; }
template<typename T, typename T2> ostream &operator<<(ostream &out, const unordered_set<T, T2> &a) { for (auto &el : a) out << el << ' '; return out; }
template<typename T> T max(T a, T b, T c) { return max(max(a, b), c); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
template<typename T> T min(T a, T b, T c) { return min(min(a, b), c); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
mt19937_64 genom(mt_seed); ll randint(ll l, ll r) { uniform_int_distribution<ll> rrrrrr(l, r); return rrrrrr(genom); }
const ll RANDOM = mt_seed; struct chash { ll operator()(ll x) const { return x ^ RANDOM; } };

bool good(vector<int> &a) {
    int cnt = 0;
    for (auto el : a) {
        if (el == 0) return 0;
        cnt += (el < 0);
    }
    return cnt % 2 == 0;
}

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int n;
    cin >> n;
    
    vector<int> a(n), b(n), c(n), d(n), pr0(n), pr1(n);

    cin >> a >> b >> c >> d;

    vector<int> zeros, no;

    for (int i = 0; i < n; ++i) {
        pr0[i] = (abs(-1 - a[i]) + b[i] - 1) / b[i] * d[i];
        pr1[i] = (abs(1 - a[i]) + b[i] - 1) / b[i] * c[i];
        if (a[i] < 0) pr0[i] = 0;
        if (a[i] > 0) pr1[i] = 0;
        if (a[i] == 0) {
            zeros.pb(i);
        } else {
            no.pb(i);
        }
    }

    int change = LLONG_MAX;
    for (auto i : no) change = min(change, max(pr0[i], pr1[i]));
    
    if (sz(zeros) == 0) {
        if (good(a)) {
            cout << 0;
        } else {
            cout << change;
        }
        return 0;
    }

    int res = 0, mn_change = LLONG_MAX;
    int cnt = 0;
    for (auto i : zeros) {
        res += min(pr0[i], pr1[i]);
        mn_change = min(mn_change, abs(pr1[i] - pr0[i]));
        if (pr0[i] < pr1[i]) {
            a[i] = -1;
        } else {
            a[i] = 1;
        }
    }

    if (good(a)) {
        cout << res;
    } else {
        cout << res + min(mn_change, change);
    }

    return 0;
}