// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/hash_policy.hpp>

#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define file_in freopen("C:\\work\\input.txt", "r", stdin);
#define file_out freopen("C:\\work\\output.txt", "w", stdout);
#define str string
#define pb push_back
#define ff first
#define sc second
#define all(a) a.begin(), a.end()
#define sz(a) (int(a.size()))
#define int ll

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T1, typename T2> istream &operator>>(istream &in, pair<T1, T2> &p) { in >> p.ff >> p.sc; return in; }
template<typename T1, typename T2> ostream &operator<<(ostream &out, const pair<T1, T2> &p) { out << p.ff << " " << p.sc; return out; }
template<typename T> istream &operator>>(istream &in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream &operator<<(ostream &out, const vector<T> &a) { for (auto &el : a) out << el << ' '; return out; }
template<typename T, typename T2> ostream &operator<<(ostream &out, const set<T, T2> &a) { for (auto &el : a) out << el << ' '; return out; }
template<typename T, typename T2> ostream &operator<<(ostream &out, const unordered_set<T, T2> &a) { for (auto &el : a) out << el << ' '; return out; }
template<typename T> T max(T a, T b, T c) { return max(max(a, b), c); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
template<typename T> T min(T a, T b, T c) { return min(min(a, b), c); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
mt19937_64 genom(mt_seed); ll randint(ll l, ll r) { uniform_int_distribution<ll> rrrrrr(l, r); return rrrrrr(genom); }
const ll RANDOM = mt_seed; struct chash { ll operator()(ll x) const { return x ^ RANDOM; } };

const int inf = 1e18;

signed main() {
    fast
#ifdef LOCAL
    file_in
    // file_out
#endif

    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    cin >> a;

    for (auto &el : a) --el;
    vector<int> first(m, -1), last(m, -1);

    vector<vector<int>> cost(m, vector<int>(m));
    cin >> cost;

    for (int i = 0; i < n; ++i)
        last[a[i]] = i;
    for (int i = n - 1; i >= 0; --i)
        first[a[i]] = i;

    vector<int> ids;
    int curl = n;
    for (int i = n - 1; i >= 0; --i) {
        if (curl > i) {
            ids.pb(i);
            curl = first[a[i]];
        }
        curl = min(curl, first[a[i]]);
    }
    reverse(all(ids));

    vector<vector<int>> dp(sz(ids) + 1, vector<int>(m, inf));
    vector<int> minima(m), nxt(m, inf), used(m, 0);
    int iter = 1;

    for (int i = 0; i < m; ++i) dp[0][i] = 0;
    for (int i = 0; i < sz(ids); ++i) {
        for (int j = 0; j < m; ++j) {
            int cst = 0;
            ++iter;
            for (int l = (i == 0 ? 0 : ids[i - 1] + 1); l <= ids[i]; ++l) {
                if (used[a[l]] != iter)
                    cst += cost[a[l]][j];
                used[a[l]] = iter;
            }
            dp[i + 1][j] = cst + minima[j];
            minima[j] = min((j == 0 ? dp[i + 1][j] : minima[j - 1]), dp[i + 1][j]);
        }
    }
    int ans = inf;
    for (int i = 0; i < m; ++i)
        ans = min(ans, dp[sz(ids)][i]);
    cout << ans;

    return 0;
}