#include <bits/stdc++.h>
#define int long long

using namespace std;
using vint = vector<int>;
using ll = long long;

#define X first
#define Y second
#define pb push_back
#define eb emplace_back()

const int INF = 2e18;

void solve() {
    int n; cin >> n;
    vector<vector<int>> dp(n, vector<int>(n));
    vector<int> ans(n, INF);
    vint v(n); for (auto &e : v) cin >> e;
    int bad = 0;
    for (int i = 0; i < n - 1; i++) {
        if (v[i] + v[i + 1] <= 0) bad++;
    }
    for (int i = bad; i < n; i++) {
        ans[i] = 0;
    }
    dp[bad] = v;
    for (int i = bad; i >= 1; i--) { // O(n) = 500
        int strong;
        int strongCost = INF;
        int poor;
        int poorCost = INF;
        for (int j = 1; j < n - 1; j++) { // O(n) = 500
            if (dp[i][j] + dp[i][j - 1] <= 0 && dp[i][j] + dp[i][j + 1] <= 0) {
                int tmp = -min(dp[i][j] + dp[i][j - 1], dp[i][j] + dp[i][j + 1]) + 1;
                if (tmp < strongCost) {
                    strong = j;
                    strongCost = tmp;
                }
                int foo = -max(dp[i][j] + dp[i][j - 1], dp[i][j] + dp[i][j + 1]) + 1;
                if (foo < poorCost) {
                    poor = j;
                    poorCost = foo;
                }
            } else if (dp[i][j] + dp[i][j - 1] <= 0 || dp[i][j] + dp[i][j + 1] <= 0) {
                int bar = -min(dp[i][j] + dp[i][j - 1], dp[i][j] + dp[i][j + 1]) + 1;
                if (bar < poorCost) {
                    poor = j;
                    poorCost = bar;
                }
            }
        }
        if (i - 2 >= 0 && strongCost < ans[i - 2]) {
            dp[i - 2] = dp[i]; // O(n) = 500
            dp[i - 2][strong] += strongCost;
            ans[i - 2] = strongCost + ans[i];
        }
        if (poorCost < ans[i - 1]) {
            dp[i - 1] = dp[i]; // O(n) = 500
            dp[i - 1][poor] += poorCost;
            ans[i - 1] = poorCost + ans[i];
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i] << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    solve();

    return 0;
}