//#pragma GCC optimize("Ofast,O3,unroll-loops");
//#pragma GCC target("avx2,tune=native");

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define forn(i, a, b) for(int i = (a); i < (b); ++i)
#define fornn(i, a, b) for(int i = (a); i > (b); --i)
#define mp(a, b) make_pair(a, b)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define endl '\n'
#define pint pair<int, int>

const int INF = 1e9 + 7, INF2 = 998244353;

void solve() {
    int a, b, n, m;
    cin >> a >> b >> n >> m;

    auto ck = [&](int x, int y) {
        if (x < 0 || y < 0) return false;
        return x * a + y == n && x * b + 2 * y == m;
    };

    if (2 * a - b == 0) {
        if (ck(0, n)) {
            cout << n << " " << 0;
        } else if (ck(n / a, 0)) {
            cout << n / a << " " << 0;
        } else cout << -1;
        return;
    }
    int y = (a * m - b * n) / (2 * a - b);
    int x = (n - y) / a;
    if (!ck(x, y)) {
        cout << -1;
        return;
    }
    cout << y << " " << x;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}
