//#pragma GCC optimize("Ofast,O3,unroll-loops");
//#pragma GCC target("avx2,tune=native");

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define forn(i, a, b) for(int i = (a); i < (b); ++i)
#define fornn(i, a, b) for(int i = (a); i > (b); --i)
#define mp(a, b) make_pair(a, b)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define endl '\n'
#define pint pair<int, int>

const int INF = 1e9 + 7, INF2 = 998244353;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    forn(i, 0, n) {
        cin >> a[i];
    }

    int curr = 0;
    forn(i, 1, n) {
        curr += a[i] + a[i - 1] <= 0;
    }
    vector<vector<int>> vals(curr + 1);
    vals[curr] = a;

    vector<int> dp(curr + 1, 0);
    fornn(i, curr - 1, -1) {
        int mn1 = INF;
        int p = -1;
        forn(j, 1, n) {
            if (-(vals[i + 1][j] + vals[i + 1][j - 1]) + 1 < mn1) {
                mn1 = -(vals[i + 1][j] + vals[i + 1][j - 1]) + 1;
                p = j;
            }
        }
        mn1 += dp[i + 1];
        int mn2 = INF;
        int p2 = -1;
        if (i + 2 <= curr) {
            forn(j, 1, n - 1) {
                if (-min(vals[i + 2][j] + vals[i + 2][j - 1], vals[i + 2][j] + vals[i + 2][j + 1]) + 1 < mn2) {
                    mn2 = -min(vals[i + 2][j] + vals[i + 2][j - 1], vals[i + 2][j] + vals[i + 2][j + 1]) + 1;
                    p2 = j;
                }
            }
        }
        mn2 += dp[i + 2];
        if (mn1 < mn2) {
            vals[i] = vals[i + 1];
            vals[i][p] = 1;
            dp[i] = mn1;
        } else {
            vals[i] = vals[i + 2];
            vals[i][p2] = 1;
            dp[i] = mn2;
        }
    }
    forn(i, 0, n) {
        if (i >= curr) cout << "0 ";
        else cout << dp[i] << " ";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}
