//#pragma GCC optimize("Ofast,O3,unroll-loops")
//#pragma GCC target("tune=native")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define forn(i, a, b) for(int i = (a); i < (b); ++i)
#define fornn(i, a, b) for(int i = (a); i > (b); --i)
#define mp(a, b) make_pair(a, b)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define endl '\n'
#define pint pair<int, int>

const int INF = 1e16 + 7, INF2 = 998244353;

vector<vector<int>> cost;
vector<int> a;
vector<vector<int>> inds;

int f(vector<int> arr, int p) {
    if (p >= a.size()) return 0;
    int need = 1e16;
    forn(col, p == 0 ? 1 : arr[p - 1], inds.size()) {
        int curr = 0;
        int nxt = inds[arr[p]].back();
        auto nxt_arr = arr;
        set<int> used = { };
        forn(j, p, nxt + 1) {
            if (!used.count(arr[j])) {
                used.insert(arr[j]);
                curr += cost[arr[j]][col];
            }
            nxt = max(nxt, inds[arr[p]].back());
            nxt_arr[j] = col;
        }
        need = min(need, f(nxt_arr, nxt + 1) + curr);
    }
    return need;
}

void solve() {
    int n, m;
    cin >> n >> m;
    a.resize(n);
    forn(i, 0, n) {
        cin >> a[i];
    }

    cost.assign(m + 1, vector<int>(m + 1));
    forn(i, 1, m + 1) {
        forn(j, 1, m + 1) {
            cin >> cost[i][j];
        }
    }

    inds.resize(m + 1);

    forn(i, 0, n) {
        inds[a[i]].push_back(i);
    }

    vector<vector<int>> dp(n, vector<int>(m + 1, INF));
    forn(col, 1, m + 1) {
        dp[0][col] = cost[a[0]][col];

        int nxt = inds[a[0]].back();
        set<int> used = { a[0] };
        int need = dp[0][col];
        forn(j, 0, nxt + 1) {
            if (!used.count(a[j])) {
                used.insert(a[j]);
                need += cost[a[j]][col];
                nxt = max(nxt, inds[a[j]].back());
            }
            dp[j][col] = need;
        }
    }
    forn(i, 1, n) {
        vector<int> mns(m + 1);
        mns[0] = INF;
        forn(j, 1, m + 1) {
            mns[j] = min(mns[j - 1], dp[i - 1][j]);
        }
        forn(col, 1, m + 1) {
            if (dp[i][col] != INF) continue;

            dp[i][col] = min(dp[i][col], mns[col] + cost[a[i]][col]);
            if (dp[i][col] >= INF) continue;
            int nxt = inds[a[i]].back();
            set<int> used = { a[i] };
            int need = dp[i][col];
            forn(j, i, nxt + 1) {
                if (!used.count(a[j])) {
                    used.insert(a[j]);
                    need += cost[a[j]][col];
                    nxt = max(nxt, inds[a[j]].back());
                }
                dp[j][col] = need;
            }
        }
    }
    int res = INF;
    forn(i, 1, m + 1) {
        res = min(res, dp[n - 1][i]);
    }

    cout << res;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}
