#include <bits/stdc++.h>
using namespace std;
using ll = long long;
void bfs(ll s, vector <vector <ll>>& g, vector <ll>& d) {
    queue <ll> q;
    d[s] = 0;
    q.push(s);
    while (!q.empty()) {
        ll v = q.front();
        q.pop();
        for (auto to : g[v]) {
            if (d[to] == -1) {
                d[to] = d[v] + 1;
                q.push(to);
            }
        }
    }
}
void dfs(ll v, vector <vector <ll>>& g, vector <bool>& used) {
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to, g, used);
        }
    }
}
void solve() {
   ios::sync_with_stdio(false);
   cin.tie(nullptr);
   cout.tie(nullptr);
   ll a, b, n, m;
   cin >> a >> b >> n >> m;
   if (b - 2 * a == 0) {
        if (m - 2 * n == 0) {
            cout << n << " " << 0;
        }
        else {
            cout << -1;
        }
        return;
   }
   ll y = (m - 2 * n) / (b - 2 * a);
   if ((m - 2 * n) % (b - 2 * a) != 0) {
        cout << -1;
        return;
   }
   if (y < 0) {
    cout << -1;
    return;
   }
   if (n - a * y < 0) {
    cout << -1;
    return;
   }
   cout << n - a * y << " " << y;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}