#include <bits/stdc++.h>
using namespace std;
using ll = long long;
void bfs(ll s, vector <vector <ll>>& g, vector <ll>& d) {
    queue <ll> q;
    d[s] = 0;
    q.push(s);
    while (!q.empty()) {
        ll v = q.front();
        q.pop();
        for (auto to : g[v]) {
            if (d[to] == -1) {
                d[to] = d[v] + 1;
                q.push(to);
            }
        }
    }
}
void dfs(ll v, vector <vector <ll>>& g, vector <bool>& used) {
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to, g, used);
        }
    }
}
void solve() {
   ios::sync_with_stdio(false);
   cin.tie(nullptr);
   cout.tie(nullptr);
   ll n;
   cin >> n;
   vector <ll> a(n);
   vector <ll> b(n);
   vector <ll> c(n);
   vector <ll> d(n);
   vector <ll> e;
   vector <bool> e1(n, true);
   ll ans = 1;
   for (ll i = 0; i < n; ++i) {
    cin >> a[i];
    if (a[i] == 0) {
        e.push_back(i);
        e1[i] = false;
        continue;
    }
    if (a[i] < 0) {
        ans = ans * (-1);
    }
   }
   for (ll i = 0; i < n; ++i) {
    cin >> b[i];
   }
   for (ll i = 0; i < n; ++i) {
    cin >> c[i];
   }
   for (ll i = 0; i < n; ++i) {
    cin >> d[i];
   }
   ll m = 1000000000000000000;
   if (e.size() > 0) {
    ll m1 = 0;
    ll ans1 = 1;
    ll ind = 0;
    bool f = false;
    for (ll i = 0; i < e.size(); ++i) {
        m1 += min(c[e[i]], d[e[i]]);
        if (c[e[i]] > d[e[i]]) {
            ans1 = ans1 * (-1);
        }
        else if (c[e[i]] == d[e[i]]) {
            f = true;
            ind = e[i];
        }
    }
    if (f == true) {
        cout << m1;
        return;
    }
    if (ans * ans1 > 0) {
        cout << m1;
        return;
    }
    ll m2 = 1000000000000000000;
    for (ll i = 0; i < n; ++i) {
        if (e1[i] == true) {
            ll k = 0;
            if (a[i] > 0) {
                k = (a[i] / b[i]) + 1;
                m2 = min(m2, k * d[i]);
            }
            else {
                k = ((-a[i]) / b[i]) + 1;
                m2 = min(m2, k * c[i]);
            }
        }
    }
    ll m4 = m1 + m2;
    ll m3 = 1000000000000000000;
    for (ll i = 0; i < e.size(); ++i) {
        m3 = min(m3, max(c[e[i]], d[e[i]]) - min(c[e[i]], d[e[i]]));
    }
    cout << min(m4, m1 + m3);
    return;
   }
   if (ans > 0) {
    cout << 0;
    return;
   }
   for (ll i = 0; i < n; ++i) {
    ll k = 0;
    if (a[i] > 0) {
        k = (a[i] / b[i]) + 1;
        m = min(m, k * d[i]);
    }
    else {
        k = ((-a[i]) / b[i]) + 1;
        m = min(m, k * c[i]);
    }
   }
   cout << m;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}