#include <bits/stdc++.h>
using namespace std;
using ll = long long;
void bfs(ll s, vector <vector <ll>>& g, vector <ll>& d) {
    queue <ll> q;
    d[s] = 0;
    q.push(s);
    while (!q.empty()) {
        ll v = q.front();
        q.pop();
        for (auto to : g[v]) {
            if (d[to] == -1) {
                d[to] = d[v] + 1;
                q.push(to);
            }
        }
    }
}
void dfs(ll v, vector <vector <ll>>& g, vector <bool>& used) {
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to, g, used);
        }
    }
}
bool f(ll x) {
    if (x == 1) {
        return true;
    }
    map <ll, ll> d;
    while (x % 2 == 0) {
        x = x / 2;
        d[2]++;
    }
    for (ll i = 3; i * i <= x; ++i) {
        if (x % i == 0) {
            while (x % i == 0) {
                x = x / i;
                d[i]++;
            }
        }
    }
    if (x > 1) {
        d[x]++;
        x = 1;
    }
    ll s = 0;
    for (auto c : d) {
        if (c.second % 2 != 0) {
            s++;
        }
    }
    if (s <= 1) {
        return true;
    }
    return false;
}
void solve() {
   ios::sync_with_stdio(false);
   cin.tie(nullptr);
   cout.tie(nullptr);
   ll n;
   cin >> n;
   if (n <= 32) {
        vector <vector <ll>> ans;
        vector <bool> used(33, false);
       if (n >= 6) {
        ans.push_back({});
        ans.back().push_back(6);
        ans.back().push_back(5);
        used[6] = true;
        used[5] = true;
       }
       if (n >= 10) {
        ans.push_back({});
        ans.back().push_back(9);
        ans.back().push_back(10);
        used[9] = true;
        used[10] = true;
       }
       if (n >= 14) {
        ans.push_back({});
        ans.back().push_back(13);
        ans.back().push_back(14);
        used[13] = true;
        used[14] = true;
       }
       if (n >= 15) {
        ans.push_back({});
        ans.back().push_back(15);
        ans.back().push_back(1);
        used[15] = true;
        used[1] = true;
       }
       if (n >= 21) {
        ans.push_back({});
        ans.back().push_back(21);
        ans.back().push_back(20);
        used[20] = true;
        used[21] = true;
       }
       if (n >= 22) {
        ans.push_back({});
        ans.back().push_back(22);
        ans.back().push_back(3);
        used[22] = true;
        used[3] = true;
       }
       if (n >= 24) {
        ans.push_back({});
        ans.back().push_back(24);
        ans.back().push_back(4);
        used[24] = true;
        used[4] = true;
       }
       if (n >= 26) {
        ans.push_back({});
        ans.back().push_back(26);
        ans.back().push_back(23);
        used[26] = true;
        used[23] = true;
       }
       if (n >= 30) {
        ans.push_back({});
        ans.back().push_back(30);
        ans.back().push_back(2);
        used[30] = true;
        used[2] = true;
       }
       for (ll i = 1; i <= min(n, 32ll); ++i) {
        if (used[i] == false) {
            ans.push_back({});
            ans.back().push_back(i);
        }
       }
       cout << ans.size() << "\n";
       for (auto c : ans) {
        cout << c.size() << "\n";
        for (auto i : c) {
            cout << i << " ";
        }
        cout << "\n";
       }
   }
   else {
    ll ans = (n * (n + 1)) / 2;
    for (ll i = 1; i <= n; ++i) {
        if (f(i) && f(ans - i)) {
            cout << "2\n1\n" << i << "\n" << n - 1 << "\n";
            for (ll j = 1; j <= n; ++j) {
                if (j != i) {
                    cout << j << " ";
                }
            }
            return;
        }
    }
   }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}