#include <bits/stdc++.h>
using namespace std;
using ll = long long;
void bfs(ll s, vector <vector <ll>>& g, vector <ll>& d) {
    queue <ll> q;
    d[s] = 0;
    q.push(s);
    while (!q.empty()) {
        ll v = q.front();
        q.pop();
        for (auto to : g[v]) {
            if (d[to] == -1) {
                d[to] = d[v] + 1;
                q.push(to);
            }
        }
    }
}
void dfs(ll v, vector <vector <ll>>& g, vector <bool>& used) {
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to, g, used);
        }
    }
}
void solve() {
   ios::sync_with_stdio(false);
   cin.tie(nullptr);
   cout.tie(nullptr);
   ll n, q;
   cin >> n >> q;
   string x;
   cin >> x;
   ll ans = 0;
   if (x[x.size() - 1] == '1') {
    ans = 1;
   }
   else {
    ans = 0;
   }
   if (ans % 2 == 0) {
    cout << "Second\n";
    }
    else {
    cout << "First\n";
    }
   for (ll i = 0; i < q; ++i) {
    ll l, r;
    cin >> l >> r;
    if (r == x.size()) {
        ans = 1 - ans;
    }
    if (ans % 2 == 0) {
        cout << "Second\n";
    }
    else {
        cout << "First\n";
    }
   }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}