#include <bits/stdc++.h>

#define _FORTIFY_SOURCE 0
#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")

using namespace std;

typedef long long ll;
typedef long double ld;
#define int ll
#define double ld

#ifdef LOCAL
#   define dbg(x) cout << #x " = " << (x) << '\n';
#   define dbgf printf
#else
#   define dbg(x)
#   define dbgf(...)
#endif

#define all(x) std::begin(x), std::end(x)
#define rall(x) std::rbegin(x), std::rend(x)

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &p) {
    return out << p.first << ' ' << p.second;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

const auto boostIO = []() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed;
    cout.precision(12);
    return 0;
} ();

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> add(n, 0);
    for (int i = 1; i < n; i++) {
        add[i] = max(0LL, -(a[i - 1] + a[i] + add[i - 1]) + 1);
    }
    vector<bool> is_deleted(n, false);
    for (int i = 0; i < n; i++) {
        cout << accumulate(all(add), 0LL) << ' ';
        int mn_ind = 0;
        int mn_value = 1e12;
        for (int j = 0; j < n; j++) {
            if (!is_deleted[j]) {
                if ((j + 1 < n ? max(0LL, -(a[j + 1] + a[j] + add[j + 1]) + 1) : 0LL) - add[j] < mn_value) {
                    mn_ind = j;
                    mn_value = (j + 1 < n && !is_deleted[j + 1] ? max(0LL, -(a[j + 1] + a[j] + add[j + 1]) + 1) : 0LL) - add[j];
                }
            }
        }
        add[mn_ind] = 0;
        if (mn_ind + 1 < n && !is_deleted[mn_ind + 1]) {
            add[mn_ind + 1] += max(0LL, -(a[mn_ind + 1] + a[mn_ind] + add[mn_ind + 1]) + 1);
        }
        is_deleted[mn_ind] = true;
    }
}

signed main() {

    solve();

    return 0;
}