#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")

// #define int long long
#define endl "\n"

ostream& operator << (ostream& out, pair<int, int>& a) {
    out << "| " << a.first << " " << a.second << " |";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

mt19937 rnd(556);
constexpr long long inf = 2e9;
constexpr long long N = 2e3 + 556;
constexpr long long A = 26;
constexpr long long T = 20;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    vector<int> b(n - 1, 0);
    for (int i = 0; i < n - 1; i++) {
        b[i] = a[i] + a[i + 1];
    }

    // cout << b << endl;

    vector<vector<int>> cst(n - 1, vector<int> (n - 1, 0));
    for (int l = 0; l < n - 1; l++) {
        for (int r = l; r < n - 1; r++) {
            int lst = 1;
            for (int k = l; k < r + 1; k++) {
                if (lst <= 0) {
                    cst[l][r] += -lst + 1;
                    lst = b[k] + (-lst + 1);
                } else {
                    lst = b[k];
                }
            }

            if (lst <= 0) {
                cst[l][r] += -lst + 1;
            }
        }
    }

    // cout << cst[0][1] << endl;
    vector<vector<int>> dp(n, vector<int> (n, inf));

    dp[0].assign(n, 0);
    for (int i = 0; i < n - 1; i++) {
        dp[i][0] = cst[0][i];
    }

    for (int k = 1; k < n; k++) {
        for (int r = 0; r < n - 1; r++) {
            if (r) {
                if (b[r] > 0) dp[r][k] = min(dp[r][k], dp[r - 1][k]);
                dp[r][k] = min(dp[r][k], dp[r - 1][k - 1]);
            }
            for (int l = 0; l < r; l++) {
                dp[r][k] = min(dp[r][k], dp[l][k] + cst[l + 1][r]);
            }
        }
    }

    // for (int i = 0; i < n - 1; i++) cout << i << ": " << dp[i] << endl;

    cout << dp[n - 2] << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}