#include <bits/stdc++.h>
using namespace std;

// #pragma GCC optimize("O3")

#define int long long
#define endl "\n"

ostream& operator << (ostream& out, pair<int, int>& a) {
    out << "| " << a.first << " " << a.second << " |";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

mt19937 rnd(556);
constexpr long long inf = 2e9;
constexpr long long N = 2e3 + 556;
constexpr long long A = 26;
constexpr long long T = 20;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> gr(n, vector<int> (0));
    for (int i = 1; i < n; i++) {
        int u, v; cin >> u >> v; u--;--v;
        gr[u].push_back(v); gr[v].push_back(u);
    }
    vector<int> d(n, 1);

    vector<int> pr(n, -1);
    
    auto dfs = [&](auto dfs, int v, int p) -> void {
        for (int to : gr[v]) {
            if (to != p) {
                d[to] = d[v] + 1;
                pr[to] = v;
                dfs(dfs, to, v);
            }
        }
    };

    dfs(dfs, 0, -1);

    int q, t; cin >> q >> t;
    while (q --> 0) {
        int k; cin >> k;

        vector<int> cst(n, 0);

        for (int i = 0; i < k; i++) {
            int v, c; cin >> v >> c; v--;
            while (v != -1) {
                cst[v] += d[v] * c;
                v = pr[v];
            }
        }

        cout << *max_element(cst.begin(), cst.end()) << endl;
    }
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}