#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define len(x) (int)x.size()

using namespace std;

void print(vector<int> a);

void print(vector<vector<int>> a);

void print(vector<char> a);

void print(vector<string> a);

void print(vector<ll> a);

 #define int ll

vector<vector<int>> g;
vector<vector<int>> col;
vector<bool> used;
vector<vector<int>> gr;
vector<int> tour;

void gettour(int cur){
    used[cur] = true;
    for(auto x : g[cur]) if(!used[x]){
        gettour(x);
    }
    tour.push_back(cur);
}

void getcol(int cur, int curcol){
    used[cur] = true;
    col[curcol].push_back(cur);
    for(auto x : gr[cur]) if(!used[x]){
        getcol(x, curcol);
    }
}

/*
4 3
3 3 1 3
0 1 0
1 0 1
1 1 0
*/

void solve(){
    int n, m;
    cin >> n >> m;
    vector<int> b(n);
    vector<int> cntin(m);
    for(int i = 0; i < n; ++i) {
        cin >> b[i];
        --b[i];
        cntin[b[i]] = 1;
    }
    g.resize(m);
    gr.resize(m);
    used.resize(m);
    for(int i = 1; i < n; ++i){
        if(b[i] == b[i - 1]) continue;
        g[b[i]].push_back(b[i - 1]);
        gr[b[i - 1]].push_back(b[i]);
    }
    for(int i = 0; i < m; ++i){
        if(!used[i] && cntin[i]) gettour(i);
    }
    used.assign(m, false);
    int cnt = 0;
    reverse(all(tour));
    for(int i = 0; i < len(tour); ++i){
        if(!used[tour[i]]){
            col.resize(cnt + 1);
            getcol(tour[i], cnt);
            ++cnt;
        }
    }
    vector<vector<int>> cost(m, vector<int>(m));
    vector<vector<int>> costcol(len(col), vector<int>(m));
    for(int i = 0; i < m; ++i) for(int j = 0; j < m; ++j) cin >> cost[i][j];
    for(int i = 0; i < len(col); ++i){
        for(int nw = 0; nw < m; ++nw){
            for(auto el : col[i]){
                costcol[i][nw] += cost[el][nw];
            }
        }
    }
    vector<ll> dp(m);
    for(int i = 0; i < len(col); ++i){
        vector<ll> dpnew(m, 1e18);
        ll mmin = dp[m - 1];
        for(int nw = m - 1; nw >= 0; --nw){
            mmin = min(dp[nw], mmin);
            dpnew[nw] = min(dpnew[nw], mmin + costcol[i][nw]);
        }
        swap(dp, dpnew);
    }
    ll ans = 1e18;
    for(int i = 0; i < m; ++i){
        ans = min(ans, dp[i]);
    }
    cout << ans << '\n';
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    solve();
}

void print(vector<int> a){
    for(auto x : a) cout << x << ' ';
    cout << endl;
}

void print(vector<vector<int>> a){
    for(auto &x : a) print(x);
}

void print(vector<char> a){
    for(auto x : a) cout << x << ' ';
    cout << '\n';
}

void print(vector<string> a){
    for(auto x : a) cout << x << '\n';
}

#ifndef int

void print(vector<ll> a){
    for(auto x : a) cout << x << ' ';
    cout << '\n';
}
#endif