#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <bitset>
#include <algorithm>
#include <numeric>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<ll> vl;
typedef vector<bool> vb;

const int INF = 2e9;
const ll LINF = 1e18;

int n;
vl a, b, c, d;

//ll minsw() {
//  ll minr = LINF;
//  for (int i = 0; i < n; i++) {
//    ll r = LINF;
//    if (a[i] > 0) {
//      ll k = (a[i] + b[i] - 1) / b[i];
//      if (a[i] % b[i] == 0) k++;
//      r = k * d[i];
//    } else if (a[i] < 0) {
//      ll k = (-a[i] + b[i] - 1) / b[i];
//      if (-a[i] % b[i] == 0) k++;
//      r = k * c[i];
//    }
//    minr = min(minr, r);
//  }
//  return minr;
//}

void solve() {
  cin >> n;
  a.resize(n);
  b.resize(n);
  c.resize(n);
  d.resize(n);
  int mult = 1, zcnt = 0;
  for (ll &i : a) {
    cin >> i;
    if (i == 0) zcnt++;
    else if (i < 0) mult *= -1;
  }
  for (ll &i : b) cin >> i;
  for (ll &i : c) cin >> i;
  for (ll &i : d) cin >> i;
  vector<vl> dp(n + 1, vl(2, LINF));
  if (a[0] == 0) {
    dp[1][0] = d[0];
    dp[1][1] = c[0];
  } else if (a[0] > 0) {
    dp[1][1] = 0;
    ll k = (a[0] + b[0] - 1) / b[0];
    if (a[0] % b[0] == 0) k++;
    dp[1][0] = k * d[0];
  } else if (a[0] < 0) {
    dp[1][0] = 0;
    ll k = (-a[0] + b[0] - 1) / b[0];
    if (-a[0] % b[0] == 0) k++;
    dp[1][1] = k * c[0];
  }
  for (int i = 1; i < n; i++) {
    for (int s = 0; s < 2; s++) {
      if (a[i] == 0) {
        dp[i + 1][s] = min(dp[i + 1][s], dp[i][s] + c[i]);
        dp[i + 1][1 - s] = min(dp[i + 1][1 - s], dp[i][s] + d[i]);
      } else {
        if (a[i] > 0) {
          ll k = (a[i] + b[i] - 1) / b[i];
          if (a[i] % b[i] == 0) k++;
          dp[i + 1][s] = min(dp[i + 1][s], dp[i][s]);
          dp[i + 1][1 - s] = min(dp[i + 1][1 - s], dp[i][s] + k * d[i]);
        } else {
          ll k = (-a[i] + b[i] - 1) / b[i];
          if (-a[i] % b[i] == 0) k++;
          dp[i + 1][s] = min(dp[i + 1][s], dp[i][s] + k * c[i]);
          dp[i + 1][1 - s] = min(dp[i + 1][1 - s], dp[i][s]);
        }
      }
    }
  }
  cout << dp[n][1] << '\n';
}

int main() {
#ifdef LOCAL
  freopen("input.in", "r", stdin);
#endif
  int t = 1;
  while (t--) solve();
}