#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    vector<ll> a1(n);
    vector<ll> b1(n);
    vector<ll> c1(n);
    vector<ll> d1(n);
    for (int i = 0; i < n; i++) cin >> a1[i];
    for (int i = 0; i < n; i++) cin >> b1[i];
    for (int i = 0; i < n; i++) cin >> c1[i];
    for (int i = 0; i < n; i++) cin >> d1[i];
    vector<pair<ll, ll>> k(n);
    for (int i = 0; i < n; i++) {
        ll a = a1[i], b = b1[i], c = c1[i], d = d1[i];
        ll col1 = (abs(a) + b) / b;
        if (a == 0) {
            k[i].first = c;
            k[i].second = d;
        }
        else if (a > 0) {
            k[i].first = 0;
            k[i].second = col1 * d;
        }
        else {
            k[i].first = col1 * c;
            k[i].second = 0;
        }
    }
    ll col = 0, res = 0;
    for (int i = 0; i < n; i++) {
        if (k[i].first < k[i].second) {
            col += k[i].first;
        }
        else {
            res++;
            col += k[i].second;
        }
    }
    if (res % 2 == 0) {
        cout << col;
        return 0;
    }
    ll mn = ll(1e18);
    for (int i = 0; i < n; i++) {
        mn = min(mn, abs(k[i].first - k[i].second));
    }
    cout << col + mn;
    return 0;
}