#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

using namespace std;

typedef tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

typedef long long ll;

/*
struct node {
    ll sum, bonus, len;
};

vector<node> tree;
vector<ll> a;

void build(ll i, ll l, ll r) {
    tree[i].len = r - l;
    if (r - l == 1) {
        tree[i].sum = a[l];
    }
    else {
        ll m = (r + l) / 2;
        build(2 * i + 1, l, m);
        build(2 * i + 2, m, r);
        tree[i].sum = tree[2 * i + 1].sum + tree[2 * i + 2].sum;
    }
}

void update(ll i, ll l, ll r, ll ql, ll qr, ll x) {
    if (qr <= l || r <= ql) return;
    if (ql <= l && r <= qr) {
        tree[i].sum += x * tree[i].len;
        tree[i].bonus += x;
        return;
    }
    ll m = (r + l) / 2;
    tree[2 * i + 1].sum += tree[i].bonus * tree[2 * i + 1].len;
    tree[2 * i + 1].bonus += tree[i].bonus;
    tree[2 * i + 2].sum += tree[i].bonus * tree[2 * i + 2].len;
    tree[2 * i + 2].bonus += tree[i].bonus;
    tree[i].bonus = 0;
    update(2 * i + 1, l, m, ql, qr, x);
    update(2 * i + 2, m, r, ql, qr, x);
    tree[i].sum = tree[2 * i + 1].sum + tree[2 * i + 2].sum;
}

ll get(ll i, ll l, ll r, ll ql, ll qr) {
    if (qr <= l || r <= ql) return 0;
    if (ql <= l && r <= qr) {
        return tree[i].sum;
    }
    ll m = (r + l) / 2;
    tree[2 * i + 1].sum += tree[i].bonus * tree[2 * i + 1].len;
    tree[2 * i + 1].bonus += tree[i].bonus;
    tree[2 * i + 2].sum += tree[i].bonus * tree[2 * i + 2].len;
    tree[2 * i + 2].bonus += tree[i].bonus;
    tree[i].bonus = 0;
    return get(2 * i + 1, l, m, ql, qr) + get(2 * i + 2, m, r, ql, qr);
}
*/

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m; cin >> n >> m;
    vector<vector<ll>> v1(n);
    vector<ll> was(n);
    ll sum = 0, col1 = 0;
    while(sum != n) {
        ll col = 0;
        col1++;
        for(int j = 0; j < n; j++) {
            if (was[j] == 0) {
                if (col % 2 == 0) {
                    was[j] = 1;
                    sum++;
                    v1[col1 - 1].push_back(j + 1);
                }
                col++;
            }
        }
    }
    cout << col1 << "\n";
    for(int i = 0; i < col1; i++) {
        ll sum = 0;
        cout << v1[i].size() << " ";
        for(ll j : v1[i]) {
            cout << j << " ";
        }
        cout << "\n";
    }
    return 0;
}