#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    vector<ll> a1(n);
    for(int i = 0; i < n; i++) cin >> a1[i];
    for(int k1= 0; k1 < n; k1++) {
        vector<ll> a = a1;
        vector<vector<ll>> c;
        ll mx = -inf, pos = 0;
        ll k = n - k1 - 1;
        for(int i = 0; i < n - 1; i++) {
            if (a[i] + a[i + 1] > 0) k--;
        }
        for(int i = 0; i < n; i++) {
            vector<ll> v;
            if (i != 0) {
                v.push_back(a[i] + a[i - 1]);
            }
            if (i != n - 1) {
                v.push_back(a[i] + a[i + 1]);
            }
            sort(v.begin(), v.end());
            if (v[0] <= 0 && v[1] <= 0) {
                if (v.size() == 2) {
                    c.push_back({abs(v[0]) + 1, i});
                }
            }
        }
        sort(c.begin(), c.end());
        vector<ll> was(n);
        ll col = 0, ans = 0;
        for(int i = 0; i < c.size(); i++) {
            if (was[c[i][1]] == 1 || was[c[i][1] + 1] == 1 || was[c[i][1] - 1] == 1) {
                continue;
            }
            if (col + 2 > k) break;
            col += 2;
            ans += c[i][0];
            a[c[i][1]] += c[i][0];
            was[c[i][1]] = 1;
            was[c[i][1] - 1] = 1;
            was[c[i][1] + 1] = 1;
        }
        vector<ll> res1;
        for(int i = 0; i < n - 1; i++) {
            if (a[i] + a[i + 1] <= 0) {
                res1.push_back(abs(a[i] + a[i + 1]) + 1);
            }
        }
        sort(res1.begin(), res1.end());
        for(int i = 0; i < min(ll(res1.size()), k - col); i++) {
            ans += res1[i];
        }
        cout << ans << "\n";
    }
    return 0;
}