#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m; cin >> n >> m;
    vector<ll> b(n);
    vector<ll> col(m + 1);
    for(int i = 0; i < n; i++) {
        cin >> b[i];
        b[i]--;
        col[b[i]]++;
    }
    vector<ll> c;
    vector<ll> was(m + 1);
    for(int i = 0; i < n; i++) {
        was[b[i]]++;
        if (was[b[i]] == 1 || was[b[i]] == col[b[i]]) {
            c.push_back(b[i]);
        }
    }
    b = c;
    n = b.size();
    vector<vector<ll>> a(m, vector<ll>(m));
    for(int i = 0; i < m; i++) {
        for(int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    vector<ll> mx(m + 1);
    for(int i = 0; i < n; i++) {
        mx[b[i]] = i;
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(m, inf));
    for(int i = 0; i < n; i++) {
        ll mn = inf;
        for(int color = 0; color < m; color++) {
            if (i != 0) mn = min(mn, dp[i - 1][color]);
            ll ind = mx[b[i]], j = i, res = mn;
            if (i == 0) res = 0;
            while(j <= ind) {
                if (mx[b[j]] == j) {
                    res += a[b[j]][color];
                }
                ind = max(ind, mx[b[j]]);
                j++;
            }
            dp[ind][color] = min(dp[ind][color], res);
        }
    }
    ll ans = inf;
    for(int i = 0; i < m; i++) {
        ans = min(ans, dp[n - 1][i]);
    }
    cout << ans;
    return 0;
}