#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

vector<vector<ll>> g;
vector<ll> was;
vector<ll> h;
vector<ll> h1;

void dfs(ll v) {
    was[v] = 1;
    for(int i = 0; i < g[v].size(); i++) {
        if (was[g[v][i]] == 0) {
            h1[g[v][i]] = h1[v] + 1;
            dfs(g[v][i]);
            h[v] += h[g[v][i]];
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    g.resize(n);
    was.resize(n);
    h.resize(n);
    h1.resize(n);
    for(int i = 0; i < n - 1; i++) {
        ll a, b; cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    ll q, t; cin >> q >> t;
    for(int i = 0; i < q; i++) {
        ll k; cin >> k;
        was.assign(n, 0);
        h.assign(n, 0);
        h1.assign(n, 0);
        for(int j = 0; j < k; j++) {
            ll v, c; cin >> v >> c;
            v--;
            h[v] += c;
        }
        dfs(0);
        ll mx = 0;
        for(int j = 0; j < n; j++) {
            mx = max(mx, h[j] * (h1[j] + 1));
        }
        cout << mx << "\n";
    }
    return 0;
}