#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e18 + 7;
const int MOD = 1e9 + 7;
const int MAXN = 1e5 + 100;

inline void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n), c(n), d(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    vector<int> pos(n), neg(n);
    for (int i = 0; i < n; ++i) {
        if (a[i] == 0) {
            pos[i] = c[i];
            neg[i] = d[i];
        }
        if (a[i] > 0) {
            pos[i] = 0;
            neg[i] = (a[i] / b[i] + 1) * d[i];
        }
        if (a[i] < 0) {
            neg[i] = 0;
            a[i] = abs(a[i]);
            pos[i] = (a[i] / b[i] + 1) * c[i];
        }
    }

    vector<vector<int>> dp(n, vector<int>(2, INF));
    dp[0][0] = neg[0];
    dp[0][1] = pos[0];
    for (int i = 1; i < n; ++i) {
        dp[i][0] = min(dp[i - 1][0] + pos[i], dp[i - 1][1] + neg[i]);
        dp[i][1] = min(dp[i - 1][0] + neg[i], dp[i - 1][1] + pos[i]);
    }
    cout << dp[n - 1][1] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tt = 1;
//    cin >> tt;
    while (tt --> 0) {
        solve();
    }
    return 0;
}