#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e18 + 7;
const int MOD = 1e9 + 7;
const int MAXN = 1e5 + 100;


bool is_simple(int n) {
    for (int i = 2; i * i <= n; ++i) {
        if (n % i == 0) {
            return false;
        }
    }
    return true;
}

bool check(int n) {
    if (is_simple(n)) {
        return true;
    }
    for (int i = 1; i * i <= n; ++i) {
        if (n % i == 0 && is_simple(i)) {
            int sq = (int)sqrt(n / i);
            if (sq * sq == n / i) {
                return true;
            }
        }
    }
    return false;
}

inline void solve() {
    int n, m;
    cin >> n >> m;
    int s = n * (n + 1) / 2;
    if (check(s)) {
        cout << "1\n";
        cout << n << '\n';
        for (int i = 1; i <= n; ++i) {
            cout << i << ' ';
        }
        return;
    }

    int need;
    for (int i = s - 1; i >= 0; --i) {
        if (check(i)) {
            need = i;
            break;
        }
    }
    int x = s - need;
    if (x <= n && check(x)) {
        cout << "2\n";
        cout << "1\n" << x << '\n';
        cout << n - 1 << '\n';
        for (int i = 1; i <= n; ++i) {
            if (i == x) continue;
            cout << i << ' ';
        }
        return;
    }

    vector<int> used(n + 1, 0);
    vector<int> ans;
    for (int i = n; i >= 1; --i) {
        if (x - i >= 0 && check(i)) {
            used[i] = 1;
            ans.emplace_back(i);
            x -= i;
        }
    }
    cout << ans.size() + 1 << '\n';
    for (auto i : ans) {
        cout << "1\n" << i << '\n';
    }
    cout << '\n';
    cout << n - ans.size() << '\n';
    for (int i = 1; i <= n; ++i) {
        if (used[i]) continue;
        cout << i << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tt = 1;
//    cin >> tt;
    while (tt --> 0) {
        solve();
    }
    return 0;
}