#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<ll>> g;
vector<ll> pred, deep;

void dfs(ll v, ll p, ll d) {
    pred[v] = p;
    deep[v] = d;
    for (auto &to: g[v]) {
        if (to != p) {
            dfs(to, v, d + 1);
        }
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n;
    cin >> n;
    g.assign(n, {});
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    pred.assign(n, 0);
    deep.assign(n, 0);
    dfs(0, -1, 0);
    ll q, t;
    cin >> q >> t;
    while (q--) {
        ll k;
        cin >> k;
        vector<ll> ans(n);
        for (ll i = 0; i < k; i++) {
            ll v, c;
            cin >> v >> c;
            v--;
            ll x = v;
            while (x != -1) {
                ans[x] += c * (deep[x] + 1);
                x = pred[x];
            }
        }
        ll mx = ans[0];
        for (ll i = 0; i < n; i++) {
            mx = max(mx, ans[i]);
        }
        cout << mx << '\n';
    }
}