#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll mex(vector<ll> a) {
    sort(a.begin(), a.end());
    for (ll i = 0; i < a.size(); i++) {
        if (a[i] != i) {
            return i;
        }
    }
    return a.size();
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n, q;
    cin >> n >> q;
    vector<vector<ll>> a(n);
    for (ll i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (auto &j: s) {
            a[i].push_back(j - '0');
        }
    }
    vector<ll> f((1 << 18) + 1);
    for (ll i = 0; i <= (1 << 18); i++) {
        vector<ll> gg;
        if (i % 2 == 0) {
            gg.push_back(f[i - 1]);
        } else {
            gg.push_back(f[i - 1]);
            gg.push_back(f[i / 2]);
        }
        f[i] = mex(gg);
    }
    {
        ll ans = 0;
        for (ll i = 0; i < n; i++) {
            ll x = 0;
            for (auto &j: a[i]) {
                x = x * 2 + j;
            }
            ans ^= f[x];
        }
        if (ans == 0) {
            cout << "Second\n";
        } else {
            cout << "First\n";
        }
    }
    while (q--) {
        ll l, r;
        cin >> l >> r;
        l--;
        r--;
        ll ind = 0;
        for (ll i = 0; i < n; i++) {
            for (long long &j: a[i]) {
                if (l <= ind && ind <= r) {
                    j = 1 - j;
                }
                ind++;
            }
        }
        ll ans = 0;
        for (ll i = 0; i < n; i++) {
            ll x = 0;
            for (auto &j: a[i]) {
                x = x * 2 + j;
            }
            ans ^= f[x];
        }
        if (ans == 0) {
            cout << "Second\n";
        } else {
            cout << "First\n";
        }
    }
}