// I wrote this code 4 u <3
#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) (int) x.size()
#define all(x) x.begin(), x.end()

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

struct ST {
    vector<ll> t;
    int sz;

    ST(int n) {
        sz = 1;
        while (sz < n) sz <<= 1;
        t.resize(sz << 1);
    }

    ll get(int l, int r) {
        l += sz;
        r += sz;
        ll res = 0;
        while (l < r) {
            if (l & 1) res += t[l++];
            if (r & 1) res += t[--r];
            l >>= 1;
            r >>= 1;
        }
        return res;
    }

    void upd(int i, ll v) {
        i += sz;
        t[i] = v;
        i >>= 1;
        while (i) {
            t[i] = t[i << 1] + t[i << 1 | 1];
            i >>= 1;
        }
    }
};

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<int> dep(n), tin(n), siz(n);
    dep[0] = 1;
    int T = 0;
    auto Dfs = [&](auto&& self, int u, int p) -> void {
        tin[u] = T++;
        siz[u] = 1;
        for (auto to : g[u]) {
            if (to == p) continue;
            dep[to] = dep[u] + 1;
            self(self, to, u);
            siz[u] += siz[to];
        }
    };
    Dfs(Dfs, 0, -1);
    int q, USELESS;
    cin >> q >> USELESS;
    while (q--) {
        int k;
        cin >> k;
        ST t(n);
        while (k--) {
            int v, c;
            cin >> v >> c;
            --v;
            t.upd(tin[v], c);
        }
        ll ans = 0;
        for (int i = 0; i < n; ++i) {
            ans = max(ans, 1ll * dep[i] * t.get(tin[i], tin[i] + siz[i]));
        }
        cout << ans << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int TET = 1;
    //cin >> TET;
    while (TET--) {
        solve();
    }
    return 0;
}