#include <bits/stdc++.h>

// #pragma GCC optimize("02,03,Ofast,unroll-loops,inline")
// #pragma GCC target("avx,avx2,sse,sse2,ssse3,sse4")


void speedInput() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(0);
  std::cout.tie(0);
}

void solveE() {
    int n, m;
    std::cin >> n >> m;

    std::vector <int> array(n);
    for (int i = 0; i < n; i++) {
        std::cin >> array[i];
    }

    std::vector <std::vector <int>> cost(m, std::vector <int> (m));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            std::cin >> cost[i][j];
        }
    }

    std::vector <int> left(m, -1);
    for (int i = 0; i < n; i++) {
        left[array[i] - 1] = i;
    }

    int curI = 0;
    int last = 0;

    std::vector <std::set <int>> components;
    std::vector <int> comps(n, -1);

    for (int i = 0; i < n; i++) {
        if (comps[i] == -1) {
            comps[i] = curI++;
            components.push_back({});
        }
        for (; last <= left[array[i] - 1]; last++) {
            comps[last] = comps[i];
            components.back().insert(array[last]);
        }
    }

    std::vector <std::vector <long long>> dp((int) components.size() + 1, std::vector <long long> (m + 1, LLONG_MAX));
    for (int i = 1; i <= m; i++) {
        dp[0][i] = 0;
    }

    for (int len = 1; len <= (int) components.size(); len++) {
        for (int cur = 1; cur <= m; cur++) {
            long long curSum = 0;
            for (auto &c : components[len - 1]) {
                curSum += cost[c - 1][cur - 1];
            }
            for (int prev = 1; prev <= cur; prev++) {
                dp[len][cur] = std::min(dp[len][cur], curSum + dp[len - 1][prev]);
            }
        }
    }

    long long res = LLONG_MAX;
    for (int i = 1; i <= m; i++) {
        res = std::min(res, dp[(int) components.size()][i]);
    }
    std::cout << res;
}

signed main() {
    speedInput();

    solveE();

    return 0;
}
