#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#define int long long
#define ld long double

using namespace std;

void dfs(int v, int pr, vector<int> &dist, vector<vector<int>> &g) {
    for (auto u : g[v]) {
        if (u != pr) {
            dist[u] = dist[v] + 1;
            dfs(u, v, dist, g);
        }
    }
}

int ans = 0;

void dfs1(int v, int pr, vector<int> &dist, vector<int> &cnt, vector<vector<int>> &g) {
    for (auto u : g[v]) {
        if (u != pr) {
            dfs1(u, v, dist, cnt, g);
            cnt[v] += cnt[u];
        }
    }
    ans = max(ans, (dist[v] + 1) * cnt[v]);
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    int u, v;
    for (int i = 0; i < n - 1; ++i) {
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int q, t;
    cin >> q >> t;
    vector<int> dist(n);
    dfs(0, -1, dist, g);
    int k, ve, c;
    for (int i = 0; i < q; ++i) {
        cin >> k;
        ans = 0;
        vector<int> cnt(n);
        for (int j = 0; j < k; ++j) {
            cin >> ve >> c;
            cnt[ve - 1] += c;
        }
        dfs1(0, -1, dist, cnt, g);
        cout << ans << endl;
    }
    return 0;
}