#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;

void solve_c() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> ans(m);
    vector<ll> to(n + 1, -1);
    //for (ll )
}

const ll INF = 1e18 + 5;

void solve_d() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    for (ll &i : a) {
        cin >> i;
    }
    vector<vector<ll>> dp(n, vector<ll> (n, INF));
    dp[n - 1] = vector<ll> (n, 0);
    for (ll k = n - 2; k >= 0; --k) {
        dp[k][0] = 0;
        for (ll i = 1; i < n; ++i) {
            vector<ll> b = a;
            ll add = 0;
            ll c = 0;
            for (ll j = i; j > 0; --j) {
                if (b[j] + b[j - 1] <= 0) {
                    ll x = abs(b[j] + b[j - 1]) + 1;
                    b[j - 1] += x;
                    add += x;
                    c++;
                }
                dp[k][i] = min(dp[min(n - 1, k + c)][j - 1] + add, dp[k][i]);
            }
        }
        for (auto i : dp[k]) {
            cout << i << ' ';
        }
        cout << endl;
    }
    for (ll k = 0; k < n; ++k) {
        cout << dp[k][n - 1] << ' ';
    }
    cout << endl;
}

void solve_d2() {

    ll n;
    cin >> n;
    vector<ll> a(n);
    for (ll &i : a) {
        cin >> i;
    }
    for (ll mask = 0; mask < (1 << n); ++mask) {
        for (ll i = 0; i < n; ++i) {
            if ((mask >> i) & 1) {

            }
        }
    }
}

void solve_f() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].emplace_back(u);
        g[u].emplace_back(v);
    }
    int q, t;
    cin >> q >> t;
    while (q--) {
        int k;
        cin >> k;
        vector<int> sum(n);
        for (int i = 0; i < k; ++i) {
            int v, c;
            cin >> v >> c;
            v--;
            sum[v] += c;
        }

        ll ans = 0;
        auto dfs = [&] (auto self, int v, int p, int d) -> void {
            ll s = sum[v];
            //cout << v << ' ' << p << endl;
            for (auto u : g[v]) {
                if (u == p) {
                    continue;
                }
                self(self, u, v, d + 1);
                s += sum[u];
            }
            ans = max(ans, s * d);
        };

        dfs(dfs, 0, -1, 0);

        cout << ans << '\n';
    }
}

void solve_g() {}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve_f();
    }
    return 0;
}