#include <bits/stdc++.h>

using namespace std;

using ll = long long;
mt19937 rnd(chrono::system_clock::now().time_since_epoch().count());
const int INF = INT_MAX;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int& i : a) {
        cin >> i;
        i--;
    }
    vector<vector<int>> cost(m, vector<int> (m));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            cin >> cost[i][j];
        }
    }
    vector<pair<int, int>> seg(m, {-1, -1});
    for (int i = 0; i < n; i++) {
        if (seg[a[i]].first == -1) seg[a[i]] = {i, i};
        else seg[a[i]].second = i;
    }

    vector<vector<int>> l;
    set<int> s;
    int mx = -1;
    s.insert(a[0]);
    mx = seg[a[0]].second;
    for (int i = 0; i < n; i++) {
        if (mx == i) {
            l.emplace_back();
            for (int x : s) l.back().push_back(x);
            s.clear();
            if (i < n - 1) {
                s.insert(a[i + 1]);
                mx = seg[a[i + 1]].second;
            }
        } else {
            s.insert(a[i]);
            mx = max(mx, seg[a[i]].second);
        }
    }

//    for (auto el : l) {
//        for (int x : el) cout << x + 1 << " ";
//        cout << endl;
//    }
//    return 0;

    vector<vector<ll>> dp(l.size(), vector<ll> (m, 1e18));
    for (int to = 0; to < m; to++) {
        ll val = 0;
        for (int x : l[0]) val += cost[x][to];
        dp[0][to] = val;
    }
    for (int i = 1; i < (int)l.size(); i++) {
        ll mn = 1e18;
        for (int to = 0; to < m; to++) {
            mn = min(mn, dp[i - 1][to]);
            ll val = 0;
            for (int x : l[i]) val += cost[x][to];
            dp[i][to] = mn + val;
        }
    }
    ll ans = 1e18;
    for (int fin = 0; fin < m; fin++) ans = min(ans, dp.back()[fin]);
    cout << ans;
}