#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define int long long
#define endl "\n"

signed main(){

    int n;
    cin >> n;

    vector<int> a(n, 0);
    vector<int> b(n, 0);
    vector<int> c(n, 0);
    vector<int> d(n, 0);


    for(int i = 0;i<n;i++){
        cin >> a[i];
    }
    for(int i = 0;i<n;i++){
        cin >> b[i];
    }
    for(int i = 0;i<n;i++){
        cin >> c[i];
    }
    for(int i = 0;i<n;i++){
        cin >> d[i];
    }

    vector<int> big(n, 0);
    vector<int> small(n, 0);

    for(int i = 0;i<n;i++){
        if(a[i] == 0){
            big[i] = c[i];
            small[i] = d[i];
        }
        else if(a[i] > 0){
            big[i] = 0;
            small[i] = (a[i] / b[i] + 1) * d[i];
        }
        else{
            small[i] = 0;
            big[i] = (abs(a[i]) / b[i] + 1) * c[i];
        }
    }

    vector<vector<int>> dp(n, vector<int> (2, 0));

    dp[0][0] = small[0];
    dp[0][1] = big[0];

    for(int i = 1;i<n;i++){
        dp[i][0] = min(dp[i-1][0] + big[i], dp[i-1][1] + small[i]);
        dp[i][1] = min(dp[i-1][1] + big[i], dp[i-1][0] + small[i]);
    }

    cout << dp[n-1][1] << endl;

}