#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>

using namespace std;

#define int long long
#define endl "\n"

bool check(int x){
    if(x == 1){
        return true;
    }
    set<int> st;
    int beg = x;
    for(int i = 2;i<=sqrt(beg);i++){
        while(x % i == 0){
            if(st.count(i)){
                st.erase(i);
            }
            else{
                st.insert(i);
            }
            x /= i;
        }
    }
    if(x != 1){
        st.insert(x);
    }
    return (int)st.size() <= 1;
}

signed main(){

    int n, m;
    cin >> n >> m;

    if(n % 2 == 0){
        int tsm = n + 1;
        int s = n / 2;
        vector<int> posl;
        for(int i = s;i >= 1;i--){
            while(i <= s && check(tsm * i)){
                s -= i;
                posl.push_back(i);
            }
        }
        vector<pair<int, int>> p;
        for(int i = 1;i<=n/2;i++){
            p.push_back({i, tsm - i});
        }
        cout << posl.size() << endl;
        for(auto it: posl){
            cout << it * 2 << endl;
            for(int i = 0;i<it;i++){
                pair<int, int> now = p.back();
                p.pop_back();
                cout << now.first << " " << now.second << " ";
            }
            cout << endl;
        }

    }
    else{
        int tsm = n + 2;
        int s = n / 2;
        vector<int> posl;
        for(int i = s;i >= 1;i--){
            while(i <= s && check(tsm * i)){
                s -= i;
                posl.push_back(i);
            }
        }
        vector<pair<int, int>> p;
        for(int i = 2;i<=(n+1)/2;i++){
            p.push_back({i, tsm - i});
        }
        cout << posl.size() + 1 << endl;
        cout << 1 << endl << 1 << endl;
        for(auto it: posl){
            cout << it * 2 << endl;
            for(int i = 0;i<it;i++){
                pair<int, int> now = p.back();
                p.pop_back();
                cout << now.first << " " << now.second << " ";
            }
            cout << endl;
        }
    }

}