#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>

using namespace std;

#define int long long
#define endl "\n"

const int INF = 1e18;



signed main(){

    int n, m;
    cin >> n >> m;

    vector<int> a(n, 0);

    for(int i = 0;i<n;i++){
        cin >> a[i];
        a[i]--;
    }

    vector<vector<int>> cost(m, vector<int>(m, 0));

    for(int i = 0;i<m;i++){
        for(int j = 0;j<m;j++){
            cin >> cost[i][j];
        }
    }

    map<int, int> was;

    vector<int> last(n, 0);
    vector<int> fst(n, 0);

    for(int i = 0;i<n;i++){
        if(!was[a[i]]){
            fst[i] = 1;
            was[a[i]] = 1;
        }
    }

    was = {};

    for(int i = n-1;i>=0;i--){
        if(!was[a[i]]){
            last[i] = 1;
            was[a[i]] = 1;
        }
    }

    vector<vector<int>> nwc;

    int bal = 0;

    for(int i = 0;i<n;i++){
        if(fst[i]){
            if(bal == 0){
                nwc.push_back(vector<int>(m, 0));
            }
            bal++;
            for(int col = 0;col<m;col++){
                nwc[nwc.size()-1][col] += cost[a[i]][col];
            }
        }
        if(last[i]){
            bal--;
        }
    }

    n = nwc.size();

    vector<vector<int>> dp(n, vector<int>(m, INF));

    for(int col = 0;col < m;col++){
        dp[0][col] = nwc[0][col];
        if(col!=0){
            dp[0][col] = min(dp[0][col], dp[0][col-1]);
        }
    }

    for(int i = 1;i<n;i++){
        for(int col = 0;col < m;col++){
            if(col!=0){
                dp[i][col] = min(dp[i][col], dp[i][col-1]);
            }
            dp[i][col] = min(dp[i][col], dp[i-1][col] + nwc[i][col]);
        }
    }

    cout << dp[n-1][m-1] << endl;

}