#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
#ifdef cot_in
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<int> a(n), b(n), c(n), d(n);
    for (auto &el : a)
        cin >> el;
    for (auto &el : b)
        cin >> el;
    for (auto &el : c)
        cin >> el;
    for (auto &el : d)
        cin >> el;
    vector<ll> upper(n), lower(n);
    for (int i = 0; i < n; i++) {
        if (a[i] > 0) {
            upper[i] = 0;
            lower[i] = 1ll * (a[i] / b[i] + 1) * d[i];
        } else if (a[i] < 0) {
            lower[i] = 0;
            upper[i] = 1ll * (abs(a[i]) / b[i] + 1) * c[i];
        } else {
            lower[i] = d[i];
            upper[i] = c[i];
        }
    }
    ll sum = 0;
    vector<ll> delta;
    for (int i = 0; i < n; i++) {
        sum += lower[i];
        delta.emplace_back(upper[i] - lower[i]);
    }
    sort(delta.begin(), delta.end());
    ll ans = (ll)(1e18);
    if (n % 2 == 0) {
        ll cur = sum;
        ans = min(ans, cur);
        for (int i = 1; i < n; i += 2) {
            cur += delta[i - 1] + delta[i];
            ans = min(ans, cur);
        }
    } else {
        ll cur = sum + delta[0];
        ans = min(ans, cur);
        for (int i = 2; i < n; i += 2) {
            cur += delta[i - 1] + delta[i];
            ans = min(ans, cur);
        }
    }
    cout << ans;
    return 0;
}