#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll inf = (ll)(1e18);

int main() {
#ifdef cot_in
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (auto &el : a) {
        cin >> el;
        el--;
    }
    vector<vector<int>> cost(m, vector<int>(m));
    for (int i = 0; i < m; i++)
        for (int j = 0; j < m; j++)
            cin >> cost[i][j];
    vector<int> last(m);
    for (int i = 0; i < n; i++)
        last[a[i]] = i;
    int ptr = 0, goal = 0;
    vector<unordered_set<int>> segs(1);
    for (; ptr < n;) {
        goal = max(goal, last[a[ptr]]);
        for (; ptr <= goal; ptr++) {
            segs.back().emplace(a[ptr]);
            goal = max(goal, last[a[ptr]]);
        }
        segs.emplace_back();
    }
    segs.pop_back();
    int e = (int) segs.size();
    vector<vector<ll>> meow(e);
    for (int i = 0; i < e; i++) {
        meow[i].resize(m);
        for (auto &el : segs[i]) {
            for (int c = 0; c < m; c++) {
                meow[i][c] += cost[el][c];
            }
        }
    }
    vector<vector<ll>> dp(e, vector<ll>(m, inf));
    for (int c = 0; c < m; c++)
        dp[0][c] = meow[0][c];
    for (int i = 1; i < e; i++) {
        ll best = inf;
        for (int cur = 0; cur < m; cur++) {
            best = min(best, dp[i - 1][cur]);
            dp[i][cur] = best + meow[i][cur];
        }
    }
    ll ans = inf;
    for (int c = 0; c < m; c++)
        ans = min(ans, dp[e - 1][c]);
    cout << ans;
    return 0;
}