#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <sstream>

#define ALL(x) x.begin(), x.end()
#define int long long

using namespace std;
typedef long long ll;

const int MAXN = 1e5 + 5;


vector<int> prost;

bool isProst(int x)
{
	for (int i = 2; i * i <= x; i++)
	{
		if (x % i == 0)
		{
			return 0;
		}
	}
	return 1;
}
vector<int> kvadra;
set<int> sec;
vector<vector<int>> anser;
int count = 1;

bool check(int x)
{
	if (x == 1)
	{
		return 1;
	}
	vector<int> prost;
	int x1 = x;
	for (int i = 2; i * i <= x; i++)
	{
		if (x % i == 0)
		{
			prost.push_back(i);
		}
		while (x % i == 0)
		{
			x /= i;
		}
	}
	if (x > 1)
	{
		prost.push_back(x);
	}
	for (auto i : prost)
	{
		if (find(ALL(kvadra), x1 / i) != kvadra.end())
		{
			return 1;
		}
	}
	return 0;
}

vector<pair<int, vector<int>>> spisok;

void solve1(int n)
{
	if (n == 0)
	{
		return;
	}
	if (n == 15)
	{
		spisok.push_back({ 3, {1, 2} });
		spisok.push_back({ 117, {} });
		for (int i = 3; i <= n; i++)
		{
			spisok.back().second.push_back(i);
		}
		return;
	}
	spisok.push_back({ 1, {1} });
	for (int i = 2; i <= n; i++)
	{
		bool ban = true;
		for (int j = spisok.size() - 1; j >= 0; j--)
		{
			auto& [sum, spis] = spisok[j];
			if (check(sum + i))
			{
				ban = false;
				sum += i;
				spis.push_back(i);
				break;
			}
		}
		if (ban)
		{
			spisok.push_back({ i, {i} });
		}
	}
}

void solve2(int n)
{
	int sum = n * (n + 1);
	sum /= 2;
	bool ban = true;
	for (int i = 0; ; i++)
	{
		int sum1 = (i) * (i + 1);
		sum1 /= 2;
		if (check(sum - sum1))
		{
			if (i > 32)
			{
				solve2(i);
			}
			else
			{
				solve1(i);
			}
			spisok.push_back({ sum - sum1, {} });
			for (int j = i + 1; j <= n; j++)
			{
				spisok.back().second.push_back(j);
			}
			ban = false;
			break;
		}
	}
}

void solve()
{
	
	int n, m;
	cin >> n >> m;
	
	
	for (int i = 1; i <= MAXN; i++)
	{
		kvadra.push_back(i * i);
	}
	
	int sum = n * (n + 1);
	sum /= 2;
	bool ban = true;
	for (int i = 0; ; i++)
	{
		int sum1 = (i) * (i + 1);
		sum1 /= 2;
		if (check(sum - sum1))
		{
			if (i > 32)
			{
				solve2(i);
			}
			else
			{
				solve1(i);
			}
			spisok.push_back({ sum - sum1, {} });
			for (int j = i + 1; j <= n; j++)
			{
				spisok.back().second.push_back(j);
			}
			ban = false;
			break;
		}
	}
	cout << spisok.size() << '\n';
	for (auto [sum, spis] : spisok)
	{
		if (!check(sum))
		{
			abort();
		}
		cout << spis.size() << ' ';
		for (auto i : spis)
		{
			cout << i << ' ';
		}
		cout << '\n';
	}
}

int32_t main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	cin.tie(0);
	ios_base::sync_with_stdio(0);

	int t = 1;
	//cin >> t;
	solve();
	/*for (int i = 1; ; i++)
	{
		cout << i << "\n\n\n";
		solve(i);
		cout << i << "\n\n\n";
	}*/
}