#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
#include <fstream>

using namespace std;

const int MAXN = 400005;
const long long INF = (long long)2e18;

#define int long long

bool f(int x, int a, int b, int n, int m) {
    n -= x;
    m -= 2 * x;
    if (min(n, m) <= 0) {
        return false;
    }
    return n / a * (b - a) > m - n;
}

void solve() {
    int a, b, n, m;
    cin >> a >> b >> n >> m;
    if (a == b) {
        if (n > m || m - n > n) {
            cout << -1;
        } else {
            cout << m - n << ' ' << n - (m - n);
        }
    } else if (a < b) {
        if (m - n < n) {
            cout << -1;
            return;
        }
        int x = m - n;
        int l = -1, r = min(n / a, m / b);
        if (x - r * (b - a) > n - r * a) {
            cout << -1;
            return;
        }
        while (r - l > 1) {
            int mid = (r + l) / 2;
            if (x - mid * (b - a) <= n - mid * a) {
                r = mid;
            } else {
                l = mid;
            }
        }
        if (x - r * (b - a) != n - r * a) {
            cout << -1;
            return;
        }
        cout << n - r * a << ' ' << r;
    } else {
        if (m - n > n) {
            cout << -1;
            return;
        }
        int x = m - n;
        int l = -1, r = min(n / a, m / b);
        if (x - r * (b - a) < n - r * a) {
            cout << -1;
            return;
        }
        while (r - l > 1) {
            int mid = (r + l) / 2;
            if (x - mid * (b - a) >= n - mid *  a) {
                r = mid;
            } else {
                l = mid;
            }
        }
        if (x - r * (b - a) != n - r * a) {
            cout << -1;
            return;
        }
        cout << n - r * a << ' ' << r;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("inp.txt", "r", stdin);
//    freopen("out.txt", "w", stdout);
    int ttt = 1;
//    cin >> ttt;
    while (ttt--) {
        solve();
    }
}