#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
#include <fstream>

using namespace std;

const int MAXN = 400005;
const long long INF = (long long)2e18;

#define int long long

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }
    if (n == 2) {
        cout << abs(a[0] + a[1]) + 1 << ' ' << 0;
        return;
    }
    for (int k = n - 1; k >= 0; --k) {
        set<pair<int, int>> st1, st1a;
        set<int> st2, st2a;
        vector<int> v(n), va(n);
        if (n % 2 == 1) {
            for (int i = 1; i < n - 1; i += 2) {
                int x = max((int)0, -a[i] - a[i - 1] + 1);
                int y = max((int)0, -a[i] - a[i + 1] + 1);
                st1.insert({min(x, y), i});
                v[i] = max(x, y) - min(x, y);
            }
            int cnt = 0;
            int ans = 0;
            while (cnt < k) {
                if (!st2.empty()) {
                    if (st1.empty() || (*st2.begin()) < (*st1.begin()).first) {
                        cnt++;
                        ans += (*st2.begin());
                        st2.erase(st2.begin());
                    } else {
                        cnt++;
                        ans += (*st1.begin()).first;
                        st2.insert(v[(*st1.begin()).second]);
                        st1.erase(st1.begin());
                    }
                } else {
                    cnt++;
                    ans += (*st1.begin()).first;
                    st2.insert(v[(*st1.begin()).second]);
                    st1.erase(st1.begin());
                }
            }
            cout << ans << ' ';
        } else {
            for (int i = 1; i < n - 2; i += 2) {
                int x = max((int)0, -a[i] - a[i - 1] + 1);
                int y = max((int)0, -a[i] - a[i + 1] + 1);
                st1.insert({min(x, y), i});
                v[i] = max(x, y) - min(x, y);
            }
            int nn = (int)a.size() - 1;
            int x = max((int)0, -a[nn] - a[nn - 1] + 1);
            st1.insert({x, nn});
            v[nn] = -1;
            int cnt = 0;
            int ans1 = 0;
            while (cnt < k) {
                if (!st2.empty()) {
                    if (st1.empty() || (*st2.begin()) < (*st1.begin()).first) {
                        cnt++;
                        ans1 += (*st2.begin());
                        st2.erase(st2.begin());
                    } else {
                        cnt++;
                        ans1 += (*st1.begin()).first;
                        if (v[(*st1.begin()).second] != -1) {
                            st2.insert(v[(*st1.begin()).second]);
                        }
                        st1.erase(st1.begin());
                    }
                } else {
                    cnt++;
                    ans1 += (*st1.begin()).first;
                    if (v[(*st1.begin()).second] != -1) {
                        st2.insert(v[(*st1.begin()).second]);
                    }
                    st1.erase(st1.begin());
                }
            }
            for (int i = 2; i < n - 1; i += 2) {
                int xx = max((int)0, -a[i] - a[i - 1] + 1);
                int yy = max((int)0, -a[i] - a[i + 1] + 1);
                st1a.insert({min(xx, yy), i});
                va[i] = max(xx, yy) - min(xx, yy);
            }
            x = max((int)0, -a[0] - a[1] + 1);
            st1a.insert({x, 0});
            va[0] = -1;
            cnt = 0;
            int ans2 = 0;
            while (cnt < k) {
                if (!st2a.empty()) {
                    if (st1a.empty() || (*st2a.begin()) < (*st1a.begin()).first) {
                        cnt++;
                        ans2 += (*st2a.begin());
                        st2a.erase(st2a.begin());
                    } else {
                        cnt++;
                        ans2 += (*st1a.begin()).first;
                        if (va[(*st1a.begin()).second] != -1) {
                            st2a.insert(va[(*st1a.begin()).second]);
                        }
                        st1a.erase(st1a.begin());
                    }
                } else {
                    cnt++;
                    ans2 += (*st1a.begin()).first;
                    if (va[(*st1a.begin()).second] != -1) {
                        st2a.insert(va[(*st1a.begin()).second]);
                    }
                    st1a.erase(st1a.begin());
                }
            }
            cout << min(ans1, ans2) << ' ';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("inp.txt", "r", stdin);
//    freopen("out.txt", "w", stdout);
    int ttt = 1;
//    cin >> ttt;
    while (ttt--) {
        solve();
    }
}