#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <string>
#include <set>
#include <map>
#define int long long

using namespace std;

istream & operator >> (istream & in, vector <auto> & v) {
    for (auto & el : v) {
        cin >> el;
    }
    return in;
}
ostream & operator << (ostream & in, vector <auto> & v) {
    for (auto & el : v) {
        cout << (int)el << " ";
    }
    cout << "\n";
    return in;
}

void solve() {
    int n;
    cin >> n;
    vector <int> a, b, c, d;
    a = b = c = d = vector <int>(n);
    cin >> a >> b >> c >> d;
    vector <int> dp1(n + 1, 1e18), dp2(n + 1, 1e18);
    dp1[0] = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) {
            dp1[i + 1] = min(dp1[i + 1], dp1[i] + c[i]);
            dp2[i + 1] = min(dp2[i + 1], dp1[i] + d[i]);
            dp1[i + 1] = min(dp1[i + 1], dp2[i] + d[i]);
            dp2[i + 1] = min(dp2[i + 1], dp2[i] + c[i]);
        }
        if (a[i] > 0) {
            dp1[i + 1] = min(dp1[i + 1], dp1[i]);
            dp2[i + 1] = min(dp2[i + 1], dp1[i] + (a[i] + 1 + b[i] - 1) / b[i] * d[i]);
            dp1[i + 1] = min(dp1[i + 1], dp2[i] + (a[i] + 1 + b[i] - 1) / b[i] * d[i]);
            dp2[i + 1] = min(dp2[i + 1], dp2[i]);
        }
        if (a[i] < 0) {
            dp1[i + 1] = min(dp1[i + 1], dp2[i]);
            dp2[i + 1] = min(dp2[i + 1], dp1[i]);
            dp1[i + 1] = min(dp1[i + 1], dp1[i] + (-a[i] + 1 + b[i] - 1) / b[i] * c[i]);
            dp2[i + 1] = min(dp2[i + 1], dp2[i] + (-a[i] + 1 + b[i] - 1) / b[i] * c[i]);
        }
    }
//    cout << dp1 << dp2;
    if ((int)(dp1[n] / (int)(1e15)) != 0) cout << (int)(dp1[n] / (int)(1e15));
    cout << (int)(dp1[n] % (int)(1e15));
}
signed main()
{
//    cout << fixed << setprecision(9);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}