#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <string>
#include <set>
#include <map>
#define int long long

using namespace std;

istream & operator >> (istream & in, vector <auto> & v) {
    for (auto & el : v) {
        cin >> el;
    }
    return in;
}
ostream & operator << (ostream & in, vector <auto> & v) {
    for (auto & el : v) {
        cout << el << " ";
    }
    cout << "\n";
    return in;
}
ostream & operator << (ostream & in, vector <vector <auto>> & v) {
    for (auto & el : v) {
        cout << el;
    }
    cout << "\n";
    return in;
}
vector <vector <int>>g;
vector <int> d;

void dfs(int v, int c) {
    d[v] = c;
    for (auto u : g[v]) {
        if (d[u] == -1) {
            dfs(u, c + 1);
        }
    }
}

void solve() {
    int n;
    cin >> n; 
    g = vector <vector <int>> (n);
    d = vector <int> (n, -1);
    for (int i = 0; i < n; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0, 0);
    int q, t;
    cin >> q >> t;
    while (t--) {
        int v,c;
        cin >> v >> c;
        v--;
        cout << (d[v] + 1) * c << "\n";
    }
}
/**
4 4
1 4 3 2
0 3 2 1
3 0 2 1
3 2 0 1
3 2 1 0

*/
signed main()
{
//    cout << fixed << setprecision(9);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}