#include <iostream>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <vector>
#include <list>
//#include <>
//#include <>

#define all(v) v.begin(), v.end()

using namespace std;
using ll = long long;
using ull = unsigned long long;

const ll INF = 1'000'000'000'000'000'000;
const ll MOD = 1'000'000'123;
vector<vector<int>> g;
vector<bool> used;
vector<int> order;

int gcd (int a, int b) {
    while(b != 0) {
        a %= b;
        swap(a,b);
    }
    return a;
}

struct DSU {
    vector<int> p;
    vector<int> r;

    int get(int v) {
        if (p[v] == v) {
           return v;
        }
        return (p[v] = get(p[v]));
    }

};

void dfs1(int v) {
    if (used[v])
        return;
    for(auto u : g[v]) {
        if (!used[u])
            dfs1(u);
    }
    order.push_back(v);
}

void Solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for(auto& e : a) cin >> e;
    vector<vector<int>> cost(m,vector<int> (m));
    for(auto& el : cost) for(auto& e : el) cin >> e;
    ll ans = 0;
    for(int i = 2; i < n; i++) {
        if (a[i] < a[i-1]) {
            ans += cost[i][i-1];
            a[i] = a[i-1];
        }
    }
    cout << ans << '\n';
    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int t = 1;
    //cin >> t;
    while(t--) {
        Solve();
    }
    return 0;
}
