#include <bits/stdc++.h>
using namespace std;

template <typename T>
istream &operator>>(istream &in, vector <T> &vec) {
    for (auto &el : vec) {
        in >> el;
    }
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector <T> &vec) {
    for (auto el : vec) {
        out << el << ' ';
    }
    out << '\n';
    return out;
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using pll = pair <long long, long long>;

#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.begin(), vec.end()
#define F first
#define S second

void solution() {
    ll n, m;
    cin >> n >> m;
    vector <ll> a(n);
    cin >> a;
    for (auto &el : a) {
        --el;
    }
    vector <vector <ll>> f(m, vector <ll> (m));
    for (auto &line : f) {
        cin >> line;
    }

    map <ll, ll> mc;
    for (auto el : a) {
        ++mc[el];
    }

    ll inc = 0, beg = 0;
    map <ll, ll> tc;
    vector <pll> seg;
    for (ll i = 0; i < n; ++i) {
        if (tc[a[i]] == 0) {
            ++inc;
        }
        ++tc[a[i]];
        if (tc[a[i]] == mc[a[i]]) {
            --inc;
        }
        if (inc == 0) {
            seg.push_back({beg, i});
            beg = i + 1;
        }
    }

    ll sz = seg.size();
    vector <vector <ll>> dp(sz, vector <ll> (m, 0));
    vector <ll> mn(m);
    vector <ll> used(m, m + 57);
    for (ll i = m - 1; i >= 0; --i) {
        for (ll j = seg.back().F; j <= seg.back().second; ++j) {
            if (used[a[j]] != i) {
                used[a[j]] = i;
                dp[sz - 1][i] += f[a[j]][i];
            }
        }
    }

    mn[m - 1] = dp[sz - 1][m - 1];
    for (ll i = m - 2; i >= 0; --i) {
        mn[i] = min(mn[i + 1], dp[sz - 1][i]);
    }

    for (ll i = sz - 2; i >= 0; --i) {
        fill(all(used), m + 57);
        for (ll j = m - 1; j >= 0; --j) {
            for (ll k = seg[i].F; k <= seg[i].S; ++k) {
                if (used[a[k]] != j) {
                    used[a[k]] = j;
                    dp[i][j] += f[a[k]][j];
                }
            }
            dp[i][j] += mn[j];
            mn[j] = dp[i][j];
            if (j < m - 1) {
                mn[j] = min(mn[j], mn[j + 1]);
            }
        }
    }

    cout << mn[0];
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tt = 1;
    // cin >> tt;
    while (tt--) {
        solution();
        cout << '\n';
    }

    return 0;
}