#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define endl '\n'

typedef long long ll;
typedef long double ld;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 1e18 + 1;
const int MOD = 1e9 + 7;
const int MOD2 = 1e9 + 9;

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

vector <vector <int>> sm;
vector <int> s;
vector <int> dp;
vector <int> h;
int res = 0;

void calc(int v = 0, int p = -1, int he = 0){
    h[v] = he;
    for (int i = 0; i < (int)sm[v].size(); i++){
        int to = sm[v][i];
        if (to == p)
            continue;
        calc(to, v, he + 1);
    }
}

void dfs(int v = 0, int p = -1){
    for (int i = 0; i < (int)sm[v].size(); i++){
        int to = sm[v][i];
        if (to == p)
            continue;
        dfs(to, v);
        s[v] += s[to];
        dp[v] += dp[to] - s[to];
    }
    res = max(dp[v], res);
}

signed main(){
    Fast();
    int n;
    cin >> n;
    sm.resize(n);
    h.resize(n);
    for (int i = 0; i < n - 1; i++){
        int a, b;
        cin >> a >> b;
        a--, b--;
        sm[a].push_back(b);
        sm[b].push_back(a);
    }
    calc();
    int q, t;
    cin >> q >> t;
    for (int _ = 0; _ < q; _++){
        int k;
        cin >> k;
        s.assign(n, 0);
        dp.assign(n, 0);
        res = 0;
        for (int i = 0; i < k; i++){
            int v, c;
            cin >> v >> c;
            v--;
            s[v] += c;
            dp[v] += c * (h[v] + 1);
        }
        dfs();
        cout << res << endl;
    }
    return 0;
}