#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <map>
#include <string>
#include <unordered_set>
#include <unordered_map>


using namespace std;


using ll = long long;
using pii = pair<int, int>;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<ll> a(n), b(n), c(n), d(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    for (int i = 0; i < n; ++i) cin >> c[i];
    for (int i = 0; i < n; ++i) cin >> d[i];
    ll inf = 1e18;
    vector<vector<ll>> dp(n + 1, vector<ll>(2, inf));
    dp[0][0] = 0;
    for (int i = 1; i <= n; ++i) {
        if (a[i - 1] > 0) {
            ll cnt = (a[i - 1] + b[i - 1]) / b[i - 1];
            dp[i][0] = min(dp[i - 1][0], dp[i - 1][1] + cnt * d[i - 1]);
            dp[i][1] = min(dp[i - 1][1], dp[i - 1][0] + cnt * d[i - 1]);
        }
        else if (a[i - 1] < 0) {
            ll cnt = (abs(a[i - 1]) + b[i - 1]) / b[i - 1];
            dp[i][0] = min(dp[i - 1][1], dp[i - 1][0] + cnt * c[i - 1]);
            dp[i][1] = min(dp[i - 1][0], dp[i - 1][1] + cnt * c[i - 1]);
        }
        else {
            dp[i][0] = min(dp[i - 1][0] + c[i - 1], dp[i - 1][1] + d[i - 1]);
            dp[i][1] = min(dp[i - 1][1] + c[i - 1], dp[i - 1][0] + d[i - 1]);
        }
    }
    cout << dp[n][0];
    return 0;
}