#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <map>
#include <string>
#include <unordered_set>
#include <unordered_map>
#include <random>


using namespace std;


using ll = long long;
using pii = pair<int, int>;

random_device rd;
mt19937 rng(rd());


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m;
    cin >> n >> m;
    vector<vector<int>> groups(20);
    for (int i = 1; i <= n; ++i) {
        for (int l = 0; l < 20; ++l) {
            if (i % (1 << l) == 0 && i % (1 << (l + 1)) != 0) {
                groups[l].push_back(i);
                break;
            }
        }
    }
    while (!groups.empty() && groups.back().empty()) groups.pop_back();
    cout << groups.size() << "\n";
    for (auto& g : groups) {
        cout << g.size() << "\n";
        for (auto el : g) cout << el << " ";
        cout << "\n";
    }
    return 0;
}