#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <map>
#include <string>
#include <unordered_set>
#include <unordered_map>


using namespace std;


using ll = long long;
using pii = pair<int, int>;

int n;
vector<int> a;
vector<int> used;
vector<ll> ans;

void gen(int num) {
    if (num == n - 1) {
        int cnt_bad = 0;
        ll res = 0;
        vector<int> cur = a;
        for (int i = 0; i < n - 1; ++i) {
            if (used[i]) {
                if (cur[i] + cur[i + 1] <= 0) cnt_bad++;
                continue;
            }
            if (cur[i] + cur[i + 1] > 0) continue;
            res += -(cur[i] + cur[i + 1]) + 1;
            cur[i + 1] += -(cur[i] + cur[i + 1]) + 1;
        }
        ans[cnt_bad] = min(ans[cnt_bad], res);
        return;
    }
    gen(num + 1);
    used[num] = 1;
    gen(num + 1);
    used[num] = 0;
    
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    ans.resize(n, (ll) 1e18);
    used.resize(n - 1);
    gen(0);
    for (int i = 1; i < n; ++i) ans[i] = min(ans[i], ans[i - 1]);
    for (auto el : ans) cout << el << " ";
    return 0;
}