#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <map>
#include <string>
#include <unordered_set>
#include <unordered_map>


using namespace std;


using ll = long long;
using pii = pair<int, int>;

vector<vector<int>> g;
vector <ll> c;
vector<ll> summ;

ll dfs(int v, int p, int d) {
    summ[v] = c[v];
    ll ans = 0;
    for (auto u : g[v]) {
        if (u == p) continue;
        ans = max(ans, dfs(u, v, d + 1));
        summ[v] += summ[u];
    }
    ans = max(ans, summ[v] * (d + 1));
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    c.resize(n);
    summ.resize(n);
    int q, t;
    cin >> q >> t;
    for (int _ = 0; _ < q; ++_) {
        int k;
        cin >> k;
        for (int i = 0; i < k; ++i) {
            int v, cost;
            cin >> v >> cost;
            c[v - 1] = cost;
        }
        cout << dfs(0, -1, 0) << "\n";
        for (int i = 0; i < n; ++i) {
            c[i] = 0;
        }
    }
    return 0;
}