#include <bits/stdc++.h>
using namespace std;
#define int long long

int up_2(int n) {
    int ans = 1;
    for (int i = 0; i < 25; ++i) {
        if (ans >= n) {
            return ans;
        }
        ans *= 2;
    }
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector<int> used(1000000);
    vector<pair<int, vector<int>>> group;
    set<pair<int, int>> st;

    for (int i = n; i > 0; --i) {
        if (used[i]) {
            continue;
        }
        used[i] = true;
        int now = up_2(i);
        if (now == i) {
            st.insert({now, group.size()});
            group.push_back({now, {i}});
        } else if (!used[now - i]) {
            used[now - i] = true;
            st.insert({now, group.size()});
            group.push_back({now, {now - i, i}});
        } else {
            // cout << "dfkjgfkjg" << endl;
        }
    }

    vector<vector<int>> ans;
    vector<int> ans_sz;

    while (st.size() >= 2) {
        auto a = *st.begin();
        st.erase(st.begin());
        auto b = *st.begin();
        st.erase(st.begin());
        if (a.first == b.first) {
            for (auto& it : group[b.second].second) {
                group[a.second].second.push_back(it);
            }
            group[a.second].first *= 2;
            st.insert({a.first * 2, a.second});
        } else {
            st.insert(b);
            ans.push_back({});
            ans_sz.push_back(group[a.second].first);
            for (auto& it : group[a.second].second) {
                ans.back().push_back(it);
            }
        }
    }
    if (st.size() == 1) {
        auto a = *st.begin();
        ans.push_back({});
        ans_sz.push_back(group[a.second].first);
        for (auto& it : group[a.second].second) {
            ans.back().push_back(it);
        }
    }

    vector<int> prime(1000000, 1);
    for (int i = 2; i < 1000000; ++i) {
        if (prime[i]) {
            for (int j = i + i; j < 1000000; j += i) {
                prime[j] = 0;
            }
        }
    }

    int ans_cnt = (int)ans.size(), check = 0, cout_sz = 0;

    if (m == 20 && (int)ans.size() > 20) {
        int sum = 0, cnt = 0;
        for (int j = 0; j < (int)ans_sz.size(); ++j) {
            sum += ans_sz[j];
            cnt += ans[j].size();
            for (int i = 1; i < 10000; ++i) {
                if (sum % (i * i) == 0 && sum / (i * i) < 1000000 && prime[sum / (i * i)]) {
                    check = j;
                    cout_sz = cnt;
                    break;
                }
            }
        }
    }
    cout << ans_cnt - check << endl;
    if (cout_sz != 0) {
        cout << cout_sz << endl;
    }

    for (int i = 0; i < ans.size(); ++i) {
        if (i <= check && cout_sz != 0) {
            for (auto& it : ans[i]) {
                cout << it << ' ';
            }
        } else {
            cout << endl << ans[i].size() << endl;
            for (auto& it : ans[i]) {
                cout << it << ' ';
            }
            cout << endl;
        }
    }
}