#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>

#define all(a) a.begin(), a.end()
#define rall(a) a.begin(), a.end()
#define read(a) for(int i = 0; i < a.size(); ++i) cin >> a[i];
#define print(a) for(int i = 0; i < a.size(); ++i) cout << a[i] << " "; cout << endl;

using namespace std;
typedef long long int64;
typedef unsigned long long uint64;

const double pi = 3.1415926536;
const int inf = 1e9;
const int64 INF = 1e18;
const int64 MOD = 1e9 + 7;

void solve()
{
	int64 a, b, n, m;
	cin >> a >> b >> n >> m;
	int64 y = 0;
	if (b - 2 * a != 0)
	{
		y = (m - 2 * n) / (b - 2 * a);
	}
	int64 x = n - (a * y);
	if (x + a * y == n && 2 * x + b * y == m && x >= 0 && y >= 0)
		cout << x << " " << y << endl;
	else
		cout << -1;
}

int main()
{	
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	int T = 1;
	/*cin >> T;*/
	while (T--) solve();
	return 0;
}