#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define read(a) for(int i = 0; i < a.size(); ++i) cin >> a[i];
#define print(a) for(int i = 0; i < a.size(); ++i) cout << a[i] << " "; cout << endl;

using namespace std;
typedef long long int64;
typedef unsigned long long uint64;

const double pi = 3.1415926536;
const int inf = 1e9;
const int64 INF = 1e18;
const int64 MOD = 1e9 + 7;

void solve()
{
	int n;
	cin >> n;
	vector<int> a(n);
	vector<int> b(n);
	read(a);	
	for (int i = 1; i < n; ++i)
	{
		if (a[i] + a[i - 1] < 0)
		{
			b[i] = abs(a[i] + a[i - 1]) + 1;
		}
	}
	sort(rall(b));
	for (int i = 0; i < n; ++i)
	{
		cout << b[i] << " ";
	}
	cout << endl;
}

int main()
{	
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	int T = 1;
	/*cin >> T;*/
	while (T--) solve();
	return 0;
}