# A * x + y = n
# B * x + 2 * y = m

# y = n - A * x
# B * x + 2 * n - 2 * A * x = m
# x * (B - 2 * A) = m - 2 * n
# x = (m - 2 * n) / (B - 2 * A)

A, B, n, m = map(int, input().split())
if B - 2 * A == 0:
    x = 0
else:
    x = (m - 2 * n) // (B - 2 * A)

y = n - A * x

if min(x, y) < 0 or A * x + y != n or B * x + 2 * y != m:
    print(-1)
else:
    print(y, x)