#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n; cin >> n;
    vector<long long> a(n), b(n), c(n), d(n);
    int sign = 1;
    vector<int> zeroes;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] != 0) {
            if (a[i] < 0) sign = -sign;
        } else {
            zeroes.push_back(i);
        }
    }
    for (int i = 0; i < n; i++) cin >> b[i];
    for (int i = 0; i < n; i++) cin >> c[i];
    for (int i = 0; i < n; i++) cin >> d[i];

    if (sign > 0 && zeroes.empty()) {
        cout << 0;
        return 0;
    }
    long long min_zero_change = 1e9 + 1;
    long long ans = 0;
    for (int i : zeroes) {
        ans += min(c[i], d[i]);
        min_zero_change = min(max(c[i], d[i]) - min(c[i], d[i]), min_zero_change);
        if (c[i] > d[i]) sign = -sign;
    }
    if (sign > 0) {
        cout << ans;
        return 0;
    }
    long long min_n_change = 1e9 + 1;
    for (int i = 0; i < n; i++) {
        if (a[i] == 0) continue;
        if (a[i] < 0) {
            int cnt = (- a[i] + 1) / b[i];
            if (a[i] + b[i] * cnt <= 0) cnt += 1;
            min_n_change = min(min_n_change, cnt * c[i]);
        } else {
            int cnt = (a[i] - 1) / b[i];
            if (a[i] - b[i] * cnt >= 0) cnt += 1;
            min_n_change = min(min_n_change, cnt * d[i]);
        }
    }
    ans += min(min_zero_change, min_n_change);
    cout << ans;
    return 0;
}