def turn_sign(a, b, c, d):
    if a > 0:
        return (abs(a) // b) * d + d
    return (abs(a) // b) * c + c


import math

n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))
c = list(map(int, input().split()))
d = list(map(int, input().split()))

s = 0

dp0 = [math.inf] * n
dp1 = [math.inf] * n

if a[0] > 0:
    dp0[0] = 0
    dp1[0] = turn_sign(a[0], b[0], c[0], d[0])
elif a[0] < 0:
    dp0[0] = turn_sign(a[0], b[0], c[0], d[0])
    dp1[0] = 0
else:
    dp0[0] = c[0]
    dp1[0] = d[0]

for i in range(1, n):
    if a[i] > 0:
        dp0[i] = min(
            dp0[i - 1],
            turn_sign(a[i], b[i], c[i], d[i]) + dp1[i - 1]
        )
        dp1[i] = min(
            turn_sign(a[i], b[i], c[i], d[i]) + dp0[i - 1],
            dp1[i - 1]
        )
    elif a[i] < 0:
        dp0[i] = min(
            dp1[i - 1],
            turn_sign(a[i], b[i], c[i], d[i]) + dp0[i - 1]
        )
        dp1[i] = min(
            turn_sign(a[i], b[i], c[i], d[i]) + dp1[i - 1],
            dp0[i - 1]
        )
    else:
        dp0[i] = min(
            dp0[i - 1] + c[i],
            dp1[i - 1] + d[i]
        )
        dp1[i] = min(
            dp0[i - 1] + d[i],
            dp1[i - 1] + c[i]
        )

#print(dp0, dp1)
print(dp0[n - 1])