#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, m;
    cin >> n >> m;
    if (n == 1) {
        cout << "1\n1\n1";
        return 0;
    }
    else if (n == 2) {
        cout << "1\n2\n1 2";
        return 0;
    }
    vector<vector<int>> ans;
    for (int i = 1; i < n; i++) {
        int step = (1 << i);
        ans.push_back(vector<int> ());
        for (int j = step / 2; j <= n; j += step) {
            ans.back().push_back(j);
        }
        if (ans.back().empty()) {
            ans.pop_back();
            break;
        }
    }
    cout << ans.size() << endl;
    for (auto& i : ans) {
        cout << i.size() << endl;
        for (auto& j : i) {
            cout << j << ' ';
        }
        cout << endl;
    }
    return 0;
}