#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const ll inf = 1e17 + 10;


struct str{
    ll l = inf, r = -inf, ind;
    str() {}
};

bool operator < (str a, str b) {
    if (a.l != b.l) {
        return a.l < b.l;
    }
    if (a.r != b.r) {
        return a.r < b.r;
    }
    return a.ind < b.ind;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<str> b(m);
    for (int i = 0; i < m; i++) {
        b[i].ind = i;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
        b[a[i]].l = min(b[a[i]].l, (ll)i);
        b[a[i]].r = max(b[a[i]].r, (ll)i);
        b[a[i]].ind = a[i];
    }
    sort(b.begin(), b.end());
    ll c[m][m];
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            cin >> c[i][j];
        }
    }

    while (b[b.size() - 1].l == inf) b.pop_back();
    vector<int> in[m];
    for (int i = 0; i < b.size(); i++) {
        for (int j = i + 1; j < b.size(); j++) {
            if (b[j].l <= b[i].r) {
                b[i].r = max(b[j].r, b[i].r);
                in[b[i].ind].push_back(b[j].ind);
                for (int col = 0; col < m; col++) {
                    c[b[i].ind][col] += c[b[j].ind][col];
                }
                b.erase(b.begin() + j);
                j = i;
            }
        }
    }

    a.clear();
    for (int i = 0; i < b.size(); i++) {
        a.push_back(b[i].ind);
    }

    n = a.size();

    vector<vector<ll>> dp(max(n, m), vector<ll> (m, inf));
    for (int i = 0; i < m; i++) {
        dp[0][i] = c[a[0]][i];
        if (i > 0) dp[0][i] = min(dp[0][i], dp[0][i - 1]);
    }
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < m; j++) {
            dp[i][j] = dp[i - 1][j] + c[a[i]][j];
            if (j > 0) dp[i][j] = min(dp[i][j], dp[i][j - 1]);
//            for (int k = 0; k <= j; k++) {
//                dp[i][j] = min(dp[i][j], dp[i - 1][k] + c[a[i]][j]);
//            }
        }
    }
    ll ans = inf;
    for (int i = 0; i < m; i++) {
        ans = min(ans, dp[n - 1][i]);
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
    return 0;
}