#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <algorithm>
#include <cmath>
#include <deque>

using namespace std;

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n;
	cin >> n;
	vector<ll> a(n), b(n), c(n), d(n);
	int xm = 0, x0 = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		if (a[i] == 0) {
			x0++;
		}
		if (a[i] < 0) {
			xm++;
		}
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> c[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> d[i];
	}

	if (x0 == 0) {
		if (xm % 2 == 0) {
			cout << 0;
		}
		else {
			ll ans = 3e18;
			for (int i = 0; i < n; ++i) {
				if (a[i] > 0) {
					ll x = a[i] / b[i] + 1;
					ans = min(ans, x * d[i]);
				}
				else {
					ll x = abs(a[i]) / b[i] + 1;
					ans = min(ans, x * c[i]);
				}
			}
			cout << ans;
		}
	}
	else {
		vector<int> pos;
		ll ans = 0;
		for (int i = 0; i < n; ++i) {
			if (a[i] == 0) {
				pos.push_back(i);
				if (c[i] <= d[i]) {
					a[i] += b[i];
					ans += c[i];
				}
				else {
					a[i] -= b[i];
					ans += d[i];
					xm++;
				}
			}
		}
		if (xm % 2 == 0) {
			cout << ans;
		}
		else {
			ll ans1 = 3e18;
			for (auto x : pos) {
				if (c[x] <= d[x]) {
					ans1 = min(ans1, d[x] - c[x]);
				}
				else {
					ans1 = min(ans1, c[x] - d[x]);
				}
			}
			ll ans2 = 3e18;
			for (int i = 0; i < n; ++i) {
				if (binary_search(pos.begin(), pos.end(), i)) {
					continue;
				}
				if (a[i] > 0) {
					ll x = a[i] / b[i] + 1;
					ans2 = min(ans2, x * d[i]);
				}
				else {
					ll x = abs(a[i]) / b[i] + 1;
					ans2 = min(ans2, x * c[i]);
				}
			}
			cout << ans + min(ans1, ans2);
		}
	}
}