#include "bits/stdc++.h"

using namespace std;

//@formatter:off
template<class T> istream &operator>>(istream &is, vector<T> &a);
template<class T> ostream &operator<<(ostream &os, const vector<T> &a);
//@formatter:on
#define int long long
signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      cin.tie(nullptr);
      ios_base::sync_with_stdio(false);
#endif
      int n;
      cin >> n;
      vector<int> a(n), b(n), c(n), d(n);
      cin >> a >> b >> c >> d;
      vector dp(n, vector<int>(2));
      dp[0][0] = (a[0] < 0 ? 0 : d[0] * ((a[0] + b[0]) / b[0]));
      dp[0][1] = (a[0] > 0 ? 0 : c[0] * ((abs(a[0]) + b[0]) / b[0]));

      for (int i = 1; i < n; ++i) {
            int to_neg = (a[i] < 0 ? 0 : d[i] * ((a[i] + b[i]) / b[i]));
            int to_pol = (a[i] > 0 ? 0 : c[i] * ((abs(a[i]) + b[i]) / b[i]));

            dp[i][0] = min(dp[i - 1][1] + to_neg, dp[i - 1][0] + to_pol);
            dp[i][1] = min(dp[i - 1][0] + to_neg, dp[i - 1][1] + to_pol);
      }

//      cout << dp;

      cout << dp[n - 1][1];
}

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
      for_each(a.begin(), a.end(), [&](auto &some) { is >> some; });
      return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &a) {
      for_each(a.begin(), a.end(), [&](auto &some) { os << some << ' '; });
      return (os << '\n');
}