#include <iomanip>
#include <string>
#include <algorithm>
#include <set>
#include <cmath>
#include <iostream>
#include <queue>
#include <map>
#include <random>
#include <vector>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    long long a, b, n, m; cin >> a >> b >> n >> m;
    //x+ay=n =>2x+2a*y=2n
    //2x+by=m
    long long s1 = 2 * a - b, s2 = 2 * n - m;
    if (s1 == 0) {
        if (m == 2 * n) { cout << n << " " << 0; }
        else { cout << -1; }
        return 0;
    }
    if (s1 > 0 && s2 < 0) { cout << -1; return 0; }
    if (s1 < 0 && s2 > 0) { cout << -1; return 0; }
    if (s2 % s1 != 0) { cout << -1; return 0; }
    long long ab = s2 / s1;
    long long x = n - a * ab;
    if (x < 0) { cout << -1; return 0; }
    cout << x << " " << ab;
    return 0;
}