#include <iomanip>
#include <string>
#include <algorithm>
#include <set>
#include <cmath>
#include <iostream>
#include <queue>
#include <map>
#include <random>
#include <vector>
using namespace std;
int n, tim = 1;
vector <vector <int>> g;
vector <int> pred, dists, tin, tout;
void dfs(int v, int p) {
    tin[v] = tim; tim++;
    pred[v] = p;
    if (p != -1) { dists[v] = dists[p] + 1; }
    for (auto elem : g[v]) {
        if (elem == p) { continue; }
        dfs(elem, v);
    }
    tout[v] = tim;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    cin >> n; g.resize(n); pred.resize(n); dists.resize(n); tin.resize(n); tout.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b; cin >> a >> b; a--; b--;
        g[a].push_back(b); g[b].push_back(a);
    }
    dfs(0, -1);
    long long q, t, lastans = 0; 
    cin >> q >> t;
    while (q--) {
        int k; cin >> k;
        vector <long long> pos(k), c(k);
        for (int i = 0; i < k; i++) { 
            cin >> pos[i] >> c[i];
            if (t == 2) {
                pos[i] = (pos[i] + lastans) % (n - 1) + 2;
            }
        }
        long long tekans = 0;
        for (int ost = 0; ost < n; ost++) {
            long long ansa = 0;
            for (int i = 0; i < k; i++) {
                int ver = pos[i] - 1;
                if (tin[ost] <= tin[ver] && tout[ost] >= tout[ver]) {
                    ansa += c[i] * (dists[ost] + 1);
                }
            }
            tekans = max(tekans, ansa);
        }
        cout << tekans << "\n";
        lastans = tekans;
    }
    return 0;
}