#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>

using namespace std;

const int N = 2 * (int)1e5, inf = (int)1e9, mod = (int)1e9 + 7;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<int, pair<int, int>> wegde;

int binpow( int a, int p )
{
  int ans = 1;
  while (p)
  {
    if (p & 1)
      ans = (1ll * ans * p) % mod;
    a = (1ll * a * a) % mod;
    p >>= 1;
  }
  return ans;
}

int gcd( int a, int b, int &x, int &y )
{
  if (a == 0)
  {
    x = 0, y = 1;
    return b;
  }
  int x1, y1;
  int res = gcd(b % a, a, x1, y1);
  x = x1 - (b / a) * y1;
  y = y1;
  return res;
}

int main( void )
{
  int n;
  cin >> n;
  vector<int> a(n), b(n), c(n), d(n), f;
  int cnt = 0, cnt2 = 0, cnt1 = 0;

  for (int i = 0; i < n; i++)
  {
    cin >> a[i];
    if (a[i] < 0)
      cnt++;
    if (a[i] == 0)
      cnt2++;
  }
  for (int i = 0; i < n; i++)
    cin >> b[i];
  for (int i = 0; i < n; i++)
    cin >> c[i];
  for (int i = 0; i < n; i++)
    cin >> d[i];

  if (cnt % 2 == 0 && cnt2 == 0)
    cout << 0;
  else
  {
    ll ans = 0;
    ll mx = 1ll * inf * inf, mx2;
    for (int i = 0; i < n; i++)
      if (a[i] < 0)
      {
        if ((mx2 = ((0ll + -a[i] + b[i]) / b[i]) * c[i]) < mx)
          mx = mx2;
      }
      else if (a[i] > 0)
      {
        if ((mx2 = ((0ll + a[i] + b[i]) / b[i]) * d[i]) < mx)
          mx = mx2;
      }
    if (cnt2 != 0)
    {
      for (int i = 0; i < n; i++)
        if (a[i] == 0)
        {
          f.push_back(i);
          if (c[i] < d[i])
            a[i] += b[i], ans += c[i];
          else
            a[i] -= b[i], ans += d[i], cnt++;
        }

      if (cnt % 2 == 0)
        cout << ans;
      else
      {
        for (int j = 0; j < (int)f.size(); j++)
        {
          int i = f[j];
          if (a[i] < 0)
          {
            if ((mx2 = 0ll + c[i] - d[i]) < mx)
              mx = mx2;
          }
          else
          {
            if ((mx2 = 0ll + d[i] - c[i]) < mx)
              mx = mx2;
          }
        }

        cout << ans + mx;
      }
    }
    else
      cout << mx;
  }

  return 0;
}