#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll
typedef long double ld;
#define double ld
typedef unsigned long long ull;

#define all(x) std::begin(x),std::end(x)
#define rall(x) std::rbegin(x),std::rend(x)
#define pii pair<int,int>
#define vi vector<int>
#define fi first
#define se second
#define eb emplace_back
#define pb push_back
#define tri tuple<int,int,int>
#define quad tuple<int,int,int,int>
#define pent tuple<int,int,int,int,int>

const int INF = numeric_limits<int>::max()/7;
const int MOD = int(1e9+7);
mt19937 RNG(chrono::high_resolution_clock::now().time_since_epoch().count());

int add(int x, int y) {
  int res = x+y;
  return (res>=MOD?res-MOD:res);
}

int sub(int x, int y) {
  int res = x-y;
  return (res<0?res+MOD:res);
}

int binexp(int x, int y) {
  int res = 1;
  while (y) {
    if (y&1) {
      (res *= x)%=MOD;
    }
    (x *= x)%=MOD;
  }
  return res;
}

int rint(int from, int to) {
  uniform_int_distribution<int> d(from, to);
  return d(RNG);
}

int n;
vi a,b,c,d;
void read() {
  cin >> n;
  a.resize(n);
  for (int& elem : a) {
    cin >> elem;
  }
  b.resize(n);
  for (int& elem : b) {
    cin >> elem;
  }
  c.resize(n);
  for (int& elem : c) {
    cin >> elem;
  }
  d.resize(n);
  for (int& elem : d) {
    cin >> elem;
  }
  return;
}

int answ;
void write() {
  cout << answ << '\n';
  return;
}

void solve() {
  answ = 0;
  int best = INF; // Лучшая стоимость смены знака
  int minus = false;
  for (int i = 0; i < n; i++) {
    // pos - это стоимость обращения числа в положительное
    int pos,neg;
    if (a[i] == 0) {
      pos = c[i];
      neg = d[i];
    } else if (a[i] < 0) {
      pos = c[i]*((-a[i]+b[i])/b[i]); // -1+1 (0) т.к. нам нужен не 0, а именно положительное
      neg = 0;
    } else if (a[i] > 0) {
      pos = 0;
      neg = d[i]*((a[i]+b[i])/b[i]);  // same
    } else {
      assert(false);
    }
    answ += min(pos,neg);
    if (neg < pos) {
      minus = !minus;
    }
    best = min(best,abs(pos-neg));
  }
  if (minus) {
    answ += best;
  }
  return;
}


signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int tt = 1;
//  cin >> tt;
  while (tt --> 0) {
    read();
    solve();
    write();
  }
  cout.flush();
  return 0;
}

/*

 * Список дел:
 * 1) Исключить нули
 * 2) Сделать кол-во отрицательных нечетным
 * Для начала как можно дешевле избавляемся от нулей. Если у нас получилось отрицательное - просто находим самый дешёвый способ поменять знак хоть где-то (для нуля это
 *  c и d, для остальных считается руками). Значит сначала запоминаем, есть ли нули и где они, потом избавляемся от них как можно дешевле, потом делаем неотрицательным.

*/