#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll
typedef long double ld;
#define double ld
typedef unsigned long long ull;

#define all(x) std::begin(x),std::end(x)
#define rall(x) std::rbegin(x),std::rend(x)
#define pii pair<int,int>
#define vi vector<int>
#define fi first
#define se second
#define eb emplace_back
#define pb push_back
#define tri tuple<int,int,int>
#define quad tuple<int,int,int,int>
#define pent tuple<int,int,int,int,int>

const int INF = numeric_limits<int>::max()/7;
const int MOD = int(1e9+7);
mt19937 RNG(chrono::high_resolution_clock::now().time_since_epoch().count());

int add(int x, int y) {
  int res = x+y;
  return (res>=MOD?res-MOD:res);
}

int sub(int x, int y) {
  int res = x-y;
  return (res<0?res+MOD:res);
}

int binexp(int x, int y) {
  int res = 1;
  while (y) {
    if (y&1) {
      (res *= x)%=MOD;
    }
    (x *= x)%=MOD;
  }
  return res;
}

int rint(int from, int to) {
  uniform_int_distribution<int> d(from, to);
  return d(RNG);
}

//const int N = int(1e5);
//vi sq, pr;
//void prepare() {
//  sq.assign(1,1);
//  pr.clear();
//  vector<bool> prime(N+1,true);
//  prime[0] = false;
//  prime[1] = false;
//  for (int i = 2; i <= N; i++) {
//    if (prime[i]) {
//      pr.pb(i);
//    }
//    for (int j = i+i; j <= N; j+=i) {
//      prime[j] = false;
//    }
//    if (i*i <= N) {
//      sq.pb(i*i);
//    }
//  }
//  return;
//}


int n;
vi a;
void read() {
  cin >> n;
  a.resize(n);
  for (int& elem : a) {
    cin >> elem;
  }
  return;
}

vector<int> answ;
void write() {
  for (int& elem : answ) {
    cout << elem << ' ';
  }
  cout << '\n';
  return;
}

void solve() {
  vector<vector<pii>> dp(n,vector<pii>());
  vector<vector<pii>> nxt(n,vector<pii>());
  dp[0].eb(0LL,a[0]);
  for (int i = 0; i < n-1; i++) {
    for (int j = 0; j <= i; j++) {
      for (auto&[spent,prev] : dp[j]) {
        int sum = prev+a[i+1];
        nxt[j].eb(spent+max(0LL,-sum+1),a[i+1]-min(0LL,sum-1));
        nxt[j+1].eb(spent,a[i+1]);
      }
    }
//    cout << "i:  " <<  i << endl;
    for (int j = 0; j <= i+1; j++) {
      vector<pii>& vec = nxt[j];
      sort(all(vec),[&](const pii& p1, const pii& p2) {
        return (p1.fi < p2.fi || (p1.fi == p2.fi && p1.se > p2.se));
      });
      vector<pii> buff;
      buff.pb(vec[0]);
      int m = int(vec.size());
      for (int k = 1; k < m; k++) {
        if (vec[k].se <= vec[k-1].se) {  // Если затраты не меньше (а они точно не меньше) и сумма не больше - скипаем
          continue;
        }
        buff.pb(vec[k]);
      }
      swap(buff,dp[j]);
      nxt[j].clear();
    }
//    cout << "i again:  " << i << endl;
  }
  answ.resize(n);
  for (int i = 0; i < n; i++) {
    answ[i] = dp[i].front().fi;
  }
  return;
}


signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
//  prepare();
  int tt = 1;
//  cin >> tt;
  while (tt --> 0) {
    read();
    solve();
    write();
  }
  cout.flush();
  return 0;
}

/*

  Давайте у нас будет какое-то dp[i][j][k] - сколько удалось потратить так, чтобы мы были на i-м элементе и плохих пар было всего j, где k - значение на предыдущем
  А вот нет, не работает это так. Ну тогда давайте k - уменьшали ли мы предыдущее?.. Если у нас идут a,b,c, обе пары плохи и мы сделали a,b хорошей, то для b,c не имеет
  смысла увеличивать b, только c. 
  Бул нам мало что даёт. Нам могло понадобиться уменьшить предыдущее сильнее или слабее. Так что надо бы хранить именно предыдущие значения.
  Но как? Мапа? Давайте для начала так: переходы только на 1 слева направо, так что динамика будет двумерной. 
  Пусть dp[i][j] - как дешево удалось сделать так, что j - сумма на предыдущем и плохих пар и плохих пар i. Надо как-то соптимизировать это клятое a*n... 
  Нам точно не нужны меньшие суммы при тех же/меньших тратах. Мб можно от этого оттолкнуться? Ну давайте хранить сумму на пред. и траты парами и отсортируем 
  каждое dp[i]. Если у нас оказалось так, что потрачено не меньше чем слева и не больше сумма - удаляем. Сортим по возрастанию трат и убыванию суммы. 
*/