#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#pragma GCC optimize(O3)
#pragma comment(linker, "/stack:200000000")
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <fstream>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<vector<long long> > data(4, vector<long long> (n));
    for (int i = 0; i < 4; i++) {
        for (int j = 0; j < n; j++) {
            cin >> data[i][j];
        }
    }
    vector<vector<long long> > dp(n, vector<long long> (2));
    if (data[0][0] == 0) {
        dp[0][0] = data[3][0];
        dp[0][1] = data[2][0];
    }
    else if (data[0][0] < 0) {
        dp[0][0] = 0;
        dp[0][1] = ((abs(data[0][0]) / data[1][0]) + 1) * data[2][0];
    }
    else {
        dp[0][0] = ((abs(data[0][0]) / data[1][0]) + 1) * data[3][0];
        dp[0][1] = 0;
    }
    for (int i = 1; i < n; i++) {
        if (data[0][i] == 0) {
            dp[i][0] = min(dp[i - 1][0] + data[2][i], dp[i - 1][1] + data[3][i]);
            dp[i][1] = min(dp[i - 1][0] + data[3][i], dp[i - 1][1] + data[2][i]);
        }
        else if (data[0][i] < 0) {
            dp[i][0] = min(dp[i - 1][0] + (abs(data[0][i]) / data[1][i] + 1) * data[2][i], dp[i - 1][1]);
            dp[i][1] = min(dp[i - 1][0], dp[i - 1][1] + (abs(data[0][i]) / data[1][i] + 1) * data[2][i]);
        }
        else {
            dp[i][0] = min(dp[i - 1][0], dp[i - 1][1] + (data[0][i] / data[1][i] + 1) * data[3][i]);
            dp[i][1] = min(dp[i - 1][0] + (data[0][i] / data[1][i] + 1) * data[3][i], dp[i - 1][1]);
        }
    }
    cout << dp[n - 1][1] << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    for (int _ = 0; _ < t; _++) {
        solve();
    }
}
