#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e18;
const int MAXN = 5*1e5;
const int MAXM = 1000;

int a[MAXN], cost[MAXM][MAXM], upd[MAXM];

int recurs(int prev, int x, int n, int m)
{
    if(x==n)
    {
        return 0;
    }
    if(upd[a[x]]<prev && (upd[a[x]]==-1 && a[x]<prev))
    {
        return INF;
    }
    if(upd[a[x]]!=-1)
    {
        int cur = recurs(upd[a[x]], x+1, n, m);
        return cur;
    }
    int cst = INF;
    for(int i=max(prev, 0ll); i<m; ++i)
    {
        upd[a[x]]=i;
        int cur = recurs(i, x+1, n, m);
        if(cur!=INF)
        {
            cst = min(cst, cost[a[x]][i]+cur);
        }
    }
    upd[a[x]]=-1;
    return cst;
}

signed main()
{
    int n, m, ans; cin >> n >> m;
    fill(upd, upd+m, -1);
    for(int i=0; i<n; ++i)
    {
        cin >> a[i]; --a[i];
    }
    for(int i=0; i<m; ++i)
    {
        for(int j=0; j<m; ++j)
        {
            cin >> cost[i][j];
        }
    }
    ans = recurs(-1, 0, n, m);
    cout << ans << "\n";
    return 0;
}
