#include <bits/stdc++.h>

using namespace std;

int INF = 1e9;

int main () {
    int n, m;
    cin >> n >> m;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector <vector <int>> cost(m, vector <int> (m));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            cin >> cost[i][j];
        }
    }
    vector <int> dp(n + 1, INF);
    dp[0] = -INF;
    for (int i = 0; i < n; i++) {
        int l = 0, r = n;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (a[i] < dp[mid]) {
                r = mid;
            } else {
                l  = mid;
            }
        }
        //cout << r << endl;
        dp[r] = a[i];
    }
    /*for (auto el : dp) {
        cout << el << " ";
    }
    cout << endl;*/
    int ans;
    for (int i = n; i >= 0; i--) {
        if (dp[i] != INF) {
            ans = i;
            break;
        }
    }
    //cout << ans << endl;
    if (m == 1) {
        cout << 0 << endl;
        return 0;
    }
    cout << (n - ans) * cost[0][1] << endl;
    return 0;
}
