#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <cctype>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <array>
#include <bitset>
#include <cmath>
#include <random>
#include <iterator>

using namespace std;

using ll = long long;
using ld = long double;

template<typename T>
int szof(T& a) {
    return a.size();
}

void solve() {
    int a, b, n, m;
    cin >> a >> b >> n >> m;
    if (2 * n == m) {
        cout << n << " 0\n";
        return;
    }
    if (2 * a > b && 2 * n > m) {
        int l = 0, r = n;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (2 * (n - (ll)mid * a) > m - (ll)mid * b) {
                l = mid;
            } else {
                r = mid;
            }
        }
        if (n - (ll)r * a >= 0 && m - (ll)r * b >= 0 && 2 * (n - r * a) == m - r * b) {
            cout << n - r * a << " " << r << "\n";
            return;
        }
    }
    if (2 * a < b && 2 * n < m) {
        int l = 0, r = n;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (2 * (n - (ll)mid * a) < m - (ll)mid * b) {
                l = mid;
            } else {
                r = mid;
            }
        }
        if (n - (ll)r * a >= 0 && m - (ll)r * b >= 0 && 2 * (n - r * a) == m - r * b) {
            cout << n - r * a << " " << r << "\n";
            return;
        }
    }
    cout << "-1\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios_base::fixed);
    cout.precision(6);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
