#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <cctype>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <array>
#include <bitset>
#include <cmath>
#include <random>
#include <iterator>

using namespace std;

using ll = long long;
using ld = long double;

template<typename T>
int szof(T& a) {
    return a.size();
}

void solve() {
    int n, m;
    cin >> n >> m;
    int mx = 0;
    while ((1 << mx) <= n) {
        ++mx;
    }
    cout << mx << "\n";
    for (int i = 1; i <= n; i *= 2) {
        cout << (n / i + 1) / 2 << "\n";
        for (int j = i; j <= n; j += 2 * i) {
            cout << j << " ";
        }
        cout << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios_base::fixed);
    cout.precision(6);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
