#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <cctype>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <array>
#include <bitset>
#include <cmath>
#include <random>
#include <iterator>

using namespace std;

using ll = long long;
using ld = long double;

template<typename T>
int szof(T& a) {
    return a.size();
}

const int N = 500, INF = 2e9;
int dp[2][N][N], add[2][N][N];

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    fill(dp[0][0] + 1, dp[0][0] + n, INF);
    for (int j = 1; j < n; ++j) {
        fill(dp[0][j], dp[0][j] + n, INF);
    }
    for (int i = 1; i < n; ++i) {
        int ii = i & 1;
        for (int j = 0; j < n; ++j) {
            dp[ii][j][0] = INF;
            if (j > 0) {
                for (int k = 0; k < n; ++k) {
                    if (a[i] + a[i - 1] + add[ii ^ 1][j - 1][k] <= 0) {
                        dp[ii][j][0] = min(dp[ii][j][0], dp[ii ^ 1][j - 1][k]);
                    }
                }
            }
            for (int k = 1; k < n; ++k) {
                dp[ii][j][k] = INF;
                add[ii][j][k] = 0;
                if (dp[ii ^ 1][j][k - 1] == INF) {
                    continue;
                }
                if (a[i] + a[i - 1] + add[ii ^ 1][j][k - 1] > 0) {
                    dp[ii][j][0] = min(dp[ii][j][0], dp[ii ^ 1][j][k - 1]);
                } else {
                    add[ii][j][k] = 1 - (a[i] + a[i - 1] + add[ii ^ 1][j][k - 1]);
                    dp[ii][j][k] = dp[ii ^ 1][j][k - 1] + add[ii][j][k];
                }
            }
        }
    }
    int nn = (n - 1) & 1;
    int mn = INF;
    for (int i = 0; i < n; ++i) {
        mn = min(mn, *min_element(dp[nn][i], dp[nn][i] + n));
        cout << mn << " ";
    }
    cout << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    freopen("error.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios_base::fixed);
    cout.precision(6);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
