#include <iostream>
#include <deque>
#include <map>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <bitset>
#include <numeric>
#include <set>
#include <queue>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pdd = pair<double, double>;
using lld = long double;
using db = double;
using pll = pair<ll, ll>;
const ll inf = 1e18;
const lld EPS = 1e-7;

void fastios() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define int long long

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<vector<int>> cost(m, vector<int>(m));
    for (int i = 0; i < m; i++)
        for (int j = 0; j < m; j++)
            cin >> cost[i][j];
    int all = cost[0][1];
    int ans = 0;
    for (int i = 1; i < n; i++) {
        if (a[i] < a[i - 1]) {
            ans += all;
            a[i] = a[i - 1];
        }
    }
    cout << ans;
}

signed main() {
    /*freopen("magic.in", "r", stdin);
    freopen("magic.out", "w", stdout);*/
    int tt = 1;
    //fastios();
    //precalc();
    //cin >> tt;
    while (tt--) {
        solve();
    }
}