#include <iostream>
#include <vector>
#include <algorithm>
#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

signed main() {
    int n, m;
    cin >> n >> m;
    vector<int> vec(n);
    for (auto &elem : vec) cin >> elem, --elem;
    vector<vector<int>> to(m, vector<int> (m));
    for (int i = 0; i < m; i++) for (int j = 0; j < m; j++) cin >> to[i][j];
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) a[i] = {vec[i], i};
    vector<vector<int>> dp(n, vector<int> (m));
    dp[0][0] = to[vec[0]][0];
    for (int i = 1; i < m; i++) dp[0][i] = min(dp[0][i - 1], to[vec[0]][i]);
    for (int i = 1; i < n; i++) {
        dp[i][0] = dp[i - 1][0] + to[vec[i]][0];
        for (int j = 1; j < m; j++) {
            dp[i][j] = min(dp[i][j - 1], dp[i - 1][j] + to[vec[i]][j]);
        }
    }
    cout << dp[n - 1][m - 1] << '\n';
}