#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<stack>
#include<algorithm>
#include<cmath>
#include<iomanip>
#include<unordered_map>
#include<unordered_set>
#include<random>
#include<cstdio>

#define all(x) x.begin(), x.end()
#define rall() x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

ll gcd(ll a, ll b) {
	return b == 0 ? a : gcd(b, a % b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}


//================================================

void solve() {
	/*int n, m;
	cin >> n >> m;*/

	int n;
	cin >> n;
	vector<int> a(n), b(n);
	for (auto& i : a) cin >> i;
	for (int i = 1; i < n; ++i) {
		b[i] = max(0, -(a[i - 1] + a[i]) + 1);
	}
	vector<vector<vector<ll>>> dp(n, vector<vector<ll>>(n, vector<ll>(2, 1e18)));
	dp[0][0][0] = 0;
	for (int i = 1; i < n; ++i) {
		for (int k = 0; k < n; ++k) {
			dp[i][k][1] = min(dp[i - 1][k][1], dp[i - 1][k][0]) + b[i];
			if (b[i] > b[i - 1]) dp[i][k][1] = min(dp[i][k][1], dp[i - 1][k][1] + max(0, b[i] - b[i - 1]));
			if (a[i] + a[i - 1] > 0) dp[i][k][0] = min(dp[i - 1][k][1], dp[i - 1][k][0]);
			else {
				if(k >= 1) dp[i][k][0] = min(dp[i - 1][k - 1][1], dp[i - 1][k - 1][0]);
				dp[i][k][0] = min(dp[i][k][0], dp[i - 1][k][1] + max(0, b[i] - b[i - 1]));
			}
		}
	}
	ll mn = 1e18;
	for (int i = 0; i < n; ++i) {
		mn = min(mn, min(dp[n - 1][i][0], dp[n - 1][i][1]));
		cout << mn << ' ';
	}
}

//===============================================

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
	return 0;
}