#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<stack>
#include<algorithm>
#include<cmath>
#include<iomanip>
#include<unordered_map>
#include<unordered_set>
#include<random>
#include<cstdio>

#define all(x) x.begin(), x.end()
#define rall() x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

ll gcd(ll a, ll b) {
	return b == 0 ? a : gcd(b, a % b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}
int n;
vector<vector<int>> g;
vector<bool> used;
vector<vector<int>> up;
vector<int> h;
vector<int> tin, tout;
int timer = 0;
void dfs(int v) {
	used[v] = true;
	tin[v] = timer++;
	for (auto i : g[v]) {
		if (!used[i]) {
			h[i] = h[v] + 1;
			up[0][i] = v;
			dfs(i);
		}
	}
	tout[v] = timer++;
}
int la(int v, int k) {
	for (int c = 0; k; ++c) {
		if (k & 1) {
			v = up[v][c];
		}
		k >>= 1;
	}
	return v;
}
int lca(int x, int y) {
	if (h[x] < h[y]) {
		swap(x, y);
	}
	x = la(x, h[x] - h[y]);
	for (int k = 19; k >= 0; --k) {
		if (up[k][x] != up[k][y]) {
			x = up[k][x];
			y = up[k][y];
		}
	}
	return x == y ? x : up[0][x];
}
vector<vector<int>> gr;
vector<ll> dp;
vector<int> c;
ll ans = 0;
void dfs2(int v) {
	dp[v] = c[v];
	for (auto i : gr[v]) {
		if (!used[i]) {
			dfs2(i);
			dp[v] += dp[i];
		}
	}
	ans = max(ans, dp[v] * (h[v] + 1));
}
bool ispr(int x, int y) {
	return tin[x] <= tin[y] && tout[y] <= tout[x];
}

//================================================

void solve() {
	cin >> n;
	g.resize(n);
	for (int i = 0; i < n - 1; ++i) {
		int x, y;
		cin >> x >> y;
		--x, --y;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	used.resize(n);
	up.resize(20, vector<int>(n));
	h.resize(n);
	tin.resize(n);
	tout.resize(n);
	dfs(0);
	for (int k = 1; k < 20; ++k) {
		for (int i = 0; i < n; ++i) {
			up[k][i] = up[k - 1][up[k - 1][i]];
		}
	}
	used.clear();
	used.resize(n);
	dp.resize(n);
	c.resize(n);
	gr.resize(n);
	int q, t;
	cin >> q >> t;
	ll last = 0;
	while (q--) {
		int k;
		cin >> k;
		vector<pair<int, int>> a(k);
		for (auto& i : a) {
			cin >> i.first >> i.second;
			if (t == 2) {
				i.first = (i.first + last) % (n - 1) + 2;
			}
			--i.first;
			c[i.first] += i.second;
		}

		vector<pair<int, int>> b;
		for (auto i : a) {
			b.push_back({ tin[i.first], i.first });
		}
		sort(all(b));
		int tt = b.size();
		for (int i = 0; i < tt - 1; ++i) {
			int v = lca(b[i].second, b[i + 1].second);
			b.push_back({ tin[v], v});
		}
		sort(all(b));

		vector<int> lg;
		vector<int> st;
		st.push_back(0);
		for (auto i : b) {
			while (!ispr(st.back(), i.second)) st.pop_back();
			if (i.second != st.back()) {
				gr[st.back()].push_back(i.second);
				lg.push_back(st.back());
				st.push_back(i.second);
			}
		}

		ans = 0;
		dfs2(0);
		last = ans;
		cout << ans << '\n';

		while (!lg.empty()) {
			gr[lg.back()].clear();
			lg.pop_back();
		}

		for (auto i : a) c[i.first] = 0;
	}
}

//===============================================

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
	return 0;
}