#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ve vector
#define fi first
#define se second
#define all(x) x.begin(), x.end()

using namespace std;

typedef pair<ll, ll> pii;

struct node{
    int par;
    int l, r;
    set<int> clrs;
};

const int MAXN = 5e5+10, MAXM = 1024;

int a[MAXN];
node t[MAXN];
int c[MAXM][MAXM];
int ls[MAXM], rs[MAXM];
int n;
bool vis[MAXN];

void init(){
    for(int i= 0; i < n; i++){
        t[i] = {i, i, i, {a[i]}};
    }
}

int findset(int a){
    if(t[a].par == a)
        return a;
    return t[a].par = findset(t[a].par);
}

void unionsets(int a, int b){
    a = findset(a);
    b = findset(b);
    if(a == b)
        return;
    if(t[a].clrs.size() < t[b].clrs.size())
        swap(a, b);
    t[a].l = min(t[a].l, t[b].l);
    t[a].r = max(t[a].r, t[b].r);
    t[b].par = a;
    for(auto i : t[b].clrs)
        t[a].clrs.insert(i);
    t[b].clrs.clear();
}

int solve(ve<int> v, ve<ve<int> > cc){
    int n = v.size();
    int m = cc[0].size();
    ve<ve<int> > dp(n, ve<int>(m));
    for(int i = 0; i < m; i++){
        dp[0][i] = cc[0][i];
        if(i)
            dp[0][i] = min(dp[0][i], dp[0][i - 1]);
    }
    for(int i = 1; i < n; i++)
    for(int j = 0; j < m; j++){
        dp[i][j] = dp[i - 1][j] + cc[i][j];
        if(j) dp[i][j] = min(dp[i][j], dp[i][j - 1]);
    }
    return dp[n - 1][m - 1];
}

signed main(){
    int m;
    cin >> n >> m;
    fill(ls, ls + m + 1, 1e9);
    for(int i = 0; i < n; i++){
        cin >> a[i];
        a[i]--;
        ls[a[i]] = min(ls[a[i]], i);
        rs[a[i]] = max(rs[a[i]], i);
    }
    init();
    for(int i = 0; i < m; i++)
        for(int j = 0; j < m; j++)
            cin >> c[i][j];
    for(int i = 0; i < n; i++){
        if(i == ls[a[i]]){
            int v = t[findset(i)].r + 1;
            int cnt = 0;
            while(v <= rs[a[i]]){
              //  cout << t[findset(i)].r << " " << t[findset(v)].r << endl;
                unionsets(i, v);
                v = t[findset(i)].r + 1;
                cnt++;
               // if(cnt == 10) return 0;
            }
        }
    }
   // return 0;
    ve<int> v;
    ve<ve<int> > cc;
    for(int i = 0; i < n; i++){
        int cur = findset(i);
        if(!vis[cur]){
            v.push_back(cur);
            vis[cur] = 1;
            cc.push_back(ve<int>(m, 0));
            for(auto j : t[cur].clrs){
                for(int k = 0; k < m; k++)
                    cc.back()[k] += c[j][k];
            }
        }
    }
    cout << solve(v, cc);
    return 0;
}