#include <iostream>

#include <vector>
#include <queue>
#include <algorithm>
#include <stack>
#include <set>
#include <map>

#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long n, m, R;
    cin >> n >> m;
    vector<long long> a(n), l(m, -1), r(m, -1), cg(m, -1);
    vector<vector<long long>> cost(m, vector<long long> (m, 0)), gcost;
    vector<set<long long>> g(1, set<long long>{});
    for (long long i = 0; i < n; ++i){
        cin >> a[i];
        a[i] -= 1;
        if (l[a[i]] == -1){
            l[a[i]] = i;
        }
        r[a[i]] = i;
    }
    R = r[a[0]];
    long long jt = 0;
    g[jt].insert(a[0]);
    for (long long i = 0; i < n; ++i){
        if (i <= R){
            g[jt].insert(a[i]);
            R = max(R, r[a[i]]);
        } else{
            g.push_back(set<long long>{});
            jt++;
            g[jt].insert(a[i]);
            R = r[a[i]];
        }
        cg[a[i]] = jt;
    }
    for (long long i = 0; i < m; ++i){
        if (cg[i] == -1){
            cg[i] = g.size();
        }
    }
    gcost.assign(g.size() + 1, vector<long long>(m, 0));
    for (long long i = 0; i < m; ++i){
        for (long long j = 0; j < m; ++j){
            cin >> cost[i][j];
        }
    }
    for (long long x = 0; x < m; ++x){
        for (long long y = 0; y < m; ++y){
            gcost[cg[x]][y] += cost[x][y];
        }
    }
    vector<vector<long long>> dp(g.size(), vector<long long>(m, 0));
    for (long long i = 0; i < g.size(); ++i){
        for (long long j = 0; j < m; ++j){
            if (i == 0){
                dp[i][j] = gcost[i][j];
            } else if (j == 0){
                dp[i][j] = dp[i - 1][j] + gcost[i][j];
            } else{
                dp[i][j] = min(dp[i - 1][j], dp[i][j - 1] - gcost[i][j - 1]) + gcost[i][j];
            }
        }
    }
    long long ans = dp[g.size() - 1][0];
    for (long long j = 0; j < m; ++j){
        ans = min(ans, dp[g.size() - 1][j]);
    }
    cout << ans;
    return 0;
}
