//#pragma optimize GCC("O3", "unroll-loops")
//#pragma GCC target("avx2", "bmi","bmi2", "popcnt")

#define _CRT_SECURE_NO_WARNINGS
#include <cmath>
#include <vector>
#include <algorithm>
#include <unordered_set>
#include <map>
#include <string>
#include <iostream>
#include <iomanip>
#include <deque>
#include <locale>
#include <unordered_map>
#include <random>
#include <bitset>
#include <queue>
#include <set>

using namespace std;

using ld = long double;
using ll = long long;

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n), b(n), c(n), d(n);
    ll p = 1;
    for (auto& x : a) {
        cin >> x;
        if (x < 0) {
            p = -p;
        }
        if (x == 0) {
            p = 0;
        }
    }
    for (auto& x : b) {
        cin >> x;
    }
    for (auto& x : c) {
        cin >> x;
    }
    for (auto& x : d) {
        cin >> x;
    }
    if (p > 0) {
        cout << 0;
        return;
    }
    if (p == 0) {
        ll ans = 0;
        vector<ll> ind;
        for (ll i = 0; i < n; i++) {
            if (!a[i]) {
                ind.push_back(i);
                if (c[i] < d[i]) {
                    a[i] += b[i];
                    ans += c[i];
                }
                else {
                    a[i] -= b[i];
                    ans += d[i];
                }
            }
        }
        p = 1;
        for (auto x : a) {
            cin >> x;
            if (x < 0) {
                p = -p;
            }
            if (x == 0) {
                p = 0;
            }
        }
        if (p > 0) {
            cout << ans;
            return;
        }
        ll ans1 = 1e9;
        for (ll i = 0; i < n; i++) {
            if (a[i] > 0) {
                ans1 = min(ans1, (a[i] / b[i] + 1) * d[i]);
            }
            else {
                ans1 = min(ans1, (-a[i] / b[i] + 1) * c[i]);
            }
        }
        ans1 += ans;
        for (auto i : ind) {
            if (a[i] > 0) {
                ans1 = min(ans1, ans - c[i] + d[i]);
            }
            else {
                ans1 = min(ans1, ans - d[i] + c[i]);

            }
        }
        cout << ans1;
        return;
    }
    if (p < 0) {
        ll ans = 1e18;
        for (ll i = 0; i < n; i++) {
            if (a[i] > 0) {
                ans = min(ans, (a[i] / b[i] + 1) * d[i]);
            }
            else {
                ans = min(ans, ((-a[i]) / b[i] + 1) * c[i]);
            }
        }
        cout << ans;
    }
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();

    }

}