//#pragma optimize GCC("O3", "unroll-loops")
//#pragma GCC target("avx2", "bmi","bmi2", "popcnt")

#define _CRT_SECURE_NO_WARNINGS
#include <cmath>
#include <vector>
#include <algorithm>
#include <unordered_set>
#include <map>
#include <string>
#include <iostream>
#include <iomanip>
#include <deque>
#include <locale>
#include <unordered_map>
#include <random>
#include <bitset>
#include <queue>
#include <set>

using namespace std;

using ld = long double;
using ll = long long;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> e(n);
    for (auto& x : e) {
        cin >> x;
        x--;
    }
    reverse(e.begin(), e.end());
    vector<vector<int>> c(m, vector<int>(m));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            cin >> c[i][j];
        }
    }
    vector<vector<int>> dp(n+1, vector<int>(m));
    for (int i = 1; i <= n; i++) {
        vector<int> pref = {0};
        for (int j = 0; j < m; j++) {
            pref.push_back(pref.back() + dp[i-1][j]);
        }
        for (int j = 0; j < m; j++) {
            dp[i][j] = pref[j+1] + c[0][1];
        }
    }
    int mn = 1e9;
    for (auto x : dp.back()) {
        mn = min(mn, x);
    }
    cout << mn;
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}