//#pragma optimize GCC("O3", "unroll-loops")
//#pragma GCC target("avx2", "bmi","bmi2", "popcnt")

#define _CRT_SECURE_NO_WARNINGS
#include <cmath>
#include <vector>
#include <algorithm>
#include <unordered_set>
#include <map>
#include <string>
#include <iostream>
#include <iomanip>
#include <deque>
#include <locale>
#include <unordered_map>
#include <random>
#include <bitset>
#include <queue>
#include <set>

using namespace std;

using ld = long double;
using ll = long long;

const ll MAXN = 4e5;
vector<ll> graph[MAXN];
ll used[MAXN], ans[MAXN], c[MAXN], h[MAXN];

void dfs(ll v) {
    used[v] = 1;
    ans[v] = c[v];
    for (auto u : graph[v]) {
        if (!used[u]) {
            h[u] = h[v]+1;
            dfs(u);
            ans[v] += ans[u];
        }
    }
}

void solve() {
    ll n;
    cin >> n;
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        u--;v--;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }
    ll q, t;
    cin >> q >> t;
    while (q--) {
        ll k;
        cin >> k;
        fill(c, c + MAXN, 0);
        fill(used, used + MAXN, 0);
        for (ll i = 0; i < k; i++) {
            ll v, ci;
            cin >> v >> ci;
            v--;
            c[v] = ci;
        }
        dfs(0);
        ll ans1 = 0;
        for (ll i = 0; i < n; i++) {
            ans1 = max(ans1, (h[i] + 1) * ans[i]);
        }
        cout << ans1 << "\n";
    }
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}